

#ifndef COMMAND_HXX
#define COMMAND_HXX

#include <iostream.h>

#include <tools/stream.hxx>
#define STRLEN 100
#ifndef UNX
#define TMPNAME "\\command.tmp"
#else
#define TMPNAME "/tmp/command.tmp"
#endif

enum ExeType
{
	EXE,	
	BAT, 	
	BTM 	
};

#define COMMAND_NOTFOUND	0x0001
#define COMMAND_TOOBIG		0x0002
#define COMMAND_INVALID		0x0004
#define COMMAND_NOEXEC		0x0008
#define COMMAND_NOMEM		0x0010
#define COMMAND_UNKNOWN		0x0020

#if defined( WIN ) || defined( DOS )
#define COMMAND_SHELL	"4dos.com"
#endif
#ifdef OS2
#define COMMAND_SHELL	"4os2.exe"
#endif
#ifdef WNT
#define COMMAND_SHELL	"4nt.exe"
#endif
#ifdef UNX
#define COMMAND_SHELL	"csh"
#endif
#ifdef MAC
#define COMMAND_SHELL	"mpw"
#endif

class CommandLine;
class LogWindow;

class CommandLine
{
friend class ChildProcess;
private:
	char 			*CommandBuffer;
	char 			*ComShell;
	char 			**ppArgv;
	BOOL			bTmpWrite;

public:
		CommandLine(BOOL bTmpWrite = FALSE);
		CommandLine(const char *, BOOL bTmpWrite = FALSE);
		CommandLine(const CommandLine&, BOOL bTmpWrite = FALSE);
	virtual 		~CommandLine();

	int 			nArgc;

	CommandLine& 	operator=(const CommandLine&);
	CommandLine& 	operator=(const char *);
	void 			BuildCommand(const char *);
	char**			GetCommand(void) { return ppArgv; }
	void 			Strtokens(const char *);
	void 			Print();
};

static ByteString thePath( "PATH" );

class CCommand
{
private:
	ByteString			aCommandLine;
	ByteString			aCommand;
	char				*pArgv;
	char				**ppArgv;
	ULONG				nArgc;
	int					nError;

protected:
	void			ImplInit();
	void			Initpp( ULONG nCount, ByteString &rStr );

public:
			CCommand( ByteString &rString );
			CCommand( const char *pChar );

	static ByteString	Search( ByteString sEnv = thePath,
						ByteString sItem = COMMAND_SHELL );

	operator const	int();

	ByteString			GetCommandLine_() { return aCommandLine; }
	ByteString			GetCommand() { return aCommand; }

	char**	GetCommandStr() { return ppArgv; }
};

#define COMMAND_EXECUTE_WINDOW	0x0000001
#define COMMAND_EXECUTE_CONSOLE	0x0000002
#define COMMAND_EXECUTE_HIDDEN  0x0000004
#define COMMAND_EXECUTE_START   0x0000008
#define COMMAND_EXECUTE_WAIT    0x0000010
#define COMMAND_EXECUTE_REMOTE  0x1000000

typedef ULONG CommandBits;

class CCommandd : public CCommand
{
	CommandBits		nFlag;
public:
		CCommandd( ByteString &rString, CommandBits nBits );
		CCommandd( const char *pChar, CommandBits nBits );
	operator const	int();
};

#endif
