
#ifndef _UPDMAKE_HXX
#define _UPDMAKE_HXX

#include <tools/string.hxx>
#include <tools/list.hxx>

class SvFileStream;
class Star;
class GenericInformationList;

class UPDDependencies : public ByteString
{
private:
	ByteString sLogName;
	ByteString sDependencies;

public:
	UPDDependencies( ByteString &rDir, ByteString &rLog );

	ByteString &GetDependencies() { return sDependencies; }
	USHORT GetDependCount() { return sDependencies.GetTokenCount(); }

	void AddDepend( ByteString &rDpc );
	BOOL RemoveDepend( ByteString &rDpc );

	ByteString &GetLogFile() { return sLogName; }
};

class UPDDirectory : public ByteString
{
private:
	ByteString sMakeCommand;

protected:
	virtual void PrintStatus( const char * cStatus ) {};

public:
	UPDDirectory( const ByteString &rDir , const ByteString &rCommand );

	void SetMakeCommand( ByteString &rMakeCommand )
		{ sMakeCommand = rMakeCommand; }
	BOOL Build( ByteString &rSwitches );
};

DECLARE_LIST( DependenciesList, UPDDependencies * );
DECLARE_LIST( DirectoryList, UPDDirectory * );

class UPDMake : public DirectoryList
{
private:
	USHORT nErrorCode;
	ByteString sPathAdd;
	ByteString sMakeCommand;
	ByteString sFileName;
	ByteString sProject;
	ByteString sWorkStamp;
	BOOL   bGetProjectFromCvs;  	

protected:
	virtual void PrintStatus( const char * cStatus ) {};

public:
			UPDMake(
				const ByteString &rProject,
				const ByteString &rWorkStamp,
				const ByteString &rMakeCommand,
				const ByteString &rFileName,
				Star *pStar = 0 );
	void				Set_GetProjectFromCvs(
				BOOL i_bDoGet );
			~UPDMake();

	USHORT 				GetErrorCode()
				{ return nErrorCode; }

	BOOL   				WriteScript(
				ByteString &rSwitches );
	void 				WriteScriptInto(				
				SvFileStream &o_rBatchFile,	
				const ByteString &i_rSwitches );

	USHORT              Build();

	static USHORT 		GetStar( Star **pStar, const ByteString &rVersion, BOOL bRecursive = FALSE, GenericInformationList *pStandLst = NULL );
};

inline void
UPDMake::Set_GetProjectFromCvs( BOOL i_bDoGet )
	{ bGetProjectFromCvs = i_bDoGet; }

#endif
