#ifndef _COM_SUN_STAR_I18N_LINEBREAKUSEROPTIONS_HPP_
#define _COM_SUN_STAR_I18N_LINEBREAKUSEROPTIONS_HPP_

#ifndef _COM_SUN_STAR_I18N_LINEBREAKUSEROPTIONS_HDL_
#include <com/sun/star/i18n/LineBreakUserOptions.hdl>
#endif

#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif

#ifndef _COM_SUN_STAR_UNO_TYPE_HXX_
#include <com/sun/star/uno/Type.hxx>
#endif


namespace com
{
namespace sun
{
namespace star
{
namespace i18n
{

inline LineBreakUserOptions::LineBreakUserOptions() SAL_THROW( () )
    : forbiddenBeginCharacters()
    , forbiddenEndCharacters()
    , applyForbiddenRules(sal_False)
    , allowPunctuationOutsideMargin(sal_False)
    , allowHyphenateEnglish(sal_False)
{
}

inline LineBreakUserOptions::LineBreakUserOptions(const ::rtl::OUString& __forbiddenBeginCharacters, const ::rtl::OUString& __forbiddenEndCharacters, const sal_Bool& __applyForbiddenRules, const sal_Bool& __allowPunctuationOutsideMargin, const sal_Bool& __allowHyphenateEnglish) SAL_THROW( () )
    : forbiddenBeginCharacters(__forbiddenBeginCharacters)
    , forbiddenEndCharacters(__forbiddenEndCharacters)
    , applyForbiddenRules(__applyForbiddenRules)
    , allowPunctuationOutsideMargin(__allowPunctuationOutsideMargin)
    , allowHyphenateEnglish(__allowHyphenateEnglish)
{
}

} // i18n
} // star
} // sun
} // com

#if ((defined(__SUNPRO_CC) && (__SUNPRO_CC == 0x500)) || (defined(__GNUC__) && defined(__APPLE__)))
static typelib_TypeDescriptionReference * s_pType_com_sun_star_i18n_LineBreakUserOptions = 0;
#endif

inline const ::com::sun::star::uno::Type& SAL_CALL getCppuType( const ::com::sun::star::i18n::LineBreakUserOptions* ) SAL_THROW( () )
{
    #if ! ((defined(__SUNPRO_CC) && (__SUNPRO_CC == 0x500)) || (defined(__GNUC__) && defined(__APPLE__)))
    static typelib_TypeDescriptionReference * s_pType_com_sun_star_i18n_LineBreakUserOptions = 0;
    #endif

    if ( !s_pType_com_sun_star_i18n_LineBreakUserOptions )
    {
        typelib_TypeDescriptionReference * aMemberRefs[5];
        const ::com::sun::star::uno::Type& rMemberType_string = getCppuType( ( const ::rtl::OUString *)0 );
        aMemberRefs[0] = rMemberType_string.getTypeLibType();
        aMemberRefs[1] = rMemberType_string.getTypeLibType();
        const ::com::sun::star::uno::Type& rMemberType_boolean = getCppuType( ( const sal_Bool *)0 );
        aMemberRefs[2] = rMemberType_boolean.getTypeLibType();
        aMemberRefs[3] = rMemberType_boolean.getTypeLibType();
        aMemberRefs[4] = rMemberType_boolean.getTypeLibType();

        typelib_static_compound_type_init( &s_pType_com_sun_star_i18n_LineBreakUserOptions, typelib_TypeClass_STRUCT, "com.sun.star.i18n.LineBreakUserOptions", 0, 5,  aMemberRefs );
    }
    return * reinterpret_cast< const ::com::sun::star::uno::Type * >( &s_pType_com_sun_star_i18n_LineBreakUserOptions );
}

#endif // _COM_SUN_STAR_I18N_LINEBREAKUSEROPTIONS_HPP_
