#ifndef _COM_SUN_STAR_SETUP_COPYFILEACTION_HPP_
#define _COM_SUN_STAR_SETUP_COPYFILEACTION_HPP_

#ifndef _COM_SUN_STAR_SETUP_COPYFILEACTION_HDL_
#include <com/sun/star/setup/CopyFileAction.hdl>
#endif

#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif

#ifndef _COM_SUN_STAR_UNO_TYPE_HXX_
#include <com/sun/star/uno/Type.hxx>
#endif

#ifndef _COM_SUN_STAR_SETUP_BASEACTION_HPP_
#include <com/sun/star/setup/BaseAction.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_DATETIME_HPP_
#include <com/sun/star/util/DateTime.hpp>
#endif

namespace com
{
namespace sun
{
namespace star
{
namespace setup
{

inline CopyFileAction::CopyFileAction() SAL_THROW( () )
    : ::com::sun::star::setup::BaseAction()
    , strSourceFilename()
    , strDestinationFilename()
    , bUnoComponent(sal_False)
    , bOverwrite(sal_False)
    , aDateTime()
    , nRights((sal_Int32)0)
{
}

inline CopyFileAction::CopyFileAction(const ::com::sun::star::setup::ActionType& __eType, const sal_Bool& __bDone, const sal_Bool& __bProcess, const ::rtl::OUString& __strSourceFilename, const ::rtl::OUString& __strDestinationFilename, const sal_Bool& __bUnoComponent, const sal_Bool& __bOverwrite, const ::com::sun::star::util::DateTime& __aDateTime, const sal_Int32& __nRights) SAL_THROW( () )
    : ::com::sun::star::setup::BaseAction(__eType, __bDone, __bProcess)
    , strSourceFilename(__strSourceFilename)
    , strDestinationFilename(__strDestinationFilename)
    , bUnoComponent(__bUnoComponent)
    , bOverwrite(__bOverwrite)
    , aDateTime(__aDateTime)
    , nRights(__nRights)
{
}

} // setup
} // star
} // sun
} // com

#if ((defined(__SUNPRO_CC) && (__SUNPRO_CC == 0x500)) || (defined(__GNUC__) && defined(__APPLE__)))
static typelib_TypeDescriptionReference * s_pType_com_sun_star_setup_CopyFileAction = 0;
#endif

inline const ::com::sun::star::uno::Type& SAL_CALL getCppuType( const ::com::sun::star::setup::CopyFileAction* ) SAL_THROW( () )
{
    #if ! ((defined(__SUNPRO_CC) && (__SUNPRO_CC == 0x500)) || (defined(__GNUC__) && defined(__APPLE__)))
    static typelib_TypeDescriptionReference * s_pType_com_sun_star_setup_CopyFileAction = 0;
    #endif

    if ( !s_pType_com_sun_star_setup_CopyFileAction )
    {
        const ::com::sun::star::uno::Type& rBaseType = getCppuType( ( const ::com::sun::star::setup::BaseAction *)0 );

        typelib_TypeDescriptionReference * aMemberRefs[6];
        const ::com::sun::star::uno::Type& rMemberType_string = getCppuType( ( const ::rtl::OUString *)0 );
        aMemberRefs[0] = rMemberType_string.getTypeLibType();
        aMemberRefs[1] = rMemberType_string.getTypeLibType();
        const ::com::sun::star::uno::Type& rMemberType_boolean = getCppuType( ( const sal_Bool *)0 );
        aMemberRefs[2] = rMemberType_boolean.getTypeLibType();
        aMemberRefs[3] = rMemberType_boolean.getTypeLibType();
        const ::com::sun::star::uno::Type& rMemberType_com_sun_star_util_DateTime = getCppuType( ( const ::com::sun::star::util::DateTime *)0 );
        aMemberRefs[4] = rMemberType_com_sun_star_util_DateTime.getTypeLibType();
        const ::com::sun::star::uno::Type& rMemberType_long = getCppuType( ( const sal_Int32 *)0 );
        aMemberRefs[5] = rMemberType_long.getTypeLibType();

        typelib_static_compound_type_init( &s_pType_com_sun_star_setup_CopyFileAction, typelib_TypeClass_STRUCT, "com.sun.star.setup.CopyFileAction", rBaseType.getTypeLibType(), 6,  aMemberRefs );
    }
    return * reinterpret_cast< const ::com::sun::star::uno::Type * >( &s_pType_com_sun_star_setup_CopyFileAction );
}

#endif // _COM_SUN_STAR_SETUP_COPYFILEACTION_HPP_
