#ifndef _COM_SUN_STAR_UCB_LOCK_HPP_
#define _COM_SUN_STAR_UCB_LOCK_HPP_

#ifndef _COM_SUN_STAR_UCB_LOCK_HDL_
#include <com/sun/star/ucb/Lock.hdl>
#endif

#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif

#ifndef _COM_SUN_STAR_UNO_TYPE_HXX_
#include <com/sun/star/uno/Type.hxx>
#endif

#ifndef _COM_SUN_STAR_UNO_SEQUENCE_HXX_
#include <com/sun/star/uno/Sequence.hxx>
#endif
#ifndef _COM_SUN_STAR_UNO_ANY_HXX_
#include <com/sun/star/uno/Any.hxx>
#endif
#ifndef _COM_SUN_STAR_UCB_LOCKDEPTH_HPP_
#include <com/sun/star/ucb/LockDepth.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_LOCKENTRY_HPP_
#include <com/sun/star/ucb/LockEntry.hpp>
#endif

namespace com
{
namespace sun
{
namespace star
{
namespace ucb
{

inline Lock::Lock() SAL_THROW( () )
    : ::com::sun::star::ucb::LockEntry()
    , Depth(::com::sun::star::ucb::LockDepth_ZERO)
    , Owner()
    , Timeout((sal_Int64)0)
    , LockTokens()
{
}

inline Lock::Lock(const ::com::sun::star::ucb::LockScope& __Scope, const ::com::sun::star::ucb::LockType& __Type, const ::com::sun::star::ucb::LockDepth& __Depth, const ::com::sun::star::uno::Any& __Owner, const sal_Int64& __Timeout, const ::com::sun::star::uno::Sequence< ::rtl::OUString >& __LockTokens) SAL_THROW( () )
    : ::com::sun::star::ucb::LockEntry(__Scope, __Type)
    , Depth(__Depth)
    , Owner(__Owner)
    , Timeout(__Timeout)
    , LockTokens(__LockTokens)
{
}

} // ucb
} // star
} // sun
} // com

#if ((defined(__SUNPRO_CC) && (__SUNPRO_CC == 0x500)) || (defined(__GNUC__) && defined(__APPLE__)))
static typelib_TypeDescriptionReference * s_pType_com_sun_star_ucb_Lock = 0;
#endif

inline const ::com::sun::star::uno::Type& SAL_CALL getCppuType( const ::com::sun::star::ucb::Lock* ) SAL_THROW( () )
{
    #if ! ((defined(__SUNPRO_CC) && (__SUNPRO_CC == 0x500)) || (defined(__GNUC__) && defined(__APPLE__)))
    static typelib_TypeDescriptionReference * s_pType_com_sun_star_ucb_Lock = 0;
    #endif

    if ( !s_pType_com_sun_star_ucb_Lock )
    {
        const ::com::sun::star::uno::Type& rBaseType = getCppuType( ( const ::com::sun::star::ucb::LockEntry *)0 );

        typelib_TypeDescriptionReference * aMemberRefs[4];
        const ::com::sun::star::uno::Type& rMemberType_com_sun_star_ucb_LockDepth = getCppuType( ( const ::com::sun::star::ucb::LockDepth *)0 );
        aMemberRefs[0] = rMemberType_com_sun_star_ucb_LockDepth.getTypeLibType();
        const ::com::sun::star::uno::Type& rMemberType_any = getCppuType( ( const ::com::sun::star::uno::Any *)0 );
        aMemberRefs[1] = rMemberType_any.getTypeLibType();
        const ::com::sun::star::uno::Type& rMemberType_hyper = getCppuType( ( const sal_Int64 *)0 );
        aMemberRefs[2] = rMemberType_hyper.getTypeLibType();
        const ::com::sun::star::uno::Type& rMemberType_seq_string = getCppuType( ( const ::com::sun::star::uno::Sequence< ::rtl::OUString > *)0 );
        aMemberRefs[3] = rMemberType_seq_string.getTypeLibType();

        typelib_static_compound_type_init( &s_pType_com_sun_star_ucb_Lock, typelib_TypeClass_STRUCT, "com.sun.star.ucb.Lock", rBaseType.getTypeLibType(), 4,  aMemberRefs );
    }
    return * reinterpret_cast< const ::com::sun::star::uno::Type * >( &s_pType_com_sun_star_ucb_Lock );
}

#endif // _COM_SUN_STAR_UCB_LOCK_HPP_
