
#ifndef _CONNECTIVITY_COMMONTOOLS_HXX_
#define _CONNECTIVITY_COMMONTOOLS_HXX_

#ifndef _RTL_USTRING_
#include <rtl/ustring>
#endif
#ifndef _COM_SUN_STAR_UNO_ANY_HXX_
#include <com/sun/star/uno/Any.hxx>
#endif
#ifndef _VECTOR_
#include <vector>
#endif
#ifndef _CPPUHELPER_WEAKREF_HXX_
#include <cppuhelper/weakref.hxx>
#endif
#ifndef _COMPHELPER_STLTYPES_HXX_
#include <comphelper/stl_types.hxx>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBCX_XCOLUMNSSUPPLIER_HPP_
#include <com/sun/star/sdbcx/XColumnsSupplier.hpp>
#endif
#ifndef _OSL_INTERLOCK_H_
#include <osl/interlck.h>
#endif

#ifdef _MSC_VER
#ifndef SAL_NO_VTABLE
#define SAL_NO_VTABLE __declspec(novtable)
#endif
#else
#define SAL_NO_VTABLE
#endif

namespace com { namespace sun { namespace star { namespace util { 
	struct Date;
	struct DateTime;
	struct Time;
}
	namespace lang {
		class DisposedException;
	}
}}}

namespace connectivity
{

	sal_Bool match(const sal_Unicode* pWild, const sal_Unicode* pStr, const sal_Unicode cEscape);

	rtl::OUString toString(const ::com::sun::star::uno::Any& rValue);
	rtl::OUString toDateString(const ::com::sun::star::util::Date& rDate);
	rtl::OUString toTimeString(const ::com::sun::star::util::Time& rTime);
	rtl::OUString toDateTimeString(const ::com::sun::star::util::DateTime& rDateTime);

	typedef std::vector< ::com::sun::star::uno::WeakReferenceHelper > OWeakRefArray;
	typedef ::com::sun::star::uno::Reference< ::com::sun::star::sdbcx::XColumnsSupplier>	OSQLTable;

	DECLARE_STL_MAP(::rtl::OUString,OSQLTable,comphelper::UStringMixLess,  OSQLTables);

	template< class VectorVal > class ORefVector : public ::std::vector< VectorVal >
	{
		oslInterlockedCount			m_refCount;
	protected:
		virtual	~ORefVector(){}
	public:
		ORefVector() : m_refCount(0) {}
		ORefVector(size_t _st) : ::std::vector< VectorVal > (_st) , m_refCount(0) {}

		inline static void * SAL_CALL operator new( size_t nSize ) SAL_THROW( () )
			{ return ::rtl_allocateMemory( nSize ); }
		inline static void * SAL_CALL operator new( size_t nSize,const void* _pHint ) SAL_THROW( () )
			{ return _pHint; }
		inline static void SAL_CALL operator delete( void * pMem ) SAL_THROW( () )
			{ ::rtl_freeMemory( pMem ); }
		inline static void SAL_CALL operator delete( void * pMem,const void* _pHint ) SAL_THROW( () )
			{  }

		void acquire()
		{
			osl_incrementInterlockedCount( &m_refCount );
		}
		void release()
		{
			if (! osl_decrementInterlockedCount( &m_refCount ))
	delete this;
		}

	};

	template< class VectorVal > class ORowVector : public  ORefVector< VectorVal >
	{
	public:
		ORowVector() : ORefVector< VectorVal >(1){}
		ORowVector(size_t _st) : ORefVector< VectorVal >(_st+1)
			{}
	};

	typedef ORefVector< ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet> > OSQLColumns;

	OSQLColumns::const_iterator find(	OSQLColumns::const_iterator __first,
							OSQLColumns::const_iterator __last,
							const ::rtl::OUString& _rVal,
							const ::comphelper::UStringMixEqual& _rCase);

	OSQLColumns::const_iterator findRealName(	OSQLColumns::const_iterator __first,
									OSQLColumns::const_iterator __last,
									const ::rtl::OUString& _rVal,
									const ::comphelper::UStringMixEqual& _rCase);

	OSQLColumns::const_iterator find(	OSQLColumns::const_iterator __first,
							OSQLColumns::const_iterator __last,
							const ::rtl::OUString& _rProp,
							const ::rtl::OUString& _rVal,
							const ::comphelper::UStringMixEqual& _rCase);

	void checkDisposed(sal_Bool _bThrow) throw ( ::com::sun::star::lang::DisposedException );
}

#define DECLARE_SERVICE_INFO()	\
	virtual ::rtl::OUString SAL_CALL getImplementationName(  ) throw (::com::sun::star::uno::RuntimeException);	\
	virtual sal_Bool SAL_CALL supportsService( const ::rtl::OUString& ServiceName ) throw(::com::sun::star::uno::RuntimeException);	\
	virtual ::com::sun::star::uno::Sequence< ::rtl::OUString > SAL_CALL getSupportedServiceNames(  ) throw(::com::sun::star::uno::RuntimeException)	\

#define IMPLEMENT_SERVICE_INFO(classname, implasciiname, serviceasciiname)	\
	::rtl::OUString SAL_CALL classname::getImplementationName(  ) throw (::com::sun::star::uno::RuntimeException)	\
	{	\
		return ::rtl::OUString::createFromAscii(implasciiname);	\
	}	\
	::com::sun::star::uno::Sequence< ::rtl::OUString > SAL_CALL classname::getSupportedServiceNames(  ) throw(::com::sun::star::uno::RuntimeException)	\
	{	\
		::com::sun::star::uno::Sequence< ::rtl::OUString > aSupported(1);	\
		aSupported[0] = ::rtl::OUString::createFromAscii(serviceasciiname);	\
		return aSupported;	\
	}	\
	sal_Bool SAL_CALL classname::supportsService( const ::rtl::OUString& _rServiceName ) throw(::com::sun::star::uno::RuntimeException)	\
	{	\
		Sequence< ::rtl::OUString > aSupported(getSupportedServiceNames());				\
		const ::rtl::OUString* pSupported = aSupported.getConstArray();					\
		const ::rtl::OUString* pEnd = pSupported + aSupported.getLength();				\
		for (;pSupported != pEnd && !pSupported->equals(_rServiceName); ++pSupported)	\
			;																			\
																			\
		return pSupported != pEnd;														\
	}	\

#endif 

