

#ifndef _DBHELPER_DBCONVERSION_HXX_
#define _DBHELPER_DBCONVERSION_HXX_

#ifndef _COM_SUN_STAR_UTIL_DATE_HPP_
#include <com/sun/star/util/Date.hpp>
#endif
#ifndef _COM_SUN_STAR_UNO_REFERENCE_HXX_
#include <com/sun/star/uno/Reference.hxx>
#endif

namespace rtl
{
	class OUString;
}
namespace com
{
	namespace sun
	{
		namespace star
		{
			namespace lang
			{
	class IllegalArgumentException;
	struct Locale;
			}
			namespace sdb
			{
	class XColumn;
	class XColumnUpdate;
			}
			namespace beans
			{
	class XPropertySet;
			}
			namespace util
			{
	class XNumberFormatter;
	class XNumberFormatsSupplier;
	struct Time;
	struct DateTime;
			}
			namespace script
			{
	class XTypeConverter;
			}
		}
	}
}

namespace dbtools
{

	class DBTypeConversion
	{
	public:
		static ::com::sun::star::util::Date getStandardDate();
		static void setValue(const ::com::sun::star::uno::Reference< ::com::sun::star::sdb::XColumnUpdate>& xVariant,
						const ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatter>& xFormatter,
						const ::com::sun::star::util::Date& rNullDate,
						const ::rtl::OUString& rString,
						sal_Int32 nKey,
						sal_Int16 nFieldType,
						sal_Int16 nKeyType) throw(::com::sun::star::lang::IllegalArgumentException);

		static void setValue(const ::com::sun::star::uno::Reference< ::com::sun::star::sdb::XColumnUpdate>& xVariant,
				 const ::com::sun::star::util::Date& rNullDate,
				 const double& rValue,
				 sal_Int16 nKeyType) throw(::com::sun::star::lang::IllegalArgumentException);

		static double getValue(const ::com::sun::star::uno::Reference< ::com::sun::star::sdb::XColumn>& xVariant, const ::com::sun::star::util::Date& rNullDate,
						sal_Int16 nKeyType);

		static ::rtl::OUString getValue(const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet>& _xColumn,
							const ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatter>& xFormatter,
							const ::com::sun::star::lang::Locale& _rLocale,
							const ::com::sun::star::util::Date& rNullDate);

		static ::rtl::OUString getValue(const ::com::sun::star::uno::Reference< ::com::sun::star::sdb::XColumn>& _xColumn,
							const ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatter>& xFormatter,
							const ::com::sun::star::util::Date& rNullDate,
							sal_Int32 nKey,
							sal_Int16 nKeyType);

		static ::com::sun::star::util::Date		toDate(double dVal, const ::com::sun::star::util::Date& _rNullDate = getStandardDate());
		static ::com::sun::star::util::Time		toTime(double dVal);
		static ::com::sun::star::util::DateTime	toDateTime(double dVal, const ::com::sun::star::util::Date& _rNullDate = getStandardDate());

		static sal_Int64 toINT64(const ::com::sun::star::util::DateTime& rVal);
		static sal_Int32 getMsFromTime(const ::com::sun::star::util::Time& rVal);

		static sal_Int32 toDays(const ::com::sun::star::util::Date& _rVal, const ::com::sun::star::util::Date& _rNullDate = getStandardDate());

		static double	toDouble(const ::com::sun::star::util::Date& rVal, const ::com::sun::star::util::Date& _rNullDate = getStandardDate());
		static double	toDouble(const ::com::sun::star::util::Time& rVal);
		static double	toDouble(const ::com::sun::star::util::DateTime& rVal, const ::com::sun::star::util::Date& _rNullDate = getStandardDate());

		static sal_Int32	toINT32(const ::com::sun::star::util::Date& rVal);
		static sal_Int32	toINT32(const ::com::sun::star::util::Time& rVal);

		static ::com::sun::star::util::Date	toDate(sal_Int32 _nVal);
		static ::com::sun::star::util::Time	toTime(sal_Int32 _nVal);

		static double toStandardDbDate(const ::com::sun::star::util::Date& _rNullDate, double _rVal) { return _rVal + toDays(_rNullDate); }

		static double toNullDate(const ::com::sun::star::util::Date& _rNullDate, double _rVal) { return _rVal - toDays(_rNullDate); }

		static ::com::sun::star::util::Date getNULLDate(const ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatsSupplier > &xSupplier);

		static ::rtl::OUString toDateString(const ::com::sun::star::util::Date& rDate);

		static ::rtl::OUString toTimeString(const ::com::sun::star::util::Time& rTime);

		static ::rtl::OUString toDateTimeString(const ::com::sun::star::util::DateTime& _rDateTime);

		::rtl::OUString toSQLString(sal_Int32 eType, const ::com::sun::star::uno::Any& _rVal, sal_Bool bQuote,
			const ::com::sun::star::uno::Reference< ::com::sun::star::script::XTypeConverter >&  _rxTypeConverter);
	};

}	

#endif 

