

#ifndef _CONNECTIVITY_SDBCX_KEY_HXX_
#define _CONNECTIVITY_SDBCX_KEY_HXX_

#ifndef COMPHELPER_IDPROPERTYARRAYUSAGEHELPER_HXX
#include <comphelper/IdPropArrayHelper.hxx>
#endif
#ifndef _CONNECTIVITY_COMMONTOOLS_HXX_
#include "connectivity/CommonTools.hxx"
#endif
#ifndef _COMPHELPER_BROADCASTHELPER_HXX_
#include <comphelper/broadcasthelper.hxx>
#endif
#ifndef _CONNECTIVITY_SDBCX_TYPEDEF_HXX_
#include "connectivity/sdbcx/VTypeDef.hxx"
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XNAMED_HPP_
#include <com/sun/star/container/XNamed.hpp>
#endif
#ifndef _CONNECTIVITY_SDBCX_IREFRESHABLE_HXX_
#include "connectivity/sdbcx/IRefreshable.hxx"
#endif
#ifndef _CONNECTIVITY_SDBCX_DESCRIPTOR_HXX_
#include "connectivity/sdbcx/VDescriptor.hxx"
#endif
#ifndef _CPPUHELPER_IMPLBASE1_HXX_
#include <cppuhelper/implbase1.hxx>
#endif
#ifndef _COM_SUN_STAR_SDBCX_XDATADESCRIPTORFACTORY_HPP_
#include <com/sun/star/sdbcx/XDataDescriptorFactory.hpp>
#endif

namespace connectivity
{
	namespace sdbcx
	{

		typedef ::cppu::ImplHelper1< ::com::sun::star::sdbcx::XDataDescriptorFactory > OKey_BASE;
		class OCollection;

		class OKey :			public comphelper::OBaseMutex,
					public ODescriptor_BASE,
					public IRefreshableColumns,
					public ::comphelper::OIdPropertyArrayUsageHelper<OKey>,
					public ODescriptor,
					public OKey_BASE
		{
		protected:
			::rtl::OUString m_ReferencedTable;
			sal_Int32		m_Type;
			sal_Int32		m_UpdateRule;
			sal_Int32		m_DeleteRule;
	OCollection*	m_pColumns;
	using ODescriptor_BASE::rBHelper;
	virtual ::cppu::IPropertyArrayHelper* createArrayHelper( sal_Int32 _nId) const;
	virtual ::cppu::IPropertyArrayHelper & SAL_CALL getInfoHelper();
		public:
			OKey(sal_Bool _bCase);
			OKey(	const ::rtl::OUString& _Name,
		const ::rtl::OUString& _ReferencedTable,
		sal_Int32		_Type,
		sal_Int32		_UpdateRule,
		sal_Int32		_DeleteRule,
		sal_Bool _bCase);
	virtual ~OKey( );
	DECLARE_SERVICE_INFO();
	         virtual ::com::sun::star::uno::Any SAL_CALL queryInterface( const ::com::sun::star::uno::Type & rType ) throw(::com::sun::star::uno::RuntimeException);
			virtual void SAL_CALL acquire() throw(::com::sun::star::uno::RuntimeException);
			virtual void SAL_CALL release() throw(::com::sun::star::uno::RuntimeException);
	         virtual ::com::sun::star::uno::Sequence< ::com::sun::star::uno::Type > SAL_CALL getTypes(  ) throw(::com::sun::star::uno::RuntimeException);
	virtual void construct();
	virtual void SAL_CALL disposing();
	         virtual ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySetInfo > SAL_CALL getPropertySetInfo(  ) throw(::com::sun::star::uno::RuntimeException);
	         virtual ::com::sun::star::uno::Reference< ::com::sun::star::container::XNameAccess > SAL_CALL getColumns(  ) throw(::com::sun::star::uno::RuntimeException);
	virtual ::rtl::OUString SAL_CALL getName(  ) throw(::com::sun::star::uno::RuntimeException);
	        virtual void SAL_CALL setName( const ::rtl::OUString& aName ) throw(::com::sun::star::uno::RuntimeException);
	         virtual ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > SAL_CALL createDataDescriptor(  ) throw(::com::sun::star::uno::RuntimeException);
		};
	}
}

#endif 

