

#ifndef _CONNECTIVITY_SDBCX_KEYCOLUMN_HXX_
#define _CONNECTIVITY_SDBCX_KEYCOLUMN_HXX_

#ifndef _CONNECTIVITY_SDBCX_COLUMN_HXX_
#include "connectivity/sdbcx/VColumn.hxx"
#endif

namespace connectivity
{
	namespace sdbcx
	{
		class OKeyColumn;
		typedef ::comphelper::OIdPropertyArrayUsageHelper<OKeyColumn> OKeyColumn_PROP;

		class OKeyColumn :	public OColumn,
				public OKeyColumn_PROP
		{
		protected:
			::rtl::OUString	m_ReferencedColumn;
			virtual ::cppu::IPropertyArrayHelper* createArrayHelper( sal_Int32 _nId) const;
			virtual ::cppu::IPropertyArrayHelper& SAL_CALL getInfoHelper();
		public:
			OKeyColumn(sal_Bool _bCase);
			OKeyColumn(	const ::rtl::OUString& _ReferencedColumn,
				const ::rtl::OUString& _Name,
				const ::rtl::OUString& _TypeName,
				const ::rtl::OUString& _DefaultValue,
				sal_Int32		_IsNullable,
				sal_Int32		_Precision,
				sal_Int32		_Scale,
				sal_Int32		_Type,
				sal_Bool		_IsAutoIncrement,
				sal_Bool		_IsRowVersion,
				sal_Bool		_IsCurrency,
				sal_Bool		_bCase);
	virtual ~OKeyColumn();
	virtual void construct();
			DECLARE_SERVICE_INFO();
		};
	}
}
#endif 

