

#ifndef CONNECTIVITY_VIRTUAL_DBTOOLS_HXX
#define CONNECTIVITY_VIRTUAL_DBTOOLS_HXX

#ifndef _RTL_REF_HXX_
#include <rtl/ref.hxx>
#endif
#ifndef _RTL_USTRING_HXX_
#include <rtl/ustring.hxx>
#endif
#ifndef _COM_SUN_STAR_UNO_REFERENCE_HXX_
#include <com/sun/star/uno/Reference.hxx>
#endif
#ifndef _COM_SUN_STAR_UTIL_DATE_HPP_
#include <com/sun/star/util/Date.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBC_SQLEXCEPTION_HPP_
#include <com/sun/star/sdbc/SQLException.hpp>
#endif

namespace com {
	namespace sun {
		namespace star {
			namespace util {
	class XNumberFormatter;
	class XNumberFormatsSupplier;
			}
			namespace beans {
	class XPropertySet;
			}
			namespace lang {
	class XMultiServiceFactory;
	struct Locale;
			}
			namespace sdbc {
	class XDatabaseMetaData;
	class XConnection;
	class XRowSet;
			}
			namespace sdb {
	class XColumn;
	class SQLContext;
			}
		}
	}
}

extern "C" void* SAL_CALL createDataAccessToolsFactory();

namespace connectivity
{

	class OParseContext;

	namespace simple
	{

		typedef void* (SAL_CALL * createDataAccessToolsFactoryFunction)( );

		class IDataAccessTools : public ::rtl::IReference
		{
		public:
			virtual ::com::sun::star::uno::Reference< ::com::sun::star::sdbc::XConnection> getConnection_withFeedback(
	const ::rtl::OUString& _rDataSourceName,
	const ::rtl::OUString& _rUser,
	const ::rtl::OUString& _rPwd,
	const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory>& _rxFactory
			) const SAL_THROW ( (::com::sun::star::sdbc::SQLException) ) = 0;
	virtual ::com::sun::star::uno::Reference< ::com::sun::star::sdbc::XConnection> calcConnection(
	const ::com::sun::star::uno::Reference< ::com::sun::star::sdbc::XRowSet>& _rxRowSet,
	const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory>& _rxFactory
			) const SAL_THROW ( (::com::sun::star::sdbc::SQLException, ::com::sun::star::uno::RuntimeException) ) = 0;
	virtual ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatsSupplier> getNumberFormats(
	const ::com::sun::star::uno::Reference< ::com::sun::star::sdbc::XConnection>& _rxConn,
	sal_Bool _bAllowDefault
			) const = 0;
	virtual void TransferFormComponentProperties(
	const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet>& _rxOld,
	const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet>& _rxNew,
	const ::com::sun::star::lang::Locale& _rLocale
			) const = 0;
	virtual ::rtl::OUString quoteName(
	const ::rtl::OUString& _rQuote,
	const ::rtl::OUString& _rName
			) const = 0;
	virtual ::rtl::OUString quoteTableName(
	const ::com::sun::star::uno::Reference< ::com::sun::star::sdbc::XDatabaseMetaData>& _rxMeta,
	const ::rtl::OUString& _rName
			) const = 0;
	virtual ::com::sun::star::sdb::SQLContext prependContextInfo(
	::com::sun::star::sdbc::SQLException& _rException,
	const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >& _rxContext,
	const ::rtl::OUString& _rContextDescription,
	const ::rtl::OUString& _rContextDetails
			) const = 0;
		};

		class IDataAccessTypeConversion : public ::rtl::IReference
		{
		public:
			virtual ::com::sun::star::util::Date getStandardDate() const = 0;
	virtual double getValue(
	const ::com::sun::star::uno::Reference< ::com::sun::star::sdb::XColumn>& _rxVariant,
	const ::com::sun::star::util::Date& rNullDate,
	sal_Int16 nKeyType) const = 0;
	virtual ::rtl::OUString getValue(
	const ::com::sun::star::uno::Reference< ::com::sun::star::sdb::XColumn >& _rxColumn,
	const ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatter >& _rxFormatter,
	const ::com::sun::star::util::Date& _rNullDate,
	sal_Int32 _nKey,
	sal_Int16 _nKeyType) const = 0;
		};

		class ISQLParseNode : public ::rtl::IReference
		{
		public:
			virtual void parseNodeToStr(::rtl::OUString& _rString,
	const ::com::sun::star::uno::Reference< ::com::sun::star::sdbc::XDatabaseMetaData >& _rxMeta
			) const = 0;
	virtual void parseNodeToPredicateStr(::rtl::OUString& _rString,
	const ::com::sun::star::uno::Reference< ::com::sun::star::sdbc::XDatabaseMetaData >& _rxMeta,
	const ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatter >& _rxFormatter,
	const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >& _rxField,
	const ::com::sun::star::lang::Locale& _rIntl,
	const sal_Char _cDecSeparator
			) const = 0;
		};

		class ISQLParser : public ::rtl::IReference
		{
		public:
			virtual ::rtl::Reference< ISQLParseNode > predicateTree(
	::rtl::OUString& rErrorMessage,
	const ::rtl::OUString& rStatement,
	const ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatter >& _rxFormatter,
	const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >& _rxField
			) const = 0;
	virtual const OParseContext& getContext() const = 0;
		};

		class IDataAccessToolsFactory : public ::rtl::IReference
		{
		public:
	virtual ::rtl::Reference< ISQLParser > createSQLParser(
	const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory >& _rxServiceFactory
	) const = 0;
	virtual ::rtl::Reference< IDataAccessTypeConversion > getTypeConversionHelper() = 0;
	virtual ::rtl::Reference< IDataAccessTools > getDataAccessTools() = 0;
		};

	}	

}	

#endif 

