

#ifndef _B2D_MBMP_HXX
#define _B2D_MBMP_HXX

#ifndef _B2D_MBASE_HXX
#include <goodies/b2dmbase.hxx>
#endif

class B2dIAOBitmapObj : public B2dIAObject
{

	Bitmap						aBmp;

	UINT16						nCenterX;
	UINT16						nCenterY;

	unsigned					bUseTransCol : 1;

	virtual void CreateGeometry();

	virtual void CreateBaseRect();

public:
	TYPEINFO();
	B2dIAOBitmapObj(B2dIAOManager* pMan, Point aPos, const Bitmap& rBmp, 
		UINT16 nCenX = 0, UINT16 nCenY = 0, BOOL bUseTransCol = FALSE, 
		Color aTransCol = Color(COL_WHITE));
	virtual ~B2dIAOBitmapObj();

	const Bitmap& GetBitmap() const { return aBmp; }
	void SetBitmap(const Bitmap& rNew);

	BOOL IsTransparenceUsed() const { return bUseTransCol; }
	void SetTransparenceUsed(BOOL bNew);

	UINT16 GetCenterX() const { return nCenterX; }
	UINT16 GetCenterY() const { return nCenterY; }
	void SetCenterXY(UINT16 nNewX, UINT16 nNewY);
};

class B2dIAOBitmapEx : public B2dIAObject
{

	BitmapEx					aBmpEx;

	UINT16						nCenterX;
	UINT16						nCenterY;

	virtual void CreateGeometry();

	virtual void CreateBaseRect();

public:
	TYPEINFO();
	B2dIAOBitmapEx(B2dIAOManager* pMan, Point aPos, const BitmapEx& rBmpEx,
		UINT16 nCenX = 0, UINT16 nCenY = 0);
	virtual ~B2dIAOBitmapEx();

	const BitmapEx& GetBitmapEx() const { return aBmpEx; }
	void SetBitmapEx(const BitmapEx& rNew);

	UINT16 GetCenterX() const { return nCenterX; }
	UINT16 GetCenterY() const { return nCenterY; }
	void SetCenterXY(UINT16 nNewX, UINT16 nNewY);
};

class B2dIAOBitmapExReference : public B2dIAObject
{

	BitmapEx*					pBmpEx;

	UINT16						nCenterX;
	UINT16						nCenterY;

	virtual void CreateGeometry();

	virtual void CreateBaseRect();

public:
	TYPEINFO();
	B2dIAOBitmapExReference(B2dIAOManager* pMan, Point aPos, BitmapEx* pBEx,
		UINT16 nCenX = 0, UINT16 nCenY = 0);
	virtual ~B2dIAOBitmapExReference();

	const BitmapEx* GetBitmapEx() const { return pBmpEx; }
	void SetBitmapEx(BitmapEx* pNew);

	UINT16 GetCenterX() const { return nCenterX; }
	UINT16 GetCenterY() const { return nCenterY; }
	void SetCenterXY(UINT16 nNewX, UINT16 nNewY);
};

#endif          
