

#ifndef _B2D_MLINE_HXX
#define _B2D_MLINE_HXX

#ifndef _B2D_MBASE_HXX
#include <goodies/b2dmbase.hxx>
#endif

#include <stdlib.h>

class B2dIAOLine : public B2dIAObject
{

	B2dPositionEntity			a2ndPosition;

	virtual void CreateGeometry();

	virtual void CreateBaseRect();

protected:

	const Point& Get2ndPositionPixel() const { return a2ndPosition.GetPositionPixel(); }

public:
	TYPEINFO();
	B2dIAOLine(B2dIAOManager* pMan, Point aStartPos, Point aEndPos);
	virtual ~B2dIAOLine();

	const Point& Get2ndPosition() const { return a2ndPosition.GetPosition(); }
	void Set2ndPosition(Point aNew);

	virtual BOOL IsHit(const Point& rPixelPos, UINT16 nTol = 0) const;
};

class B2dIAOLineStriped : public B2dIAOLine
{

	UINT16						nStripeLen;

protected:
	virtual BOOL AddLinePixel(const Point& rPos, UINT32 nPixelNum);

public:
	TYPEINFO();
	B2dIAOLineStriped(B2dIAOManager* pMan, Point aStartPos, Point aEndPos, UINT16 nSLen = 4);
	virtual ~B2dIAOLineStriped();

	UINT16 GetStripeLength() const { return nStripeLen; }
	void SetStripeLength(UINT16 nNew);
};

class B2dIAOLineTwoColor : public B2dIAOLineStriped
{

	Color						a2ndColor;

protected:
	virtual BOOL AddLinePixel(const Point& rPos, UINT32 nPixelNum);

public:
	TYPEINFO();
	B2dIAOLineTwoColor(B2dIAOManager* pMan, Point aStartPos, Point aEndPos, UINT16 nSLen = 4);
	virtual ~B2dIAOLineTwoColor();

	const Color& Get2ndColor() const { return a2ndColor; }
	void Set2ndColor(Color aNew);
};

class B2dIAOLineTwoColorAnim : public B2dIAOLineTwoColor
{

	UINT16						nStartCount;
	UINT16						nStartAdd;

	virtual void AnimationStep(UINT32 nAnimCounter);

protected:
	virtual BOOL AddLinePixel(const Point& rPos, UINT32 nPixelNum);

public:
	TYPEINFO();
	B2dIAOLineTwoColorAnim(B2dIAOManager* pMan, Point aStartPos, Point aEndPos, UINT16 nSLen = 4);
	virtual ~B2dIAOLineTwoColorAnim();
};

#endif          
