

#ifndef _B2D_MPNT_HXX
#define _B2D_MPNT_HXX

#ifndef _B2D_MBASE_HXX
#include <goodies/b2dmbase.hxx>
#endif

enum B2dIAOMarkerKind
{
	B2D_IAO_MARKER_POINT,
	B2D_IAO_MARKER_PLUS,
	B2D_IAO_MARKER_CROSS,

	B2D_IAO_MARKER_RECT_3X3,
	B2D_IAO_MARKER_RECT_5X5,
	B2D_IAO_MARKER_RECT_7X7,
	B2D_IAO_MARKER_RECT_9X9,

	B2D_IAO_MARKER_CIRCLE_3X3,
	B2D_IAO_MARKER_CIRCLE_5X5,
	B2D_IAO_MARKER_CIRCLE_7X7,
	B2D_IAO_MARKER_CIRCLE_9X9,

	B2D_IAO_MARKER_ELLIPSE_5X3,
	B2D_IAO_MARKER_ELLIPSE_7X5,
	B2D_IAO_MARKER_ELLIPSE_9X7,

	B2D_IAO_MARKER_ELLIPSE_3X5,
	B2D_IAO_MARKER_ELLIPSE_5X7,
	B2D_IAO_MARKER_ELLIPSE_7X9,

	B2D_IAO_MARKER_CROSSHAIR_3X3,
	B2D_IAO_MARKER_CROSSHAIR_5X5,
	B2D_IAO_MARKER_CROSSHAIR_7X7,
	B2D_IAO_MARKER_CROSSHAIR_9X9
};

class B2dIAOMarker : public B2dIAObject
{

	Color						a2ndColor;

	B2dIAOMarkerKind			eMarkerKind;

	virtual void CreateGeometry();

	virtual void CreateBaseRect();

	void CreateGeometryFromMarkerData(BYTE* pData);
	void CreateBaseRectFromMarkerData(BYTE* pData);
	BOOL DoHitTestWithMarkerData(BYTE* pData, const Point& rPixelPos, UINT16 nTol);

public:
	TYPEINFO();
	B2dIAOMarker(B2dIAOManager* pMan, Point aPos, B2dIAOMarkerKind eKind = B2D_IAO_MARKER_POINT);
	virtual ~B2dIAOMarker();

	const Color& Get2ndColor() const { return a2ndColor; }
	void Set2ndColor(Color aNew);

	B2dIAOMarkerKind GetKind() const { return eMarkerKind; }
	void SetMarkerKind(B2dIAOMarkerKind eNew);

	virtual BOOL IsHit(const Point& rPixelPos, UINT16 nTol = 0);
};

#endif          
