

#ifndef _B2D_MTRI_HXX
#define _B2D_MTRI_HXX

#ifndef _B2D_MBASE_HXX
#include <goodies/b2dmbase.hxx>
#endif

class B2dIAOTriangle : public B2dIAObject
{

	B2dPositionEntity			a2ndPosition;
	B2dPositionEntity			a3rdPosition;

	virtual void CreateGeometry();

	virtual void CreateBaseRect();

	BOOL SimpleCrossTestCut(const Point& rPos, const Point& rStart, const Point& rEnd) const;

protected:

	const Point& Get2ndPositionPixel() const { return a2ndPosition.GetPositionPixel(); }
	const Point& Get3rdPositionPixel() const { return a3rdPosition.GetPositionPixel(); }

public:
	TYPEINFO();
	B2dIAOTriangle(B2dIAOManager* pMan, Point aEdge1, Point aEdge2, Point aEdge3, Color aCol = Color(COL_WHITE));
	virtual ~B2dIAOTriangle();

	const Point& Get2ndPosition() const { return a2ndPosition.GetPosition(); }
	const Point& Get3rdPosition() const { return a3rdPosition.GetPosition(); }
	void Set2ndPosition(Point aNew);
	void Set3rdPosition(Point aNew);

	virtual BOOL IsHit(const Point& rPixelPos, UINT16 nTol = 0) const;
};

class B2dIAOBitmapTriangle : public B2dIAOTriangle
{

	BitmapEx					aBmpEx;

	BitmapWriteAccess*			aBmpWrite;
	BitmapWriteAccess*			aMaskWrite;

	Point						aTopLeft;

	virtual void CreateGeometry();

protected:

	virtual BOOL AddTrianglePixel(const Point& rPos);

public:
	TYPEINFO();
	B2dIAOBitmapTriangle(B2dIAOManager* pMan, Point aEdge1, Point aEdge2, Point aEdge3, Color aCol = Color(COL_WHITE));
	virtual ~B2dIAOBitmapTriangle();
};

#endif          
