
#ifndef _MAILBOOK_HXX
#define _MAILBOOK_HXX

#ifndef _STRING_HXX 
#include <tools/string.hxx>
#endif

class MailAddressList;
struct AddressBookImpl;

enum MailAddressLocation
{
	MAIL_LOCATION_UNKNOWN = 0,
	MAIL_LOCATION_LOCAL,
	MAIL_LOCATION_DIALIN,
	MAIL_LOCATION_POSTOFFICE
};

struct MailAddress
{
	String				aName;
	String				aAddress;
	String				aComment;
	MailAddressLocation	eLocation;
};

#define DIRECTORY			((USHORT)1)
#define PUBLIC_MAIL_LIST	((USHORT)2)
#define PRIVATE_MAIL_LIST	((USHORT)3)

class MailAddressBook
{
private:
	AddressBookImpl*	pImpl;

public:
			MailAddressBook();
			MailAddressBook( const MailAddressBook &rBook );
	MailAddressBook&	operator =( const MailAddressBook &rBook );
			~MailAddressBook();

	USHORT				GetAddressCount();
	String				GetName( USHORT nNo );
	String				GetAddress( USHORT nNo );
	MailAddressLocation GetLocation( USHORT nNo );
	void				SetAddressList( const MailAddressList& rList );
};

#endif

