
#ifndef _MAILLOG_HXX
#define _MAILLOG_HXX

#ifndef _EDIT_HXX 
#include <vcl/edit.hxx>
#endif
#ifndef _DIALOG_HXX 
#include <vcl/dialog.hxx>
#endif
#ifndef _BUTTON_HXX 
#include <vcl/button.hxx>
#endif
#ifndef _FIXED_HXX 
#include <vcl/fixed.hxx>
#endif
#ifndef _STDCTRL_HXX 
#include <svtools/stdctrl.hxx>
#endif
#ifndef _GROUP_HXX 
#include <vcl/group.hxx>
#endif

#include <goodies/mailenum.hxx>

class MailSystem;

#define HIDE_PATH       	0x01	
#define HIDE_NAME       	0x02	
#define HIDE_PASSWD     	0x04	
#define HIDE_SAVE_PASSWD	0x08	
#define HIDE_ERROR_TEXT		0x10	

class MailLoginDialog : public ModalDialog
{
private:
	FixedInfo		aErrorText;
	GroupBox		aErrorBox;
	FixedText		aPathText;
	Edit			aPathEdit;
	FixedText		aNameText;
	Edit			aNameEdit;
	FixedText		aPasswordText;
	Edit			aPasswordEdit;
	CheckBox		aSavePasswdBtn;
	GroupBox		aLoginGroup;
	OKButton		aOKBtn;
	CancelButton	aCancelBtn;
	HelpButton		aHelpBtn;

	MailDriver		eDriver;

	DECL_LINK( OKHdl, Button * );

public:
	MailLoginDialog( Window* pParent, ResMgr* pResMgr, const String& rText );
	MailLoginDialog( Window* pParent, const MailSystem& rSys,
		 MailDriver eDrive, const String& rTxt );

	String			GetPath() const { return aPathEdit.GetText(); }
	void			SetPath( const String& rNewPath )
			{ aPathEdit.SetText( rNewPath ); }
	String			GetName() const { return aNameEdit.GetText(); }
	void			SetName( const String& rNewName )
			{ aNameEdit.SetText( rNewName ); }
	String			GetPassword() const { return aPasswordEdit.GetText(); }
	void			SetPassword( const String& rNew )
			{ aPasswordEdit.SetText( rNew ); }
	BOOL			IsSavePassword() const
			{ return aSavePasswdBtn.IsChecked(); }
	void			SetSavePassword( BOOL bSave )
			{ aSavePasswdBtn.Check( bSave ); }
	void			SetSavePasswordText( const String& rTxt )
			{ aSavePasswdBtn.SetText( rTxt ); }
	void			SetErrorText( const String& rTxt )
			{ aErrorText.SetText( rTxt ); }
	FASTBOOL		GetDefaultUser( String& rPath,
						String& rUser, String& rPasswd ) const;
	void			ClearPassword();
	void			HideControls( BYTE nFlag );
};

#endif

