
#ifndef _MAILREAD_HXX
#define _MAILREAD_HXX

#define _SVSTDARR_STRINGS

#ifndef _DIALOG_HXX 
#include <vcl/dialog.hxx>
#endif
#ifndef _FIXED_HXX 
#include <vcl/fixed.hxx>
#endif
#ifndef _BUTTON_HXX 
#include <vcl/button.hxx>
#endif
#ifndef _EDIT_HXX 
#include <vcl/edit.hxx>
#endif
#ifndef _MENUBTN_HXX 
#include <vcl/menubtn.hxx>
#endif
#ifndef _LSTBOX_HXX 
#include <vcl/lstbox.hxx>
#endif
#ifndef _GROUP_HXX 
#include <vcl/group.hxx>
#endif
#ifndef _SVSTDARR_HXX
#include <svtools/svstdarr.hxx>	
#endif

#ifdef VCL
#include <svtools/svmedit.hxx>
#endif

#include <goodies/mailenum.hxx>	

class MailServer;

class MailReadOnlyDialog : public ModalDialog
{
private:
	CancelButton	aCloseButton;
	MenuButton		aAttachButton;
	HelpButton		aHelpButton;

	FixedText		aAddressText;
	ListBox			aAddressBox;
	FixedText		aSubjectText;
	Edit			aSubjectEdit;
	FixedText		aPrioText;
	Edit			aPrioEdit;
	FixedText		aReceiptText;
	FixedBitmap		aReceiptBitmap;
	FixedText		aMessageText;
	MultiLineEdit	aMessageEdit;
	GroupBox		aTextGroup;

	MailServer*		pServer;
	Link			aOpenHdlLink;
	SvStrings		aFileList;

#if 0 // _SOLAR__PRIVATE
	DECL_LINK( SelectHdl, Button * );
#endif

public:
	MailReadOnlyDialog( Window* pParent, MailServer& rServer );
	~MailReadOnlyDialog();

	void			SetSubject( const String& rSubject )
			 { aSubjectEdit.SetText( rSubject ); }
	void			SetMessage( const String& rMessage )
			 { aMessageEdit.SetText( rMessage ); }
	void			SetPriority( MailPriority eNewPriority );
	void			SetReceipt( BOOL bReceipt );

	void			SetSenderName( const String& rSender );
	void			AppendReceiver( const String& rReceiver )
			{	aAddressBox.InsertEntry( rReceiver ); }
	void			AppendAttach( const String& rAttachFile,
					  const String& rAttachName,
					  BOOL bURL );
	String 			GetAttachFileName();

	void			SetOpenHdl( const Link& rNewLink )
			{ aOpenHdlLink = rNewLink; }
	const Link&		GetOpenHdl() const { return aOpenHdlLink; }
};

#endif

