

#ifndef _INET_HTTPWRAP_HXX
#define _INET_HTTPWRAP_HXX "$Revision: 1.1.1.1 $"

#ifndef _SAL_TYPES_H_
#include <sal/types.h>
#endif

#ifndef _VOS_MUTEX_HXX_
#include <vos/mutex.hxx>
#endif
#ifndef _VOS_REF_HXX_
#include <vos/ref.hxx>
#endif

#ifndef _INET_MACROS_HXX
#include <inet/macros.hxx>
#endif

class INetCoreDNSResolver;

#ifdef _USE_NAMESPACE
namespace inet {
#endif

class INetHTTPConnection;

class INetHTTPGetRequest;
class INetHTTPHeadRequest;
class INetHTTPPostRequest;

class INetHTTPPutRequest;
class INetHTTPDeleteRequest;

class INetHTTPWrapper : public NAMESPACE_VOS(OMutex)
{
	VOS_DECLARE_CLASSINFO (VOS_NAMESPACE (INetHTTPWrapper, inet));

public:

	INetHTTPWrapper (void);
	virtual ~INetHTTPWrapper (void);

	virtual sal_Bool newHTTPConnection (
		NAMESPACE_VOS(ORef)<INetHTTPConnection> &rxConnection);

	virtual sal_Bool newHTTPGetRequest (
		NAMESPACE_VOS(ORef)<INetHTTPGetRequest> &rxRequest);

	virtual sal_Bool newHTTPHeadRequest (
		NAMESPACE_VOS(ORef)<INetHTTPHeadRequest> &rxRequest);

	virtual sal_Bool newHTTPPostRequest (
		NAMESPACE_VOS(ORef)<INetHTTPPostRequest> &rxRequest);

	virtual sal_Bool newHTTPPutRequest (
		NAMESPACE_VOS(ORef)<INetHTTPPutRequest> &rxRequest);

	virtual sal_Bool newHTTPDeleteRequest (
		NAMESPACE_VOS(ORef)<INetHTTPDeleteRequest> &rxRequest);

private:

	INetCoreDNSResolver *m_pResolver;

	INetHTTPWrapper (const INetHTTPWrapper&);
	INetHTTPWrapper& operator= (const INetHTTPWrapper&);
};

#ifdef _USE_NAMESPACE
}
#endif

extern "C" {
	NAMESPACE_INET(INetHTTPWrapper)* SAL_CALL NewINetHTTPWrapper (void);
};

#endif 

