

#ifndef _INET_LDAPWRAP_HXX
#define _INET_LDAPWRAP_HXX "$Revision: 1.1.1.1 $"

#ifndef _SAL_TYPES_H_
#include <sal/types.h>
#endif

#ifndef _VOS_REF_HXX_
#include <vos/ref.hxx>
#endif

#ifndef _VOS_MUTEX_HXX_
#include <vos/mutex.hxx>
#endif

#ifndef _INET_MACROS_HXX
#include <inet/macros.hxx>
#endif

class INetCoreLDAPConnection;

class INetCoreLDAPSearchRequestMessage;
class INetCoreLDAPModifyRequestMessage;

class INetCoreLDAPAttributeValuePair;
class INetCoreLDAPAttribute;
class INetCoreLDAPEntry;
class INetCoreLDAPModification;

class INetCoreLDAPAndFilter;
class INetCoreLDAPOrFilter;
class INetCoreLDAPNotFilter;

class INetCoreLDAPEqualityMatchFilter;
class INetCoreLDAPApproxMatchFilter;

class INetCoreLDAPGreaterOrEqualFilter;
class INetCoreLDAPLessOrEqualFilter;

class INetCoreLDAPPresentFilter;
class INetCoreLDAPSubstringFilter;

#ifdef _USE_NAMESPACE
namespace inet {
#endif

class INetLDAPWrapper : public NAMESPACE_VOS(OMutex)
{
	VOS_DECLARE_CLASSINFO (VOS_NAMESPACE (INetLDAPWrapper, inet));

public:

	INetLDAPWrapper (void);
	virtual ~INetLDAPWrapper (void);

	virtual sal_Bool newLDAPConnection (
		NAMESPACE_VOS(ORef)<INetCoreLDAPConnection> &rxConnection);

	virtual sal_Bool newLDAPSearchRequestMessage (
		INetCoreLDAPSearchRequestMessage *&rpMessage);

	virtual sal_Bool newLDAPModifyRequestMessage (
		INetCoreLDAPModifyRequestMessage *&rpMessage);

	virtual sal_Bool newLDAPAttributeValuePair (
		INetCoreLDAPAttributeValuePair *&rpAttribValuePair);

	virtual sal_Bool newLDAPAttribute (
		INetCoreLDAPAttribute *&rpAttrib);

	virtual sal_Bool newLDAPEntry (
		INetCoreLDAPEntry *&rpEntry);

	virtual sal_Bool newLDAPModification (
		INetCoreLDAPModification *&rpModification);

	virtual sal_Bool newLDAPAndFilter (
		INetCoreLDAPAndFilter *&rpFilter);

	virtual sal_Bool newLDAPOrFilter (
		INetCoreLDAPOrFilter *&rpFilter);

	virtual sal_Bool newLDAPNotFilter (
		INetCoreLDAPNotFilter *&rpFilter);

	virtual sal_Bool newLDAPEqualityMatchFilter (
		INetCoreLDAPEqualityMatchFilter *&rpFilter);

	virtual sal_Bool newLDAPApproxMatchFilter (
		INetCoreLDAPApproxMatchFilter *&rpFilter);

	virtual sal_Bool newLDAPGreaterOrEqualFilter (
		INetCoreLDAPGreaterOrEqualFilter *&rpFilter);

	virtual sal_Bool newLDAPLessOrEqualFilter (
		INetCoreLDAPLessOrEqualFilter *&rpFilter);

	virtual sal_Bool newLDAPPresentFilter (
		INetCoreLDAPPresentFilter *&rpFilter);

	virtual sal_Bool newLDAPSubstringFilter (
		INetCoreLDAPSubstringFilter *&rpFilter);

private:

	INetLDAPWrapper (const INetLDAPWrapper&);
	INetLDAPWrapper& operator= (const INetLDAPWrapper&);
};

#ifdef _USE_NAMESPACE
}
#endif

extern "C" {
	NAMESPACE_INET(INetLDAPWrapper)* SAL_CALL NewINetLDAPWrapper (void);
}

#endif 

