/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIBooleanExpression.idl
 */

#ifndef __gen_nsIBooleanExpression_h__
#define __gen_nsIBooleanExpression_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

#ifndef __gen_nsISupportsArray_h__
#include "nsISupportsArray.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
typedef PRInt32 nsBooleanConditionType;


/* starting interface:    nsIBooleanConditionTypes */
#define NS_IBOOLEANCONDITIONTYPES_IID_STR "f51387b1-5aef-4a1c-830e-7cd3b02366ce"

#define NS_IBOOLEANCONDITIONTYPES_IID \
  {0xf51387b1, 0x5aef, 0x4a1c, \
    { 0x83, 0x0e, 0x7c, 0xd3, 0xb0, 0x23, 0x66, 0xce }}

/**
 * Condition types
 *
 * Constants defining the types of condition
 * to obtain a boolean result of TRUE or FALSE
 *
 */
class NS_NO_VTABLE nsIBooleanConditionTypes {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IBOOLEANCONDITIONTYPES_IID)

  enum { Exists = 0 };

  enum { DoesNotExist = 1 };

  enum { Contains = 2 };

  enum { DoesNotContain = 3 };

  enum { Is = 4 };

  enum { IsNot = 5 };

  enum { BeginsWith = 6 };

  enum { EndsWith = 7 };

  enum { LessThan = 8 };

  enum { GreaterThan = 9 };

  enum { SoundsLike = 10 };

  enum { RegExp = 11 };

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIBOOLEANCONDITIONTYPES \

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIBOOLEANCONDITIONTYPES(_to) \

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIBOOLEANCONDITIONTYPES(_to) \

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsBooleanConditionTypes : public nsIBooleanConditionTypes
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIBOOLEANCONDITIONTYPES

  nsBooleanConditionTypes();
  virtual ~nsBooleanConditionTypes();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsBooleanConditionTypes, nsIBooleanConditionTypes)

nsBooleanConditionTypes::nsBooleanConditionTypes()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsBooleanConditionTypes::~nsBooleanConditionTypes()
{
  /* destructor code */
}

/* End of implementation class template. */
#endif

typedef PRInt32 nsBooleanOperationType;


/* starting interface:    nsIBooleanOperationTypes */
class NS_NO_VTABLE nsIBooleanOperationTypes {
 public: 

  enum { AND = 0 };

  enum { OR = 1 };

  enum { NOT = 2 };

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIBOOLEANOPERATIONTYPES \

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIBOOLEANOPERATIONTYPES(_to) \

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIBOOLEANOPERATIONTYPES(_to) \

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsBooleanOperationTypes : public nsIBooleanOperationTypes
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIBOOLEANOPERATIONTYPES

  nsBooleanOperationTypes();
  virtual ~nsBooleanOperationTypes();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsBooleanOperationTypes, nsIBooleanOperationTypes)

nsBooleanOperationTypes::nsBooleanOperationTypes()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsBooleanOperationTypes::~nsBooleanOperationTypes()
{
  /* destructor code */
}

/* End of implementation class template. */
#endif


/* starting interface:    nsIBooleanConditionString */
#define NS_IBOOLEANCONDITIONSTRING_IID_STR "c3869d72-cfd0-45f0-a0ec-3f67d83c7110"

#define NS_IBOOLEANCONDITIONSTRING_IID \
  {0xc3869d72, 0xcfd0, 0x45f0, \
    { 0xa0, 0xec, 0x3f, 0x67, 0xd8, 0x3c, 0x71, 0x10 }}

/**
 * String condition
 *
 * A string condition represents a leaf node in a
 * boolean expression tree and represents
 * test which will return TRUE or FALSE
 *
 * Condition is an expression which is a
 * leaf node in a boolean expression tree
 *
 */
class NS_NO_VTABLE nsIBooleanConditionString : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IBOOLEANCONDITIONSTRING_IID)

  /**
     * The condition for how the a value
     * should be compared
     *
     */
  /* attribute nsBooleanConditionType condition; */
  NS_IMETHOD GetCondition(nsBooleanConditionType *aCondition) = 0;
  NS_IMETHOD SetCondition(nsBooleanConditionType aCondition) = 0;

  /**
     * The lhs of the condition
     *
     * Represents a property name which
     * should be evaluated to obtain the
     * lhs.
     *
     */
  /* attribute string name; */
  NS_IMETHOD GetName(char * *aName) = 0;
  NS_IMETHOD SetName(const char * aName) = 0;

  /**
     * The rhs of the condition
     *
     * <name> [condition] value
     *
     */
  /* attribute wstring value; */
  NS_IMETHOD GetValue(PRUnichar * *aValue) = 0;
  NS_IMETHOD SetValue(const PRUnichar * aValue) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIBOOLEANCONDITIONSTRING \
  NS_IMETHOD GetCondition(nsBooleanConditionType *aCondition); \
  NS_IMETHOD SetCondition(nsBooleanConditionType aCondition); \
  NS_IMETHOD GetName(char * *aName); \
  NS_IMETHOD SetName(const char * aName); \
  NS_IMETHOD GetValue(PRUnichar * *aValue); \
  NS_IMETHOD SetValue(const PRUnichar * aValue); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIBOOLEANCONDITIONSTRING(_to) \
  NS_IMETHOD GetCondition(nsBooleanConditionType *aCondition) { return _to ## GetCondition(aCondition); } \
  NS_IMETHOD SetCondition(nsBooleanConditionType aCondition) { return _to ## SetCondition(aCondition); } \
  NS_IMETHOD GetName(char * *aName) { return _to ## GetName(aName); } \
  NS_IMETHOD SetName(const char * aName) { return _to ## SetName(aName); } \
  NS_IMETHOD GetValue(PRUnichar * *aValue) { return _to ## GetValue(aValue); } \
  NS_IMETHOD SetValue(const PRUnichar * aValue) { return _to ## SetValue(aValue); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIBOOLEANCONDITIONSTRING(_to) \
  NS_IMETHOD GetCondition(nsBooleanConditionType *aCondition) { return !_to ## ? NS_ERROR_NULL_POINTER : _to ##->GetCondition(aCondition); } \
  NS_IMETHOD SetCondition(nsBooleanConditionType aCondition) { return !_to ## ? NS_ERROR_NULL_POINTER : _to ##->SetCondition(aCondition); } \
  NS_IMETHOD GetName(char * *aName) { return !_to ## ? NS_ERROR_NULL_POINTER : _to ##->GetName(aName); } \
  NS_IMETHOD SetName(const char * aName) { return !_to ## ? NS_ERROR_NULL_POINTER : _to ##->SetName(aName); } \
  NS_IMETHOD GetValue(PRUnichar * *aValue) { return !_to ## ? NS_ERROR_NULL_POINTER : _to ##->GetValue(aValue); } \
  NS_IMETHOD SetValue(const PRUnichar * aValue) { return !_to ## ? NS_ERROR_NULL_POINTER : _to ##->SetValue(aValue); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsBooleanConditionString : public nsIBooleanConditionString
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIBOOLEANCONDITIONSTRING

  nsBooleanConditionString();
  virtual ~nsBooleanConditionString();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsBooleanConditionString, nsIBooleanConditionString)

nsBooleanConditionString::nsBooleanConditionString()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsBooleanConditionString::~nsBooleanConditionString()
{
  /* destructor code */
}

/* attribute nsBooleanConditionType condition; */
NS_IMETHODIMP nsBooleanConditionString::GetCondition(nsBooleanConditionType *aCondition)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsBooleanConditionString::SetCondition(nsBooleanConditionType aCondition)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute string name; */
NS_IMETHODIMP nsBooleanConditionString::GetName(char * *aName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsBooleanConditionString::SetName(const char * aName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute wstring value; */
NS_IMETHODIMP nsBooleanConditionString::GetValue(PRUnichar * *aValue)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsBooleanConditionString::SetValue(const PRUnichar * aValue)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    nsIBooleanExpression */
#define NS_IBOOLEANEXPRESSION_IID_STR "67f87c44-2c63-41a2-9545-aff1d9f09623"

#define NS_IBOOLEANEXPRESSION_IID \
  {0x67f87c44, 0x2c63, 0x41a2, \
    { 0x95, 0x45, 0xaf, 0xf1, 0xd9, 0xf0, 0x96, 0x23 }}

/**
 * N Boolean expression type
 *
 * Supports Unary Binary and N boolean expressions
 *
 * An operation represents a node in a boolean
 * expression tree which may contain one or more
 * child conditions or expressions
 *
 */
class NS_NO_VTABLE nsIBooleanExpression : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IBOOLEANEXPRESSION_IID)

  /**
     * The boolean operation to be applied to
     * results of all evaluated expressions
     *
     */
  /* attribute nsBooleanOperationType operation; */
  NS_IMETHOD GetOperation(nsBooleanOperationType *aOperation) = 0;
  NS_IMETHOD SetOperation(nsBooleanOperationType aOperation) = 0;

  /**
     * List of peer expressions
     *
     * e1 [op] e2 [op] .... en
     *
     */
  /* attribute nsISupportsArray expressions; */
  NS_IMETHOD GetExpressions(nsISupportsArray * *aExpressions) = 0;
  NS_IMETHOD SetExpressions(nsISupportsArray * aExpressions) = 0;

  /**
     * expressions attribute defined explicitly as an
     * array of nsISupports
     *
     */
  /* void asetExpressions (in unsigned long aExpressionsSize, [array, size_is (aExpressionsSize)] in nsISupports aExpressionsArray); */
  NS_IMETHOD AsetExpressions(PRUint32 aExpressionsSize, nsISupports **aExpressionsArray) = 0;

  /* void agetExpressions (out unsigned long aExpressionsSize, [array, size_is (aExpressionsSize), retval] out nsISupports aExpressionsArray); */
  NS_IMETHOD AgetExpressions(PRUint32 *aExpressionsSize, nsISupports ***aExpressionsArray) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIBOOLEANEXPRESSION \
  NS_IMETHOD GetOperation(nsBooleanOperationType *aOperation); \
  NS_IMETHOD SetOperation(nsBooleanOperationType aOperation); \
  NS_IMETHOD GetExpressions(nsISupportsArray * *aExpressions); \
  NS_IMETHOD SetExpressions(nsISupportsArray * aExpressions); \
  NS_IMETHOD AsetExpressions(PRUint32 aExpressionsSize, nsISupports **aExpressionsArray); \
  NS_IMETHOD AgetExpressions(PRUint32 *aExpressionsSize, nsISupports ***aExpressionsArray); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIBOOLEANEXPRESSION(_to) \
  NS_IMETHOD GetOperation(nsBooleanOperationType *aOperation) { return _to ## GetOperation(aOperation); } \
  NS_IMETHOD SetOperation(nsBooleanOperationType aOperation) { return _to ## SetOperation(aOperation); } \
  NS_IMETHOD GetExpressions(nsISupportsArray * *aExpressions) { return _to ## GetExpressions(aExpressions); } \
  NS_IMETHOD SetExpressions(nsISupportsArray * aExpressions) { return _to ## SetExpressions(aExpressions); } \
  NS_IMETHOD AsetExpressions(PRUint32 aExpressionsSize, nsISupports **aExpressionsArray) { return _to ## AsetExpressions(aExpressionsSize, aExpressionsArray); } \
  NS_IMETHOD AgetExpressions(PRUint32 *aExpressionsSize, nsISupports ***aExpressionsArray) { return _to ## AgetExpressions(aExpressionsSize, aExpressionsArray); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIBOOLEANEXPRESSION(_to) \
  NS_IMETHOD GetOperation(nsBooleanOperationType *aOperation) { return !_to ## ? NS_ERROR_NULL_POINTER : _to ##->GetOperation(aOperation); } \
  NS_IMETHOD SetOperation(nsBooleanOperationType aOperation) { return !_to ## ? NS_ERROR_NULL_POINTER : _to ##->SetOperation(aOperation); } \
  NS_IMETHOD GetExpressions(nsISupportsArray * *aExpressions) { return !_to ## ? NS_ERROR_NULL_POINTER : _to ##->GetExpressions(aExpressions); } \
  NS_IMETHOD SetExpressions(nsISupportsArray * aExpressions) { return !_to ## ? NS_ERROR_NULL_POINTER : _to ##->SetExpressions(aExpressions); } \
  NS_IMETHOD AsetExpressions(PRUint32 aExpressionsSize, nsISupports **aExpressionsArray) { return !_to ## ? NS_ERROR_NULL_POINTER : _to ##-> AsetExpressions(aExpressionsSize, aExpressionsArray); } \
  NS_IMETHOD AgetExpressions(PRUint32 *aExpressionsSize, nsISupports ***aExpressionsArray) { return !_to ## ? NS_ERROR_NULL_POINTER : _to ##-> AgetExpressions(aExpressionsSize, aExpressionsArray); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsBooleanExpression : public nsIBooleanExpression
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIBOOLEANEXPRESSION

  nsBooleanExpression();
  virtual ~nsBooleanExpression();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsBooleanExpression, nsIBooleanExpression)

nsBooleanExpression::nsBooleanExpression()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsBooleanExpression::~nsBooleanExpression()
{
  /* destructor code */
}

/* attribute nsBooleanOperationType operation; */
NS_IMETHODIMP nsBooleanExpression::GetOperation(nsBooleanOperationType *aOperation)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsBooleanExpression::SetOperation(nsBooleanOperationType aOperation)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute nsISupportsArray expressions; */
NS_IMETHODIMP nsBooleanExpression::GetExpressions(nsISupportsArray * *aExpressions)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsBooleanExpression::SetExpressions(nsISupportsArray * aExpressions)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void asetExpressions (in unsigned long aExpressionsSize, [array, size_is (aExpressionsSize)] in nsISupports aExpressionsArray); */
NS_IMETHODIMP nsBooleanExpression::AsetExpressions(PRUint32 aExpressionsSize, nsISupports **aExpressionsArray)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void agetExpressions (out unsigned long aExpressionsSize, [array, size_is (aExpressionsSize), retval] out nsISupports aExpressionsArray); */
NS_IMETHODIMP nsBooleanExpression::AgetExpressions(PRUint32 *aExpressionsSize, nsISupports ***aExpressionsArray)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIBooleanExpression_h__ */
