
#ifndef _OFF_APP_HXX
#define _OFF_APP_HXX

#ifndef _SFXAPP_HXX 
#include <sfx2/app.hxx>
#endif

#define SFX_INTERFACE_OFFAPP SFX_INTERFACE_OFA_START

#define ADDRPI_BTN_INSERT	1
#define ADDRPI_BTN_MERGE	2

#define OFA_REFERER			"private:user"

class MailServer;
#if (SUPD<639)
class SbaObject;
#endif
class SbaDLL;
class OfaHtmlOptions;
class OfaAutoCorrCfg;
class SvxAutoCorrect;
class SvStringsDtor;

class SchDLL;
class SimDLL;
class SmDLL;
class XColorTable;
class XOutdevItemPool;
class OfaTabAppearanceCfg;
class CntAnchor;
class SfxTabPage;
class SimpleResMgr;
class OfaFilterOptions;

class  OfficeData_Impl;
struct ConvertData;

#if 0 // _SOLAR__PRIVATE
struct OfficeAppl_Impl
{
	ResMgr*				pResMgr;
	SfxObjectFactory*	pOffMessageDoc_ImplFactory;
	SimpleResMgr*		m_pThreadSafeRessources;

	OfficeAppl_Impl() :
		pResMgr( NULL ),
		pOffMessageDoc_ImplFactory( NULL ),
		m_pThreadSafeRessources( NULL )
	{}
};
#else
struct OfficeAppl_Impl;
#endif

class OfficeApplication : public SfxApplication
{
private:
	OfficeAppl_Impl*	pImpl;			  
	OfficeData_Impl*	pDataImpl;		  
#if (SUPD<639)
	SbaObject*          pSbaObject;       
#endif
	USHORT              nAddrButtonFlags; 
	Link				aSbaCreatedLink;

#if 0 // _SOLAR__PRIVATE
					DECL_LINK( ImplGetAutoCorrect, void* );
					DECL_LINK( ImplInitFilterHdl, ConvertData* );
					DECL_LINK( ChangeUserDataHdl_Impl, void* );
#endif

#if 0 // _SOLAR__PRIVATE
	void						CreateDataImpl();
	void						DeleteDataImpl();

public:
	void						WriterExec_Impl( SfxRequest &rReq );
	void						DrawExec_Impl( SfxRequest &rReq );
	void						CalcExec_Impl( SfxRequest &rReq );
	void 						BaseExec_Impl( SfxRequest &rReq );
	void						ModuleState_Impl( SfxItemSet &rState );
	void						Execute_Impl( SfxRequest &rReq );
	void						GetState_Impl( SfxItemSet &rState );
	void						ExecuteApp_Impl( SfxRequest &rReq );
	void						GetStateApp_Impl( SfxItemSet &rState );
	void 						ExecAPI_Impl( SfxRequest &rReq );
	void 						StateAPI_Impl( SfxItemSet &rState );
#endif

protected:
#if SUPD<590
	virtual void                Main( );
#endif
	virtual void                Init( );
	virtual void				Exit();

public:
					TYPEINFO();
					SFX_DECL_INTERFACE(SFX_INTERFACE_OFFAPP);
						OfficeApplication();
	                            ~OfficeApplication();

#if SUPD<590
	virtual SbxObject*          GetSbxObject();
#endif

	ResMgr* 					GetOffResManager();

	SimpleResMgr*				GetOffSimpleResManager();
	void						SetSbxCreatedLink( const Link &rLink );
	OfaHtmlOptions*				GetHtmlOptions();
	OfaFilterOptions*			GetFilterOptions();

	OfaAutoCorrCfg*				GetAutoCorrConfig();
	SvxAutoCorrect*				GetAutoCorrect();

	OfaTabAppearanceCfg*		GetTabAppearanceConfig();
	void                        UseFontSubst();

	XColorTable*				GetStdColorTable();
	XOutdevItemPool*			GetXOutdevItemPool();

	static void					InitMailServer( MailServer* pServer );
	static BOOL					GetEmailNames( SvStringsDtor& rNameList );

	void                		SystemSettingsChanging( AllSettings& rSettings, Window* pFrame );

	virtual SfxItemSet*			CreateItemSet( USHORT nId );
	virtual void				ApplyItemSet( USHORT nId, const SfxItemSet& rSet );
	SfxTabPage*					CreateTabPage( USHORT nId, Window* pParent, const SfxItemSet& rSet );
	void						ExecuteGeneralOptionsDialog(USHORT nSlotId);

#if 0 // _SOLAR__PRIVATE
	OfficeAppl_Impl*			Get_Impl() { return pImpl; }
#endif
	 static ::rtl::OUString		ChooseMacro( BOOL bExecute = TRUE, BOOL bChooseOnly = FALSE, const ::rtl::OUString& rMacroDesc = ::rtl::OUString() );
};

#define OFF_APP()	( (OfficeApplication*)SfxGetpApp() )

#endif 

