
#ifndef _OFAACCFG_HXX
#define _OFAACCFG_HXX

#ifndef _UTL_CONFIGITEM_HXX_
#include <unotools/configitem.hxx>
#endif

class SvxAutoCorrect;
class OfaAutoCorrCfg;
class OfaBaseAutoCorrCfg : public utl::ConfigItem
{
	OfaAutoCorrCfg& rParent;
	com::sun::star::uno::Sequence<rtl::OUString> 	GetPropertyNames();

public:
	OfaBaseAutoCorrCfg(OfaAutoCorrCfg& rParent);
	~OfaBaseAutoCorrCfg();

	void					Load(sal_Bool bInit);
	virtual void			Commit();
	virtual void 			Notify( const com::sun::star::uno::Sequence<rtl::OUString>& aPropertyNames);
	void 					SetModified() {ConfigItem::SetModified();}
};

class OfaSwAutoCorrCfg : public utl::ConfigItem
{
	OfaAutoCorrCfg& rParent;
	com::sun::star::uno::Sequence<rtl::OUString> 	GetPropertyNames();

public:
	OfaSwAutoCorrCfg(OfaAutoCorrCfg& rParent);
	~OfaSwAutoCorrCfg();

	void					Load(sal_Bool bInit);
	virtual void			Commit();
	virtual void 			Notify( const com::sun::star::uno::Sequence<rtl::OUString>& aPropertyNames);
	void 					SetModified() {ConfigItem::SetModified();}
};

class OfaAutoCorrCfg
{
	friend class OfaBaseAutoCorrCfg;
	friend class OfaSwAutoCorrCfg;

	SvxAutoCorrect*	pAutoCorrect;

	OfaBaseAutoCorrCfg		aBaseConfig;
	OfaSwAutoCorrCfg		aSwConfig;

	sal_Bool	bFileRel;
	sal_Bool	bNetRel;

	sal_Bool	bAutoTextTip;
	sal_Bool	bAutoTextPreview;
	sal_Bool	bAutoFmtByInput;

public:
	void		SetModified()
	{
		aBaseConfig.SetModified();
		aSwConfig.SetModified();
	}
	 SvxAutoCorrect* GetAutoCorrect()			{ return pAutoCorrect; }
	const SvxAutoCorrect* GetAutoCorrect() const	{ return pAutoCorrect; }

	void SetAutoCorrect( SvxAutoCorrect* );

	sal_Bool IsAutoFmtByInput() const 		{ return bAutoFmtByInput; }
	void SetAutoFmtByInput( sal_Bool bSet ) { bAutoFmtByInput = bSet;aSwConfig.SetModified();}

	sal_Bool IsSaveRelFile() const 			{ return bFileRel; }
	void SetSaveRelFile( sal_Bool bSet ) 	{ bFileRel = bSet; aSwConfig.SetModified(); }

	sal_Bool IsSaveRelNet() const 			{ return bNetRel; }
	void SetSaveRelNet( sal_Bool bSet ) 	{ bNetRel = bSet; aSwConfig.SetModified();}

	sal_Bool IsAutoTextPreview() const {return bAutoTextPreview;}
	void	 SetAutoTextPreview(sal_Bool bSet) {bAutoTextPreview = bSet; aSwConfig.SetModified();}

	sal_Bool IsAutoTextTip() const 			{ return bAutoTextTip; }
	void SetAutoTextTip(sal_Bool bSet )  	{ bAutoTextTip = bSet;aSwConfig.SetModified();}

	OfaAutoCorrCfg();
	virtual ~OfaAutoCorrCfg();
};

#endif

