
#ifndef _SBAITEMS_HXX
#define _SBAITEMS_HXX

#ifndef _SFXPOOLITEM_HXX 
#include <svtools/poolitem.hxx>
#endif
#ifndef _REF_HXX 
#include <tools/ref.hxx>
#endif
#ifndef _LIST_HXX 
#include <tools/list.hxx>
#endif

#ifndef _SFXPOOLITEM_HXX 
#include <svtools/poolitem.hxx>
#endif

#ifndef _SFXENUMITEM_HXX 
#include <svtools/eitem.hxx>
#endif

#ifndef _SFXSTRITEM_HXX 
#include <svtools/stritem.hxx>
#endif

#ifndef _STREAM_HXX 
#include <tools/stream.hxx>
#endif

#ifndef _SBA_DBOBJENU_HXX
#include <offmgr/dbobjenu.hxx>
#endif

class SbaSelectionList: public List , public SvRefBase
{
public:
	SbaSelectionList():
	List(CONTAINER_MAXBLOCKSIZE,100,100){}
};

SV_DECL_IMPL_REF(SbaSelectionList)

DBG_NAMEEX(SbaSelectionItem);
class SbaSelectionItem: public SfxPoolItem
{
private:
	SbaSelectionListRef pSelectionList;

public:
	SbaSelectionItem( USHORT nWhich );
	SbaSelectionItem( USHORT nWhich, const SbaSelectionListRef pNewSelectionList );
	~SbaSelectionItem() { DBG_DTOR(SbaSelectionItem,NULL); }
	virtual int 	operator==( const SfxPoolItem& ) const;
	virtual String	GetValueText() const;
	virtual SfxPoolItem* Clone( SfxItemPool *pPool = 0 ) const;
	SbaSelectionListRef	GetSelectionList() const { return pSelectionList; }
	virtual USHORT	GetVersion(USHORT) const;
};

DBG_NAMEEX(SbaNameItem);
class SbaNameItem: public SfxStringItem
{
	BOOL bCase;	

public:
	TYPEINFO();
	SbaNameItem():bCase(FALSE){DBG_CTOR(SbaNameItem,NULL);};
	SbaNameItem(USHORT nWhich, const String& rVal, BOOL _bCase)
		:SfxStringItem(nWhich, rVal)
		,bCase(_bCase){DBG_CTOR(SbaNameItem,NULL);}
	~SbaNameItem(){ DBG_DTOR(SbaNameItem,NULL); };
	virtual int 			 operator==( const SfxPoolItem& ) const;
	virtual SfxPoolItem*     Clone( SfxItemPool *pPool = 0 ) const;
};

DBG_NAMEEX(SbaDataFieldTypeItem);
class SbaDataFieldTypeItem: public SfxEnumItem
{
public:
	TYPEINFO();

	SbaDataFieldTypeItem(USHORT nWhich, SbaFieldType nValue = dbText):
		  SfxEnumItem( nWhich, (USHORT)nValue ){DBG_CTOR(SbaDataFieldTypeItem,NULL);}
	SbaDataFieldTypeItem(USHORT nWhich, SvStream& rStream ):
		  SfxEnumItem( nWhich, rStream ){DBG_CTOR(SbaDataFieldTypeItem,NULL);}
	~SbaDataFieldTypeItem(){ DBG_DTOR(SbaDataFieldTypeItem,NULL); }

	virtual USHORT			GetValueCount() const;
	virtual SfxPoolItem*	Clone( SfxItemPool *pPool = 0 ) const;
	virtual String			GetValueTextByPos( USHORT nPos ) const;
	virtual String			GetValueText() const;
	virtual USHORT			GetValueByPos( USHORT nPos ) const;
	virtual int 			operator==( const SfxPoolItem& rItem ) const;
	virtual USHORT			GetVersion(USHORT) const;
	virtual SfxPoolItem*	Create( SvStream &, USHORT nVer ) const;

	SbaFieldType			GetType() const {return	(SbaFieldType)GetValue();}
};

class SbaColRowSizeItem : public SfxPoolItem
{
	UINT16	nCompVal;	
	UINT16  nVal;		
	UINT16  nVersion;

public:
	TYPEINFO();
	SbaColRowSizeItem( USHORT nWhich, UINT16 nCompValue, UINT16 nValue);
	SbaColRowSizeItem( USHORT nWhich, UINT16 nValue = 0);
	SbaColRowSizeItem( const SbaColRowSizeItem&);
	~SbaColRowSizeItem();

	virtual int				 operator==( const SfxPoolItem& ) const;
	virtual SfxPoolItem*	 Clone( SfxItemPool *pPool = 0 ) const;
	virtual SfxPoolItem*	 Create(SvStream &, USHORT nVersion) const;
	virtual SvStream&		 Store(SvStream &, USHORT nItemVersion) const;

	virtual USHORT			 GetVersion(USHORT) const;
	UINT16					 GetLogicValue() const {return nVal;}
	UINT16					 GetPixelValue() const {return nCompVal;}

	void					 PutPixelValue(UINT16 nNewVal);
	void					 PutLogicValue(UINT16 nNewVal);
};

DBG_NAMEEX(SbaDBDatabaseItem);
typedef sal_Int32 SbaDatabase;
class SbaDBDatabaseItem : public SfxPoolItem
{
	SbaDatabase*	xDatabase;

public:
	TYPEINFO();

	SbaDBDatabaseItem( USHORT nWhich ) :
		SfxPoolItem( nWhich )
	{ DBG_CTOR(SbaDBDatabaseItem,NULL); }
	SbaDBDatabaseItem( USHORT nWhich, SbaDatabase* pDatabase = NULL ) :
		 SfxPoolItem( nWhich )
		,xDatabase( pDatabase )
	{ DBG_CTOR(SbaDBDatabaseItem,NULL); }
	~SbaDBDatabaseItem(){ DBG_DTOR(SbaDBDatabaseItem,NULL); }
	SbaDatabase* GetDatabase() const { return xDatabase; }
	virtual int operator==( const SfxPoolItem& ) const;
	virtual SfxPoolItem* Clone( SfxItemPool *pPool = 0 ) const;
};

DBG_NAMEEX(SbaPointerItem);
class SbaPointerItem : public SfxPoolItem
{
	void*	m_pPtr;
public:
	TYPEINFO();
	virtual int				operator==( const SfxPoolItem& ) const;
	virtual SfxPoolItem*	Clone( SfxItemPool *pPool = 0 ) const;
				SbaPointerItem( USHORT nWhich, void* pPtr = NULL );
				SbaPointerItem( const SbaPointerItem& rSource );
	void*					GetValue() const { return m_pPtr; }
};
#endif

