

#ifndef SC_SCDLL_HXX
#define SC_SCDLL_HXX

class ResMgr;
class SvFactory;
class SotFactory;
class StatusBar;
class SfxMedium;
class SfxFilter;

#ifndef _SFXDEFS_HXX 
#include <sfx2/sfxdefs.hxx>
#endif
#ifndef _SFXMODULE_HXX 
#include <sfx2/module.hxx>
#endif
#ifndef _SFX_OBJFAC_HXX
#include <sfx2/docfac.hxx>
#endif

class ScDLL

{
public:
			ScDLL();
		~ScDLL();

	static void 	LibInit();	
	static void 	LibExit();	
	static void 	PreExit();	

	static void 	Init(); 	
	static void 	Exit(); 	

	static void 	FillStatusBar(StatusBar &rBar);

	static ULONG	DetectFilter( SfxMedium& rMedium, const SfxFilter** ppFilter,
						SfxFilterFlags nMust, SfxFilterFlags nDont );
};

#ifdef WNT
typedef void ( __cdecl * ScSigCatchFunc )( int );
#else
typedef void ( * ScSigCatchFunc )( int );
#endif
typedef ScSigCatchFunc ( * ScLibSignalFunc )( int, ScSigCatchFunc );

class ScModuleDummy: public SfxModule

{
public:

	SotFactory* 	pScDocShellFactory;
	ScLibSignalFunc pSignalFunc;
			ScModuleDummy( ResMgr *pResMgr, BOOL bDummy, SfxObjectFactory* pFact )
		:	SfxModule(pResMgr, bDummy, pFact, NULL),
			pScDocShellFactory(pFact), pSignalFunc(0)
		{}

	virtual SfxModule* Load();

	ScLibSignalFunc GetSignalFunc() { return pSignalFunc; }

	static SvGlobalName GetID(USHORT nFileFormat);
	static USHORT		HasID(const SvGlobalName& rName);
};

#define SC_DLL() ( *(ScModuleDummy**) GetAppData(SHL_CALC) )

#endif

