
#ifndef _SCH_CELLRANGES_HXX_
#define _SCH_CELLRANGES_HXX_

#ifndef _SAL_TYPES_H_
#include <sal/types.h>
#endif
#ifndef _RTL_USTRING_HXX_
#include <rtl/ustring.hxx>
#endif
#include <vector>

struct SchSingleCell
{
	sal_Int32 mnColumn, mnRow;
	sal_Bool  mbRelativeColumn : 1;     
	sal_Bool  mbRelativeRow    : 1;     
	 SchSingleCell() :
	        mnColumn( -1 ),
	        mnRow( -1 ),
	        mbRelativeColumn( sal_False ),
	        mbRelativeRow( sal_False )
	    {}
};

struct SchCellAddress
{
	::std::vector< SchSingleCell > maCells;      
};

struct SchCellRangeAddress
{
	SchCellAddress maUpperLeft;
	SchCellAddress maLowerRight;    
	::rtl::OUString msTableName;
	sal_Int32 mnTableNumber;        
	 SchCellRangeAddress() :
	        mnTableNumber( -1 )
	    {}
};

struct SchChartRange
{
	::std::vector< SchCellRangeAddress > maRanges;    
	sal_Bool mbFirstColumnContainsLabels;
	sal_Bool mbFirstRowContainsLabels;
	sal_Bool mbKeepCopyOfData;                        
	 SchChartRange() :
	        mbFirstRowContainsLabels( sal_False ),
	        mbFirstColumnContainsLabels( sal_False ),
	        mbKeepCopyOfData( sal_True )
	    {}
};

#endif	
