
#ifndef _ZIPLST_HXX
#define _ZIPLST_HXX

class GenericInformationList;
class GenericInformation;
class InformationClient;

#define ZSTANDLIST				"r:\\b_server\\config\\stand.lst"
#define ZIPLIST					"r:\\b_server\\zip\\zip.lst"
#define ZIPROOT					"r:\\b_server\\zip"

#define ISERVER					"iserver.stardiv.de"

#define META_ENVIRONMENT		"{environment}"
#define META_SOLARPATH			"{solarpath}"
#define META_SOLARENVPATH	  	"{solarenvpath}"
#define META_PMISCPATH			"{pmiscpath}"
#define META_WORKSTAMP			"{workstamp}"
#define META_MINOR				"{minor}"
#define META_MINORSUB			"{minorsub}"
#define META_LANGUAGES			"{languages}"
#define META_LANGUAGES_ALPHA	"{languagesalpha}"
#define META_BUILDID			"{buildid}"
#define META_OS			   		"{os}"
#define META_OSDEF		   		"{osdef}"
#define META_OSALPHA 			"{osalpha}"

#define KEY_ACTIVE				"active"
#define KEY_PRIO				"prio"
#define KEY_LOG	 				"log"
#define KEY_SCRIPT				"script"
#define KEY_FATBINARY			"fatbinary"
#define KEY_SPLITSIZE			"splitsize"
#define KEY_COMPRESSION			"compression"
#define KEY_LANGUAGES			"languages"
#define KEY_DESTINATION			"destination"
#define KEY_INCLUDE				"include"
#define KEY_SUCCESS				"success"
#define KEY_FAIL				"fail"
#define KEY_WEB					"web"

struct MetaReplacement
{
	ByteString 				aMetaWorkstamp;
	ByteString 				aMetaEnvironment;
	ByteString 				aMetaMinor;
	ByteString 				aMetaMinorSub;
	ByteString 				aMetaOSDef;
	ByteString 				aMetaOS;
	ByteString				aMetaBuildID;
	ByteString				aMetaSolarPath;
	ByteString				aMetaSolarEnvPath;
};

extern ByteString GetProcessorType(const ByteString&);
extern BOOL GetMetaReplacement(MetaReplacement*, const ByteString&, GenericInformationList*, BOOL bUseEnv = TRUE);
extern ByteString DoMetaReplacement(MetaReplacement*, const ByteString&, const ByteString&);

class IServerZipList
{
protected:
	GenericInformation*		m_pGenInfo;
public:

		IServerZipList();
		~IServerZipList();
	BOOL					InitZipList(InformationClient* pIClient);
	void					UnloadZipList();
	ByteString 				GetValue( GenericInformationList* pGenList, ByteString& rPath );
};

class Project : public IServerZipList
{
	InformationClient*	m_pIClient;

public:
		Project( InformationClient* pIClient );
		~Project();

	void				Read( GenericInformationList* pGenList, GenericInformation* pGenInf );
	void 				ReadSettings( GenericInformationList* pGenList, const ByteString& rPath );

	Project*			GetNewOverloaded( ByteString aWorkstamp, ByteString aEnvironment, ByteString aMinor );

	ByteString				m_aName;
	BOOL					m_bActive;
	BOOL					m_bWeb;

	USHORT					m_nPrio;
	ByteString				m_aLogfile;
	ByteString				m_aScript;
	ByteString				m_aFatbinary;
	ULONG 					m_nSplitSize;
	USHORT 					m_aCompression;
	ByteString				m_aLanguages;
	ByteString				m_aDestination;
	ByteString				m_aInclude;

	ByteString				m_aSuccessRecipients;
	ByteString				m_aFailRecipients;
};

#endif 
