
#ifndef _ARCH_HXX
#define _ARCH_HXX

#ifndef _LOADER_CXX
#include <tools/solar.h>
#else
#undef BOOL
#define BOOL unsigned char
#ifndef ULONG
#define ULONG unsigned long
#endif
#ifndef USHORT
#define USHORT unsigned short
#endif
#endif

#include <stdio.h>

#define MAX_ENTRYS				10000
#define MAX_ARCH_PATH			255
#define BUF_SZ					32000
#define ARCH_ACTUAL_VERSION		1

#ifndef WIN
#ifndef WNT
#define CALLTYPE
#else
#define CALLTYPE			__cdecl
#endif
#else
#define PASCAL				_pascal
#define FAR					_far
#define CALLTYPE			FAR PASCAL
#endif

extern "C" {
	typedef const char* (*FncFindArch)(const char* pDefSource, const char* pDefName);
};

struct ArchEntry
{
	ULONG	nOffset;
	ULONG	nSize;
	char*	pName;
};

class ArchDirectory
{
	FILE*		pArch;
	ULONG		nArchSize;
	FncFindArch	fncFindArch;

	char		cDelim;
	char		pSourceDir[MAX_ARCH_PATH];
	char		pMasterArch[MAX_ARCH_PATH];
	char		pErrorMsg[1000];
	BOOL		bNoJunk;

	ULONG		nArchVersion;
	ULONG		nDirOffset;
	ULONG 		nDataOffset;

	ULONG 		nDirCount;
	ArchEntry* 	pDirectory[MAX_ENTRYS];

	void				GetArchFileName( USHORT nSegment, char* pBuffer );
	BOOL				ReadDirectory();
public:
		ArchDirectory();
		~ArchDirectory();

	void 				SetFindArchHdl(FncFindArch fncNew) { fncFindArch = fncNew; }
	char*				GetErrorMsg() { return pErrorMsg; }

	BOOL				SetArchFile(const char* pBigFile);
	const ArchEntry*	ExistsFile(const char* pFileName);
	BOOL				GetFile(const char* pFileName, const char* pDestDir);

	ULONG 				GetCount() const { return nDirCount; }
	ArchEntry** 		GetRawList() const { return (ArchEntry**)pDirectory; }

	void				ExtractAll( const char* pDirname );
};

#ifdef _LOADER_CXX
#undef BOOL
#endif

#endif 

