

#ifndef SETUP_INSTDB_HXX
#define SETUP_INSTDB_HXX

#include <limits.h>

#include <setup2/ident.hxx>
#include <setup2/hashtbl.hxx>
#include <setup2/simode.hxx>

#if SUPD < 364

#else
#ifndef _DATE_HXX 
#include <tools/date.hxx>
#endif
#ifndef _TIME_HXX 
#include <tools/time.hxx>
#endif
#endif

class SiCompiledScript;
class SiDeclarator;
class SiModule;
class SiFile;
class SiProcedure;
class SiCustom;
class SiDirectory;
class SiDirectoryList;
class SiFolder;
class SiFolderItem;
class SiOs2Class;
class SiOs2Creator;
class SiOs2Template;
class SiRegistryItem;

class SiFileStream;

DECLARE_HASHTABLE(SiDBDoneList,ByteString,UINT32);

class SiDatabase
{
	SiFileStream&	m_aStream;
	SiInstallMode 	m_eInstallMode;
	SiDBDoneList  	m_aDoneList;
	int           	m_nListPos;
	BOOL			m_bScpMode;

	USHORT 			m_nLaguage;

	BOOL WriteObject(SiDeclarator const*);

	void AddSeparator();
	static ByteString Quote(ByteString const&);

	BOOL Create(SiDirectoryList const&);
	BOOL Create(SiDirectory const*);
	BOOL Create(SiFile const*);
	BOOL Create(SiProcedure const*);
	BOOL Create(SiCustom const*);
	BOOL Create(SiModule const*);
	BOOL Create(SiFolder const*);
	BOOL Create(SiFolderItem const*);

	BOOL Create(SiOs2Class const*);
	BOOL Create(SiOs2Creator const*);
	BOOL Create(SiOs2Template const*);

	BOOL Create(SiRegistryItem const*);

public:

	void BeginDeclaration (ByteString const& aName, SiDeclarator const*);
	void WriteProperty (ByteString const& aName, BOOL, USHORT nLanguage = USHRT_MAX);
	void WriteProperty (ByteString const& aName, long, USHORT nLanguage = USHRT_MAX);
	void WriteProperty (ByteString const& aName, sal_uInt32, USHORT nLanguage = USHRT_MAX);
	void WriteProperty (ByteString const& aName, int, USHORT nLanguage = USHRT_MAX);
	void WriteProperty (ByteString const& aName, ByteString const&, USHORT nLanguage = USHRT_MAX);
	void WriteProperty (ByteString const& aName, SiIdentifier const&, USHORT nLanguage = USHRT_MAX);
	void WriteProperty (ByteString const& aName, SiDeclarator const*, USHORT nLanguage = USHRT_MAX);
	void WriteProperty (ByteString const& aName, Date const&, USHORT nLanguage = USHRT_MAX);
	void WriteProperty (ByteString const& aName, Time const&, USHORT nLanguage = USHRT_MAX);
	void EndDeclaration();

	void BeginProperty (ByteString const& aName, USHORT nLang) { m_nLaguage = nLang; BeginProperty(aName); }
	void BeginProperty (ByteString const& aName);
	void BeginList();
	void AddListValue(long);
	void AddListValue(ByteString const&, BOOL bNewLine = FALSE);
	void AddListValue(SiIdentifier const&);
	void AddListValue(SiDeclarator const*);
	void EndList();
	void EndProperty();
	void WriteFreeStyle(const ByteString& rFreeCode);

public:
		SiDatabase(SiFileStream&);

	BOOL		Create(SiCompiledScript const*, SiInstallMode, ByteString const& aPath, BOOL bInstallFromNet);
	BOOL 		Create(SiCompiledScript const*);
};

#endif 

