
#ifndef _MAINDLG_HXX
#define _MAINDLG_HXX

#include <setup2/agentdlg.hxx>

class SiEnvironment;
class SiCompiledScript;

enum ModelType {
	MODEL_NOTSET 					= 0,
	MODEL_FIRST_INST				= 1,
	MODEL_END_FIRST_INST			= 2,
	MODEL_END_FIRST_INST_BOOT		= 3,
	MODEL_END_INST_BOOT				= 4,
	MODEL_END_INST					= 5,
	MODEL_REINSTALL					= 6,
	MODEL_WRONG_SETUP				= 7,
	MODEL_UPDATE_OLD_VERSION		= 8,
	MODEL_FIRST_INST_APPSERVER		= 9,
	MODEL_USERONLY_APPSERVER		= 10,
	MODEL_REINST_APPSERVER			= 11,
 	MODEL_CRCCHECK					= 12,
	MODEL_USERDATAONLY				= 13,
	MODEL_OFFICEREPAIR				= 14,
	MODEL_SCRIPT_NOT_FOUND			= 15,
	MODEL_RESPONSE_WIZARD			= 16
};

class SetupAgentDialog : public SvAgentDlg
{
	BOOL 				bAskOnExit;
	BOOL				bModalFlag;
	BOOL				bModalSucc;
	ULONG 				nSuccEventID;
	ULONG 				nFailEventID;

	ModelType 			eModelType;

	USHORT 				nLanguage;
	SiEnvironment* 		pEnv;
	SiCompiledScript*	pCScript;

	ByteString			aTempReadmePath;

	DECL_LINK(InitPage,SvAgentPage*);
public:
		SetupAgentDialog(Window* pParent, ResMgr* pMgr, BOOL bWizard = FALSE);
		~SetupAgentDialog();

	virtual BOOL		Close();
	virtual void		AddAllPages();

	void 				SetAskOnExit( BOOL bNew ) { bAskOnExit = bNew; }
	BOOL 				AskExit();

	BOOL				EndAgentDlg(BOOL bSucc);
	BOOL				DoModal();

	void 				SetModelType( ModelType eNew )	{ eModelType = eNew; }
	ModelType 			GetModelType() const 			{ return eModelType; }

	void				SuccEvent(ULONG nNew) { nSuccEventID = nNew; }
	void				FailEvent(ULONG nNew) { nFailEventID = nNew; }

	void				SetLanguage(USHORT nNew ) { nLanguage = nNew; }
	USHORT		 		GetLanguage() const { return nLanguage; }
	void				SetEnv(SiEnvironment* pNew ) { pEnv = pNew; }
	SiEnvironment* 		GetEnv() const { return pEnv; }
	void				SetCScript(SiCompiledScript* pNew ) { pCScript = pNew; }
	SiCompiledScript*	GetCScript() const { return pCScript; }

	void				CreateModel_FirstInstallation();
	void				CreateModel_EndFirstInstallation(BOOL bReboot = FALSE);
	void				CreateModel_EndInstallation(BOOL bReboot = FALSE);
	void 				CreateModel_ReInstallation();
	void				CreateModel_WrongSetup();
	void 				CreateModel_ScriptNotFound();
	void				CreateModel_UpdateOldVersion();

	void				CreateModel_ResponseWizard();

	void				CreateModel_AppServerInstallation();
	void 				CreateModel_AppServerReInstallation();

	void				CreateModel_CRCCheck();

	void				CreateModel_UserDataOnly();
	void				CreateModel_OfficeRepair();
};

#define GETDLG() ((SetupAgentDialog*)GetAgentDlg())

#endif 
