
#ifndef _SFXCTRLITEM_HXX
#define _SFXCTRLITEM_HXX

#ifndef _SFXPOOLITEM_HXX 
#include <svtools/poolitem.hxx>
#endif
#include <so3/binding.hxx>

class SfxPoolItem;
class SfxBindings;
class SvStream;

class SfxControllerItem
{
friend SvStream& operator<<( SvStream& rStream, const SfxControllerItem& rFunc );
friend SvStream& operator>>( SvStream& rStream, SfxControllerItem& rFunc );

private:
	USHORT				nId;
	SfxControllerItem*	pNext; 
	SfxBindings*		pBindings;

protected:
#if defined( DBG_UTIL ) && defined( _SOLAR__PRIVATE )
	void 				CheckConfigure_Impl( ULONG nType );
#endif

public:
	SfxBindings &		GetBindings() {
				DBG_ASSERT(pBindings, "keine Bindings");
				return *pBindings;
			}
	const SfxBindings &	GetBindings() const {
				DBG_ASSERT(pBindings, "keine Bindings");
				return *pBindings;
			}
				SfxControllerItem(); 
			SfxControllerItem( USHORT nId, SfxBindings & );
	virtual 			~SfxControllerItem();

	void				Bind( USHORT nNewId, SfxBindings * = 0);	
	void				UnBind();
	void				ReBind();
	BOOL				IsBound() const;
	void				UpdateSlot();
	void				ClearCache();
	void				SetBindings(SfxBindings &rBindings) { pBindings = &rBindings; }

	SfxControllerItem*	GetItemLink();
	SfxControllerItem*	ChangeItemLink( SfxControllerItem* pNewLink );

	void                SetId( USHORT nItemId );
	USHORT				GetId() const { return nId; }

	virtual void		StateChanged( USHORT nSID, SfxItemState eState,
						  const SfxPoolItem* pState );
	virtual void        DeleteFloatingWindow();

	SfxMapUnit			GetCoreMetric() const;

	static SfxItemState	GetItemState( const SfxPoolItem* pState );

#if 0 // _SOLAR__PRIVATE
	BOOL					IsBindable_Impl() const
				{ return pBindings != NULL; }
#endif
};

class SfxStatusForwarder: public SfxControllerItem
{
	SfxControllerItem*		pMaster;

protected:
	virtual void		StateChanged( USHORT nSID, SfxItemState eState,
						  const SfxPoolItem* pState );

public:
				SfxStatusForwarder( USHORT nSlotId,
					   SfxControllerItem&rMaster );
};

#endif

