
#ifndef _SFX_DINFEDT_HXX
#define _SFX_DINFEDT_HXX

#ifndef _SV_BUTTON_HXX
#include <vcl/button.hxx>
#endif
#ifndef _SV_DIALOG_HXX
#include <vcl/dialog.hxx>
#endif
#ifndef _SV_EDIT_HXX
#include <vcl/edit.hxx>
#endif
#ifndef _SV_FIXED_HXX
#include <vcl/fixed.hxx>
#endif

class InfoEdit_Impl : public Edit
{
public:
	InfoEdit_Impl( Window* pParent, const ResId& rResId ) :
		Edit( pParent, rResId ) {}

	virtual void	KeyInput( const KeyEvent& rKEvent );
};

class SfxDocInfoEditDlg : public ModalDialog
{
private:
	FixedLine		aInfoFL;
	InfoEdit_Impl	aInfo1ED;
	InfoEdit_Impl	aInfo2ED;
	InfoEdit_Impl	aInfo3ED;
	InfoEdit_Impl	aInfo4ED;
	OKButton		aOkBT;
	CancelButton	aCancelBT;
	HelpButton		aHelpBtn;

public:
	SfxDocInfoEditDlg( Window* pParent );

	void	SetText1( const String &rStr) { aInfo1ED.SetText( rStr ); }
	void	SetText2( const String &rStr) { aInfo2ED.SetText( rStr ); }
	void	SetText3( const String &rStr) { aInfo3ED.SetText( rStr ); }
	void	SetText4( const String &rStr) { aInfo4ED.SetText( rStr ); }

	String	GetText1() const { return aInfo1ED.GetText(); }
	String	GetText2() const { return aInfo2ED.GetText(); }
	String	GetText3() const { return aInfo3ED.GetText(); }
	String	GetText4() const { return aInfo4ED.GetText(); }
};

#endif

