
#ifndef _SFXDOCKWIN_HXX
#define _SFXDOCKWIN_HXX

#ifndef _DOCKWIN_HXX 
#include <vcl/dockwin.hxx>
#endif
#include <sfx2/childwin.hxx>

class SfxSplitWindow;
class SfxDockingWindow_Impl;

class SfxDockingWindow : public DockingWindow
{
private:
	Rectangle               aInnerRect;
	Rectangle               aOuterRect;
	SfxBindings*            pBindings;
	Size                    aFloatSize;
	SfxChildWindow*         pMgr;
	SfxDockingWindow_Impl*  pImp;

protected:
	SfxChildAlignment   CalcAlignment(const Point& rPos, Rectangle& rRect );
	void                CalcSplitPosition(const Point rPos, Rectangle& rRect,
				SfxChildAlignment eAlign);
	virtual Size        CalcDockingSize(SfxChildAlignment);
	virtual SfxChildAlignment
			CheckAlignment(SfxChildAlignment,SfxChildAlignment);

	virtual void        Resize();
	virtual BOOL        PrepareToggleFloatingMode();
	virtual void        ToggleFloatingMode();
	virtual void        StartDocking();
	virtual BOOL        Docking( const Point& rPos, Rectangle& rRect );
	virtual void        EndDocking( const Rectangle& rRect, BOOL bFloatMode );
	virtual void        Resizing( Size& rSize );
	virtual void        Paint( const Rectangle& rRect );
	virtual BOOL        Close();

#if 0 // _SOLAR__PRIVATE
	SfxChildWindow*		GetChildWindow_Impl()	{ return pMgr; }
#endif

public:
			SfxDockingWindow( SfxBindings *pBindings,
							  SfxChildWindow *pCW,
							  Window* pParent,
							  WinBits nWinBits=0);
			SfxDockingWindow( SfxBindings *pBindings,
							  SfxChildWindow *pCW,
							  Window* pParent,
							  const ResId& rResId);
			~SfxDockingWindow();

	void                Initialize (SfxChildWinInfo* pInfo);
	virtual void        FillInfo(SfxChildWinInfo&) const;

	void                SetDockingRects(const Rectangle& rOuter, const Rectangle& rInner)
				{ aInnerRect = rInner; aOuterRect = rOuter; }
	const Rectangle&    GetInnerRect() const					{ return aInnerRect; }
	const Rectangle&    GetOuterRect() const					{ return aOuterRect; }
	SfxBindings&        GetBindings() const						{ return *pBindings; }
	USHORT              GetType() const							{ return pMgr->GetType(); }
	SfxChildAlignment   GetAlignment() const					{ return pMgr->GetAlignment(); }
	void                SetAlignment(SfxChildAlignment eAlign)	{ pMgr->SetAlignment(eAlign); }
	Size                GetFloatingSize() const					{ return aFloatSize; }
	void                SetFloatingSize(const Size& rSize)		{ aFloatSize=rSize; }

	void                SetMinOutputSizePixel( const Size& rSize );
	Size                GetMinOutputSizePixel() const;
	void                EnableSplitting ( BOOL bEnable = TRUE );
	virtual long		Notify( NotifyEvent& rNEvt );
	virtual void        FadeIn( BOOL );

#if 0 // _SOLAR__PRIVATE
	USHORT              GetWinBits_Impl() const;
	void                SetItemSize_Impl( const Size& rSize );
	void 				Disappear_Impl();
	void 				Reappear_Impl();
	BOOL				IsAutoHide_Impl() const;
	BOOL				IsPinned_Impl() const;
	void				AutoShow_Impl( BOOL bShow = TRUE );
	void 				Pin_Impl( BOOL bPinned );
	SfxSplitWindow*		GetSplitWindow_Impl() const;
#endif
};

#endif 

