
#ifndef _SFXEVENT_HXX
#define _SFXEVENT_HXX

#ifndef _STRING_HXX 
#include <tools/string.hxx>
#endif
#ifndef _SFXHINT_HXX 
#include <svtools/hint.hxx>
#endif

class SfxObjectShell;

class SfxEventHint : public SfxHint
{
	USHORT				nEventId;
	SfxObjectShell* 	pObjShell;
	String				_aArgs;
	BOOL				_bDummy;
	BOOL                _bAddToHistory;

public:
	TYPEINFO();
			SfxEventHint( USHORT nId,
						  const String& rArgs,
						  SfxObjectShell *pObj = 0  )
			:	nEventId(nId),
				pObjShell(pObj),
				_bAddToHistory(FALSE),
				_aArgs( rArgs )
			{}
			SfxEventHint( USHORT nId, SfxObjectShell *pObj = 0 )
			:	nEventId(nId),
				pObjShell(pObj),
				_bAddToHistory(FALSE)
			{}

	const String& GetArgs() const {	return _aArgs;}

	USHORT				GetEventId() const
			{ return nEventId; }

	SfxObjectShell* 	GetObjShell() const
			{ return pObjShell; }
};

class SfxNamedHint : public SfxHint
{
	String				_aEventName;
	SfxObjectShell* 	_pObjShell;
	String				_aArgs;
	BOOL				_bDummy;
	BOOL                _bAddToHistory;

public:
			TYPEINFO();
				SfxNamedHint( const String& rName,
						  const String& rArgs,
						  SfxObjectShell *pObj = 0  )
			:	_aEventName( rName ),
				_pObjShell( pObj),
				_bAddToHistory( FALSE ),
				_aArgs( rArgs )
			{}
				SfxNamedHint( const String& rName,
						  SfxObjectShell *pObj = 0 )
			:	_aEventName( rName ),
				_pObjShell( pObj ),
				_bAddToHistory( FALSE )
			{}

	const String&		GetArgs() const { return _aArgs;}
	const String&		GetName() const { return _aEventName; }
	SfxObjectShell*     GetObjShell() const { return _pObjShell; }
};

#endif
