
#ifndef _SFX_EVENTCONF_HXX
#define _SFX_EVENTCONF_HXX

#if 0 // _SOLAR__PRIVATE

#ifndef _SV_MSGBOX_HXX 
#include <vcl/msgbox.hxx>
#endif
#ifndef _FIXED_HXX 
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_BUTTON_HXX
#include <vcl/button.hxx>
#endif

#endif

#define _SVSTDARR_USHORTS
#include <svtools/svstdarr.hxx>		
#include <sfx2/cfgitem.hxx>
#include <sfx2/event.hxx>

#include <sfx2/sfxsids.hrc>
#ifdef ITEMID_MACRO
#undef ITEMID_MACRO
#endif
#define ITEMID_MACRO SID_ATTR_MACROITEM
#include <svtools/macitem.hxx>

class SfxMacroInfo;
class SfxMacroTabPage;
class SfxMacroInfoArr_Impl;
class SfxEventConfigItem_Impl;
class SfxEventInfoArr_Impl;
class SfxObjectShell;

#define SFX_NO_EVENT USHRT_MAX

#if 0 // _SOLAR__PRIVATE
struct SfxEvent_Impl
{
	String						aEventName;
	USHORT						nEventId;

	SfxEvent_Impl(const String& rName, USHORT nId) :
		aEventName(rName),
		nEventId(nId)
	{}
};

SV_DECL_PTRARR(SfxEventArr_Impl, SfxEvent_Impl*, 5, 5);

#define	PROP_EVENT_TYPE		"EventType"
#define PROP_LIBRARY		"Library"
#define PROP_SCRIPT			"Script"
#define PROP_MACRO_NAME		"MacroName"
#define STAR_BASIC			"StarBasic"
#define JAVA_SCRIPT			"JavaScript"

#else
typedef SvPtrarr SfxEventArr_Impl;
#endif

class SfxEventConfiguration
{
friend class SfxEventConfigItem_Impl;

	SfxMacroInfoArr_Impl*	pArr;
	SfxEventArr_Impl*		pEventArr;
	SfxEventConfigItem_Impl* pAppEventConfig;
	SfxEventConfigItem_Impl* pDocEventConfig;
	sal_Bool				bIgnoreConfigure;

public:
				SfxEventConfiguration();
				~SfxEventConfiguration();

	void					RegisterEvent(USHORT nId, const String& rName);
	String					GetEventName(USHORT nId) const;
	USHORT					GetEventId(const String& rName) const;
	USHORT					GetEventCount() const
				{ return pEventArr->Count()-1; }
	const SvxMacro*			GetMacroForEventId( USHORT nEventId, SfxObjectShell *pObjSh );
	void					ConfigureEvent(USHORT nId, const SvxMacro&,
					SfxObjectShell* pObjSh);
	void					ConfigureEvent(USHORT nId, const String& rMacro,
					SfxObjectShell* pObjSh);

	const SfxMacroInfo*		GetMacroInfo(USHORT nEventId, SfxObjectShell* pObjSh) const;

	void					ExecuteEvent(
					USHORT nId, SfxObjectShell *pDoc, FASTBOOL bSynchron,
					const String& rArgs );

	void					SetWarningEnabled( BOOL bOn );
	void					SetWarningForced( BOOL bOn );
	BOOL					IsWarningEnabled() const;
	BOOL					IsWarningForced() const;
	void 					AddEvents( SfxMacroTabPage* ) const;
	SvxMacroTableDtor*		GetAppEventTable();
	SvxMacroTableDtor*		GetDocEventTable(SfxObjectShell*);
	void					SetAppEventTable( const SvxMacroTableDtor& );
	void					SetDocEventTable( SfxObjectShell*, const SvxMacroTableDtor& );

	static void				RegisterEvent( USHORT nId, const String& rName,
							   const String& rMacroName );

#if 0 // _SOLAR__PRIVATE
	const SfxEvent_Impl*		GetEvent_Impl(USHORT nPos) const
						{ return (*pEventArr)[nPos+1]; }
	BOOL						Warn_Impl( SfxObjectShell *pDoc, const SvxMacro* pMacro );
	void						PropagateEvents_Impl( SfxObjectShell *pDoc,
										  const SvxMacroTableDtor& rTable );
	void                        PropagateEvent_Impl( SfxObjectShell *pDoc,
	                                                 USHORT nId,
	                                                 const SvxMacro* pMacro );
	static rtl::OUString		GetEventName_Impl( ULONG nID );
	static ULONG				GetEventId_Impl( const rtl::OUString& rEventName );
	::com::sun::star::uno::Any	CreateEventData_Impl( const SvxMacro *pMacro );

	static ULONG				GetPos_Impl( USHORT nID, sal_Bool &rFound );
	static ULONG				GetPos_Impl( const String& rName, sal_Bool &rFound );
#endif
};

#if 0 // _SOLAR__PRIVATE
class SfxEventConfigItem_Impl : public SfxConfigItem
{
friend class SfxEventConfiguration;

	SfxEventConfiguration	*pEvConfig;
	SfxObjectShell			*pObjShell;
	BOOL					bWarning;
	BOOL					bAlwaysWarning;
	SvxMacroTableDtor		aMacroTable;

	void					ConstructMacroTable();
	int                     Load(SvStream&);
	BOOL                    Store(SvStream&);

public:
				SfxEventConfigItem_Impl( USHORT,
					SfxEventConfiguration*,
					SfxObjectShell* pObjSh = NULL );
				~SfxEventConfigItem_Impl();

	void					Init( SfxConfigManager* );
	virtual int             Load(SotStorage&);
	virtual BOOL            Store(SotStorage&);
	virtual String          GetStreamName() const;
	virtual void			UseDefault();
	void					ConfigureEvent( USHORT nPos, SvxMacro* );
};

class SfxMacroQueryDlg_Impl : public ModalDialog
{
	FixedImage				aIcon;
	FixedText				aFTMessage;
	CheckBox				aCBWarning;
	OKButton				aOKButton;
	CancelButton			aCancelButton;

public:
				SfxMacroQueryDlg_Impl( const ResId& rResId );
	void					SetWarningState( BOOL bOn )
				{ aCBWarning.Check( !bOn ); }
	BOOL					GetWarningState() const
				{ return !aCBWarning.IsChecked(); }
	void					HideCheckBox()
				{ aCBWarning.Hide(); }
};

#endif

#endif
