

#ifndef _EXCHOBJ_HXX
#define _EXCHOBJ_HXX

#ifndef _DEBUG_HXX 
#include <tools/debug.hxx>
#endif
#ifndef _SO2REF_HXX 
#include <so3/so2ref.hxx>
#endif

class SfxExchangeObject;

SO2_DECL_REF( SfxExchangeObject )

SV_DECL_IMPL_REF_LIST( SvDataObject, SvDataObject* )

class SfxExchangeObject : public SvDataObject
{

	SvDataObjectMemberList*       _pObjList;
	SvDataTypeList*               _pTypeList;

private:

#if 0 // _SOLAR__PRIVATE
	static SfxExchangeObjectRef   DetectObject_Impl( SvDataObject* pObj );

	BOOL                          SetFileList_Impl( SvData* ) const;
#endif

public:

	SO2_DECL_BASIC_CLASS( SfxExchangeObject )
						  SfxExchangeObject();
					  SfxExchangeObject( SvDataObject* pExternal );
	virtual                       ~SfxExchangeObject();

	virtual const SvDataTypeList& GetTypeList() const;
	virtual const SvDataTypeList& GetSetDataTypeList() const;

	virtual BOOL	              SetData( SvData* pData );
	virtual BOOL	              GetData( SvData* pData );
	virtual BOOL	              GetDataHere( SvData* pData );
	virtual BOOL	              QueryDataType( SvDataType& rInOutType );

	inline void                   Insert( SvDataObject* pObj );
	inline SvDataObject*          GetObject( ULONG nIndex ) const;
	inline ULONG                  Count() const;

	static SfxExchangeObjectRef   PasteClipboard();
	static SfxExchangeObjectRef   PasteDragServer( const DropEvent& rEvt );

};

inline void SfxExchangeObject::Insert( SvDataObject* pObj )
{
	DBG_ASSERT( pObj, "SfxExchangeObject:ungueltiges Objekt" );
	_pObjList->Insert( pObj, LIST_APPEND );
}

inline SvDataObject* SfxExchangeObject::GetObject( ULONG nIndex ) const
{
	DBG_ASSERT( nIndex < Count(), "SfxExchangeObject:ungueltige Indizierung" );
	return _pObjList->GetObject( nIndex );
}

inline ULONG SfxExchangeObject::Count() const
{
	return _pObjList->Count();
}

SO2_IMPL_REF( SfxExchangeObject )

#endif

