
#ifndef _FILEDLGHELPER_HXX
#define _FILEDLGHELPER_HXX

#ifndef  _COM_SUN_STAR_UNO_REFERENCE_HXX_
#include <com/sun/star/uno/Reference.hxx>
#endif

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif
#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif
#ifndef _ERRCODE_HXX
#include <tools/errcode.hxx>
#endif

#ifndef _SV_DIALOG_HXX
#include <vcl/dialog.hxx>
#endif
#ifndef _SV_EDIT_HXX
#include <vcl/edit.hxx>
#endif
#ifndef _SV_BUTTON_HXX
#include <vcl/button.hxx>
#endif
#ifndef _SV_GRAPH_HXX
#include <vcl/graph.hxx>
#endif

#ifndef  _SFXDEFS_HXX
#include <sfx2/sfxdefs.hxx>
#endif
#ifndef  _SFX_SFXUNO_HXX
#include <sfx2/sfxuno.hxx>
#endif

namespace com
{
	namespace sun
	{
	    namespace star
	    {
	        namespace ui
	        {
	            namespace dialogs
	            {
					class XFilePicker;
	    class XFilePickerListener;
	            }
	        }
	    }
	}
}

class SfxItemSet;
class SfxObjectFactory;
class SvStringsDtor;
class Window;

#define SFXWB_INSERT			( 0x04000000L | WB_OPEN )   
#define SFXWB_PASSWORD			WB_PASSWORD                 
#define SFXWB_READONLY			WB_READONLY                 
#define SFXWB_PATHDIALOG		WB_PATH                     
#define SFXWB_CLASSPATH			( 0x08000000L | SFXWB_PATHDIALOG )
#define SFXWB_SHOWALLFOLDER		0x10000000L		
#define SFXWB_MULTISELECTION	0x20000000L		
#define SFXWB_NOREMOTE          0x40000000L
#define SFXWB_SHOWVERSIONS		0x80000000L  	

#define SFXWB_GRAPHIC           0x00800000L     
#define SFXWB_SHOWSTYLES        0x01000000L     

#define FILEDIALOG_FILTER_ALL   "*.*"

#define FILE_OPEN_SERVICE_NAME      "com.sun.star.ui.dialogs.FilePicker"
#define FOLDER_PICKER_SERVICE_NAME  "com.sun.star.ui.dialogs.FolderPicker"

const short FILEOPEN_SIMPLE                                   = 0;
const short FILESAVE_SIMPLE                                   = 1;
const short FILESAVE_AUTOEXTENSION_PASSWORD                   = 2;
const short FILESAVE_AUTOEXTENSION_PASSWORD_FILTEROPTIONS     = 3;
const short FILESAVE_AUTOEXTENSION_SELECTION                  = 4;
const short FILESAVE_AUTOEXTENSION_TEMPLATE                   = 5;
const short FILEOPEN_LINK_PREVIEW_IMAGE_TEMPLATE              = 6;
const short FILEOPEN_PLAY                                     = 7;
const short FILEOPEN_READONLY_VERSION                         = 8;
const short FILEOPEN_LINK_PREVIEW                             = 9;

#if 0 // _SOLAR__PRIVATE
#ifndef DONT_USE_FILE_DIALOG_SERVICE

class SfxUrlDialog : public ModalDialog
{
private:
	Edit			aEdit;
	OKButton		aOk;
	CancelButton	aCancel;

public:
		SfxUrlDialog( Window* pParent );

	String			GetUrl() const { return aEdit.GetText(); }
	void 			SetUrl( const String& rUrl ) { aEdit.SetText( rUrl ); }
};

#endif
#endif

namespace sfx2 { 

class FileDialogHelper_Impl;

class FileDialogHelper
{
private:
	::com::sun::star::uno::Reference < ::com::sun::star::ui::dialogs::XFilePickerListener > mxImp;
	FileDialogHelper_Impl	*mpImp;

#if 0 // _SOLAR__PRIVATE
	 const short              getDialogType( sal_uInt32 nFlags ) const;

#endif

public:
				 FileDialogHelper( sal_uInt32 nFlags,
								   const SfxObjectFactory& rFactory );
				 FileDialogHelper( const short nDialogType,
	                                           sal_uInt32 nFlags,
								   const SfxObjectFactory& rFactory );
				 FileDialogHelper( sal_uInt32 nFlags );
				 FileDialogHelper( const short nDialogType,
	                                           sal_uInt32 nFlags );
	                         ~FileDialogHelper();

	ErrCode					 Execute();
	void					 SetTitle( const String&  rNewTitle );
	String					 GetPath() const;
	 void                     AddFilter( const String& rFilterName, const String& rExtension );
	void                     SetCurrentFilter( const String& rFilter );
	void                     SetDisplayDirectory( const String& rPath );
	 String                   GetCurrentFilter() const;
	String                   GetDisplayDirectory() const;
#if SUPD < 639
	Graphic                  GetGraphic() const;
#endif
	ErrCode                  GetGraphic( Graphic& rGraphic ) const;
	 ::com::sun::star::uno::Reference < ::com::sun::star::ui::dialogs::XFilePicker > GetFilePicker() const;

#if 0 // _SOLAR__PRIVATE
	ErrCode					 Execute( const String&   rPath,
						  SvStringsDtor*& rpURLList,
						  SfxItemSet *&   rpSet,
						  String&         rFilter );
	ErrCode					 Execute( SfxItemSet *&   rpSet,
						  String&         rFilter );
#endif
};

#if 0 // _SOLAR__PRIVATE
ErrCode FileOpenDialog_Impl( sal_uInt32 nFlags,
				 const SfxObjectFactory& rFact,
				 SvStringsDtor *& rpURLList,
				 String& rFilter,
				 SfxItemSet *& rpSet,
				 String aPath );
#endif
}

#endif
