

#ifndef _FRMHTML_HXX
#define _FRMHTML_HXX

#include <sfx2/frmdescr.hxx>
#include <sfx2/sfxhtml.hxx>

class SfxFrameHTMLParser;
class SfxDocumentInfo;
class _SfxFrameHTMLContexts;
class SfxFrameSetObjectShell;
class SvULongs;
class SfxMedium;
namespace svtools { class AsynchronLink; }

class _SfxFrameHTMLContext
{
	friend class SfxFrameHTMLParser;
	friend class _SfxFrameHTMLContexts;

	USHORT nLine;
	USHORT nFrame;
	SfxFrameSetDescriptor *pFrameSet;

	_SfxFrameHTMLContext( const SfxFrameHTMLParser *pParser );
	~_SfxFrameHTMLContext();
};

SV_DECL_PTRARR_DEL( _SfxFrameHTMLContexts, _SfxFrameHTMLContext*, 1, 1 )

class SfxFrameHTMLParser : public SfxHTMLParser
{
	friend class _SfxFrameHTMLContext;

	SfxFrameSetObjectShell*	pDoc;				
	SfxFrameSetDescriptor*	pFrameSet;			
	SfxFrameSetDescriptor*	pDocFrameSet;		
	String 					aScriptSource;
	HTMLScriptLanguage 		eScriptType;
	_SfxFrameHTMLContexts 	aContextStack;		

	USHORT 					nLine;				
	USHORT 					nFrame;				

	BOOL 					bIsFrameDoc : 1;	
	BOOL 					bInNoFrames : 1;	
	BOOL					bIgnoreRawData : 1;
	BOOL					bParseScriptAgain : 1;
	svtools::AsynchronLink*	pDeleteLink;
	String					aBaseURL;

	void 					SaveContext();		

	void 					InitContext( SfxFrameSetDescriptor * );
	void 					RestoreContext();	

	SfxFrameDescriptor*		GetCurrentFrame() const;

	void 					IncFramePos();

	void 					ParseSizeSpec( const String& rSpec, SvULongs& rSizes,
					SvUShorts& rAttrs ) const;

	void 					InsertTitle();		
	void 					NewFrameSet();		
	void 					EndFrameSet();		
	void 					InsertFrame();		
	SfxDocumentInfo*		GetDocInfo();

	DECL_STATIC_LINK(		SfxFrameHTMLParser, Delete_Impl, void* );

protected:

	virtual void 			NextToken( int nToken );
	virtual void			Continue( int nToken );
	void					NewScript();
	void					EndScript();

public:
				SfxFrameHTMLParser( SvStream& rStream,
						SfxFrameSetObjectShell* _pDoc=0 );
				SfxFrameHTMLParser( SfxMedium& rMedium,
						SfxFrameSetObjectShell* _pDoc=0 );
				~SfxFrameHTMLParser();

	virtual SvParserState 	CallParser();   
	void					EndParser();	

	BOOL 					IsFrameDoc() const
				{ return bIsFrameDoc; }

	static void 			ParseFrameOptions(SfxFrameDescriptor*,
										const HTMLOptions*);
};

#endif

