
#ifndef _FRMHTMLW_HXX
#define _FRMHTMLW_HXX

#include <sfx2/frmdescr.hxx>

#ifndef _STREAM_HXX
#include <tools/stream.hxx>
#endif

#ifndef _PARHTML_HXX
#include <svtools/parhtml.hxx>
#endif
#ifndef _HTMLOUT_HXX
#include <svtools/htmlout.hxx>
#endif
#ifndef _HTMLKYWD_HXX
#include <svtools/htmlkywd.hxx>
#endif

class SfxDocumentInfo;
class SfxFrameSetObjectShell;
class SfxFrame;

class SfxFrameHTMLWriter
{
	static const sal_Char 	sNewLine[];
	ByteString 				aFill;
	SvStream* 				pStrm;		
	USHORT					nNestCnt;		
	SfxFrameSetObjectShell*	pDoc;

	void 					OutHeader( rtl_TextEncoding eDestEnc );
	void 					OutFooter();	
	void 					OutNestSpace();	
	void 					Out_FrameSetDescriptor(
		const SfxFrameSetDescriptor *pFSet, BOOL bFlatten,
		SfxFrame* pTopFrame, rtl_TextEncoding eDestEnc,
				String *pNonConvertableChars = 0 );
	SvStream& 				Strm()
				{ return *pStrm; }
	static void 			OutMeta( SvStream& rStrm,
					const sal_Char *pIndent, const String& rName,
					const String& rContent, BOOL bHTTPEquiv,
					rtl_TextEncoding eDestEnc,
				String *pNonConvertableChars = 0 );
	inline static void 		OutMeta( SvStream& rStrm,
					const sal_Char *pIndent, const sal_Char *pName,
					const String& rContent, BOOL bHTTPEquiv,
					rtl_TextEncoding eDestEnc,
				String *pNonConvertableChars = 0 );

public:
	SfxFrameHTMLWriter();
	~SfxFrameHTMLWriter();

	static void Out_DocInfo( SvStream& rStrm, const SfxDocumentInfo* pInfo,
				 const sal_Char *pIndent,
				rtl_TextEncoding eDestEnc = RTL_TEXTENCODING_MS_1252,
				String *pNonConvertableChars = 0 );

	static void Out_FrameDescriptor(
		SvStream&, const SfxFrameDescriptor*,
		BOOL bFlatten = FALSE, SfxFrame* pTopFrame = 0,
		rtl_TextEncoding eDestEnc = RTL_TEXTENCODING_MS_1252,
		String *pNonConvertableChars = 0 );

	ULONG Write( SfxFrameSetObjectShell *pDoc,  SvStream& rOut,
	 const SfxFrameSetDescriptor* pSet = 0, BOOL bFlatten = FALSE,
	 SfxFrame* pTopFrame = 0 );
	static String CreateDataURL(SfxFrameSetObjectShell *pDoc,
					const SfxFrameSetDescriptor* pSet,
					SfxFrame* pTopFrame );
	static String CreateURL( SfxFrame* pTopFrame );
};

inline void SfxFrameHTMLWriter::OutMeta( SvStream& rStrm,
				const sal_Char *pIndent, const sal_Char *pName,
				const String& rContent, BOOL bHTTPEquiv,
				rtl_TextEncoding eDestEnc,
				String *pNonConvertableChars )
{
	String sTmp = String::CreateFromAscii( pName );
	OutMeta( rStrm, pIndent, sTmp, rContent, bHTTPEquiv, eDestEnc, pNonConvertableChars );
}

inline void SfxFrameHTMLWriter::OutFooter()
{

	HTMLOutFuncs::Out_AsciiTag( Strm(), sHTML_html, FALSE ) << sNewLine;
}

inline void SfxFrameHTMLWriter::OutNestSpace()
{
	if( nNestCnt>0 )
		Strm() << aFill.Copy( 0, nNestCnt ).GetBuffer();
}

#endif

