
#ifndef _FSETOBJSH_HXX
#define _FSETOBJSH_HXX

#include <sfx2/objsh.hxx>
#include <sfx2/docfac.hxx>

class SfxFrameSetDescriptor;
class SfxFrameSetObjectShell_Impl;
class SvStrings;

class SfxFrameSetObjectShell: public SfxObjectShell
{
friend class SfxFrameHTMLParser;
	SfxFrameSetDescriptor*          pDescriptor;
	SfxFrameSetObjectShell_Impl*	pImp;

protected:
	virtual void    FillClass( SvGlobalName * pClassName,
					   sal_uInt32 * pClipFormat,
					   String * pAppName,
					   String * pLongUserName,
					   String * pUserName ) const;
public:
		TYPEINFO();
		SfxFrameSetObjectShell(SfxObjectCreateMode = SFX_CREATE_MODE_EMBEDDED);
		~SfxFrameSetObjectShell();
			SFX_DECL_INTERFACE(SFX_INTERFACE_SFXFRAMESETOBJ);
	                SFX_DECL_SIMPLE_OBJECTFACTORY(SfxFrameSetObjectShell);

	virtual sal_Bool    ConvertTo( SfxMedium& rMed );
	virtual sal_Bool    ConvertFrom( SfxMedium& rMed );
	void 			Exec_Impl(SfxRequest&);
	void 			State_Impl(SfxItemSet&);
	virtual sal_Bool	InitNew( SvStorage* );
	virtual sal_Bool	Load( SvStorage* );
	virtual sal_Bool    Save();
	virtual sal_Bool    SaveAs( SvStorage* );
	virtual sal_Bool	SaveCompleted( SvStorage* );

	const SfxFrameSetDescriptor*
		GetFrameSetDescriptor() const
		{ return pDescriptor; }
	sal_Bool			Initialize( const String& );
	void			TakeDescriptor( SfxFrameSetDescriptor *pSet );
	void			ReInit_Impl( SfxFrameSetDescriptor *pSet);
	String			GetSource();
	void			TakeSource( const String& rSource );
	void			SetScriptsAndComments( SvStrings*, SvStrings* );
};

#include <cppuhelper/weak.hxx>
#include <sfx2/objuno.hxx>
#ifndef _COM_SUN_STAR_FRAME_XFRAMESETMODEL_HPP_
#include <com/sun/star/frame/XFrameSetModel.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XSERVICENAME_HPP_
#include <com/sun/star/lang/XServiceName.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XSERVICEINFO_HPP_
#include <com/sun/star/lang/XServiceInfo.hpp>
#endif
namespace com{namespace sun{namespace star{namespace lang{
class XMultiServiceFactory;
}}}}

class SfxFrameSetModel	:	public SfxBaseModel								,
				public ::com::sun::star::frame::XFrameSetModel	,
				public ::com::sun::star::lang::XServiceInfo
{
	SfxFrameSetObjectShell* pDoc;
	::rtl::OUString				aSource;
public:
	SfxFrameSetModel( const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory > & xFactory );
	SfxFrameSetModel( SfxFrameSetObjectShell *pDoc );
	virtual ~SfxFrameSetModel();

	SFX_DECL_XINTERFACE_XTYPEPROVIDER_XSERVICEINFO

	virtual	void SAL_CALL setSource( const ::rtl::OUString& rSource ) throw ( ::com::sun::star::uno::RuntimeException );
	virtual ::rtl::OUString SAL_CALL getSource() throw ( ::com::sun::star::uno::RuntimeException );
};

#endif

