
#ifndef _SFXFSETVIW_HXX
#define _SFXFSETVIW_HXX

#include <sfx2/viewsh.hxx>

class SfxFrameSetDescriptor;
class SfxFrame;
class SfxURLFrame;
struct SfxFrameSet_Impl;
class SplitWindow;

class SfxFrameSetViewShell: public SfxViewShell
{
friend class SfxFrameSetWindow_Impl;
	SfxFrameSetDescriptor*	pDescriptor;
	BOOL					bEditMode;
	SfxFrameSet_Impl*		pImp;

private:
	void            Construct();
	DECL_LINK(		EventHdl_Impl, void*);

protected:
	virtual void    OuterResizePixel( const Point &rOfs, const Size &rSize );
	virtual void    InnerResizePixel( const Point &rOfs, const Size &rSize );
	virtual void    SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCType,
				const SfxHint& rHint, const TypeId& rHintType );
public:
		TYPEINFO();
		SfxFrameSetViewShell( SfxViewFrame *pFrame,
							  const SfxFrameSetViewShell& rWin,
							  USHORT nFlags = SFX_VIEW_MAXIMIZE_FIRST );
		SfxFrameSetViewShell( SfxViewFrame *pFrame,
							  SfxViewShell *pOld,
							  USHORT nFlags = SFX_VIEW_MAXIMIZE_FIRST );
		~SfxFrameSetViewShell();
			SFX_DECL_INTERFACE( SFX_INTERFACE_SFXFRAMESETVIEWSH );
	virtual void    Activate( BOOL bMDI );
	void			Fill( const SfxFrameSetDescriptor* pSet );
	void			ReFill( const SfxFrameSetDescriptor* pSet );
	void			MakeWindows( const SfxFrameSetDescriptor*,
								SfxFrame*, USHORT );
	SplitWindow*	GetSplitWindow() const;

	BOOL			IsInEditMode() const
		{ return bEditMode; }

	void			SetEditMode( BOOL bSet )
		{ bEditMode = bSet; }

	void 			SetActiveFrame( SfxFrame* );
	SfxFrame*		GetActiveFrame() const;

	const SfxFrameSetDescriptor*
		GetDescriptor() const
		{ return pDescriptor; }

	void 			UpdateFrameBorder( SfxFrameSetDescriptor* pSet=NULL );
	long			GetDefaultSplitSize() const;

	SfxFrameSetViewShell*
		GetParentFrameSet() const;
	void 			SaveUndo( SfxFrameSetDescriptor* pUndo,
				SfxFrameSetDescriptor *pRedo, const String&, BOOL bClose = FALSE );

	BOOL            StartEditing();
	BOOL            EndEditing();
	USHORT          GetItemId( SfxFrame* );
	USHORT          GetCurItemId();
	SfxFrame*   	Split( USHORT, USHORT );
	void            SetFrameContent( USHORT, const String& );
	void            SetFrameName( USHORT, const String& );
	void            ModifyFrame( USHORT, const SfxItemSet& );
	void            DeleteFrame( USHORT );
	void 			SetFrameSpacing( long nValue );
	void			ForceInit( BOOL bWithFrames = TRUE );

#if 0 // _SOLAR__PRIVATE
	SfxFrameSetDescriptor*
		GetDescriptor_Impl()
		{ return pDescriptor; }
	void			FrameFinishedLoading_Impl( SfxFrame *pFrame );
	DECL_LINK(		SplitHdl_Impl, SfxFrameSetWindow_Impl* );
	void			UpdateFrame_Impl( SfxURLFrame* );
#endif
};

#endif

