
#ifndef _SFXIMGMGR_HXX
#define _SFXIMGMGR_HXX

#include <sfx2/cfgitem.hxx>

#include <sfx2/imgdef.hxx>

#include <sal/types.h>
#include <tools/link.hxx>

#ifndef _GEN_HXX 
#include <tools/gen.hxx>
#endif
#ifndef _IMAGE_HXX 
#include <vcl/image.hxx>
#endif

class ToolBox;
class SfxObjectShell;
class SfxModule;
class SfxToolBoxManager;
class SfxImageManager_Impl;
struct SfxImageManagerData_Impl;
class SfxImageManager
{
	SfxImageManager_Impl* pImp;
	SfxImageManagerData_Impl* pData;
	 void            SetSymbolSet_Impl( sal_Int16 );
	void            SetOutStyle_Impl( sal_Int16 );
	void            ExchangeItemImage_Impl( USHORT nId, const Image& rImage );
	DECL_LINK(      OptionsChanged_Impl, void* );
	DECL_LINK(      ConfigChanged_Impl, void* );

public:
	static BOOL     Import( SvStream& rInStream, SotStorage& rOutStorage );
	static BOOL     Export( SotStorage& rInStorage, SvStream& rOutStream );
	static BOOL		Copy( SotStorage& rIn, SotStorage& rOut );
	static Image    GetGlobalImage( USHORT nId, BOOL bBig );
			SfxImageManager( SfxObjectShell* pDoc );
		~SfxImageManager();

	Size            GetImageSize() const;
	Color			GetMaskColor() const;

	Image           GetImage(USHORT nId, SfxModule* pMod = 0) const;
	void			SetImages( ToolBox& rToolBox, SfxModule* );
	void            LockImage(USHORT nNewId, ToolBox *pBox);
	Image           GetImage(USHORT nId, SfxModule* pMod, BOOL bBig ) const;

	void			ReplaceImage(USHORT nId, Bitmap* pBmp=0);
	void			AddImage(USHORT nId, const Image& rImage);

	void            StartCustomize();
	void            EndCustomize();
	Image           SeekImage(USHORT nId, SfxModule* pModule = 0) const;

	void			RegisterToolBox(ToolBox*, USHORT nFlags=0xFFFF );
	void			RegisterToolBox(ToolBox*, SfxModule*, USHORT nFlags=0xFFFF );
	void			ReleaseToolBox(ToolBox*);
	void			RegisterToolBoxManager(SfxToolBoxManager*, USHORT nFlags=0xFFFF );
	void			ReleaseToolBoxManager(SfxToolBoxManager*);

#if 0 // _SOLAR__PRIVATE
	BOOL			IsUserDef_Impl(USHORT nId) const;
	const Bitmap&	GetUserDefBitmap_Impl(USHORT nId) const;
	Image           GetAndLockImage_Impl(USHORT nId, SfxModule* pMod = 0);
	Image			GetImageFromModule_Impl( USHORT nId, SfxModule *pMod );
#endif
};

#endif
