
#ifndef _SFX_INTERNO_HXX
#define _SFX_INTERNO_HXX

#ifndef _IPOBJ_HXX 
#include <so3/ipobj.hxx>
#endif
#include <sfx2/objsh.hxx>
#include <sfx2/ipfrm.hxx>
#include <sfx2/sfx.hrc>

struct SfxChild_Impl;
struct SfxInPlaceObject_Impl;
class SfxToolBoxManager;
class SfxObjectShell;
class SfxMenuBarManager;
class SfxAcceleratorManager;
class SvInPlaceMenuBar;
class INote;
class SfxInPlaceFrame;
class SfxViewFrame;

class SfxInPlaceObject : public SvInPlaceObject
{
	SfxObjectShell* 	pObjShell;
	SfxViewFrame*		pFrame;
	INote*              pNote;
	BOOL                bTriggerLinkTimer : 1;
	BOOL				bDisableViewScaling : 1;

#if 0 // _SOLAR__PRIVATE
private:
	SfxInPlaceFrame*    GetIPFrame_Impl() const {
				return PTR_CAST(SfxInPlaceFrame,pFrame); }

public:
	SfxViewFrame*       GetViewFrame_Impl() const
			{ return pFrame; }
#endif
#if SUPD>556
	                    SO2_DECL_STANDARD_CLASS(SfxInPlaceObject)
#endif
public:
	SfxObjectShell*     GetObjectShell() const { return pObjShell; }

protected:
	void                SetShell( SfxObjectShell *pObjSh )
			{ pObjShell = pObjSh; }

	virtual void        FillClass( SvGlobalName * pClassName,
					   ULONG * pClipFormat,
					   String * pAppName,
					   String * pLongUserName,
	                               String * pUserName,
	                               long nVersion = SOFFICE_FILEFORMAT_CURRENT
	) const;

	virtual void        TopWinActivate( BOOL bActivate );
	virtual void        DocWinActivate( BOOL bActivate );
	virtual BOOL        InitNew( SvStorage * );         
	virtual BOOL        Load( SvStorage * );            
	virtual BOOL        Save();                         
	virtual BOOL        SaveAs( SvStorage * pNewStg );  
	virtual void        HandsOff();                     
	virtual BOOL        SaveCompleted( SvStorage * );   

	virtual ErrCode		Verb( long nVerbPos,
				SvEmbeddedClient *pCaller,
				Window *pWin,
				const Rectangle *pWorkAreaPixel );
	virtual BOOL		Verb( long nVerbPos, const Rectangle *pWorkAreaPixel );
	virtual void        Embed( BOOL bEmbedded );
	virtual void        Open( BOOL bOpen );
	virtual void        InPlaceActivate( BOOL );
	virtual void        UIActivate( BOOL );
	virtual void		DocumentNameChanged( const String & rDocName );

	virtual 			~SfxInPlaceObject();

public:
			SfxInPlaceObject();

	void                SetTriggerLinkTimer( BOOL bSet )
			{ bTriggerLinkTimer = bSet; }
	void                UpdateLinks();

	virtual void        SetVisArea( const Rectangle & rVisArea );

	void				SetModified( BOOL bSet );
	void				DisableViewScaling( BOOL bSet )
			{ bDisableViewScaling = bSet; }
	BOOL				IsViewScalingDisabled()
			{ return bDisableViewScaling; }
};

#ifndef SFX_DECL_INTERNALOBJECT_DEFINED
#define SFX_DECL_INTERNALOBJECT_DEFINED
SO2_DECL_REF(SfxInPlaceObject)
#endif
SO2_IMPL_REF(SfxInPlaceObject)

#if 0 // _SOLAR__PRIVATE
class SfxForceLinkTimer_Impl
{
	SfxInPlaceObject *pInObj;

public:
	SfxForceLinkTimer_Impl( SfxObjectShell *pObj );
	~SfxForceLinkTimer_Impl()
	{ if( pInObj ) pInObj->SetTriggerLinkTimer( TRUE ); }
};
#endif

#endif

