
#ifndef _SFXMODULE_HXX
#define _SFXMODULE_HXX	
#define _SFXMOD_HXX		

#ifndef _SFX_SHELL_HXX
#include <sfx2/shell.hxx>
#endif

#ifndef _SFX_IMGDEF_HXX
#include <sfx2/imgdef.hxx>
#endif
#ifndef _SAL_TYPES_H_
#include <sal/types.h>
#endif
class ImageList;

class SfxAcceleratorManager;
class SfxMenuBarManager;
class SfxBindings;
class SfxObjectFactory;
class ModalDialog;
class SfxObjectFactory;
class SfxModuleArr_Impl;
class SfxModule_Impl;
class SfxSlotPool;
struct SfxChildWinContextFactory;
struct SfxChildWinFactory;
struct SfxMenuCtrlFactory;
struct SfxStbCtrlFactory;
struct SfxTbxCtrlFactory;
class SfxTbxCtrlFactArr_Impl;
class SfxChildWinFactArr_Impl;
class SfxMenuCtrlFactArr_Impl;
class SfxStbCtrlFactArr_Impl;
class SfxTabPage;
class Window;

class ISfxModule
{
public:
	virtual ModalDialog*	CreateAboutDialog() = 0;
	virtual					~ISfxModule(){};
	virtual ResMgr*			GetResMgr() = 0;
};

class SfxModule : public SfxShell, public ISfxModule
{
private:
	ResMgr*                     pResMgr;
	sal_Bool                    bDummy : 1;
	SfxModule_Impl*             pImpl;

#if 0 // _SOLAR__PRIVATE
	void 						Construct_Impl();
#endif

protected:
	virtual sal_Bool                QueryUnload();

public:
					TYPEINFO();
					SFX_DECL_INTERFACE(SFX_INTERFACE_SFXMODULE);
						SfxModule( ResMgr* pMgrP, sal_Bool bDummy,
						SfxObjectFactory* pFactoryP, ... );
					~SfxModule();

	virtual	SfxModule*			Load();
	virtual void            	Free();
	sal_Bool						IsLoaded() const { return !bDummy; }

	virtual ModalDialog*		CreateAboutDialog();
	virtual ResMgr*             GetResMgr();
	SfxSlotPool*				GetSlotPool() const;

	void						RegisterToolBoxControl(SfxTbxCtrlFactory*);
	void                        RegisterChildWindow(SfxChildWinFactory*);
	void                        RegisterChildWindowContext( sal_uInt16,	SfxChildWinContextFactory* );
	void                        RegisterStatusBarControl(SfxStbCtrlFactory*);
	void                        RegisterMenuControl(SfxMenuCtrlFactory*);

	virtual SfxTabPage*			CreateTabPage( sal_uInt16 nId,
								   Window* pParent,
								   const SfxItemSet& rSet );
	virtual void                Invalidate(USHORT nId = 0);

#if 0 // _SOLAR__PRIVATE
	static SfxModuleArr_Impl&   GetModules_Impl();
	SfxTbxCtrlFactArr_Impl* 	GetTbxCtrlFactories_Impl() const;
	SfxStbCtrlFactArr_Impl* 	GetStbCtrlFactories_Impl() const;
	SfxMenuCtrlFactArr_Impl* 	GetMenuCtrlFactories_Impl() const;
	SfxChildWinFactArr_Impl*	GetChildWinFactories_Impl() const;
	ImageList*                  GetImageList_Impl( BOOL bBig );
#endif
};

#define SFX_IMPL_MODULE_LIBRARY( LibName )									\
																\
		extern "C" void _CDECLARE_ Init##LibName##Dll()                     \
		{																	\
			LibName##DLL::Init();											\
		}																	\
		extern "C" void _CDECLARE_ DeInit##LibName##Dll()                   \
		{																	\
			LibName##DLL::Exit();											\
		}

#endif

