
#ifndef	_SFXMSG_HXX
#define	_SFXMSG_HXX

#ifndef _RTTI_HXX
#include <tools/rtti.hxx>
#endif
#include <sfx2/shell.hxx>

#define SFX_SLOT_CACHABLE		   0x0001L 
#define SFX_SLOT_VOLATILE		   0x0002L 
#define SFX_SLOT_TOGGLE 		   0x0004L 
#define SFX_SLOT_AUTOUPDATE 	   0x0008L 

#define SFX_SLOT_SYNCHRON		   0x0010L 
#define SFX_SLOT_ASYNCHRON		   0x0020L 

#define SFX_SLOT_HASCOREID		   0x0040L 
#define SFX_SLOT_HASDIALOG		   0x0080L 

#define SFX_SLOT_NORECORD		   0x0100L 
#define SFX_SLOT_RECORDPERITEM	   0x0200L 
#define SFX_SLOT_RECORDPERSET	   0x0400L 
#define SFX_SLOT_RECORDMANUAL	   0x0800L 

#define SFX_SLOT_RECORDABSOLUTE 0x1000000L 
#define SFX_SLOT_STANDARD		( SFX_SLOT_CACHABLE | \
					  SFX_SLOT_SYNCHRON | \
					  SFX_SLOT_RECORDPERSET )

#define SFX_SLOT_PROPGET		  0x1000L  
#define SFX_SLOT_PROPSET		  0x2000L  
#define SFX_SLOT_METHOD 		  0x4000L  

#define SFX_SLOT_FASTCALL		  0x8000L  

#define SFX_SLOT_STATUSBARCONFIG 0x10000L  
#define SFX_SLOT_MENUCONFIG 	 0x20000L  
#define SFX_SLOT_TOOLBOXCONFIG	 0x40000L  
#define SFX_SLOT_ACCELCONFIG	 0x80000L  

#define SFX_SLOT_CONTAINER		0x100000L  
#define SFX_SLOT_READONLYDOC	0x200000L  
#define SFX_SLOT_PLUGCOMM	    0x400000L  

class SfxRequest;
class SfxItemSet;

#define SFX_EXEC_STUB( aShellClass, aExecMethod) \
 void __EXPORT SfxStub##aShellClass##aExecMethod( \
   SfxShell *pShell, SfxRequest& rReq) \
  { \
	(( aShellClass* ) pShell )->aExecMethod( rReq ); \
  }

#define SFX_STATE_STUB( aShellClass, aStateMethod) \
 void  __EXPORT SfxStub##aShellClass##aStateMethod( \
   SfxShell *pShell, SfxItemSet& rSet) \
  { \
	(( aShellClass* ) pShell )->aStateMethod( rSet ); \
  }

#define SFX_STUB_PTR( aShellClass, aMethod ) \
   &SfxStub##aShellClass##aMethod

#define SFX_STUB_PTR_EXEC_NONE &SfxShell::EmptyExecStub

#define SFX_STUB_PTR_STATE_NONE &SfxShell::EmptyStateStub

enum SfxSlotKind
{
	SFX_KIND_STANDARD,
	SFX_KIND_ENUM,
	SFX_KIND_ATTR
};

struct SfxTypeAttrib
{
	USHORT					nAID;
	const char __FAR_DATA*	pName;
};

struct SfxType
{
	TypeId			aTypeId;
	USHORT			nAttribs;
	SfxTypeAttrib	aAttrib[16];

	const TypeId&	Type() const
		{ return aTypeId; }
	SfxPoolItem*	CreateItem() const
		{ return (SfxPoolItem*) aTypeId(); }
};

struct SfxType0
{
	TypeId			aTypeId;
	USHORT			nAttribs;

	const TypeId&	Type() const
		{ return aTypeId; }
	SfxPoolItem*	CreateItem() const
		{ return (SfxPoolItem*) aTypeId(); }
};

#define SFX_DECL_TYPE(n)    struct SfxType##n                   \
				{ 									\
					TypeId			aTypeId; 		\
					USHORT			nAttribs; 		\
					SfxTypeAttrib	aAttrib[n]; 	\
				}

#define SFX_TYPE(Class) &a##Class##_Impl

SFX_DECL_TYPE(1);
SFX_DECL_TYPE(2);
SFX_DECL_TYPE(3);
SFX_DECL_TYPE(4);
SFX_DECL_TYPE(5);
SFX_DECL_TYPE(6);
SFX_DECL_TYPE(7);
SFX_DECL_TYPE(8);

SFX_DECL_TYPE(14);
SFX_DECL_TYPE(15); 
SFX_DECL_TYPE(22); 

#define SFX_SLOT_ARG( aShellClass, id, GroupId, ExecMethodPtr, StateMethodPtr, Flags, ItemClass, nArg0, nArgs, Name, Prop ) \
	  { id, GroupId, id, Flags | Prop, \
	 USHRT_MAX, 0, \
	             ExecMethodPtr, \
	             StateMethodPtr, \
	 (const SfxType*) &a##ItemClass##_Impl, \
	 Name, Name, 0, 0, \
	 &a##aShellClass##Args_Impl[nArg0], nArgs, 0 \
	  }

#define SFX_SLOT( aShellClass, id, GroupId, ExecMethodPtr, StateMethodPtr, Flags, ItemClass ) \
	  { id, GroupId, id, Flags, \
	 0, 0, \
	             ExecMethodPtr, \
	             StateMethodPtr, \
	 (const SfxType*) &a##ItemClass##_Impl, \
	 0, 0, 0, 0, 0, 0, 0 \
	  }

#define SFX_SLOT_ATTR( id, GroupId, Dummy, ExecMethodPtr, StateMethodPtr, Flags, ItemClass ) \
	  { id, GroupId, id, Flags, \
	 USHRT_MAX, 0, \
	             ExecMethodPtr, \
	             StateMethodPtr, \
	 (const SfxType*) &a##ItemClass##_Impl, \
	 0, 0, 0, 0, 0, 0, 0 \
	  }

#define SFX_SLOT_ENUM( SlaveId, GroupId, MasterId, Value, Flags ) \
	  { SlaveId, GroupId, id, Flags,	 \
	 MasterId,	Value, 0, 0, \
	 (const SfxType*) &aSfxBoolItem_Impl, \
	 0, 0, 0, 0, 0, 0, 0 \
	           }
#define SFX_NEW_SLOT_ARG( aShellClass, id, hid, GroupId, pLinked, pNext, ExecMethodPtr, StateMethodPtr, Flags, DisableFlags, ItemClass, nArg0, nArgs, Name, Prop, UnoName ) \
	  { id, GroupId, hid, Flags | Prop, \
	 USHRT_MAX, 0, \
	             ExecMethodPtr, \
	             StateMethodPtr, \
	 (const SfxType*) &a##ItemClass##_Impl, \
	 Name, Name, \
	 pLinked, pNext, \
	 &a##aShellClass##Args_Impl[nArg0], nArgs, DisableFlags, UnoName \
	  }

#define SFX_NEW_SLOT_ENUM( SlaveId, hid, GroupId, pMaster, pNext, MasterId, Value, Flags, DisableFlags, UnoName  ) \
	  { SlaveId, GroupId, hid, Flags,	 \
	 MasterId,	Value, \
	 0, \
	 0, \
	 (const SfxType*) &aSfxBoolItem_Impl, \
	 0, 0, \
	 pMaster, \
	 pNext, \
	 0, 0, DisableFlags, UnoName \
	           }

#define SFX_SLOTMAP_NONE(ShellClass) \
			static SfxFormalArgument __FAR_DATA a##ShellClass##Args_Impl[1]; \
			static SfxSlot __FAR_DATA a##ShellClass##Slots_Impl[] = \
			{ { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 } }

#define SFX_ARGUMENT( ArgSlotId, ArgName, ArgTypeId ) \
			{ (const SfxType*) &a##ArgTypeId##_Impl, ArgName, ArgSlotId }

class SfxPoolItem;

struct SfxFormalArgument
{
	const SfxType*			pType;	
	const char __FAR_DATA*	pName;	
	USHORT      			nSlotId;

	const TypeId&			Type() const
				{ return pType->aTypeId; }
	SfxPoolItem*			CreateItem() const
				{ return (SfxPoolItem*) pType->aTypeId(); }
};

class SfxSlot
{
public:
	USHORT						nSlotId;		
	USHORT						nGroupId;		
	ULONG						nHelpId;		
	ULONG						nFlags;			

	USHORT						nMasterSlotId;	
	USHORT						nValue;			

	SfxExecFunc			        fnExec;			
	SfxStateFunc		        fnState;		

	const SfxType*				pType;			
	const char __FAR_DATA*		pName;			
	const char __FAR_DATA*		pMethodName;	

	const SfxSlot*				pLinkedSlot;	
	const SfxSlot*				pNextSlot;		

	const SfxFormalArgument*	pFirstArgDef;	
	USHORT						nArgDefCount;	
	long						nDisableFlags;		

#if SUPD>380
	const char __FAR_DATA*		pUnoName;		
#endif

public:

	SfxSlotKind 	GetKind() const;
	USHORT			GetSlotId() const;
	ULONG			GetHelpId() const;
	ULONG			GetMode() const;
	BOOL			IsMode( ULONG nMode ) const;
	USHORT			GetGroupId() const;
	USHORT			GetMasterSlotId() const { return nMasterSlotId; }
	USHORT			GetWhich( const SfxItemPool &rPool ) const;
	USHORT			GetValue() const { return nValue; }
	const SfxType*  GetType() const { return pType; }
#if SUPD>380
	const char*		GetUnoName() const { return pUnoName; }
#endif

	USHORT			GetFormalArgumentCount() const { return nArgDefCount; }
	const SfxFormalArgument& GetFormalArgument( USHORT nNo ) const
		{ return pFirstArgDef[nNo]; }

	SfxExecFunc 	GetExecFnc() const { return fnExec; }
	SfxStateFunc	GetStateFnc() const { return fnState; }

	const SfxSlot*	GetLinkedSlot() const { return pLinkedSlot; }
	const SfxSlot*	GetNextSlot() const { return pNextSlot; }
};

inline USHORT SfxSlot::GetSlotId() const
{
	return nSlotId;
}

inline ULONG SfxSlot::GetHelpId() const
{
	return nHelpId;
}

inline ULONG SfxSlot::GetMode() const
{
	return nFlags;
}

inline BOOL SfxSlot::IsMode( ULONG nMode ) const
{
	return (nFlags & nMode)	!= 0;
}

inline USHORT SfxSlot::GetGroupId() const
{
	return nGroupId;

}

#endif
