
#ifndef _SFXNEW_HXX
#define _SFXNEW_HXX

#ifndef _BUTTON_HXX 
#include <vcl/button.hxx>
#endif
#ifndef _LSTBOX_HXX 
#include <vcl/lstbox.hxx>
#endif
#ifndef _EDIT_HXX 
#include <vcl/edit.hxx>
#endif
#ifndef _FIXED_HXX 
#include <vcl/fixed.hxx>
#endif
#include <sfx2/basedlgs.hxx>

class SfxObjectShellLock;
class SfxDocumentInfo;
class SfxObjectShell;
class SvStorageRef;
class MoreButton;

#define SFXWB_DOCINFO 0x0001
#define SFXWB_PREVIEW 0x0003
#define SFXWB_LOAD_TEMPLATE 0x0004

#define SFX_LOAD_TEXT_STYLES    0x0001
#define SFX_LOAD_FRAME_STYLES   0x0002
#define SFX_LOAD_PAGE_STYLES    0x0004
#define SFX_LOAD_NUM_STYLES     0x0008
#define SFX_MERGE_STYLES        0x0010

#define RET_TEMPLATE_LOAD       100

class SfxPreviewWin: public Window
{
	SfxObjectShellLock &rDocShell;
protected:
	virtual void	Paint( const Rectangle& rRect );
public:
	SfxPreviewWin( Window* pParent,
	   const ResId& rResId,
	   SfxObjectShellLock &rDocSh );
};

class SfxNewFileDialog_Impl;
class SfxNewFileDialog : public SfxModalDialog
{
	friend class SfxNewFileDialog_Impl;
private:

	SfxNewFileDialog_Impl* pImpl;
protected:
	virtual BOOL FillDocumentInfo(const String &rFile, SfxDocumentInfo &);
public:

	SfxNewFileDialog(Window *pParent, USHORT nFlags = 0);
	~SfxNewFileDialog();

	BOOL IsTemplate() const;
	String GetTemplateRegion() const;
	String GetTemplateName() const;
	String GetTemplateFileName() const;
	 USHORT  GetTemplateFlags()const;
	void    SetTemplateFlags(USHORT nSet);
};

#endif
