
#ifndef _SFX_PASSWD_HXX
#define _SFX_PASSWD_HXX

#ifndef _SV_BUTTON_HXX
#include <vcl/button.hxx>
#endif
#ifndef _SV_DIALOG_HXX
#include <vcl/dialog.hxx>
#endif
#ifndef _SV_EDIT_HXX
#include <vcl/edit.hxx>
#endif
#ifndef _SV_FIXED_HXX
#include <vcl/fixed.hxx>
#endif

#define SHOWEXTRAS_NONE		((USHORT)0x0000)
#define SHOWEXTRAS_USER		((USHORT)0x0001)
#define SHOWEXTRAS_CONFIRM	((USHORT)0x0002)
#define SHOWEXTRAS_ALL		((USHORT)(SHOWEXTRAS_USER | SHOWEXTRAS_CONFIRM))

class SfxPasswordDialog : public ModalDialog
{
private:
	FixedText		maUserFT;
	Edit			maUserED;
	FixedText		maPasswordFT;
	Edit			maPasswordED;
	FixedText		maConfirmFT;
	Edit			maConfirmED;
	FixedLine       maPasswordBox;

	OKButton		maOKBtn;
	CancelButton	maCancelBtn;
	HelpButton		maHelpBtn;

	String			maConfirmStr;
	USHORT			mnMinLen;
	USHORT			mnExtras;

#if 0 // _SOLAR__PRIVATE
	DECL_LINK( EditModifyHdl, Edit* );
	DECL_LINK( OKHdl, OKButton* );
#endif

public:
	SfxPasswordDialog( Window* pParent, const String* pGroupText = NULL );

	String			GetUser() const	{ return maUserED.GetText(); }
	String			GetPassword() const { return maPasswordED.GetText(); }
	String			GetConfirm() const { return maConfirmED.GetText(); }

	void 			SetMinLen( USHORT Len );
	void			SetEditHelpId( ULONG nId ) { maPasswordED.SetHelpId( nId ); }
	void			ShowExtras( USHORT nExtras ) { mnExtras = nExtras; }

	virtual short	Execute();
};

#endif 

