
#ifndef _SFX_HELP_HXX
#define _SFX_HELP_HXX

#ifndef _HELP_HXX 
#include <vcl/help.hxx>
#endif

#include <tools/string.hxx>

class SfxHelp_Impl;
class SfxFrame;
class SfxHelp : public Help
{
	String          aTicket;        
	String          aUser;
	String			aLanguageStr;
	String			aCountryStr;
	sal_Bool		bIsDebug;
	SfxHelp_Impl*   pImp;

private:
	virtual BOOL	Start( ULONG nHelpId, const Window* pWindow );
	virtual BOOL    Start( const String& rURL, const Window* pWindow );

	String          GetHelpModuleName_Impl( ULONG nHelpId );
	String			CreateHelpURL_Impl( ULONG nHelpId, const String& rModuleName );

public:
	                 SfxHelp();
	                ~SfxHelp();
	void            SetTicket( const String& rTicket )
	                { aTicket = rTicket;}
	void            SetUser( const String& rUser )
	                { aUser = rUser;}

	virtual XubString	GetHelpText( ULONG nHelpId, const Window* pWindow );

	static String		CreateHelpURL( ULONG nHelpId, const String& rModuleName );
	static void      	OpenHelpAgent( SfxFrame* pFrame, ULONG nHelpId );
};

#endif 

