
#ifndef _SFX_STYFITEM_HXX
#define _SFX_STYFITEM_HXX

#ifndef _BITMAP_HXX 
#include <vcl/bitmap.hxx>
#endif
#ifndef _IMAGE_HXX 
#include <vcl/image.hxx>
#endif
#ifndef _LIST_HXX 
#include <tools/list.hxx>
#endif
#ifndef _RC_HXX 
#include <vcl/rc.hxx>
#endif
#ifndef _RSCSFX_HXX
#include <rsc/rscsfx.hxx>
#endif

#ifndef _SFX_STYFITEM_HXX_NOLIST
struct SfxFilterTupel {
	String aName;
	USHORT nFlags;
};

DECLARE_LIST(SfxStyleFilter, SfxFilterTupel*)
#else
typedef List SfxStyleFilter;
#endif

class SfxStyleFamilyItem: public Resource
{
	Image           aImage;
	Bitmap          aBitmap;
	String          aText;
	String          aHelpText;
	USHORT          nFamily;
	SfxStyleFilter  aFilterList;

public:
		SfxStyleFamilyItem( const ResId &rId );
		~SfxStyleFamilyItem();

	const Bitmap&   GetBitmap() const { return aBitmap; }
	const String&   GetText() const { return aText; }
	const String&   GetHelpText() const { return aHelpText; }
	SfxStyleFamily  GetFamily() const { return (SfxStyleFamily)nFamily; }
	const SfxStyleFilter& GetFilterList() const { return aFilterList; }
	const Image&    GetImage() const { return aImage; }
};

#if 0 // _SOLAR__PRIVATE
DECLARE_LIST(SfxStyleFamilyList, SfxStyleFamilyItem*)
#else
typedef List SfxStyleFamilyList;
#endif

class SfxStyleFamilies: public Resource
{
	SfxStyleFamilyList  aEntryList;

public:
			SfxStyleFamilies( const ResId &);
			SfxStyleFamilies( ) {};
			~SfxStyleFamilies();

	USHORT              Count() const
			{ return (USHORT)aEntryList.Count(); }

	const SfxStyleFamilyItem* GetObject(ULONG nIdx) const
			{ return (SfxStyleFamilyItem*)aEntryList.GetObject(nIdx); }
};

#endif

