
#ifndef _SFX_STYLEDLG_HXX
#define _SFX_STYLEDLG_HXX

#include <sfx2/tabdlg.hxx>

class SfxStyleSheetBase;

class SfxStyleDialog: public SfxTabDialog
{
private:
	SfxStyleSheetBase*			pStyle;
#if 0 // _SOLAR__PRIVATE
	DECL_LINK( CancelHdl, Button * );
#endif
protected:
	virtual const SfxItemSet*	GetRefreshedSet();

public:
#define ID_TABPAGE_MANAGESTYLES	1
#if SUP <= 372
	SfxStyleDialog( Window* pParent, const ResId& rResId, SfxStyleSheetBase&,
		BOOL bFreeRes = TRUE);
	SfxStyleDialog( Window* pParent, const ResId& rResId, SfxStyleSheetBase&,
		BOOL bFreeRes, const String* pUserBtnTxt );
#else
	SfxStyleDialog( Window* pParent, const ResId& rResId, SfxStyleSheetBase&,
		BOOL bFreeRes = TRUE, const String* pUserBtnTxt = 0 );
#endif

	~SfxStyleDialog();

	SfxStyleSheetBase&			GetStyleSheet() { return *pStyle; }
	const SfxStyleSheetBase&	GetStyleSheet() const { return *pStyle; }

	virtual short 				Ok();
};

#endif

