
#ifndef _SFX_TOPFRM_HXX
#define _SFX_TOPFRM_HXX

#ifndef _COM_SUN_STAR_UNO_REFERENCE_H_
#include <com/sun/star/uno/Reference.h>
#endif
#ifndef _SV_DOCKWIN_HXX 
#include <vcl/dockwin.hxx>
#endif
#include <vcl/wrkwin.hxx>

#include <sfx2/frame.hxx>
#include <sfx2/viewfrm.hxx>

class SfxViewShell;
class SfxTopFrame;
namespace svtools { class AsynchronLink; }

class SfxTopFrame :	public SfxFrame
{
friend class SfxTopWindow_Impl;
friend class SfxTopFrameWindow_Impl;
friend class SfxTopFrame_Impl;

	SfxTopFrame_Impl*	pImp;
	Window*             pWindow;
	                    SfxTopFrame( Window* pWindow=NULL, sal_Bool bHidden = sal_False );
	virtual             ~SfxTopFrame();
public:
	static SfxTopFrame* Create( ::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrame > xFrame );
	static SfxTopFrame* Create( SfxObjectShell* pDoc=0, USHORT nViewId=0, BOOL bHidden=sal_False, const SfxItemSet* pSet=NULL );
	static SfxTopFrame* Create( SfxObjectShell* pDoc, Window* pWindow, USHORT nViewId=0, BOOL bHidden=sal_False, const SfxItemSet* pSet=NULL );

	virtual Window&		GetWindow() const;
	virtual BOOL		Close();
	virtual	BOOL		InsertDocument( SfxObjectShell *pDoc );
	String				GetWindowData();
	 void                SetPresentationMode( BOOL bSet );

#if 0 // _SOLAR__PRIVATE
	void                LockResize_Impl( BOOL bLock );
	void                SetMenuBar_Impl( MenuBar* pMenu );
	void                SetMenuBarOn_Impl( BOOL bOn );
	BOOL                IsMenuBarOn_Impl() const;
	MenuBar*            GetMenuBar_Impl() const;
	BOOL				InsertDocument_Impl( SfxObjectShell *pDoc, USHORT nViewId=0 );
	SystemWindow*       GetTopWindow_Impl() const;
#endif
};

class SfxTopViewFrame : public SfxViewFrame
{
friend class SfxTopWindow_Impl;
friend class SfxTopViewFrame_Impl;

	SfxTopViewFrame_Impl*	pImp;
	svtools::AsynchronLink* pCloser;

protected:

	virtual void            Notify( SfxBroadcaster& rBC, const SfxHint& rHint );
	virtual void            Activate( BOOL bUI );
	virtual void            Deactivate( BOOL bUI );
	virtual BOOL            Close();
	virtual                 ~SfxTopViewFrame();

public:
				TYPEINFO();
				SFX_DECL_INTERFACE(SFX_INTERFACE_SFXTOPFRM);
	                         SfxTopViewFrame( SfxFrame* pFrame, SfxObjectShell *pDoc=NULL, USHORT nViewId=0 );
	 virtual void            SetZoomFactor( const Fraction &rZoomX, const Fraction &rZoomY );
	virtual BOOL			SetBorderPixelImpl( const SfxViewShell *pSh, const SvBorder &rBorder );
	virtual void			InvalidateBorderImpl( const SfxViewShell *pSh );
	virtual String			UpdateTitle();

#if 0 // _SOLAR__PRIVATE
	void					Exec_Impl(SfxRequest &);
	void                    GetState_Impl(SfxItemSet &);
	void					INetExecute_Impl(SfxRequest &);
	void					INetState_Impl(SfxItemSet &);
	SfxTopFrame*            GetTopFrame_Impl()
	                        { return (SfxTopFrame*) GetFrame(); }
#endif
};

#endif 

