

#ifndef TF_SVDATA
#ifndef _DTRANS_HXX
#define _DTRANS_HXX

#ifndef _SOT_DTRANS_HXX
#include <sot/dtrans.hxx>
#endif
#ifndef _SV_EVENT_HXX
#include <vcl/event.hxx>
#endif
#ifndef _SV_WINDOW_HXX
#include <vcl/window.hxx>
#endif
#ifndef _IFACE_HXX
#include <so3/iface.hxx>
#endif

struct tagFORMATETC;
typedef struct tagFORMATETC FORMATETC;
struct tagSTGMEDIUM;
typedef struct tagSTGMEDIUM STGMEDIUM;

#ifndef SO2_DECL_SVSTORAGE_DEFINED
#define SO2_DECL_SVSTORAGE_DEFINED
SO2_DECL_REF(SvStorage)
#endif

#ifndef SO2_DECL_SVSTORAGESTREAM_DEFINED
#define SO2_DECL_SVSTORAGESTREAM_DEFINED
SO2_DECL_REF(SvStorageStream)
#endif

#ifndef SO2_DECL_SVDATAOBJECT_DEFINED
#define SO2_DECL_SVDATAOBJECT_DEFINED
SO2_DECL_REF(SvDataObject)
#endif

#ifndef SO2_DECL_SVDATAMEMBEROBJECT_DEFINED
#define SO2_DECL_SVDATAMEMBEROBJECT_DEFINED
SO2_DECL_REF(SvDataMemberObject)
#endif

class DropEvent;
class ImpDataObject;
struct IDataObject;
class Pointer;
class Window;
class Region;
class SvDataObject : virtual public SvObject, public SotDataObject

{
friend ImpDataObject;
friend class SvFactory;
	SvDataTypeList *	pTypeList;
	SvDataTypeList *	pSetDataTypeList;
	IDataObject *   	pObjI;
	static void         FlushClipboard();
protected:

	void				Impl_SetTypeList( const SvDataTypeList & );
	void				Impl_SetSetDataTypeList( const SvDataTypeList & );

	const SvDataTypeList & Impl_GetTypeList() const;
	const SvDataTypeList & Impl_GetSetDataTypeList() const;
	void				SetTypeList( const SvDataTypeList & );
	void				SetSetDataTypeList( const SvDataTypeList & );
	BOOL                IsTypeListSet() const { return pTypeList!=NULL; }
	BOOL                IsSetDataTypeListSet() const
			{ return pSetDataTypeList != NULL; }
				~SvDataObject();
public:
		SvDataObject();
		SO2_DECL_STANDARD_CLASS_DLL(SvDataObject,SOAPP)
	IDataObject *	GetDataObject() const;
	virtual const SvDataTypeList & GetTypeList() const;
	virtual const SvDataTypeList & GetSetDataTypeList() const;

	virtual BOOL    SetData( SvData * );
	virtual BOOL    GetData( SvData * );
	virtual BOOL    GetDataHere( SvData * );
	virtual BOOL    QueryDataType( SvDataType & rInOutType );
	BOOL            HasFormat( const SvDataType & rType ) const;

	virtual SvDataMemberObjectRef CreateSnapshot();

	BOOL            CopyClipboard();
	static SvDataObjectRef PasteClipboard();
	DropAction      ExecuteDrag( Window * pSource,
					 const Pointer& rMovePtr,
					 const Pointer& rCopyPtr,
					 USHORT nOptions = DRAG_ALL,
					 const Region* pDropRegion = NULL );
	DropAction      ExecuteDrag( Window * pSource,
					 const Pointer& rMovePtr,
					 const Pointer& rCopyPtr,
					 const Pointer& rLinkPtr,
					 USHORT nOptions = DRAG_ALL,
					 const Region* pDropRegion = NULL );
	static SvDataObjectRef PasteDragServer( const DropEvent & rEvt );

	static USHORT   Ole2SvAspect( ULONG nAspectP );
	static ULONG    Sv2OleAspect( USHORT nAspectP );

	static void		SetupType( SvDataType & rType, const FORMATETC * pFormat );
	static void		FillSysFormat( const SvDataType & rType, FORMATETC * pFormat );

	static void    SetSysData( SvData & rData, FORMATETC *, STGMEDIUM *, BOOL bConvert = TRUE,
			TransferOperation = TRANSFER_MOVE );
	static BOOL    GetSysData( SvData & rData, USHORT nTymed, STGMEDIUM * pMed, TransferOperation = TRANSFER_MOVE );
	static BOOL    GetSysData( SvData & rData, FORMATETC * pAsk, STGMEDIUM * pMed, TransferOperation = TRANSFER_MOVE );
};
SO2_IMPL_REF(SvDataObject)

class SvDataMemberObject : public SvDataObject

{
	SvDataList          aDataList;
	SvDataTypeList      aTypeList;
	SvDataObjectRef		xExtObj;
public:
		SvDataMemberObject();
		SvDataMemberObject( SvDataObject * pExtObj );
		~SvDataMemberObject();

	virtual const SvDataTypeList & GetTypeList() const;
	virtual BOOL    GetData( SvData * );
	virtual BOOL    GetDataHere( SvData * );

	SvDataList &    GetDataList() { return aDataList; }
	void            Append( SvData * );
};
SO2_IMPL_REF(SvDataMemberObject)

#endif 
#endif
