

#ifndef _IPCLIENT_HXX
#define _IPCLIENT_HXX

#include <so3/client.hxx>

class  SvInPlaceClient;
class  SvInPlaceObject;
class  ImpInPlaceSite;
class  ImpInPlaceFrame;
class  ImpInPlaceUIWin;
class  MenuBar;
class  Accelerator;
class  SvInPlaceClientList;
class  SvInPlaceClient;
struct IOleInPlaceSite;
struct IOleInPlaceFrame;
struct IOleInPlaceUIWindow;
class  SvInPlaceEnvironment;
class SvContainerEnvironment;

class SvInPlaceClient : public SvEmbeddedClient
{
friend ImpInPlaceSite;
friend ImpInPlaceFrame;
friend ImpInPlaceUIWin;
friend SvInPlaceObject;
friend SvEditObjectProtocol;
friend ImplSvEditObjectProtocol;
friend SvContainerEnvironment;

	IOleInPlaceSite *       pObjI;

	BOOL            	CanInPlaceActivate() const;
protected:
			~SvInPlaceClient();

	virtual void    	Opened( BOOL bOpen );
	virtual void    	InPlaceActivate( BOOL bActivate );
	virtual void    	UIActivate( BOOL bActivate );

	virtual void		MakeViewData();
public:
			SvInPlaceClient();
			SvInPlaceClient( WorkWindow * pTopWin,
							 WorkWindow * pDocWin,
							 Window * pEditWin );
			SO2_DECL_STANDARD_CLASS_DLL(SvInPlaceClient,SOAPP)

	IOleInPlaceSite *   		GetInPlaceSite() const;

	static SvInPlaceClientList & GetIPActiveClientList();

	SvContainerEnvironment * 	GetEnv();
	virtual void    			MakeVisible();

	BOOL            			IsInPlaceActive() const
					{ return aProt.IsInPlaceActive(); }
	SvInPlaceObject * 			GetIPObj() const
					{ return aProt.GetIPObj(); }

	virtual void 				DeactivateAndUndo();
	virtual void 				DiscardUndoState();
};
#ifndef SO2_DECL_SVINPLACECLIENT_DEFINED
#define SO2_DECL_SVINPLACECLIENT_DEFINED
SO2_DECL_REF(SvInPlaceClient)
#endif
SO2_IMPL_REF(SvInPlaceClient)

#define inline
SV_DECL_REF_LIST(SvInPlaceClient,SvInPlaceClient*)
#undef inline

#endif 
