

#ifndef _IPENV_HXX
#define _IPENV_HXX

#include <so3/client.hxx>
#ifndef _TOOLS_VCLRSC_HXX
#include <vcl/mapunit.hxx>
#endif

class  SvInPlaceClient;
class  SvInPlaceObject;
class  MenuBar;
class  Menu;
class  SvInPlaceMenuBar;
class  Accelerator;
class  KeyCode;
class  SvContainerEnvironment;
class  SvInPlaceClipWindow;
class  SvInPlaceWindow;
class  Window;
class  KeyEvent;
class  SvContainerEnvironmentList;
class  INetURLObject;
struct IOleInPlaceFrame;
struct IOleInPlaceUIWindow;

class SvAppFrame : public SvObject
{
friend class ImpInPlaceFrame;
friend SvContainerEnvironment;
friend SvInPlaceClient;
	IOleInPlaceFrame *      	pObjI;
	SvContainerEnvironment *	pEnv;
protected:
			~SvAppFrame();
public:
			SO2_DECL_INTERFACE()
			SvAppFrame( SvContainerEnvironment * );
	IOleInPlaceFrame *	GetInPlaceFrame() const;
};
SV_DECL_IMPL_REF(SvAppFrame)

class SvDocFrame : public SvObject
{
friend class ImpInPlaceUIWindow;
friend SvContainerEnvironment;
friend SvInPlaceClient;
	IOleInPlaceUIWindow *   	pObjI;
	SvContainerEnvironment *	pEnv;
protected:
			~SvDocFrame();
public:
			SO2_DECL_INTERFACE()
			SvDocFrame( SvContainerEnvironment * );
	IOleInPlaceUIWindow * GetOleInPlaceUIWindow() const;
};
SV_DECL_IMPL_REF(SvDocFrame)

struct tagOIFI;
typedef struct tagOIFI OLEINPLACEFRAMEINFO;

class SvContainerEnvironment : public SvClientData
{
friend class ImpInPlaceSite;
friend class ImpInPlaceFrame;
friend class ImpInPlaceUIWindow;
friend class SvInPlaceEnvironment;
friend SvInPlaceClient;
friend SvInPlaceObject;

	SvInPlaceEnvironment *		pIPEnv; 
	SvInPlaceClient *			pObj;	
	SvContainerEnvironment *	pParent;
	SvContainerEnvironmentList * pChildList; 
	WorkWindow *            	pTopWin;
	WorkWindow *            	pDocWin;
	SvAppFrameRef				xAppFrame;
	SvDocFrameRef				xDocFrame;
	OLEINPLACEFRAMEINFO *   	pOleInfo;

	long                    hOleMenuDesc; 
	USHORT                  nCount1, nCount2, nCount3;

	USHORT            		nMenuUseCount;  
	MenuBar *               pOleMenu;   
	Accelerator *           pAccel;     
	Rectangle               aClipAreaPixel;

	SvBorder        		aTopBorder;	
	SvBorder        		aDocBorder;	
	BOOL					bDfltUIAction:1,
				bDeleteTopWin:1,
				bDeleteDocWin:1,
				bDeleteEditWin:1,
				bDummy1;

	void			SetIPEnv( SvInPlaceEnvironment * pEnv )
		{ pIPEnv = pEnv; }
	void			ResetIPEnv()
		{ pIPEnv = NULL; }
	void			MakeWinContext_Impl();

protected:
	virtual void	ShowUIByChildDeactivate();

	MenuBar *		DoQueryMenu( USHORT * p0, USHORT * p1, USHORT * p2 );
	virtual MenuBar * QueryMenu( USHORT *, USHORT *, USHORT * );
	virtual void    SetInPlaceMenu( MenuBar * pIPMenu, BOOL bSet );
	void    		DoMenuReleased( MenuBar * pMenu );
	virtual void    MenuReleased();
	virtual void 	UIToolsShown( BOOL bShow );
	void			RemoveDocWin() { pDocWin = NULL; }
	void			RemoveEditWin() { SetEditWin( NULL ); }
	BOOL			IsDefaultUIAction() const
		{ return bDfltUIAction; }
	const SvBorder& GetTopBorder() const
		{ return aTopBorder; }

public:
		TYPEINFO();
		SvContainerEnvironment( SvInPlaceClient *,
								WorkWindow * pTopWin = NULL,
								WorkWindow * pDocWin = NULL,
								Window * pObjWin = NULL );
		SvContainerEnvironment( SvInPlaceClient *,
								SvContainerEnvironment * pParent );
	virtual         ~SvContainerEnvironment();

	IOleInPlaceFrame *		GetInPlaceFrame() const;
	IOleInPlaceUIWindow *	GetOleInPlaceUIWindow() const;
	OLEINPLACEFRAMEINFO * 	GetOleInfo_Impl();

	SvContainerEnvironment* GetParent() const { return pParent; }
	SvContainerEnvironment* GetChild( ULONG n ) const;
	void 					ResetChilds();
	void					ResetChilds2IPActive();
	BOOL					IsChild( SvContainerEnvironment * pEnv ) const;
	SvInPlaceEnvironment * 	GetIPEnv() const { return pIPEnv; }

	BOOL			IsStub() const;
	SvInPlaceClient	* GetIPClient() const { return pObj; }
	void			SetDefaultUIAction( BOOL bOn )
		{ bDfltUIAction = bOn; }

	WorkWindow *    GetTopWin() const;
	WorkWindow *    GetDocWin() const;
	virtual Window* GetEditWin() const;

	virtual void	Scroll( const Size & rSize );

	void            DeleteMenu();
	void            SetMenu( MenuBar * pOleMenu, USHORT n1 = 0,
				 USHORT n2 = 0, USHORT n3 = 0 );

	void                  	SetAccel( const Accelerator & );
	virtual                 BOOL DispatchAccel( const KeyCode & );
	virtual Accelerator * 	GetAccel();

	virtual void	SetSizeScale( const Fraction & rScaleWidth,
					  const Fraction & rScaleHeight );
	void			OutDevScaleChanged();
	void            SetClipAreaPixel( const Rectangle & );
	const Rectangle & GetClipAreaPixel() const
		{ return aClipAreaPixel; }
	virtual BOOL    SetObjArea( const Rectangle & );
	virtual Rectangle GetObjArea() const;

	Rectangle		PixelObjVisAreaToLogic( const Rectangle & rObjRect ) const;
	virtual void    RequestObjAreaPixel( const Rectangle & rObjRect );

	void            SetTopToolFramePixel( const SvBorder & rBorder );
	Rectangle 		GetTopOuterRectPixel() const;

	void            SetDocToolFramePixel( const SvBorder & rBorder );
	Rectangle 		GetDocOuterRectPixel() const;

	virtual BOOL    RequestTopToolSpacePixel( const SvBorder & );
	virtual BOOL    RequestDocToolSpacePixel( const SvBorder & );
	virtual BOOL    SetTopToolSpacePixel( const SvBorder & );
	virtual BOOL    SetDocToolSpacePixel( const SvBorder & );

	virtual BOOL    SetStatusText( const String & rText );
	virtual void 	ShowDocument( const INetURLObject &,
					  const XubString & );
};
DECLARE_LIST(SvContainerEnvironmentList,SvContainerEnvironment*)

class SvInPlaceEnvironment
{
friend SvInPlaceObject;
friend class ImpInPlaceObject;
friend SvInPlaceClient;
friend SvContainerEnvironment;
friend class ImpOleInPlaceActiveObject;
friend ImplSvEditObjectProtocol;

	USHORT                  nChangeRectsLockCount;
	BOOL					bShowUITools:1,
				bTopWinResize:1,
				bDocWinResize:1,
				bDeleteEditWin:1;

	MenuBar *      			pUIMenu;
	MenuBar *				pClientMenu;
	SvInPlaceMenuBar *      pObjMenu;

	SvInPlaceClipWindow *   pClipWin;
	SvInPlaceWindow *       pBorderWin;
	Window *				pEditWin;
	Rectangle               aOldClipAreaPixel;
	Rectangle               aOldObjAreaPixel;

	SvContainerEnvironment *pContEnv;
	SvInPlaceObject *		pObj;

	void 			MergeMenus();
	void 			ReleaseClientMenu();
protected:
	virtual void	TopWinResize();
	virtual void	DocWinResize();

	virtual MenuBar * QueryMenu( USHORT * pCount0, USHORT * pCount1,
					 USHORT * pCount2 );
	virtual void	ShowIPObj( BOOL bShow );
	virtual void	ShowUITools( BOOL bShow );

	virtual void 	RectsChangedPixel( const Rectangle & rObjRect,
							const Rectangle & rClip );

	virtual 		BOOL DispatchAccel( const KeyCode & );

	void			SetObjMenu( SvInPlaceMenuBar * pMenu )
		{ pObjMenu = pMenu; }
	void			DeleteObjMenu();

	void 			MakeWindows();
	void			DeleteWindows();
	void			SetClipWin( SvInPlaceClipWindow * pWin )
		{ pClipWin = pWin; }
	void			DeleteClipWin();
	void			SetBorderWin( SvInPlaceWindow * pWin )
		{ pBorderWin = pWin; }
	void			DeleteBorderWin();

public:
		SvInPlaceEnvironment( SvContainerEnvironment *, SvInPlaceObject * );
	virtual			~SvInPlaceEnvironment();

	SvInPlaceObject *	GetIPObj() const { return pObj; }
	void			DoTopWinResize();
	void			DoDocWinResize();
	void			DoShowIPObj( BOOL bShow );
	void			DoShowUITools( BOOL bShow );
	BOOL			IsShowUITools() const { return bShowUITools; }
	void			MakeUI( BOOL bMake );
	void 			MakeScale( const Size & rVisAreaSize,
				 MapUnit nVisAreaUnit,
				 const Size & rObjSizePixel );

	const Rectangle & GetOldObjAreaPixel() const
		{ return aOldObjAreaPixel; }
	virtual void	QueryObjAreaPixel( Rectangle & rRect ) const;

	SvInPlaceMenuBar *		GetObjMenu() const { return pObjMenu; }
	SvInPlaceClipWindow *	GetClipWin() const { return pClipWin; }
	SvInPlaceWindow * 		GetBorderWin() const { return pBorderWin; }
	void					SetEditWin( Window * pWin )
				{ pEditWin = pWin; }
	void					DeleteEditWin();
	Window *         		GetEditWin();
	SvContainerEnvironment* GetContainerEnv() const { return pContEnv; }

	void            DoRectsChanged( BOOL bIfEqual = FALSE );
	USHORT          GetRectsChangedLockCount() const
		{
			return nChangeRectsLockCount;
		}
	void            LockRectsChanged();
	void            UnlockRectsChanged();
};

enum PlugInMode
{
	PLUGIN_EMBEDED		= 1,
	PLUGIN_FULL			= 2,
	PLUGIN_BACKGROUND	= 3
};

struct PlugJavaRequester
{
	virtual	void *	GetJavaPeer( Window * pPlugWin ) = 0;
};

class SvPlugInObject;
class SvPlugInEnvironment_Impl;
class SvPlugInEnvironment : public SvInPlaceEnvironment
#ifdef SOLAR_JAVA
, PlugJavaRequester
#endif
{
friend class SvPlugInObject;

	DECL_STATIC_LINK( SvPlugInEnvironment, MenuSelectHdl, Menu * );
	BOOL        bIsStarPlugIn;
	SvPlugInObject* pObj;
	SvPlugInEnvironment_Impl* pImpl;

#if( SUPD < 583)
	void *		pOld;
#endif

protected:
	virtual void	DocWinResize();
	virtual void 	RectsChangedPixel( const Rectangle & rObjRect,
						 const Rectangle & rClip );
public:
		SvPlugInEnvironment( SvContainerEnvironment *, SvPlugInObject * );
		~SvPlugInEnvironment();

	BOOL            IsStarPlug() const { return bIsStarPlugIn; }

	virtual BOOL    MIMETypeDetected( const String& rMIME );
	virtual	void *	GetJavaPeer( Window * pPlugWin );
};

#endif 
