
#ifndef _LINKMGR_HXX
#define _LINKMGR_HXX

#ifndef _LINKSRC_HXX
#include <so3/linksrc.hxx>
#endif
#ifndef _TOOLS_STRING_HXX
#include <tools/string.hxx>
#endif
#ifndef _SVARRAY_HXX
#include <svtools/svarray.hxx>
#endif

class SvPersist;

namespace so3
{
class SvBaseLink;
class SvBaseLinkRef;

typedef SvBaseLinkRef* SvBaseLinkRefPtr;
SV_DECL_PTRARR( SvBaseLinks, SvBaseLinkRefPtr, 1, 1 )

typedef SvLinkSource* SvLinkSourcePtr;
SV_DECL_PTRARR( SvLinkSources, SvLinkSourcePtr, 1, 1 )

class SvLinkManager
{
	SvBaseLinks		aLinkTbl;
	SvLinkSources aServerTbl;
	SvPersist	*pPersist; 
protected:
	BOOL 		InsertLink( SvBaseLink* pLink, USHORT nObjType, USHORT nUpdateType,
				const String* pName = 0 );
public:
	SvLinkManager();
	~SvLinkManager();

	SvPersist*	GetPersist() const 				{ return pPersist; }
	void        SetPersist( SvPersist * p ) 	{ pPersist = p; }

	void		Remove( SvBaseLink *pLink );
	void		Remove( USHORT nPos, USHORT nCnt = 1 );
	BOOL		Insert( SvBaseLink* pLink );

	BOOL 		InsertDDELink( SvBaseLink*,
			const String& rServer,
			const String& rTopic,
			const String& rItem );

	BOOL 		InsertDDELink( SvBaseLink* );

	virtual BOOL GetDisplayNames( const SvBaseLink *,
						String* pType,
						String* pFile = 0,
						String* pLink = 0,
						String* pFilter = 0 ) const;

	virtual SvLinkSourceRef CreateObj( SvBaseLink * );

	void 		UpdateAllLinks( BOOL bAskUpdate = TRUE,
					BOOL bCallErrHdl = TRUE,
					BOOL bUpdateGrfLinks = FALSE );

	const 		SvBaseLinks& GetLinks() const { return aLinkTbl; }

	const SvLinkSources& GetServers() const { return aServerTbl; }

	BOOL 		InsertServer( SvLinkSource* rObj );
	void 		RemoveServer( SvLinkSource* rObj );
	void 		RemoveServer( USHORT nPos, USHORT nCnt = 1 )
	{	aServerTbl.Remove( nPos, nCnt ); }

private:
		SvLinkManager( const SvLinkManager& );
	SvLinkManager& operator=( const SvLinkManager& );
};

const sal_Char cTokenSeperator = '\xff';

void MakeLnkName( String& rName,
	 const String* pType,		
	 const String& rFile,
	 const String& rLink,
	 const String* pFilter = 0 );

}

#endif

