

#ifndef _PLUGIN_HXX
#define _PLUGIN_HXX

#include <so3/ipobj.hxx>
#include <svtools/ownlist.hxx>
#include <so3/ipenv.hxx>

class Timer;
class INetURLObject;
struct SvPlugInData_Impl;
class SjJScriptPluginObject;
class SjJScriptJavaObject;
class SvPlugInObject : public SvInPlaceObject

{
friend class SvPlugInEnvironment;
	SvPlugInEnvironment * pPlugInEnv;
	SvPlugInData_Impl *	pImpl;
	SvCommandList	aCmdList;
	INetURLObject*	pURL;
	USHORT			nPlugInMode;

	DECL_STATIC_LINK( SvPlugInObject, NewPlugInHdl_Impl, Timer * );
	DECL_STATIC_LINK( SvPlugInObject, DataAvailable, void* );

	void			DataChanged_Impl( BOOL bOnlyEmbedSource );
protected:
	BOOL			DoStartPlugIn( );
	BOOL			StartPlugIn( );
	virtual void    FillClass( SvGlobalName * pClassName,
				   ULONG * pFormat,
				   String * pAppName,
				   String * pFullTypeName,
				   String * pShortTypeName,
	                           long nFileFormat = SOFFICE_FILEFORMAT_CURRENT ) const;

	virtual void    Open( BOOL bOpen );
	virtual void    Embed( BOOL );
	virtual void    InPlaceActivate( BOOL );
	virtual ErrCode Verb( long, SvEmbeddedClient * pCallerClient,
			Window * pWin, const Rectangle * pWorkRectPixel );

	virtual void    SetVisArea( const Rectangle & rVisArea );
	virtual void    Draw( OutputDevice *,
			  const JobSetup & rSetup,
			  USHORT nAspect = ASPECT_CONTENT );

	virtual BOOL    InitNew( SvStorage * );
	virtual BOOL    Load( SvStorage * );
	virtual BOOL    Save();
	virtual BOOL    SaveAs( SvStorage * );
	virtual void    HandsOff();
	virtual BOOL    SaveCompleted( SvStorage * );

	void            SetMIMEDetectedLink( const Link& rLink );
			~SvPlugInObject();
public:
		SO2_DECL_BASIC_CLASS_DLL(SvPlugInObject,SOAPP)
		SvPlugInObject();

	virtual ULONG	GetMiscStatus() const;
	virtual BOOL	IsLink() const;

	void			SetCommandList( const SvCommandList & rList );
	const SvCommandList & GetCommandList() const { return aCmdList; }
	void			SetURL( const INetURLObject & rURL );
	INetURLObject *	GetURL() const { return pURL; }
	void			SetMimeType( const String & rMimeType );
	const String &	GetMimeType() const;
	void			SetPlugInMode( USHORT );
	USHORT  		GetPlugInMode() const { return nPlugInMode; }
};

SO2_DECL_IMPL_REF(SvPlugInObject)

#endif 
