

#ifndef _SVSTOR_HXX
#define _SVSTOR_HXX

#ifndef _IFACE_HXX
#include <so3/iface.hxx>
#endif
#ifndef _SOT_STORAGE_HXX
#include <sot/storage.hxx>
#endif

#include <so3/so2defs.hxx>

class SvStorage;
class StorageStream;
class SvStorageStream : virtual public SvObject, public SotStorageStream
{
friend SvStorage;
friend class ImpStream;
	void *   pObjI;      
	void  *  pRelease;   
	virtual ULONG       GetData( void* pData, ULONG nSize );
	virtual ULONG       PutData( const void* pData, ULONG nSize );
	virtual ULONG       SeekPos( ULONG nPos );
	virtual void        FlushData();
protected:
			~SvStorageStream();
public:
	static void			Ole2SvStreamMode( ULONG nOleMode,
							StreamMode *, StorageMode * );
	static ULONG        Sv2OleStreamMode( StreamMode, StorageMode );
			SvStorageStream( const String &,
						 StreamMode = STREAM_STD_READWRITE,
						 StorageMode = 0 );
	                    SvStorageStream( BaseStorageStream *pStm );
			SvStorageStream();
			SO2_DECL_STANDARD_CLASS_DLL(SvStorageStream,SOAPP)

	virtual USHORT		IsA() const;
	virtual void 		SyncSvStream();

	virtual void        SetSize( ULONG nNewSize );
	virtual BOOL        Commit();
	virtual BOOL        Revert();
};
#ifndef SO2_DECL_SVSTORAGESTREAM_DEFINED
#define SO2_DECL_SVSTORAGESTREAM_DEFINED
SO2_DECL_REF(SvStorageStream)
#endif
SO2_IMPL_REF(SvStorageStream)

class  ImpPersistFile;
class  SvStorageInfoList;
class  Storage;
class SvStorage : virtual public SvObject, public SotStorage
{
friend SvStorageStream;
friend ImpPersistFile;
	void	 *  pRelease;  
	void *		pObjI;     
protected:
			~SvStorage();
public:
			SvStorage( const String &,
					   StreamMode = STREAM_STD_READWRITE,
					   StorageMode = 0 );
	                    SvStorage( BOOL bUCBStorage, const String &,
	                               StreamMode = STREAM_STD_READWRITE,
	                               StorageMode = 0 );
	                    SvStorage( BaseStorage * );
			SvStorage( SvStream & rStm );
	                    SvStorage( BOOL bUCBStorage, SvStream & rStm );
			SvStorage( SvStream * pStm, BOOL bDelete );
			SvStorage();
			SO2_DECL_STANDARD_CLASS_DLL(SvStorage,SOAPP)

	static BOOL         IsStorageFile( const String & rFileName );
	const String &      GetName() const;

	void                SetClass( const SvGlobalName & rClass,
					  ULONG bOriginalClipFormat,
					  const String & rUserTypeName );
	void                SetConvertClass( const SvGlobalName & rConvertClass,
							 ULONG bOriginalClipFormat,
							 const String & rUserTypeName );
	SvGlobalName        GetClassName();
	ULONG               GetFormat();
	String              GetUserName();
	BOOL                ShouldConvert();

	void                FillInfoList( SvStorageInfoList * ) const;
	BOOL                CopyTo( SotStorage * pDestStg );
	BOOL                Commit();
	BOOL                Revert();

	SotStorageStream *  OpenSotStream( const String & rEleName,
						StreamMode = STREAM_STD_READWRITE,
						StorageMode = 0 );
	SotStorage *        OpenSotStorage( const String & rEleName,
						StreamMode = STREAM_STD_READWRITE,
						StorageMode = STORAGE_TRANSACTED );
	SvStorageStream *   OpenStream( const String & rEleName,
						StreamMode a = STREAM_STD_READWRITE,
						StorageMode b = 0 )
			{ return (SvStorageStream*)OpenSotStream( rEleName, a, b ); }
	SvStorage *         OpenStorage( const String & rEleName,
						StreamMode a = STREAM_STD_READWRITE,
						StorageMode b = STORAGE_TRANSACTED )
			{ return (SvStorage*)OpenSotStorage( rEleName, a, b ); }
	SvStorage *        OpenUCBStorage( const String & rEleName,
	                                StreamMode = STREAM_STD_READWRITE,
	                                StorageMode = STORAGE_TRANSACTED );
	SvStorage *        OpenOLEStorage( const String & rEleName,
	                                StreamMode = STREAM_STD_READWRITE,
	                                StorageMode = STORAGE_TRANSACTED );

	BOOL                IsStream( const String & rEleName ) const;
	BOOL                IsStorage( const String & rEleName ) const;
	BOOL                IsContained( const String & rEleName ) const;

	BOOL                Remove( const String & rEleName );

	BOOL                Rename( const String & rEleName,
					const String & rNewName );
	BOOL                CopyTo( const String & rEleName, SotStorage * pDest,
					const String & rNewName );
	BOOL                MoveTo( const String & rEleName, SotStorage * pDest,
					const String & rNewName );
};

#ifndef SO2_DECL_SVSTORAGE_DEFINED
#define SO2_DECL_SVSTORAGE_DEFINED
SO2_DECL_REF(SvStorage)
#endif
SO2_IMPL_REF(SvStorage)

#endif 
