

#ifndef _SOT_FACTORY_HXX
#define _SOT_FACTORY_HXX

#ifndef _TOOLS_GLOBNAME_HXX
#include <tools/globname.hxx>
#endif
#ifndef _TOOLS_RTTI_HXX
#include <tools/rtti.hxx>
#endif

class SotObject;
class SotFactory;

DECLARE_LIST( SotFactoryList, SotFactory * )
typedef void * (*CreateInstanceType)( SotObject ** );

class SotFactory : public SvGlobalName
{
	USHORT              nSuperCount;    
	const SotFactory ** pSuperClasses;  
	CreateInstanceType  pCreateFunc;
	 String              aClassName;
	 static  BOOL        ExistTest( const SvGlobalName & );
protected:
	virtual             ~SotFactory();
public:
			TYPEINFO();
	static	void		DeInit();
	static  void        IncSvObjectCount( SotObject * = NULL );
	static  void        DecSvObjectCount( SotObject * = NULL );
	static  UINT32      GetSvObjectCount();
	static  void        TestInvariant();
	 static  const SotFactory * 		Find( const SvGlobalName & );
	static  const SotFactoryList *	GetFactoryList();
	         SotFactory( const SvGlobalName &,
	                   const String & rClassName, CreateInstanceType );
	 const String &      GetClassName() const { return aClassName; }
	void                PutSuperClass( const SotFactory * );
	virtual void *      CreateInstance( SotObject ** ppObj = NULL ) const;
	void *				CastAndAddRef( SotObject * ) const;
	void * 				AggCastAndAddRef( SotObject * ) const;
	 BOOL                Is( const SotFactory * pSuperClass ) const;
	const SotFactory *  GetSuper( USHORT nPos ) const
			{
				return nPos < nSuperCount ?
							 pSuperClasses[ nPos ]
							 : NULL;
			}

private:
	                    SotFactory( const SotFactory & );
	SotFactory &        operator = ( const SotFactory & );
};

#endif 
