

#ifndef _FILELIST_HXX
#define _FILELIST_HXX

#ifndef _STREAM_HXX 
#include <tools/stream.hxx>
#endif

class FileStringList;

class FileList : public SvDataCopyStream
{
	FileStringList*		pStrList;

protected:

	virtual	void		Load( SvStream& );
	virtual	void		Save( SvStream& );
	virtual	void		Assign( const SvDataCopyStream& );

	void ClearAll( void );

public:

	TYPEINFO();
			FileList();
			~FileList();

	FileList&			operator=( const FileList& rFileList );

	friend SvStream&	operator<<( SvStream& rOStm, const FileList& rFileList );
	friend SvStream&	operator>>( SvStream& rIStm, FileList& rFileList );
	 static ULONG		GetFormat();

	void AppendFile( const String& rStr );
	String GetFile( ULONG i ) const;
	ULONG Count( void ) const;

};	

#endif 

