

#ifndef _STGIO_HXX
#define _STGIO_HXX

#ifndef _STGCACHE_HXX
#include <sot/stgcache.hxx>
#endif
#ifndef _STGELEM_HXX
#include <sot/stgelem.hxx>
#endif
#ifndef _TOOLS_STRING_HXX
#include <tools/string.hxx>
#endif

class StgFATStrm;
class StgDataStrm;
class StgDirStrm;
class String;

enum FAT_ERROR
{
	FAT_OK,
	FAT_WRONGLENGTH,
	FAT_UNREFCHAIN,
	FAT_OVERWRITE,
	FAT_OUTOFBOUNDS,

	FAT_INMEMORYERROR,
	FAT_ONFILEERROR,
	FAT_BOTHERROR
};

struct StgLinkArg
{
	String aFile;
	ULONG nErr;
};

class StgIo : public StgCache {
	void SetupStreams();			
	BOOL         bCopied;
public:
	StgIo();
   ~StgIo();
	StgHeader    aHdr;				
	StgFATStrm*  pFAT;				
	StgDirStrm*  pTOC;				
	StgDataStrm* pDataFAT;			
	StgDataStrm* pDataStrm;			
	short	  	 GetDataPageSize();	
	BOOL Load();					
	BOOL Init();					
	BOOL CommitAll();				

	static Link aErrorLink;
	static void SetErrorLink( const Link& );
	static const Link& GetErrorLink() { return aErrorLink; }
	ULONG ValidateFATs( );
};

#endif
