

#ifndef _SOT_STORINFO_HXX
#define _SOT_STORINFO_HXX

#include <tools/pstm.hxx>
#include <tools/globname.hxx>
#ifndef _TOOLS_OWNLIST_HXX
#include <tools/ownlist.hxx>
#endif

class StgDirEntry;
class SvStorageInfo
{
friend class SvStorage;
	String          aName;
	SvGlobalName    aClassName;
	ULONG           nSize;
	BOOL            bStream:1,
	                bStorage:1;
					SvStorageInfo(){}; 
public:
	                        SvStorageInfo( const StgDirEntry& );
	                        SvStorageInfo( const String& rName, ULONG nSz, BOOL bIsStorage )
	                            : aName( rName )
	                            , nSize( nSz )
	                            , bStream( !bIsStorage )
	                            , bStorage( bIsStorage )
	                        {}
	 const SvGlobalName &    GetClassName() const { return aClassName; }
	const String &          GetName() const { return aName; }
	BOOL                    IsStream() const { return bStream; }
	BOOL                    IsStorage() const { return bStorage; }
	ULONG                   GetSize() const { return nSize;      }
};

class SvStorageInfoList
{
	PRV_SV_DECL_OWNER_LIST(SvStorageInfoList,SvStorageInfo)
	const SvStorageInfo * Get( const String & rName );
};

ULONG ReadClipboardFormat( SvStream & rStm );
void WriteClipboardFormat( SvStream & rStm, ULONG nFormat );

#endif 
