
#ifndef SMDLL_HXX
#define SMDLL_HXX

#define SMDLL	1

#ifndef _SMDLL0_HXX
#include <starmath/smdll0.hxx>
#endif
#ifndef _TOOLS_RESID_HXX 
#include <tools/resid.hxx>
#endif
#ifndef _SFXDEFS_HXX
#include <sfx2/sfxdefs.hxx>
#endif

class SmData;
class SfxMedium;
class SfxFilter;

class SmDLL
{
	static BOOL bInitialized;
public:
	SmDLL();
	~SmDLL();

	static void Init();
	static void LibInit();
	static void Exit();
	static void LibExit();

	static ULONG DetectFilter( SfxMedium& rMedium, const SfxFilter **ppFilter,
				   SfxFilterFlags nMust, SfxFilterFlags nDont );
};

#ifdef SMDLL
class SmResId : public ResId
{
public:
	SmResId(USHORT nId) :
		ResId(nId, SM_MOD()->GetResMgr())
	{
	}
};
#endif

#endif

