

#ifndef _SMMOD_HXX
#define _SMMOD_HXX

#ifndef _SV_RESARY_HXX
#include <tools/resary.hxx>
#endif

#ifndef _SMDLL_HXX
#define _SM_DLL             
#include <starmath/smdll.hxx>        
#endif

class SvxErrorHandler;
class SvFactory;

class SmConfig;
class SmModule;

class SmRectCache;
class SvtSysLocale;

class SmLocalizedSymbolData : public Resource
{
	ResStringArray		aUiSymbolNamesAry;
	ResStringArray		aExportSymbolNamesAry;
	ResStringArray      aUiSymbolSetNamesAry;
	ResStringArray      aExportSymbolSetNamesAry;
	ResStringArray      aFrench50NamesAry;
	ResStringArray      aFrench60NamesAry;

public:
	SmLocalizedSymbolData();
	~SmLocalizedSymbolData();
	 const ResStringArray& GetUiSymbolNamesArray() const     { return aUiSymbolNamesAry; }
	const ResStringArray& GetExportSymbolNamesArray() const { return aExportSymbolNamesAry; }
	 const ResStringArray& GetUiSymbolSetNamesArray() const     { return aUiSymbolSetNamesAry; }
	const ResStringArray& GetExportSymbolSetNamesArray() const { return aExportSymbolSetNamesAry; }
	 const ResStringArray& GetFrench50NamesArray() const     { return aFrench50NamesAry; }
	const ResStringArray& GetFrench60NamesArray() const     { return aFrench60NamesAry; }
};

class SmModule : public SmModuleDummy
{
	SmConfig                *pConfig;
	SmLocalizedSymbolData   *pLocSymbolData;
	SmRectCache             *pRectCache;
	SvtSysLocale            *pSysLocale;

	virtual void FillStatusBar(StatusBar &rBar);
	void _CreateSysLocale() const;

public:
	TYPEINFO();
	SFX_DECL_INTERFACE(SFX_INTERFACE_SMA_START + 0);

	SmModule(SvFactory* pObjFact);
	virtual ~SmModule();

	virtual SfxModule *	Load();
	virtual void		Free();
	 SmConfig *          GetConfig();
	SmRectCache *		GetRectCache()	   { return pRectCache; }
	 const SmLocalizedSymbolData &   GetLocSymbolData() const;

	void GetState(SfxItemSet&);

	const SvtSysLocale& GetSysLocale() const
	{
		if( !pSysLocale )
			_CreateSysLocale();
		return *pSysLocale;
	}

	virtual SfxItemSet*	 CreateItemSet( USHORT nId );
	virtual void		 ApplyItemSet( USHORT nId, const SfxItemSet& rSet );
	virtual	SfxTabPage*	 CreateTabPage( USHORT nId, Window* pParent, const SfxItemSet& rSet );
};

#define SM_MOD1() ( *(SmModule**) GetAppData(SHL_SM) )

#endif                                 

