

#ifndef _FILTER_CONFIG_ITEM_HXX_
#define _FILTER_CONFIG_ITEM_HXX_

#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif
#ifndef _COM_SUN_STAR_AWT_SIZE_HPP_
#include <com/sun/star/awt/Size.hpp>
#endif

#ifndef _COM_SUN_STAR_UNO_ANY_H_
#include <com/sun/star/uno/Any.h>
#endif
#ifndef _COM_SUN_STAR_UNO_REFERENCE_H_
#include <com/sun/star/uno/Reference.h>
#endif
#ifndef _COM_SUN_STAR_UNO_XINTERFACE_HPP_
#include <com/sun/star/uno/XInterface.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif

class FilterConfigItem
{
		::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface	> xUpdatableView;
		::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > xPropSet;

		sal_Bool	bModified;

		sal_Bool	ImplGetPropertyValue( ::com::sun::star::uno::Any& rAny,
			const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >& rXPropSet,
				const ::rtl::OUString& rPropName,
					sal_Bool bTestPropertyAvailability );
	public :

		FilterConfigItem( const ::rtl::OUString& rSubTree );
		~FilterConfigItem();

		sal_Bool	ReadBool( const ::rtl::OUString& rKey, sal_Bool bDefault );
		sal_Int32	ReadInt32( const ::rtl::OUString& rKey, sal_Int32 nDefault );
		::com::sun::star::awt::Size	
		ReadSize( const ::rtl::OUString& rKey, const ::com::sun::star::awt::Size& rDefault );
		::rtl::OUString
		ReadString( const ::rtl::OUString& rKey, const ::rtl::OUString& rDefault );

		void		WriteBool( const ::rtl::OUString& rKey, sal_Bool bValue );
		void		WriteInt32( const ::rtl::OUString& rKey, sal_Int32 nValue );
		void		WriteSize( const ::rtl::OUString& rKey, const ::com::sun::star::awt::Size& rSize );
		void		WriteString( const ::rtl::OUString& rKey, const ::rtl::OUString& rSize );
};

#endif	

