

#ifndef _ARGS_HXX
#define _ARGS_HXX

#include <limits.h>
#ifndef _REF_HXX
#include <tools/ref.hxx>
#endif

class String;
class SbxVariable;
class SbxArray;

#ifndef SBX_ARRAY_DECL_DEFINED
#define SBX_ARRAY_DECL_DEFINED
SV_DECL_REF(SbxArray);
#endif

#include <svtools/sbx.hxx>

#if SUPD<311

#define SFX_ARGUMENT_ERROR( nArgNo, nCode ) ( ( (nArgNo) << 16 ) | (nCode) )

#define SFX_ERR_NOT_IMPLEMENTED    1
#define SFX_ERR_INVALID_ARGUMENT   2
#define SFX_ERR_ARGUMENT_EXPECTED  3
#define SFX_ERR_TOO_MANY_ARGUMENTS 4

#else

#define SFX_ARGUMENT_ERROR( nArgNo, nCode ) (nCode)

HACK(nur zum Uebergang)
#define SFX_ERR_NOT_IMPLEMENTED    	ERRCODE_IO_NOTSUPPORTED
#define SFX_ERR_INVALID_ARGUMENT   	ERRCODE_IO_INVALIDPARAMETER
#define SFX_ERR_ARGUMENT_EXPECTED	ERRCODE_IO_INVALIDPARAMETER
#define SFX_ERR_TOO_MANY_ARGUMENTS 	ERRCODE_IO_INVALIDPARAMETER

#endif

class SfxArguments
{
	SbxArrayRef                 aArrayRef;
	USHORT						nFrom, nCount;

public:
					SfxArguments( BOOL bCreateArray = TRUE );
					SfxArguments( SbxArray* pArray,
								  USHORT nFrom = 1,
								  USHORT nCount = USHRT_MAX );
	virtual                     ~SfxArguments();

	virtual void				Append( SbxVariable *pArg );
	void						AppendEmpty( );
	void						AppendInteger( INT16 nArg );
	void						AppendLong( INT32 nArg );
	void						AppendSingle( float nArg );
	void						AppendDouble( double nArg );
	void						AppendBool( BOOL nArg );
	void						AppendString( const String& rArg );
	void                        AppendEnum( INT16 nArg );

	virtual USHORT              Count() const;
	virtual const SbxVariable&	Get( USHORT nNo ) const;
	const SbxVariable&			operator[] ( USHORT nNo ) const
					{ return Get(nNo); }
};

#endif

