

#ifndef SVTOOLS_ASYNCLINK_HXX
#define  SVTOOLS_ASYNCLINK_HXX

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif
#ifndef _LINK_HXX
#include <tools/link.hxx>
#endif

class Timer;

namespace vos
{
	class OMutex;
}

namespace svtools {

class AsynchronLink
{
	Link   _aLink;
	ULONG  _nEventId;
	Timer* _pTimer;
	BOOL   _bInCall;
	BOOL*  _pDeleted;
	void*  _pArg;
	vos::OMutex* _pMutex;

	DECL_STATIC_LINK( AsynchronLink, HandleCall, void* );
	void Call_Impl( void* pArg );
public:
	AsynchronLink( const Link& rLink ) :
		_pTimer( 0 ), _aLink( rLink ), _nEventId( 0 ), _bInCall( FALSE ),
		_pDeleted( 0 ), _pMutex( 0 ){}
	AsynchronLink() : _nEventId( 0 ), _pTimer( 0 ), _bInCall( FALSE ),
			_pDeleted( 0 ), _pMutex( 0 ){}
	~AsynchronLink();

	void CreateMutex();
	void operator=( const Link& rLink ) { _aLink = rLink; }
	void Call( void* pObj, BOOL bAllowDoubles = FALSE,
	  BOOL bUseTimer = FALSE );
	void ForcePendingCall( );
	void ClearPendingCall( );
	BOOL IsSet() const { return _aLink.IsSet(); }
	Link GetLink() const { return _aLink; }
};

}

#endif
