

#ifndef _BINTITEM_HXX
#define _BINTITEM_HXX

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif

#ifndef _RTTI_HXX
#include <tools/rtti.hxx>
#endif

#ifndef _BIGINT_HXX
#include <tools/bigint.hxx>
#endif

#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif

#include <svtools/poolitem.hxx>

class SfxArguments;
class SvStream;

DBG_NAMEEX(SfxBigIntItem);

class SfxBigIntItem: public SfxPoolItem
{
	BigInt aVal;

public:
	TYPEINFO();
	SfxBigIntItem();
	SfxBigIntItem(USHORT nWhich, const BigInt& rValue);
	SfxBigIntItem(USHORT nWhich, SvStream &);
	SfxBigIntItem(const SfxBigIntItem&);
	~SfxBigIntItem() { DBG_DTOR(SfxBigIntItem, 0); }

	virtual SfxItemPresentation GetPresentation(
		SfxItemPresentation ePres,
		SfxMapUnit eCoreMetric,
		SfxMapUnit ePresMetric,
		XubString &rText,
	    const IntlWrapper * = 0 ) const;

	virtual int operator==(const SfxPoolItem&) const;
	virtual int Compare(const SfxPoolItem &rWith) const;
	virtual SfxPoolItem* Clone(SfxItemPool *pPool = 0) const;
	virtual SfxPoolItem* Create(SvStream &, USHORT nVersion) const;
	virtual SvStream& Store(SvStream &, USHORT nItemVersion) const;

	virtual	BOOL PutValue  ( const com::sun::star::uno::Any& rVal,
			     BYTE nMemberId = 0 );
	virtual	BOOL QueryValue( com::sun::star::uno::Any& rVal,
				 BYTE nMemberId = 0 ) const;

	virtual SfxFieldUnit GetUnit() const;	 

	const BigInt& GetValue() const { return aVal; }
	void SetValue(const BigInt& rNewVal)
	{
		DBG_ASSERT(GetRef() == 0, "SetValue() with pooled item");
		aVal = rNewVal;
	}
};

#endif 

