

#ifndef _SVTOOLS_CINTITEM_HXX
#define _SVTOOLS_CINTITEM_HXX

#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif

#ifndef _SFXPOOLITEM_HXX
#include <svtools/poolitem.hxx>
#endif

DBG_NAMEEX(CntByteItem);

class CntByteItem: public SfxPoolItem
{
	BYTE m_nValue;

public:
	TYPEINFO();

	CntByteItem(USHORT nWhich = 0, BYTE nTheValue = 0):
		SfxPoolItem(nWhich), m_nValue(nTheValue) { DBG_CTOR(CntByteItem, 0); }

	CntByteItem(USHORT nWhich, SvStream & rStream);

	CntByteItem(const CntByteItem & rItem):
		SfxPoolItem(rItem), m_nValue(rItem.m_nValue)
	{ DBG_CTOR(CntByteItem, 0); }

	virtual ~CntByteItem() { DBG_DTOR(CntByteItem, 0); }

	virtual int operator ==(const SfxPoolItem & rItem) const;

	virtual int Compare(const SfxPoolItem & rWith) const;

	virtual SfxItemPresentation GetPresentation(SfxItemPresentation,
									SfxMapUnit, SfxMapUnit,
									XubString & rText,
	                                            const IntlWrapper * = 0)
		const;

	virtual	BOOL QueryValue(com::sun::star::uno::Any& rVal,
				BYTE nMemberId = 0) const;

	virtual	BOOL PutValue(const com::sun::star::uno::Any& rVal,
			  BYTE nMemberId = 0);

	virtual SfxPoolItem * Create(SvStream & rStream, USHORT) const;

	virtual SvStream & Store(SvStream & rStream, USHORT) const;

	virtual SfxPoolItem * Clone(SfxItemPool * = 0) const;

	virtual BYTE GetMin() const;

	virtual BYTE GetMax() const;

	virtual SfxFieldUnit GetUnit() const;

	BYTE GetValue() const { return m_nValue; }

	inline void SetValue(BYTE nTheValue);
};

inline void CntByteItem::SetValue(BYTE nTheValue)
{
	DBG_ASSERT(GetRef() == 0, "CntByteItem::SetValue(): Pooled item");
	m_nValue = nTheValue;
}

DBG_NAMEEX(CntUInt16Item);

class CntUInt16Item: public SfxPoolItem
{
	UINT16 m_nValue;

public:
	TYPEINFO();

	CntUInt16Item(USHORT nWhich = 0, UINT16 nTheValue = 0):
		SfxPoolItem(nWhich), m_nValue(nTheValue)
	{ DBG_CTOR(CntUInt16Item, 0); }

	CntUInt16Item(USHORT nWhich, SvStream & rStream);

	CntUInt16Item(const CntUInt16Item & rItem):
		SfxPoolItem(rItem), m_nValue(rItem.m_nValue)
	{ DBG_CTOR(CntUInt16Item, 0); }

	virtual ~CntUInt16Item() { DBG_DTOR(CntUInt16Item, 0); }

	virtual int operator ==(const SfxPoolItem & rItem) const;

	virtual int Compare(const SfxPoolItem & rWith) const;

	virtual SfxItemPresentation GetPresentation(SfxItemPresentation,
									SfxMapUnit, SfxMapUnit,
									XubString & rText,
	                                            const IntlWrapper * = 0)
		const;

	virtual	BOOL QueryValue(com::sun::star::uno::Any& rVal,
				BYTE nMemberId = 0) const;

	virtual	BOOL PutValue(const com::sun::star::uno::Any& rVal,
			  BYTE nMemberId = 0);

	virtual SfxPoolItem * Create(SvStream & rStream, USHORT) const;

	virtual SvStream & Store(SvStream & rStream, USHORT) const;

	virtual SfxPoolItem * Clone(SfxItemPool * = 0) const;

	virtual UINT16 GetMin() const;

	virtual UINT16 GetMax() const;

	virtual SfxFieldUnit GetUnit() const;

	INT16 GetValue() const { return m_nValue; }

	inline void SetValue(UINT16 nTheValue);
};

inline void CntUInt16Item::SetValue(UINT16 nTheValue)
{
	DBG_ASSERT(GetRef() == 0, "CntUInt16Item::SetValue(): Pooled item");
	m_nValue = nTheValue;
}

DBG_NAMEEX(CntInt32Item);

class CntInt32Item: public SfxPoolItem
{
	INT32 m_nValue;

public:
	TYPEINFO();

	CntInt32Item(USHORT nWhich = 0, INT32 nTheValue = 0):
		SfxPoolItem(nWhich), m_nValue(nTheValue)
	{ DBG_CTOR(CntInt32Item, 0); }

	CntInt32Item(USHORT nWhich, SvStream & rStream);

	CntInt32Item(const CntInt32Item & rItem):
		SfxPoolItem(rItem), m_nValue(rItem.m_nValue)
	{ DBG_CTOR(CntInt32Item, 0); }

	virtual ~CntInt32Item() { DBG_DTOR(CntInt32Item, 0); }

	virtual int operator ==(const SfxPoolItem & rItem) const;

	virtual int Compare(const SfxPoolItem & rWith) const;

	virtual SfxItemPresentation GetPresentation(SfxItemPresentation,
									SfxMapUnit, SfxMapUnit,
									XubString & rText,
	                                            const IntlWrapper * = 0)
		const;

	virtual	BOOL QueryValue(com::sun::star::uno::Any& rVal,
				BYTE nMemberId = 0) const;

	virtual	BOOL PutValue(const com::sun::star::uno::Any& rVal,
			  BYTE nMemberId = 0);

	virtual SfxPoolItem * Create(SvStream & rStream, USHORT) const;

	virtual SvStream & Store(SvStream &, USHORT) const;

	virtual SfxPoolItem * Clone(SfxItemPool * = 0) const;

	virtual INT32 GetMin() const;

	virtual INT32 GetMax() const;

	virtual SfxFieldUnit GetUnit() const;

	INT32 GetValue() const { return m_nValue; }

	inline void SetValue(INT32 nTheValue);
};

inline void CntInt32Item::SetValue(INT32 nTheValue)
{
	DBG_ASSERT(GetRef() == 0, "CntInt32Item::SetValue(): Pooled item");
	m_nValue = nTheValue;
}

DBG_NAMEEX(CntUInt32Item);

class CntUInt32Item: public SfxPoolItem
{
	UINT32 m_nValue;

public:
	TYPEINFO();

	CntUInt32Item(USHORT nWhich = 0, UINT32 nTheValue = 0):
		SfxPoolItem(nWhich), m_nValue(nTheValue)
	{ DBG_CTOR(CntUInt32Item, 0); }

	CntUInt32Item(USHORT nWhich, SvStream & rStream);

	CntUInt32Item(const CntUInt32Item & rItem):
		SfxPoolItem(rItem), m_nValue(rItem.m_nValue)
	{ DBG_CTOR(CntUInt32Item, 0); }

	virtual ~CntUInt32Item() { DBG_DTOR(CntUInt32Item, 0); }

	virtual int operator ==(const SfxPoolItem & rItem) const;

	virtual int Compare(const SfxPoolItem & rWith) const;

	virtual SfxItemPresentation GetPresentation(SfxItemPresentation,
									SfxMapUnit, SfxMapUnit,
									XubString & rText,
	                                            const IntlWrapper * = 0)
		const;

	virtual	BOOL QueryValue(com::sun::star::uno::Any& rVal,
				BYTE nMemberId = 0) const;

	virtual	BOOL PutValue(const com::sun::star::uno::Any& rVal,
			  BYTE nMemberId = 0);

	virtual SfxPoolItem * Create(SvStream & rStream, USHORT) const;

	virtual SvStream & Store(SvStream & rStream, USHORT) const;

	virtual SfxPoolItem * Clone(SfxItemPool * = 0) const;

	virtual UINT32 GetMin() const;

	virtual UINT32 GetMax() const;

	virtual SfxFieldUnit GetUnit() const;

	UINT32 GetValue() const { return m_nValue; }

	inline void SetValue(UINT32 nTheValue);
};

inline void CntUInt32Item::SetValue(UINT32 nTheValue)
{
	DBG_ASSERT(GetRef() == 0, "CntUInt32Item::SetValue(): Pooled item");
	m_nValue = nTheValue;
}

#endif 

