

#ifndef _SV_COLRDLG_HXX
#define _SV_COLRDLG_HXX

#ifndef _SV_DIALOG_HXX 
#include <vcl/dialog.hxx>
#endif
#ifndef _SV_BUTTON_HXX 
#include <vcl/button.hxx>
#endif
#ifndef _SV_FIXED_HXX 
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_FIELD_HXX 
#include <vcl/field.hxx>
#endif

#ifndef _SV_COLCTRL_HXX
#include <svtools/colctrl.hxx>
#endif

class SvColorDialog : public ModalDialog
{
private:
	ColorMixingControl	maColMixCtrl;
	PushButton		maBtn1;
	PushButton		maBtn2;

	SvColorControl	maCtlColor;

	FixedText		maFtRed;
	NumericField	maNumRed;
	FixedText		maFtGreen;
	NumericField	maNumGreen;
	FixedText		maFtBlue;
	NumericField	maNumBlue;

	FixedText		maFtCyan;
	MetricField		maNumCyan;
	FixedText		maFtMagenta;
	MetricField		maNumMagenta;
	FixedText		maFtYellow;
	MetricField		maNumYellow;
	FixedText		maFtKey;
	MetricField		maNumKey;

	FixedText		maFtHue;
	NumericField	maNumHue;
	FixedText		maFtSaturation;
	NumericField	maNumSaturation;
	FixedText		maFtLuminance;
	NumericField	maNumLuminance;

	ColorPreviewControl	maCtlPreview;
	ColorPreviewControl	maCtlPreviewOld;

	OKButton		maBtnOK;
	CancelButton	maBtnCancel;
	HelpButton		maBtnHelp;

	Color			maColor;

	void			Initialize();

	DECL_LINK( ColorModifyHdl, void * );
	DECL_LINK( ClickBtnHdl, void * );
	DECL_LINK( ClickMixCtrlHdl, void * );
	DECL_LINK( SelectMixCtrlHdl, void * );

public:
		SvColorDialog( Window* pParent );
		~SvColorDialog();

	void			SetColor( const Color& rColor );
	const Color&	GetColor() const;

	virtual short	Execute();
};

#endif  
