 
#ifndef _DATETIMEITEM_HXX
#define _DATETIMEITEM_HXX

#ifndef _RTTI_HXX
#include <tools/rtti.hxx>
#endif

#ifndef _DATETIME_HXX
#include <tools/datetime.hxx>
#endif

#include <svtools/poolitem.hxx>

class SvStream;

DBG_NAMEEX(SfxDateTimeItem);

class SfxDateTimeItem : public SfxPoolItem
{
private:
	DateTime				aDateTime;

public:
				TYPEINFO();
					SfxDateTimeItem( USHORT nWhich );
				SfxDateTimeItem( USHORT nWhich,
								 const DateTime& rDT );
				SfxDateTimeItem( const SfxDateTimeItem& rCpy );
					~SfxDateTimeItem() {
					DBG_DTOR(SfxDateTimeItem, 0); }

	virtual	int				operator==( const SfxPoolItem& ) const;
	virtual int				Compare( const SfxPoolItem &rWith ) const;
	virtual SfxPoolItem*	Create( SvStream&, USHORT nItemVersion ) const;
	virtual SvStream&		Store( SvStream&, USHORT nItemVersion ) const;
	virtual SfxPoolItem*	Clone( SfxItemPool* pPool = 0 ) const;

	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
						XubString &rText,
	                                const IntlWrapper * pIntlWrapper = 0 )
		const;

	const DateTime&			GetDateTime() const { return aDateTime; }
	void					SetDateTime( const DateTime& rDT ) {
					DBG_ASSERT( GetRef() == 0,
								"SetDateTime() with pooled item" );
					aDateTime = rDT; }

	virtual	BOOL PutValue  ( const com::sun::star::uno::Any& rVal,
			     BYTE nMemberId = 0 );
	virtual	BOOL QueryValue( com::sun::star::uno::Any& rVal,
				 BYTE nMemberId = 0 ) const;
};

class SfxColumnDateTimeItem : public SfxDateTimeItem
{
public:
				TYPEINFO();
					SfxColumnDateTimeItem( USHORT nWhich );
				SfxColumnDateTimeItem( USHORT nWhich,
								 const DateTime& rDT );
				SfxColumnDateTimeItem( const SfxDateTimeItem& rCpy );
					~SfxColumnDateTimeItem() {}

	virtual SfxPoolItem*	Clone( SfxItemPool* pPool = 0 ) const;

	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
						XubString &rText,
	                                const IntlWrapper * pIntlWrapper = 0 )
		const;
};

#endif

