
#ifndef INCLUDED_SVTOOLS_DYNAMICMENUOPTIONS_HXX
#define INCLUDED_SVTOOLS_DYNAMICMENUOPTIONS_HXX

#ifndef _SAL_TYPES_H_
#include <sal/types.h>
#endif

#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif

#ifndef _COM_SUN_STAR_UNO_SEQUENCE_H_
#include <com/sun/star/uno/Sequence.h>
#endif

#ifndef _COM_SUN_STAR_BEANS_PROPERTYVALUE_HPP_
#include <com/sun/star/beans/PropertyValue.hpp>
#endif

#define DYNAMICMENU_PROPERTYNAME_URL                    ::rtl::OUString(RTL_CONSTASCII_USTRINGPARAM("URL"             ))
#define DYNAMICMENU_PROPERTYNAME_TITLE                  ::rtl::OUString(RTL_CONSTASCII_USTRINGPARAM("Title"           ))
#define DYNAMICMENU_PROPERTYNAME_IMAGEIDENTIFIER        ::rtl::OUString(RTL_CONSTASCII_USTRINGPARAM("ImageIdentifier" ))
#define DYNAMICMENU_PROPERTYNAME_TARGETNAME             ::rtl::OUString(RTL_CONSTASCII_USTRINGPARAM("TargetName"      ))

enum EDynamicMenuType
{
	E_NEWMENU       =   0,
	E_WIZARDMENU    =   1,
	E_HELPBOOKMARKS =   2
};

class SvtDynamicMenuOptions_Impl;

class SvtDynamicMenuOptions
{

	public:
	      SvtDynamicMenuOptions();
	    ~SvtDynamicMenuOptions();
	     void Clear( EDynamicMenuType eMenu );
	     ::com::sun::star::uno::Sequence< ::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue > > GetMenu( EDynamicMenuType eMenu ) const;
	     void AppendItem(            EDynamicMenuType    eMenu            ,
	                        const   ::rtl::OUString&    sURL             ,
	                        const   ::rtl::OUString&    sTitle           ,
	                        const   ::rtl::OUString&    sImageIdentifier ,
	                        const   ::rtl::OUString&    sTargetName      );

		static ::osl::Mutex& GetOwnStaticMutex();

	private:
	     static SvtDynamicMenuOptions_Impl* m_pDataContainer    ;   
	    static sal_Int32             m_nRefCount         ;   

};      

#endif  
