

#ifndef _EXTATTR_HXX
#define _EXTATTR_HXX

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif

class ImpEaMgr;
class Icon;
class DirEntry;
class String;
class SvFileStream;
class ResId;

class SvEaMgr
{
friend class ImpEaMgr;

private:
	ImpEaMgr*		pImp;
public:
		SvEaMgr( const DirEntry& rEntry );
		SvEaMgr( const String& rFilename );
		SvEaMgr( SvFileStream& rStream );
			~SvEaMgr();

	BOOL  			GetIcon( Icon& ) const;
	BOOL			SetIcon( const ResId& );
	BOOL			SetIcon( const String& rIconFileName );

	BOOL  			GetLongName( String& ) const;
	BOOL			SetLongName( const String& );

	BOOL  			GetFileType( String& ) const;
	BOOL			SetFileType( const String& );

	BOOL    		GetComment( String& ) const;
	BOOL			SetComment( const String& );

	BOOL  			GetCreator( String& ) const;
	BOOL			SetCreator( const String& );

	BOOL  			GetVersionInfo( String& ) const;
	BOOL			SetVersionInfo( const String& );

	BOOL			Clone( const SvEaMgr& );

	static BOOL		GetAppCreator( String& );
};

#if !defined(OS2) && !defined(MAC) && !defined(UNX)

inline SvEaMgr::SvEaMgr( const DirEntry& ) {}
inline SvEaMgr::SvEaMgr( const String& ) {}
inline SvEaMgr::SvEaMgr( SvFileStream& ) {}
inline SvEaMgr::~SvEaMgr() {}
inline BOOL SvEaMgr::GetIcon( Icon& ) const { return FALSE; }
inline BOOL SvEaMgr::SetIcon( const ResId& ) { return FALSE; }
inline BOOL SvEaMgr::SetIcon( const String&  ) { return FALSE; }
inline BOOL SvEaMgr::GetLongName( String& ) const { return FALSE; }
inline BOOL SvEaMgr::SetLongName( const String& ) { return FALSE; }
inline BOOL SvEaMgr::GetFileType( String& ) const { return FALSE; }
inline BOOL SvEaMgr::SetFileType( const String& ) { return FALSE; }
inline BOOL SvEaMgr::GetComment( String& ) const { return FALSE; }
inline BOOL SvEaMgr::SetComment( const String& ) { return FALSE; }
inline BOOL SvEaMgr::GetCreator( String& ) const { return FALSE; }
inline BOOL SvEaMgr::SetCreator( const String& ) { return FALSE; }
inline BOOL SvEaMgr::GetVersionInfo( String& ) const { return FALSE; }
inline BOOL SvEaMgr::SetVersionInfo( const String& ) { return FALSE; }
inline BOOL SvEaMgr::Clone( const SvEaMgr& ) { return FALSE; }
inline BOOL SvEaMgr::GetAppCreator( String& ) { return FALSE; }

#endif

#endif

