
#ifndef _FILEARCH_HXX
#define _FILEARCH_HXX

#ifndef _STREAM_HXX
#include <tools/stream.hxx>
#endif

class SortedFileEntries;
class FileEntry;

class SimpleFileArchive
{
private:
	String				aArchiveName;	
	SortedFileEntries*	pFiles;

	SvFileStream		aDirStream;
	SvFileStream		aDataStream;

	void				ImpReadIndex();
	void				ImpWriteEntry( const FileEntry* pEntry );
	SvStream*			ImpGetFile( const FileEntry* pEntry );
	BOOL 				ImpDelFile( FileEntry* pEntry, BOOL bWriteIndex );

public:
	SimpleFileArchive( const String& rFilename, USHORT nOpenMode );
	~SimpleFileArchive();

	const String&	GetArchiveName() const { return aArchiveName; }

	USHORT			GetFileCount() const;
	String			GetFileName( USHORT nFile ) const;
	void			ChangeFileName( const String& rOldName, const String& rNewName );

	SvStream*		GetFile( USHORT nFile );
	SvStream*		GetFile( const String& rFileName );
	BOOL			HasFile( const String& rFileName ) const;

	BOOL			AddFile( SvStream& rInput, const String& rName, BOOL bWriteIndex = TRUE );
	BOOL			DelFile( const String& rFileName, BOOL bWriteIndex = TRUE );
	BOOL			DelFile( USHORT nFile, BOOL bWriteIndex = TRUE );

	BOOL			AddArchive( SimpleFileArchive& rArchive, BOOL bWriteIndex = TRUE );
	BOOL			WriteIndex();
	BOOL			ReOrganize();
};

#endif 

