
#ifndef INCLUDED_SVTOOLS_HELPOPT_HXX
#define INCLUDED_SVTOOLS_HELPOPT_HXX

#include <list>
#include <tools/string.hxx>

typedef std::list< sal_Int32 > IdList;

class SvtHelpOptions_Impl;
class SvtHelpOptions
{
	SvtHelpOptions_Impl*    pImp;

public:
	                SvtHelpOptions();
	                ~SvtHelpOptions();
	 void            SetExtendedHelp( sal_Bool b );
	sal_Bool        IsExtendedHelp() const;
	void            SetHelpTips( sal_Bool b );
	sal_Bool        IsHelpTips() const;
	 void            SetHelpAgentAutoStartMode( sal_Bool b );
	sal_Bool        IsHelpAgentAutoStartMode() const;
	void			SetHelpAgentTimeoutPeriod( sal_Int32 _nSeconds );
	sal_Int32		GetHelpAgentTimeoutPeriod( ) const;
	void			SetHelpAgentRetryLimit( sal_Int32 _nTrials );
	sal_Int32		GetHelpAgentRetryLimit( ) const;

	sal_Int32		getAgentIgnoreURLCounter( const ::rtl::OUString& _rURL );

	void			decAgentIgnoreURLCounter( const ::rtl::OUString& _rURL );

	void			resetAgentIgnoreURLCounter( const ::rtl::OUString& _rURL );

	void			resetAgentIgnoreURLCounter();
	 void            SetWelcomeScreen( sal_Bool b );
	sal_Bool        IsWelcomeScreen() const;
	 IdList*         GetPIStarterList();
	void            AddToPIStarterList( sal_Int32 nId );
	void            RemoveFromPIStarterList( sal_Int32 nId );

	String			GetLocale() const;
	String			GetSystem() const;
};

#endif

