
#ifndef _SFXHINT_HXX
#define _SFXHINT_HXX

#ifndef _RTTI_HXX
#include <tools/rtti.hxx>
#endif

class SfxHint
{
public:
	TYPEINFO();

	virtual ~SfxHint();
};

#define DECL_PTRHINT(Name, Type) \
		class Name: public SfxHint \
	    { \
	        Type* pObj; \
	        BOOL  bIsOwner; \
	    \
	    public: \
			TYPEINFO(); \
	        Name( Type* Object, BOOL bOwnedByHint = FALSE ); \
	        ~Name(); \
	    \
	        Type* GetObject() const { return pObj; } \
	        BOOL  IsOwner() const { return bIsOwner; } \
	    }

#define IMPL_PTRHINT_AUTODELETE(Name, Type) \
		TYPEINIT1(Name, SfxHint);	\
	    Name::Name( Type* pObject, BOOL bOwnedByHint ) \
	        { pObj = pObject; bIsOwner = bOwnedByHint; } \
	    Name::~Name() { if ( bIsOwner ) delete pObj; }

#define IMPL_PTRHINT(Name, Type) \
		TYPEINIT1(Name, SfxHint);	\
	    Name::Name( Type* pObject, BOOL bOwnedByHint ) \
	        { pObj = pObject; bIsOwner = bOwnedByHint; } \
	    Name::~Name() {}

#endif

