
#ifndef _INETIMG_HXX
#define _INETIMG_HXX

#ifndef _STRING_HXX 
#include <tools/string.hxx>
#endif
#ifndef _SV_GEN_HXX
#include <tools/gen.hxx>
#endif

class SvData;
class SotDataObject;
class SotDataMemberObject;

class INetImage
{
	String			aImageURL;
	String			aTargetURL;
	String			aTargetFrame;
	String			aAlternateText;
	Size			aSizePixel;

protected:
	String			CopyExchange() const;
	void			PasteExchange( const String& rString );

	void 			SetImageURL( const String& rS )		{ aImageURL = rS; }
	void 			SetTargetURL( const String& rS )	{ aTargetURL = rS; }
	void 			SetTargetFrame( const String& rS )	{ aTargetFrame = rS; }
	void 			SetAlternateText( const String& rS ){ aAlternateText = rS; }
	void			SetSizePixel( const Size& rSize ) 	{ aSizePixel = rSize; }

public:
		INetImage(
			const String& rImageURL,
			const String& rTargetURL,
			const String& rTargetFrame,
			const String& rAlternateText,
			const Size& rSizePixel )
		:	aImageURL( rImageURL ),
			aTargetURL( rTargetURL ),
			aTargetFrame( rTargetFrame ),
			aAlternateText( rAlternateText ),
			aSizePixel( rSizePixel )
		{}
		INetImage()
		{}

	const String&	GetImageURL() const { return aImageURL; }
	const String&	GetTargetURL() const { return aTargetURL; }
	const String&	GetTargetFrame() const { return aTargetFrame; }
	const String&	GetAlternateText() const { return aAlternateText; }
	const Size&		GetSizePixel() const { return aSizePixel; }

	sal_Bool Write( SvStream& rOStm, ULONG nFormat ) const;
	sal_Bool Read( SvStream& rIStm, ULONG nFormat );
};

#endif 

