

#ifndef _SVTOOLS_INETOPTIONS_HXX_
#define _SVTOOLS_INETOPTIONS_HXX_

#ifndef _COM_SUN_STAR_UNO_REFERENCE_HXX_
#include <com/sun/star/uno/Reference.hxx>
#endif
#ifndef _COM_SUN_STAR_UNO_SEQUENCE_HXX_
#include <com/sun/star/uno/Sequence.hxx>
#endif
#ifndef _SAL_TYPES_H_
#include <sal/types.h>
#endif

namespace com { namespace sun { namespace star { namespace beans {
	class XPropertiesChangeListener;
} } } }
namespace rtl { class OUString; }

#define SVT_INET_OPTION_DNS_IP_ADDRESS "Inet/DNS/IP_Address"
#define SVT_INET_OPTION_PROXY_NO_PROXY "Inet/Proxy/NoProxy"
#define SVT_INET_OPTION_PROXY_TYPE "Inet/Proxy/Type"
#define SVT_INET_OPTION_PROXY_FTP_NAME "Inet/Proxy/FTP/Name"
#define SVT_INET_OPTION_PROXY_FTP_PORT "Inet/Proxy/FTP/Port"
#define SVT_INET_OPTION_PROXY_HTTP_NAME "Inet/Proxy/HTTP/Name"
#define SVT_INET_OPTION_PROXY_HTTP_PORT "Inet/Proxy/HTTP/Port"
#define SVT_INET_OPTION_PROXY_SOCKS_NAME "Inet/Proxy/SOCKS/Name"
#define SVT_INET_OPTION_PROXY_SOCKS_PORT "Inet/Proxy/SOCKS/Port"

class SvtInetOptions
{
public:
	SvtInetOptions();

	~SvtInetOptions();

	enum ProxyType { NONE, AUTOMATIC, MANUAL };

	rtl::OUString GetDnsIpAddress() const;

	rtl::OUString GetProxyNoProxy() const;

	sal_Int32 GetProxyType() const;

	rtl::OUString GetProxyFtpName() const;

	sal_Int32 GetProxyFtpPort() const;

	rtl::OUString GetProxyHttpName() const;

	sal_Int32 GetProxyHttpPort() const;

	rtl::OUString GetProxySocksName() const;

	sal_Int32 GetProxySocksPort() const;

	sal_Bool ShouldUseFtpProxy(const rtl::OUString &rUrl) const;
	 void SetDnsIpAddress(rtl::OUString const & rValue, bool bFlush = false);

	void SetSmtpServerName(rtl::OUString const & rValue, bool bFlush = false);

	void SetProxyNoProxy(rtl::OUString const & rValue, bool bFlush = false);

	void SetProxyType(ProxyType eValue, bool bFlush = false);

	void SetProxyFtpName(rtl::OUString const & rValue, bool bFlush = false);

	void SetProxyFtpPort(sal_Int32 nValue, bool bFlush = false);

	void SetProxyHttpName(rtl::OUString const & rValue, bool bFlush = false);

	void SetProxyHttpPort(sal_Int32 nValue, bool bFlush = false);

	void SetProxySocksName(rtl::OUString const & rValue, bool bFlush = false);

	void SetProxySocksPort(sal_Int32 nValue, bool bFlush = false);
	 void flush();

	void
	addPropertiesChangeListener(
		com::sun::star::uno::Sequence< rtl::OUString > const & rPropertyNames,
		com::sun::star::uno::Reference<
	      com::sun::star::beans::XPropertiesChangeListener > const &
	  rListener);

	void
	removePropertiesChangeListener(
		com::sun::star::uno::Sequence< rtl::OUString > const & rPropertyNames,
		com::sun::star::uno::Reference<
	      com::sun::star::beans::XPropertiesChangeListener > const &
	  rListener);

private:
	class Impl;

	static Impl * m_pImpl;
};

#endif 
