

#ifndef SVTOOLS_INSTRM_HXX
#define SVTOOLS_INSTRM_HXX

#ifndef _COM_SUN_STAR_UNO_REFERENCE_H_
#include <com/sun/star/uno/Reference.h>
#endif
#ifndef _STREAM_HXX
#include <tools/stream.hxx>
#endif

namespace com { namespace sun { namespace star { namespace io {
	class XInputStream;
	class XSeekable;
} } } }

class SvDataPipe_Impl;

class SvInputStream: public SvStream
{
	com::sun::star::uno::Reference< com::sun::star::io::XInputStream >
	 m_xStream;
	com::sun::star::uno::Reference< com::sun::star::io::XSeekable >
	 m_xSeekable;
	SvDataPipe_Impl * m_pPipe;
	ULONG m_nSeekedFrom;

	bool open();

	virtual ULONG GetData(void * pData, ULONG nSize);

	virtual ULONG PutData(void const *, ULONG);

	virtual ULONG SeekPos(ULONG nPos);

	virtual void FlushData();

	virtual void SetSize(ULONG);

public:
	SvInputStream(
		com::sun::star::uno::Reference< com::sun::star::io::XInputStream >
	      const &
	  rTheStream);

	virtual ~SvInputStream();

	virtual USHORT IsA() const;

	virtual void AddMark(ULONG nPos);

	virtual void RemoveMark(ULONG nPos);
};

#endif 

