
#ifndef INCLUDED_SVTOOLS_INTERNALOPTIONS_HXX
#define INCLUDED_SVTOOLS_INTERNALOPTIONS_HXX

#ifndef _SAL_TYPES_H_
#include <sal/types.h>
#endif

#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif

#ifndef _RTL_USTRING_
#include <rtl/ustring>
#endif

#define	MUTEX			::osl::Mutex
#define	OUSTRING		::rtl::OUString

class SvtInternalOptions_Impl;

class SvtInternalOptions
{

	public:
	      SvtInternalOptions();
	    ~SvtInternalOptions();

		sal_Bool SlotCFGEnabled		() const;
		sal_Bool CrashMailEnabled	() const;
	    sal_Bool MailUIEnabled      () const;
	    sal_Bool IsRemoveMenuEntryClose() const;
	    sal_Bool IsRemoveMenuEntryBackToWebtop() const;
	    sal_Bool IsRemoveMenuEntryNewWebtop() const;
	    sal_Bool IsRemoveMenuEntryLogout() const;

		void PushRecoveryItem(	const	OUSTRING&	sURL		,
					const	OUSTRING&	sFilter		,
					const	OUSTRING&	sTempName	);
		void PopRecoveryItem(			OUSTRING&	sURL		,
							OUSTRING&	sFilter		,
							OUSTRING&	sTempName	);
		sal_Bool IsRecoveryListEmpty() const;

		static MUTEX& GetOwnStaticMutex();

	private:
	 	static SvtInternalOptions_Impl*	m_pDataContainer	;	
		static sal_Int32				m_nRefCount			;	

};		

#endif	
