

#ifndef _SVTOOLS_LINGUCFG_HXX_
#define _SVTOOLS_LINGUCFG_HXX_

#include <com/sun/star/beans/PropertyValues.hpp>
#include <com/sun/star/uno/Sequence.hxx>

#ifndef _COM_SUN_STAR_UNO_ANY_H_
#include <com/sun/star/uno/Any.h>
#endif

#include <tools/solar.h>

#ifndef _RTL_USTRING_HXX_
#include <rtl/ustring.hxx>
#endif
#ifndef _UTL_CONFIGITEM_HXX_
#include <unotools/configitem.hxx>
#endif
#ifndef _SV_TIMER_HXX
#include <vcl/timer.hxx>
#endif

struct SvtLinguOptions
{
	::com::sun::star::uno::Sequence< rtl::OUString >	aActiveDics;

	INT16	nHyphMinLeading,
			nHyphMinTrailing,
			nHyphMinWordLength;

	INT16	nDefaultLanguage;
	INT16	nDefaultLanguage_CJK;
	INT16	nDefaultLanguage_CTL;

	BOOL	bIsSpellSpecial;
	BOOL	bIsSpellInAllLanguages;
	BOOL	bIsSpellAuto;
	BOOL	bIsSpellHideMarkings;
	BOOL	bIsSpellReverse;

	BOOL	bIsHyphSpecial;
	BOOL	bIsHyphAuto;

	BOOL	bIsGermanPreReform;
	BOOL	bIsUseDictionaryList;
	BOOL	bIsIgnoreControlCharacters;

	BOOL	bIsSpellWithDigits,
			bIsSpellUpperCase,
			bIsSpellCapitalization;

	SvtLinguOptions();
};

class SvtLinguConfigItem : public utl::ConfigItem
{

	SvtLinguConfigItem( const SvtLinguConfigItem & );
	SvtLinguConfigItem & operator = ( const SvtLinguConfigItem & );

public:
	SvtLinguConfigItem( const rtl::OUString &rPath ) : ConfigItem( rPath )	{}

	com::sun::star::uno::Sequence< rtl::OUString > 
		GetPropertyNames();

	com::sun::star::uno::Sequence< com::sun::star::uno::Any >
		GetProperties(
			const com::sun::star::uno::Sequence< rtl::OUString > &rNames )
		{ 
			return ConfigItem::GetProperties(rNames); 
		}

	sal_Bool 
		PutProperties(
	const com::sun::star::uno::Sequence< rtl::OUString > &rNames,
			const com::sun::star::uno::Sequence< 
	com::sun::star::uno::Any > &rValues)
		{
			return ConfigItem::PutProperties( rNames, rValues);
		}

	sal_Bool 
		SetSetProperties(
			const rtl::OUString &rNode, 
			com::sun::star::uno::Sequence< 
	com::sun::star::beans::PropertyValue > rValues )
		{
			return ConfigItem::SetSetProperties( rNode, rValues );
		}

	sal_Bool 
	    ReplaceSetProperties(
			const rtl::OUString &rNode, 
			com::sun::star::uno::Sequence< 
	com::sun::star::beans::PropertyValue > rValues )
		{
	        return ConfigItem::ReplaceSetProperties( rNode, rValues );
		}

	com::sun::star::uno::Sequence< rtl::OUString >
		GetNodeNames( const rtl::OUString &rNode )
		{
			return ConfigItem::GetNodeNames( rNode );
		}
};

class SvtLinguConfig
{
	Timer aSaveTimer;

	SvtLinguOptions		aOpt;
	BOOL				bIsModified;

	SvtLinguConfig( const SvtLinguConfig & );
	SvtLinguConfig & operator = ( const SvtLinguConfig & );

 	static BOOL	GetHdlByName( INT32 &rnHdl, const rtl::OUString &rPropertyName );

	BOOL	LoadConfig();
	BOOL	SaveConfig();

	DECL_LINK( TimeOut, Timer * );

protected:
	void		SetModified( BOOL bVal );
	inline BOOL	IsModified() const	{ return bIsModified; }

public:
	SvtLinguConfig();
	~SvtLinguConfig();

	com::sun::star::uno::Any
			GetProperty( const rtl::OUString &rPropertyName ) const;
	com::sun::star::uno::Any
			GetProperty( INT32 nPropertyHandle ) const;

	BOOL    SetProperty( const rtl::OUString &rPropertyName, 
			 const com::sun::star::uno::Any &rValue );
	BOOL    SetProperty( INT32 nPropertyHandle, 
			 const com::sun::star::uno::Any &rValue );

	BOOL	GetOptions( SvtLinguOptions &rOptions ) const;
	BOOL	SetOptions( const SvtLinguOptions &rOptions );
};

#endif

