

#ifndef _SVTOOLS_LOGINDLG_HXX_
#define _SVTOOLS_LOGINDLG_HXX_

#ifndef _STDCTRL_HXX
#include <svtools/stdctrl.hxx>
#endif
#ifndef _SV_BUTTON_HXX
#include <vcl/button.hxx>
#endif
#ifndef _SV_DIALOG_HXX
#include <vcl/dialog.hxx>
#endif
#ifndef _SV_EDIT_HXX
#include <vcl/edit.hxx>
#endif
#ifndef _SV_FIXED_HXX
#include <vcl/fixed.hxx>
#endif

#define LF_NO_PATH				0x0001	
#define LF_NO_USERNAME			0x0002	
#define LF_NO_PASSWORD			0x0004	
#define LF_NO_SAVEPASSWORD		0x0008	
#define LF_NO_ERRORTEXT			0x0010	
#define LF_PATH_READONLY		0x0020	
#define LF_USERNAME_READONLY	0x0040	
#define LF_NO_ACCOUNT			0x0080	

namespace svt
{

class LoginDialog : public ModalDialog
{
	FixedInfo		aErrorInfo;
	FixedLine		aErrorGB;
	FixedInfo		aRequestInfo;
	FixedText		aPathFT;
	Edit			aPathED;
	FixedInfo		aPathInfo;
	PushButton		aPathBtn;
	FixedText		aNameFT;
	Edit			aNameED;
	FixedInfo		aNameInfo;
	FixedText		aPasswordFT;
	Edit			aPasswordED;
	FixedText		aAccountFT;
	Edit			aAccountED;
	CheckBox		aSavePasswdBtn;
	FixedLine		aLoginGB;
	OKButton		aOKBtn;
	CancelButton	aCancelBtn;
	HelpButton		aHelpBtn;

	void			HideControls_Impl( USHORT nFlags );

	DECL_LINK( OKHdl_Impl, OKButton * );
	DECL_LINK( PathHdl_Impl, PushButton * );

public:
	LoginDialog( Window* pParent, USHORT nFlags,
	 const String& rServer, const String* pRealm = NULL );

	String			GetPath() const { return aPathED.GetText(); }
	void			SetPath( const String& rNewPath )
			{ aPathED.SetText( rNewPath );
			  aPathInfo.SetText( rNewPath );}
	String			GetName() const { return aNameED.GetText(); }
	void			SetName( const String& rNewName );
	String			GetPassword() const { return aPasswordED.GetText(); }
	void			SetPassword( const String& rNew )
			{ aPasswordED.SetText( rNew ); }
	String			GetAccount() const { return aAccountED.GetText(); }
	void			SetAccount( const String& rNew )
			{ aAccountED.SetText( rNew ); }
	BOOL			IsSavePassword() const
			{ return aSavePasswdBtn.IsChecked(); }
	void			SetSavePassword( BOOL bSave )
			{ aSavePasswdBtn.Check( bSave ); }
	void			SetSavePasswordText( const String& rTxt )
			{ aSavePasswdBtn.SetText( rTxt ); }
	void			SetErrorText( const String& rTxt )
			{ aErrorInfo.SetText( rTxt ); }
	void			SetLoginRequestText( const String& rTxt )
			{ aRequestInfo.SetText( rTxt ); }
	void			ClearPassword();
	void			ClearAccount();
};

}	

#endif 

