
#ifndef _NUMUNO_HXX
#define _NUMUNO_HXX

#ifndef _COM_SUN_STAR_UTIL_XNUMBERFORMATSSUPPLIER_HPP_
#include <com/sun/star/util/XNumberFormatsSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XUNOTUNNEL_HPP_
#include <com/sun/star/lang/XUnoTunnel.hpp>
#endif

#ifndef _CPPUHELPER_IMPLBASE2_HXX_
#include <cppuhelper/implbase2.hxx>
#endif

class SvNumberFormatter;
class SvNumFmtSuppl_Impl;

com::sun::star::uno::Reference<com::sun::star::uno::XInterface> SAL_CALL
	SvNumberFormatterServiceObj_NewInstance(
		const com::sun::star::uno::Reference<
			com::sun::star::lang::XMultiServiceFactory>& rSMgr );

class SvNumberFormatsSupplierObj : public cppu::WeakAggImplHelper2<
						com::sun::star::util::XNumberFormatsSupplier,
						com::sun::star::lang::XUnoTunnel>
{
private:
	SvNumFmtSuppl_Impl*	pImpl;

public:
					SvNumberFormatsSupplierObj();
					SvNumberFormatsSupplierObj(SvNumberFormatter* pForm);
	virtual						~SvNumberFormatsSupplierObj();

	void						SetNumberFormatter(SvNumberFormatter* pNew);
	SvNumberFormatter*			GetNumberFormatter() const;

	virtual void				NumberFormatDeleted(sal_uInt32 nKey);

	virtual void				SettingsChanged();

	virtual ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > SAL_CALL
					getNumberFormatSettings()
						throw(::com::sun::star::uno::RuntimeException);
	virtual ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormats > SAL_CALL
					getNumberFormats()
						throw(::com::sun::star::uno::RuntimeException);

	virtual sal_Int64 SAL_CALL	getSomething( const ::com::sun::star::uno::Sequence<
						sal_Int8 >& aIdentifier )
							throw(::com::sun::star::uno::RuntimeException);

	static const com::sun::star::uno::Sequence<sal_Int8>& getUnoTunnelId();
	static SvNumberFormatsSupplierObj* getImplementation( const com::sun::star::uno::Reference<
						com::sun::star::util::XNumberFormatsSupplier> xObj );
};

#endif 

