
#ifndef INCLUDED_SVTOOLS_PATHOPTIONS_HXX
#define INCLUDED_SVTOOLS_PATHOPTIONS_HXX

#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif
#ifndef _LANG_HXX
#include <tools/lang.hxx>
#endif

#define SVT_SEARCHPATH_DELIMITER      ';'
class SvtPathOptions_Impl;

class SvtPathOptions_Impl;
class SvtPathOptions
{
private:
	SvtPathOptions_Impl*	pImp;

public:
	enum Pathes
	{
		PATH_ADDIN,
		PATH_AUTOCORRECT,
		PATH_AUTOTEXT,
		PATH_BACKUP,
		PATH_BASIC,
		PATH_BITMAP,
		PATH_CONFIG,
		PATH_DICTIONARY,
		PATH_FAVORITES,
		PATH_FILTER,
		PATH_GALLERY,
		PATH_GRAPHIC,
		PATH_HELP,
		PATH_LINGUISTIC,
		PATH_MODULE,
		PATH_PALETTE,
		PATH_PLUGIN,
		PATH_STORAGE,
		PATH_TEMP,
		PATH_TEMPLATE,
		PATH_USERCONFIG,
		PATH_USERDICTIONARY,
		PATH_WORK
	};

	SvtPathOptions();
	~SvtPathOptions();

	const String&	GetAddinPath() const;
	const String&	GetAutoCorrectPath() const;
	const String&	GetAutoTextPath() const;
	const String&	GetBackupPath() const;
	const String&	GetBasicPath() const;
	const String&	GetBitmapPath() const;
	const String&	GetConfigPath() const;
	const String&	GetDictionaryPath() const;
	const String&	GetFavoritesPath() const;
	const String&	GetFilterPath() const;
	const String&	GetGalleryPath() const;
	const String&	GetGraphicPath() const;
	const String&	GetHelpPath() const;
	const String&	GetLinguisticPath() const;
	const String&	GetModulePath() const;
	const String&	GetPalettePath() const;
	const String&	GetPluginPath() const;
	const String&	GetStoragePath() const;
	const String&	GetTempPath() const;
	const String&	GetTemplatePath() const;
	const String&	GetUserConfigPath() const;
	const String&	GetUserDictionaryPath() const;
	const String&	GetWorkPath() const;

	void			SetAddinPath( const String& rPath );
	void			SetAutoCorrectPath( const String& rPath );
	void			SetAutoTextPath( const String& rPath );
	void			SetBackupPath( const String& rPath );
	void			SetBasicPath( const String& rPath );
	void			SetBitmapPath( const String& rPath );
	void			SetConfigPath( const String& rPath );
	void			SetDictionaryPath( const String& rPath );
	void			SetFavoritesPath( const String& rPath );
	void			SetFilterPath( const String& rPath );
	void			SetGalleryPath( const String& rPath );
	void			SetGraphicPath( const String& rPath );
	void			SetHelpPath( const String& rPath );
	void			SetLinguisticPath( const String& rPath );
	void			SetModulePath( const String& rPath );
	void			SetPalettePath( const String& rPath );
	void			SetPluginPath( const String& rPath );
	void			SetStoragePath( const String& rPath );
	void			SetTempPath( const String& rPath );
	void			SetTemplatePath( const String& rPath );
	void			SetUserConfigPath( const String& rPath );
	void			SetUserDictionaryPath( const String& rPath );
	void			SetWorkPath( const String& rPath );

	String			SubstituteVariable( const String& rVar );
	sal_Bool		SearchFile( String& rIniFile, Pathes ePath = PATH_USERCONFIG );
	LanguageType	GetLanguageType() const;
};

#ifndef _COM_SUN_STAR_FRAME_XCONFIGMANAGER_HPP_
#include <com/sun/star/frame/XConfigManager.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XSERVICEINFO_HPP_
#include <com/sun/star/lang/XServiceInfo.hpp>
#endif
#ifndef _CPPUHELPER_IMPLBASE2_HXX_
#include <cppuhelper/implbase2.hxx>
#endif

class PathService : public ::cppu::WeakImplHelper2< ::com::sun::star::frame::XConfigManager, ::com::sun::star::lang::XServiceInfo >
{
	virtual ::rtl::OUString	SAL_CALL	getImplementationName(  ) throw(::com::sun::star::uno::RuntimeException);
	virtual sal_Bool SAL_CALL			supportsService( const ::rtl::OUString& ServiceName ) throw(::com::sun::star::uno::RuntimeException);
	virtual ::com::sun::star::uno::Sequence< ::rtl::OUString > SAL_CALL
							getSupportedServiceNames(  ) throw(::com::sun::star::uno::RuntimeException);
	virtual ::rtl::OUString SAL_CALL	substituteVariables( const ::rtl::OUString& sText ) throw(::com::sun::star::uno::RuntimeException);
	virtual void SAL_CALL				addPropertyChangeListener( const ::rtl::OUString& sKeyName, const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertyChangeListener >& xListener ) throw(::com::sun::star::uno::RuntimeException);
	virtual void SAL_CALL				removePropertyChangeListener( const ::rtl::OUString& sKeyName, const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertyChangeListener >& xListener ) throw(::com::sun::star::uno::RuntimeException);
	virtual void SAL_CALL				flush(  ) throw(::com::sun::star::uno::RuntimeException);
};

#endif 

