

#ifndef INCLUDED_SVTOOLS_PRINTOPTIONS_HXX
#define INCLUDED_SVTOOLS_PRINTOPTIONS_HXX

#ifndef _SAL_TYPES_H_
#include <sal/types.h>
#endif
#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif
#ifndef _RTL_USTRING_
#include <rtl/ustring>
#endif

class SvtPrintOptions_Impl;

class PrinterOptions;

class SvtBasePrintOptions
{
protected:
	 SvtPrintOptions_Impl* m_pDataContainer;
	 void        SetDataContainer( SvtPrintOptions_Impl* pDataContainer ) { m_pDataContainer = pDataContainer; }

public:
	 static ::osl::Mutex& GetOwnStaticMutex();

public:
	             SvtBasePrintOptions();
	            ~SvtBasePrintOptions();

	sal_Bool	IsReduceTransparency() const;
	sal_Int16   GetReducedTransparencyMode() const;
	sal_Bool	IsReduceGradients() const;
	sal_Int16   GetReducedGradientMode() const;
	sal_Int16   GetReducedGradientStepCount() const;
	sal_Bool	IsReduceBitmaps() const;
	sal_Int16   GetReducedBitmapMode() const;
	sal_Int16   GetReducedBitmapResolution() const;
	sal_Bool	IsReducedBitmapIncludesTransparency() const;
	sal_Bool	IsConvertToGreyscales() const;

	void        SetReduceTransparency( sal_Bool	bState );
	void        SetReducedTransparencyMode( sal_Int16 nMode );
	void        SetReduceGradients( sal_Bool bState );
	void        SetReducedGradientMode( sal_Int16 nMode );
	void        SetReducedGradientStepCount( sal_Int16 nStepCount );
	void        SetReduceBitmaps( sal_Bool bState );
	void        SetReducedBitmapMode( sal_Int16   bState );
	void        SetReducedBitmapResolution( sal_Int16 nResolution );
	void        SetReducedBitmapIncludesTransparency( sal_Bool bState );
	void        SetConvertToGreyscales( sal_Bool bState );

public:
	 void        GetPrinterOptions( PrinterOptions& rOptions ) const;
	void        SetPrinterOptions( const PrinterOptions& rOptions );
};

class SvtPrinterOptions : public SvtBasePrintOptions
{
private:
	 static SvtPrintOptions_Impl*    m_pStaticDataContainer;	
	static sal_Int32			    m_nRefCount;	        

public:
	 SvtPrinterOptions();
	~SvtPrinterOptions();
};

class SvtPrintFileOptions : public SvtBasePrintOptions
{
private:
	 static SvtPrintOptions_Impl*    m_pStaticDataContainer;	
	static sal_Int32			    m_nRefCount;	        

public:
	 SvtPrintFileOptions();
	~SvtPrintFileOptions();
};

#endif 
