

#ifndef _SV_PRIVSPLT_HXX
#define	_SV_PRIVSPLT_HXX

#ifndef _SV_FIXED_HXX
#include <vcl/fixed.hxx>
#endif

enum PRIVSPLIT_DIRECTION {PRIVSPLIT_HORZ,PRIVSPLIT_VERT };

class SvPrivatSplit : public FixedLine
{
	private:

		Link				aCtrModifiedLink;
		BOOL				aMovingFlag;
		Pointer				aWinPointer;		
		PRIVSPLIT_DIRECTION	eAdrSplit;
		short				nOldX;
		short				nOldY;
		short				nNewX;
		short				nNewY;
		short				nMinPos;
		short				nMaxPos;
		Range				aXMovingRange;
		Range				aYMovingRange;
		short				nDeltaX;
		short				nDeltaY;
		void				ImplInitSettings( BOOL bFont, BOOL bForeground, BOOL bBackground );

	protected:
		virtual void		MouseButtonDown( const MouseEvent& rMEvt );
		virtual void		Tracking( const TrackingEvent& rTEvt );

	public:

		SvPrivatSplit( Window* pWindow, const ResId& rResId,PRIVSPLIT_DIRECTION eAdrSplit);

		SvPrivatSplit( Window* pParent,PRIVSPLIT_DIRECTION eAdrSplit, WinBits nStyle = 0);

		virtual short	GetDeltaX();
		virtual short	GetDeltaY();

		virtual void    CtrModified();

		void			SetXRange(Range cRgeX);
		void			SetYRange(Range cRgeY);

		void			MoveSplitTo(Point aPos);

		virtual	void	StateChanged( StateChangedType nType );
		virtual	void	DataChanged( const DataChangedEvent& rDCEvt );

		void            SetCtrModifiedHdl( const Link& rLink ) { aCtrModifiedLink = rLink; }
		const Link&     GetCtrModifiedHdl() const { return aCtrModifiedLink; }
};

#endif
