
#ifndef _SFXPTITEM_HXX
#define _SFXPTITEM_HXX

#include <tools/solar.h>
#include <tools/rtti.hxx>

#ifndef _GEN_HXX 
#include <tools/gen.hxx>
#endif

#include <svtools/poolitem.hxx>

class SfxArguments;
class SvStream;

DBG_NAMEEX(SfxPointItem);

class SfxPointItem: public SfxPoolItem
{
	Point					 aVal;

public:
				 TYPEINFO();
				 SfxPointItem();
				 SfxPointItem( USHORT nWhich, const Point& rVal );
				 SfxPointItem( USHORT nWhich, SvStream & );
				 SfxPointItem( const SfxPointItem& );
				 ~SfxPointItem() {
					 DBG_DTOR(SfxPointItem, 0); }

	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
						XubString &rText,
	                                const IntlWrapper * = 0 ) const;

	virtual int 			 operator==( const SfxPoolItem& ) const;

	virtual SfxPoolItem*     Clone( SfxItemPool *pPool = 0 ) const;
	virtual SfxPoolItem*	 Create(SvStream &, USHORT nItemVersion) const;
	virtual SvStream&		 Store(SvStream &, USHORT nItemVersion) const;

	const Point&    	 	 GetValue() const { return aVal; }
			void			 SetValue( const Point& rNewVal ) {
					 DBG_ASSERT( GetRef() == 0, "SetValue() with pooled item" );
					 aVal = rNewVal;
				 }

	virtual	BOOL 			 QueryValue( com::sun::star::uno::Any& rVal,
				 			 BYTE nMemberId = 0 ) const;
	virtual	BOOL 			 PutValue( const com::sun::star::uno::Any& rVal,
			   			   BYTE nMemberId = 0 );
};

#endif
