

#ifndef _SBXFORM_HXX
#define _SBXFORM_HXX

#define _with_sprintf	

#ifndef _String_HXX
 #include <tools/string.hxx>
#endif

class SbxBasicFormater {
  public:

	SbxBasicFormater( sal_Unicode _cDecPoint, sal_Unicode _cThousandSep,
		  String _sOnStrg,
		  String _sOffStrg,
		  String _sYesStrg,
		  String _sNoStrg,
		  String _sTrueStrg,
		  String _sFalseStrg,
		  String _sCurrencyStrg,
		  String _sCurrencyFormatStrg );

	String	BasicFormat( double dNumber, String sFormatStrg );
	String  BasicFormatNull( String sFormatStrg );

  private:

	inline void	ShiftString( String& sStrg, USHORT nStartPos );
	inline void	StrAppendChar( String& sStrg, sal_Unicode ch );
	void	AppendDigit( String& sStrg, short nDigit );
	void	LeftShiftDecimalPoint( String& sStrg );
	void	StrRoundDigit( String& sStrg, short nPos, BOOL& bOverflow );
	void	StrRoundDigit( String& sStrg, short nPos );
	void	ParseBack( String& sStrg, const String& sFormatStrg,
	short nFormatPos );
#ifdef _with_sprintf

	void	InitScan( double _dNum );
	void	InitExp( double _dNewExp );
	short	GetDigitAtPosScan( short nPos, BOOL& bFoundFirstDigit );
	short	GetDigitAtPosExpScan( double dNewExponent, short nPos,
	BOOL& bFoundFirstDigit );
	short	GetDigitAtPosExpScan( short nPos, BOOL& bFoundFirstDigit );
#else

	short	GetDigitAtPos( double dNumber, short nPos, double& dNextNumber,
	BOOL& bFoundFirstDigit );
	short	RoundDigit( double dNumber );
#endif
	String	GetPosFormatString( const String& sFormatStrg, BOOL & bFound );
	String	GetNegFormatString( const String& sFormatStrg, BOOL & bFound );
	String	Get0FormatString( const String& sFormatStrg, BOOL & bFound );
	String	GetNullFormatString( const String& sFormatStrg, BOOL & bFound );
	short	AnalyseFormatString( const String& sFormatStrg,
	short& nNoOfDigitsLeft, short& nNoOfDigitsRight,
	short& nNoOfOptionalDigitsLeft,
	short& nNoOfExponentDigits,
	short& nNoOfOptionalExponentDigits,
	BOOL& bPercent, BOOL& bCurrency, BOOL& bScientific,
	BOOL& bGenerateThousandSeparator,
	short& nMultipleThousandSeparators );
	void	ScanFormatString( double dNumber, const String& sFormatStrg,
	String& sReturnStrg, BOOL bCreateSign );

	sal_Unicode cDecPoint;		
	sal_Unicode cThousandSep;	

	String 	sOnStrg;
	String 	sOffStrg;
	String	sYesStrg;
	String 	sNoStrg;
	String 	sTrueStrg;
	String 	sFalseStrg;
	String  sCurrencyStrg;
	String  sCurrencyFormatStrg;

	String	sSciNumStrg;

	String  sNumExpStrg;
	double	dNum;			
	short	nNumExp;		
	short	nExpExp;		
};

#endif

