
#ifndef _SFXSLSTITM_HXX
#define _SFXSLSTITM_HXX

#ifndef _RTTI_HXX 
#include <tools/rtti.hxx>
#endif
#ifndef _LIST_HXX
#include <tools/list.hxx>
#endif

#include <svtools/poolitem.hxx>

class SfxImpStringList;

class SfxStringListItem : public SfxPoolItem
{
protected:
	SfxImpStringList*	pImp;

public:
	TYPEINFO();

	SfxStringListItem();
	SfxStringListItem( USHORT nWhich, const List* pList=NULL );
	SfxStringListItem( USHORT nWhich, SvStream& rStream );
	SfxStringListItem( const SfxStringListItem& rItem );
	~SfxStringListItem();

	List *					GetList();

	const List *			GetList() const
	{ return SAL_CONST_CAST(SfxStringListItem *, this)->GetList(); }

#ifndef TF_POOLABLE
	virtual int 			IsPoolable() const;
#endif

	virtual	void			SetString( const XubString& );
	virtual XubString		GetString();

	virtual int 			operator==( const SfxPoolItem& ) const;
	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
						XubString &rText,
	                                const IntlWrapper * = 0 ) const;
	virtual SfxPoolItem*    Clone( SfxItemPool *pPool = 0 ) const;
	virtual SfxPoolItem*	Create( SvStream &, USHORT nVersion ) const;
	virtual SvStream&		Store( SvStream &, USHORT nItemVersion ) const;
	void 					Sort( BOOL bAscending = TRUE, List* pParallelList = 0 );

	virtual	BOOL 			PutValue  ( const com::sun::star::uno::Any& rVal,
			     			BYTE nMemberId = 0 );
	virtual	BOOL 			QueryValue( com::sun::star::uno::Any& rVal,
				 			BYTE nMemberId = 0 ) const;
};
#endif
