

#ifndef _SVTOOLS_SVTDATA_HXX
#define _SVTOOLS_SVTDATA_HXX

#ifndef _LANG_HXX
#include <tools/lang.hxx>
#endif
#ifndef _TOOLS_RESID_HXX
#include <tools/resid.hxx>
#endif
#ifndef _TOOLS_SIMPLERESMGR_HXX_
#include <tools/simplerm.hxx>
#endif

class ResMgr;
class SfxItemDesruptorList_Impl;
class SfxItemPool;
class Twain;
struct SvDemo_Impl;

class ImpSvtData
{
public:
	Twain * pTwain;
	const SfxItemPool * pStoringPool;
	SfxItemDesruptorList_Impl * pItemDesruptList;
	SvDemo_Impl * pDemo;

	ResMgr *		pResMgr;

	void*			m_pThreadsafeRMs;

private:
	ImpSvtData():
		pTwain(0), pStoringPool(0), pItemDesruptList(0), pDemo(0), pResMgr(0), m_pThreadsafeRMs(NULL)
	{}

	~ImpSvtData();

public:
	ResMgr * GetResMgr(LanguageType eLanguage);
	ResMgr * GetResMgr(); 

	SimpleResMgr * GetSimpleRM(LanguageType eLanguage);

	static ImpSvtData & GetSvtData();
};

class SvtResId: public ResId
{
public:
	SvtResId(USHORT nId, LanguageType eLanguage):
		ResId(nId, ImpSvtData::GetSvtData().GetResMgr(eLanguage)) {}

	SvtResId(USHORT nId): ResId(nId, ImpSvtData::GetSvtData().GetResMgr()) {}

};

class SvtSimpleResId
{
	String	m_sValue;

public:
	SvtSimpleResId(USHORT nId, LanguageType eLanguage) : m_sValue(ImpSvtData::GetSvtData().GetSimpleRM(eLanguage)->ReadString(nId)) { };

	operator String () const { return m_sValue; }
};

#endif 

