

#ifndef _SMART_COM_SUN_STAR_IO_XCONNECTABLE_HXX_
#include <smart/com/sun/star/io/XConnectable.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_IO_XOUTPUTSTREAM_HXX_
#include <smart/com/sun/star/io/XOutputStream.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_IO_XDATAOUTPUTSTREAM_HXX_
#include <smart/com/sun/star/io/XDataOutputStream.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_IO_XACTIVEDATACONTROL_HXX_
#include <smart/com/sun/star/io/XActiveDataControl.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_IO_XDATAINPUTSTREAM_HXX_
#include <smart/com/sun/star/io/XDataInputStream.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_IO_XMARKABLESTREAM_HXX_
#include <smart/com/sun/star/io/XMarkableStream.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_IO_XINPUTSTREAM_HXX_
#include <smart/com/sun/star/io/XInputStream.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_IO_XSTREAMLISTENER_HXX_
#include <smart/com/sun/star/io/XStreamListener.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_IO_XACTIVEDATASINK_HXX_
#include <smart/com/sun/star/io/XActiveDataSink.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_IO_XACTIVEDATASOURCE_HXX_
#include <smart/com/sun/star/io/XActiveDataSource.hxx>
#endif

#ifndef _STREAM_HXX 
#include <tools/stream.hxx>
#endif

class SvToXInputStream : public XInputStream, public UsrObject
{
	SvStream &_aStream;
public:
	SvToXInputStream(SvStream &aStream)
			:_aStream(aStream){}

	virtual INT32 readBytes(Sequence< BYTE >& aData, INT32 nBytesToRead)
		THROWS( (NotConnectedException, BufferSizeExceededException, UsrSystemException) );
	virtual INT32 readSomeBytes(Sequence< BYTE >& aData, INT32 nMaxBytesToRead)
		THROWS( (NotConnectedException, BufferSizeExceededException, UsrSystemException) );
	virtual void  skipBytes(INT32 nBytesToSkip)
		THROWS( (NotConnectedException, BufferSizeExceededException, UsrSystemException) );
	virtual INT32 available(void)
		THROWS( (NotConnectedException, UsrSystemException) );
	virtual void  closeInput(void)
		THROWS( (NotConnectedException, UsrSystemException) ); 

	SMART_UNO_DECLARATION( SvToXInputStream, UsrObject );
	virtual BOOL queryInterface( UsrUik aUIK, XInterfaceRef& );
	static  const XIdlClassRef&  staticGetIdlClass();
	virtual Sequence< XIdlClassRef > getIdlClasses( void ) {
		return Sequence< XIdlClassRef>( &staticGetIdlClass(), 1 ); }
};

class SvToXOutputStream : public XOutputStream, public UsrObject
{
	SvStream &_aStream;
public:
	SvToXOutputStream(SvStream &aStream)
			:_aStream(aStream){}
	 virtual void writeBytes(const Sequence< BYTE >& aData) THROWS( (NotConnectedException, BufferSizeExceededException, UsrSystemException) );
	virtual void flush(void) THROWS( (NotConnectedException, BufferSizeExceededException, UsrSystemException) );
	virtual void closeOutput(void) THROWS( (NotConnectedException, BufferSizeExceededException, UsrSystemException) );

	SMART_UNO_DECLARATION( SvToXOutputStream, UsrObject );
	virtual BOOL queryInterface( UsrUik aUIK, XInterfaceRef& );
	static  const XIdlClassRef&  staticGetIdlClass();
	virtual Sequence< XIdlClassRef > getIdlClasses( void ) {
		return Sequence< XIdlClassRef>( &staticGetIdlClass(), 1 ); }
};
