

#ifndef _SVT_UNOIFACE_HXX
#define _SVT_UNOIFACE_HXX

#include <toolkit/awt/vclxwindow.hxx>
#include <toolkit/awt/vclxwindows.hxx>
#include <toolkit/helper/listenermultiplexer.hxx>

#include <cppuhelper/typeprovider.hxx>

#include <com/sun/star/lang/IllegalArgumentException.hpp>

#include <svtools/svmedit.hxx>

#include <svtools/fmtfield.hxx>

#ifndef _COM_SUN_STAR_UTIL_XNUMBERFORMATSSUPPLIER_HPP_
#include <com/sun/star/util/XNumberFormatsSupplier.hpp>
#endif

class SvNumberFormatsSupplierObj;

class VCLXMultiLineEdit :	public ::com::sun::star::awt::XTextComponent, 
				public ::com::sun::star::awt::XTextArea, 
				public ::com::sun::star::awt::XTextLayoutConstrains, 
				public VCLXWindow
{
private:
	TextListenerMultiplexer	maTextListeners;

protected:
	DECL_LINK( 	 		ModifyHdl, MultiLineEdit* );

public:
		VCLXMultiLineEdit();
		~VCLXMultiLineEdit();

	void	SetWindow( Window* pWindow );
	 ::com::sun::star::uno::Any					SAL_CALL queryInterface( const ::com::sun::star::uno::Type & rType ) throw(::com::sun::star::uno::RuntimeException);
	void										SAL_CALL acquire() throw(::com::sun::star::uno::RuntimeException)	{ VCLXWindow::acquire(); }
	void										SAL_CALL release() throw(::com::sun::star::uno::RuntimeException)	{ VCLXWindow::release(); }

	::com::sun::star::uno::Sequence< ::com::sun::star::uno::Type >	SAL_CALL getTypes() throw(::com::sun::star::uno::RuntimeException);
	::com::sun::star::uno::Sequence< sal_Int8 >						SAL_CALL getImplementationId() throw(::com::sun::star::uno::RuntimeException);
	 void SAL_CALL addTextListener( const ::com::sun::star::uno::Reference< ::com::sun::star::awt::XTextListener >& l ) throw(::com::sun::star::uno::RuntimeException);
	void SAL_CALL removeTextListener( const ::com::sun::star::uno::Reference< ::com::sun::star::awt::XTextListener >& l ) throw(::com::sun::star::uno::RuntimeException);
	void SAL_CALL setText( const ::rtl::OUString& aText ) throw(::com::sun::star::uno::RuntimeException);
	void SAL_CALL insertText( const ::com::sun::star::awt::Selection& Sel, const ::rtl::OUString& Text ) throw(::com::sun::star::uno::RuntimeException);
	::rtl::OUString SAL_CALL getText(  ) throw(::com::sun::star::uno::RuntimeException);
	::rtl::OUString SAL_CALL getSelectedText(  ) throw(::com::sun::star::uno::RuntimeException);
	void SAL_CALL setSelection( const ::com::sun::star::awt::Selection& aSelection ) throw(::com::sun::star::uno::RuntimeException);
	::com::sun::star::awt::Selection SAL_CALL getSelection(  ) throw(::com::sun::star::uno::RuntimeException);
	sal_Bool SAL_CALL isEditable(  ) throw(::com::sun::star::uno::RuntimeException);
	void SAL_CALL setEditable( sal_Bool bEditable ) throw(::com::sun::star::uno::RuntimeException);
	void SAL_CALL setMaxTextLen( sal_Int16 nLen ) throw(::com::sun::star::uno::RuntimeException);
	sal_Int16 SAL_CALL getMaxTextLen(  ) throw(::com::sun::star::uno::RuntimeException);
	 ::rtl::OUString SAL_CALL getTextLines(  ) throw(::com::sun::star::uno::RuntimeException);
	 ::com::sun::star::awt::Size SAL_CALL getMinimumSize(  ) throw(::com::sun::star::uno::RuntimeException);
	::com::sun::star::awt::Size SAL_CALL getPreferredSize(  ) throw(::com::sun::star::uno::RuntimeException);
	::com::sun::star::awt::Size SAL_CALL calcAdjustedSize( const ::com::sun::star::awt::Size& aNewSize ) throw(::com::sun::star::uno::RuntimeException);
	 ::com::sun::star::awt::Size SAL_CALL getMinimumSize( sal_Int16 nCols, sal_Int16 nLines ) throw(::com::sun::star::uno::RuntimeException);
	void SAL_CALL getColumnsAndLines( sal_Int16& nCols, sal_Int16& nLines ) throw(::com::sun::star::uno::RuntimeException);
	 void SAL_CALL setProperty( const ::rtl::OUString& PropertyName, const ::com::sun::star::uno::Any& Value ) throw(::com::sun::star::uno::RuntimeException);
	::com::sun::star::uno::Any SAL_CALL getProperty( const ::rtl::OUString& PropertyName ) throw(::com::sun::star::uno::RuntimeException);
};

class VCLXFileControl : ::com::sun::star::awt::XTextComponent, public ::com::sun::star::awt::XTextLayoutConstrains, public VCLXWindow
{
protected:
	DECL_LINK( 	 	ModifyHdl, Edit* );
	TextListenerMultiplexer	maTextListeners;

public:
		VCLXFileControl();
		~VCLXFileControl();

	void 			SetWindow( Window* pWindow );
	 ::com::sun::star::uno::Any					SAL_CALL queryInterface( const ::com::sun::star::uno::Type & rType ) throw(::com::sun::star::uno::RuntimeException);
	void										SAL_CALL acquire() throw(::com::sun::star::uno::RuntimeException)	{ VCLXWindow::acquire(); }
	void										SAL_CALL release() throw(::com::sun::star::uno::RuntimeException)	{ VCLXWindow::release(); }

	::com::sun::star::uno::Sequence< ::com::sun::star::uno::Type >	SAL_CALL getTypes() throw(::com::sun::star::uno::RuntimeException);
	::com::sun::star::uno::Sequence< sal_Int8 >						SAL_CALL getImplementationId() throw(::com::sun::star::uno::RuntimeException);
	 void SAL_CALL addTextListener( const ::com::sun::star::uno::Reference< ::com::sun::star::awt::XTextListener >& l ) throw(::com::sun::star::uno::RuntimeException);
	void SAL_CALL removeTextListener( const ::com::sun::star::uno::Reference< ::com::sun::star::awt::XTextListener >& l ) throw(::com::sun::star::uno::RuntimeException);
	void SAL_CALL setText( const ::rtl::OUString& aText ) throw(::com::sun::star::uno::RuntimeException);
	void SAL_CALL insertText( const ::com::sun::star::awt::Selection& Sel, const ::rtl::OUString& Text ) throw(::com::sun::star::uno::RuntimeException);
	::rtl::OUString SAL_CALL getText(  ) throw(::com::sun::star::uno::RuntimeException);
	::rtl::OUString SAL_CALL getSelectedText(  ) throw(::com::sun::star::uno::RuntimeException);
	void SAL_CALL setSelection( const ::com::sun::star::awt::Selection& aSelection ) throw(::com::sun::star::uno::RuntimeException);
	::com::sun::star::awt::Selection SAL_CALL getSelection(  ) throw(::com::sun::star::uno::RuntimeException);
	sal_Bool SAL_CALL isEditable(  ) throw(::com::sun::star::uno::RuntimeException);
	void SAL_CALL setEditable( sal_Bool bEditable ) throw(::com::sun::star::uno::RuntimeException);
	void SAL_CALL setMaxTextLen( sal_Int16 nLen ) throw(::com::sun::star::uno::RuntimeException);
	sal_Int16 SAL_CALL getMaxTextLen(  ) throw(::com::sun::star::uno::RuntimeException);
	 ::com::sun::star::awt::Size SAL_CALL getMinimumSize(  ) throw(::com::sun::star::uno::RuntimeException);
	::com::sun::star::awt::Size SAL_CALL getPreferredSize(  ) throw(::com::sun::star::uno::RuntimeException);
	::com::sun::star::awt::Size SAL_CALL calcAdjustedSize( const ::com::sun::star::awt::Size& aNewSize ) throw(::com::sun::star::uno::RuntimeException);
	 ::com::sun::star::awt::Size SAL_CALL getMinimumSize( sal_Int16 nCols, sal_Int16 nLines ) throw(::com::sun::star::uno::RuntimeException);
	void SAL_CALL getColumnsAndLines( sal_Int16& nCols, sal_Int16& nLines ) throw(::com::sun::star::uno::RuntimeException);
};

class SVTXFormattedField : public VCLXSpinField
{
protected:
	SvNumberFormatsSupplierObj*	m_pCurrentSupplier;
	sal_Bool					bIsStandardSupplier;

	sal_Int32					nKeyToSetDelayed;

	FormattedField*				GetFormattedField() const { return (FormattedField*)GetWindow(); }	

public:
	SVTXFormattedField();
	~SVTXFormattedField();
	 void SAL_CALL setProperty( const ::rtl::OUString& PropertyName, const ::com::sun::star::uno::Any& Value ) throw(::com::sun::star::uno::RuntimeException);
	::com::sun::star::uno::Any SAL_CALL getProperty( const ::rtl::OUString& PropertyName ) throw(::com::sun::star::uno::RuntimeException);

protected:
	::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatsSupplier >  getFormatsSupplier(void) const;
	void	setFormatsSupplier(const ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatsSupplier > & xSupplier);
	sal_Int32	getFormatKey(void) const;
	void	setFormatKey(sal_Int32 nKey);

	void	SetValue(const ::com::sun::star::uno::Any& rValue);
	::com::sun::star::uno::Any	GetValue();

	void	SetTreatAsNumber(sal_Bool bSet);
	sal_Bool	GetTreatAsNumber();

	void	SetDefaultValue(const ::com::sun::star::uno::Any& rValue);
	::com::sun::star::uno::Any	GetDefaultValue();

	void	SetMinValue(const ::com::sun::star::uno::Any& rValue);
	::com::sun::star::uno::Any	GetMinValue();

	void	SetMaxValue(const ::com::sun::star::uno::Any& rValue);
	::com::sun::star::uno::Any	GetMaxValue();

	void	NotifyTextListeners();
	::com::sun::star::uno::Any	convertEffectiveValue(const ::com::sun::star::uno::Any& rValue);

	virtual void	SetWindow(Window* _pWindow);
};

class SVTXNumericField : public ::com::sun::star::awt::XNumericField, public SVTXFormattedField
{
public:
		SVTXNumericField();
		~SVTXNumericField();
	 ::com::sun::star::uno::Any					SAL_CALL queryInterface( const ::com::sun::star::uno::Type & rType ) throw(::com::sun::star::uno::RuntimeException);
	void										SAL_CALL acquire() throw(::com::sun::star::uno::RuntimeException)	{ SVTXFormattedField::acquire(); }
	void										SAL_CALL release() throw(::com::sun::star::uno::RuntimeException)	{ SVTXFormattedField::release(); }

	::com::sun::star::uno::Sequence< ::com::sun::star::uno::Type >	SAL_CALL getTypes() throw(::com::sun::star::uno::RuntimeException);
	::com::sun::star::uno::Sequence< sal_Int8 >						SAL_CALL getImplementationId() throw(::com::sun::star::uno::RuntimeException);
	 void SAL_CALL setValue( double Value ) throw(::com::sun::star::uno::RuntimeException);
	double SAL_CALL getValue(  ) throw(::com::sun::star::uno::RuntimeException);
	void SAL_CALL setMin( double Value ) throw(::com::sun::star::uno::RuntimeException);
	double SAL_CALL getMin(  ) throw(::com::sun::star::uno::RuntimeException);
	void SAL_CALL setMax( double Value ) throw(::com::sun::star::uno::RuntimeException);
	double SAL_CALL getMax(  ) throw(::com::sun::star::uno::RuntimeException);
	void SAL_CALL setFirst( double Value ) throw(::com::sun::star::uno::RuntimeException);
	double SAL_CALL getFirst(  ) throw(::com::sun::star::uno::RuntimeException);
	void SAL_CALL setLast( double Value ) throw(::com::sun::star::uno::RuntimeException);
	double SAL_CALL getLast(  ) throw(::com::sun::star::uno::RuntimeException);
	void SAL_CALL setSpinSize( double Value ) throw(::com::sun::star::uno::RuntimeException);
	double SAL_CALL getSpinSize(  ) throw(::com::sun::star::uno::RuntimeException);
	void SAL_CALL setDecimalDigits( sal_Int16 nDigits ) throw(::com::sun::star::uno::RuntimeException);
	sal_Int16 SAL_CALL getDecimalDigits(  ) throw(::com::sun::star::uno::RuntimeException);
	void SAL_CALL setStrictFormat( sal_Bool bStrict ) throw(::com::sun::star::uno::RuntimeException);
	sal_Bool SAL_CALL isStrictFormat(  ) throw(::com::sun::star::uno::RuntimeException);
};

class SVTXCurrencyField : public ::com::sun::star::awt::XCurrencyField, public SVTXFormattedField
{
public:
		SVTXCurrencyField();
		~SVTXCurrencyField();
	 ::com::sun::star::uno::Any					SAL_CALL queryInterface( const ::com::sun::star::uno::Type & rType ) throw(::com::sun::star::uno::RuntimeException);
	void										SAL_CALL acquire() throw(::com::sun::star::uno::RuntimeException)	{ SVTXFormattedField::acquire(); }
	void										SAL_CALL release() throw(::com::sun::star::uno::RuntimeException)	{ SVTXFormattedField::release(); }

	::com::sun::star::uno::Sequence< ::com::sun::star::uno::Type >	SAL_CALL getTypes() throw(::com::sun::star::uno::RuntimeException);
	::com::sun::star::uno::Sequence< sal_Int8 >						SAL_CALL getImplementationId() throw(::com::sun::star::uno::RuntimeException);
	 void SAL_CALL setProperty( const ::rtl::OUString& PropertyName, const ::com::sun::star::uno::Any& Value ) throw(::com::sun::star::uno::RuntimeException);
	::com::sun::star::uno::Any SAL_CALL getProperty( const ::rtl::OUString& PropertyName ) throw(::com::sun::star::uno::RuntimeException);
	 void SAL_CALL setValue( double Value ) throw(::com::sun::star::uno::RuntimeException);
	double SAL_CALL getValue(  ) throw(::com::sun::star::uno::RuntimeException);
	void SAL_CALL setMin( double Value ) throw(::com::sun::star::uno::RuntimeException);
	double SAL_CALL getMin(  ) throw(::com::sun::star::uno::RuntimeException);
	void SAL_CALL setMax( double Value ) throw(::com::sun::star::uno::RuntimeException);
	double SAL_CALL getMax(  ) throw(::com::sun::star::uno::RuntimeException);
	void SAL_CALL setFirst( double Value ) throw(::com::sun::star::uno::RuntimeException);
	double SAL_CALL getFirst(  ) throw(::com::sun::star::uno::RuntimeException);
	void SAL_CALL setLast( double Value ) throw(::com::sun::star::uno::RuntimeException);
	double SAL_CALL getLast(  ) throw(::com::sun::star::uno::RuntimeException);
	void SAL_CALL setSpinSize( double Value ) throw(::com::sun::star::uno::RuntimeException);
	double SAL_CALL getSpinSize(  ) throw(::com::sun::star::uno::RuntimeException);
	void SAL_CALL setDecimalDigits( sal_Int16 nDigits ) throw(::com::sun::star::uno::RuntimeException);
	sal_Int16 SAL_CALL getDecimalDigits(  ) throw(::com::sun::star::uno::RuntimeException);
	void SAL_CALL setStrictFormat( sal_Bool bStrict ) throw(::com::sun::star::uno::RuntimeException);
	sal_Bool SAL_CALL isStrictFormat(  ) throw(::com::sun::star::uno::RuntimeException);
};

class VCLXProgressBar :	public ::com::sun::star::awt::XProgressBar, 
			public VCLXWindow
{
private:
	sal_Int32	m_nValue;
	sal_Int32	m_nValueMin;
	sal_Int32	m_nValueMax;

protected:
	void			ImplUpdateValue();

public:
		VCLXProgressBar();
		~VCLXProgressBar();
	 ::com::sun::star::uno::Any					SAL_CALL queryInterface( const ::com::sun::star::uno::Type & rType ) throw(::com::sun::star::uno::RuntimeException);
	void										SAL_CALL acquire() throw(::com::sun::star::uno::RuntimeException)	{ VCLXWindow::acquire(); }
	void										SAL_CALL release() throw(::com::sun::star::uno::RuntimeException)	{ VCLXWindow::release(); }

	::com::sun::star::uno::Sequence< ::com::sun::star::uno::Type >	SAL_CALL getTypes() throw(::com::sun::star::uno::RuntimeException);
	::com::sun::star::uno::Sequence< sal_Int8 >						SAL_CALL getImplementationId() throw(::com::sun::star::uno::RuntimeException);
	 void SAL_CALL setForegroundColor( sal_Int32 nColor ) throw(::com::sun::star::uno::RuntimeException);
	void SAL_CALL setBackgroundColor( sal_Int32 nColor ) throw(::com::sun::star::uno::RuntimeException);
	void SAL_CALL setValue( sal_Int32 nValue ) throw(::com::sun::star::uno::RuntimeException);
	void SAL_CALL setRange(	sal_Int32 nMin, sal_Int32 nMax ) throw(::com::sun::star::uno::RuntimeException );
	sal_Int32 SAL_CALL getValue() throw(::com::sun::star::uno::RuntimeException);
	 void SAL_CALL setProperty( const ::rtl::OUString& PropertyName, const ::com::sun::star::uno::Any& Value ) throw(::com::sun::star::uno::RuntimeException);
	::com::sun::star::uno::Any SAL_CALL getProperty( const ::rtl::OUString& PropertyName ) throw(::com::sun::star::uno::RuntimeException);
};

#endif	

