

#ifndef SVTOOLS_URIHELPER_HXX
#define SVTOOLS_URIHELPER_HXX

#ifndef _RTL_TEXTENC_H 
#include <rtl/textenc.h>
#endif
#ifndef _LINK_HXX 
#include <tools/link.hxx>
#endif
#ifndef _SOLAR_H 
#include <tools/solar.h>
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif

namespace com { namespace sun { namespace star { namespace uno {
	class RuntimeException;
} } } }
class ByteString;
class CharClass;
class UniString;

namespace URIHelper {

UniString
SmartRel2Abs(INetURLObject const & rTheBaseURIRef,
	ByteString const & rTheRelURIRef,
	Link const & rMaybeFileHdl = Link(),
	bool bCheckFileExists = true,
	bool bIgnoreFragment = false,
	INetURLObject::EncodeMechanism eEncodeMechanism
	    = INetURLObject::WAS_ENCODED,
	INetURLObject::DecodeMechanism eDecodeMechanism
	    = INetURLObject::DECODE_TO_IURI,
	rtl_TextEncoding eCharset = RTL_TEXTENCODING_UTF8,
	bool bRelativeNonURIs = false,
	INetURLObject::FSysStyle eStyle = INetURLObject::FSYS_DETECT);

UniString
SmartRel2Abs(INetURLObject const & rTheBaseURIRef,
	UniString const & rTheRelURIRef,
	Link const & rMaybeFileHdl = Link(),
	bool bCheckFileExists = true,
	bool bIgnoreFragment = false,
	INetURLObject::EncodeMechanism eEncodeMechanism
	    = INetURLObject::WAS_ENCODED,
	INetURLObject::DecodeMechanism eDecodeMechanism
	    = INetURLObject::DECODE_TO_IURI,
	rtl_TextEncoding eCharset = RTL_TEXTENCODING_UTF8,
	bool bRelativeNonURIs = false,
	INetURLObject::FSysStyle eStyle = INetURLObject::FSYS_DETECT);

void SetMaybeFileHdl(Link const & rTheMaybeFileHdl);

Link GetMaybeFileHdl();

inline UniString
SmartRelToAbs(ByteString const & rTheRelURIRef,
	 bool bIgnoreFragment = false,
	 INetURLObject::EncodeMechanism eEncodeMechanism
	     = INetURLObject::WAS_ENCODED,
	 INetURLObject::DecodeMechanism eDecodeMechanism
	     = INetURLObject::DECODE_TO_IURI,
	 rtl_TextEncoding eCharset = RTL_TEXTENCODING_UTF8,
	 INetURLObject::FSysStyle eStyle = INetURLObject::FSYS_DETECT)
{
	return SmartRel2Abs(INetURLObject(INetURLObject::GetBaseURL()),
			rTheRelURIRef, GetMaybeFileHdl(), true,
			bIgnoreFragment, eEncodeMechanism, eDecodeMechanism,
			eCharset, false, eStyle);
}

inline UniString
SmartRelToAbs(UniString const & rTheRelURIRef,
	 bool bIgnoreFragment = false,
	 INetURLObject::EncodeMechanism eEncodeMechanism
	     = INetURLObject::WAS_ENCODED,
	 INetURLObject::DecodeMechanism eDecodeMechanism
	     = INetURLObject::DECODE_TO_IURI,
	 rtl_TextEncoding eCharset = RTL_TEXTENCODING_UTF8,
	 INetURLObject::FSysStyle eStyle = INetURLObject::FSYS_DETECT)
{
	return SmartRel2Abs(INetURLObject(INetURLObject::GetBaseURL()),
			rTheRelURIRef, GetMaybeFileHdl(), true,
			bIgnoreFragment, eEncodeMechanism, eDecodeMechanism,
			eCharset, false, eStyle);
}

UniString
FindFirstURLInText(UniString const & rText,
	   xub_StrLen & rBegin,
	   xub_StrLen & rEnd,
	   CharClass const & rCharClass,
	   INetURLObject::EncodeMechanism eMechanism
	       = INetURLObject::WAS_ENCODED,
	   rtl_TextEncoding eCharset = RTL_TEXTENCODING_UTF8,
	   INetURLObject::FSysStyle eStyle
	       = INetURLObject::FSYS_DETECT);

UniString
removePassword(UniString const & rURI,
	  INetURLObject::EncodeMechanism eEncodeMechanism
	      = INetURLObject::WAS_ENCODED,
	  INetURLObject::DecodeMechanism eDecodeMechanism
	      = INetURLObject::DECODE_TO_IURI,
	  rtl_TextEncoding eCharset = RTL_TEXTENCODING_UTF8);

INetURLObject::FSysStyle queryFSysStyle(UniString const & rFileUrl,
							bool bAddConvenienceStyles = true)
	throw (com::sun::star::uno::RuntimeException);

}

#endif 
