

#ifndef _SVT_WIZDLG_HXX
#define _SVT_WIZDLG_HXX

#ifndef _VCL_DIALOG_HXX
#include <vcl/dialog.hxx>
#endif

class TabPage;
class Button;
class PushButton;
class FixedLine;
struct ImplWizPageData;
struct ImplWizButtonData;

#define WIZARDDIALOG_BUTTON_STDOFFSET_X 	10

class WizardDialog : public ModalDialog
{
private:
	Size				maPageSize;
	ImplWizPageData*	mpFirstPage;
	ImplWizButtonData*	mpFirstBtn;
	FixedLine*			mpFixedLine;
	TabPage*			mpCurTabPage;
	PushButton* 		mpPrevBtn;
	PushButton* 		mpNextBtn;
	Window* 			mpViewWindow;
	USHORT				mnCurLevel;
	WindowAlign 		meViewAlign;
	Link				maActivateHdl;
	Link				maDeactivateHdl;

#ifdef _SVT_WIZDLG_CXX
private:
	void				ImplInitData();
	void				ImplCalcSize( Size& rSize );
	void				ImplPosCtrls();
	void				ImplPosTabPage();
	void				ImplShowTabPage( TabPage* pPage );
	TabPage*			ImplGetPage( USHORT nLevel ) const;
#endif

public:
			WizardDialog( Window* pParent,
						  WinBits nStyle = WB_STDTABDIALOG );
			WizardDialog( Window* pParent, const ResId& rResId );
			~WizardDialog();

	virtual void		Resize();
	virtual void		StateChanged( StateChangedType nStateChange );
	virtual long		Notify( NotifyEvent& rNEvt );

	virtual void		ActivatePage();
	virtual long		DeactivatePage();

	BOOL				ShowPrevPage();
	BOOL				ShowNextPage();
	BOOL				ShowPage( USHORT nLevel );
	BOOL				Finnish( long nResult = 0 );
	USHORT				GetCurLevel() const { return mnCurLevel; }

	void				AddPage( TabPage* pPage );
	void				RemovePage( TabPage* pPage );
	void				SetPage( USHORT nLevel, TabPage* pPage );
	TabPage*			GetPage( USHORT nLevel ) const;

	void				AddButton( Button* pButton, long nOffset = 0 );
	void				RemoveButton( Button* pButton );

	void				SetPrevButton( PushButton* pButton ) { mpPrevBtn = pButton; }
	PushButton* 		GetPrevButton() const { return mpPrevBtn; }
	void				SetNextButton( PushButton* pButton ) { mpNextBtn = pButton; }
	PushButton* 		GetNextButton() const { return mpNextBtn; }

	void				ShowButtonFixedLine( BOOL bVisible );
	BOOL				IsButtonFixedLineVisible();

	void				SetViewWindow( Window* pWindow ) { mpViewWindow = pWindow; }
	Window* 			GetViewWindow() const { return mpViewWindow; }
	void				SetViewAlign( WindowAlign eAlign ) { meViewAlign = eAlign; }
	WindowAlign 		GetViewAlign() const { return meViewAlign; }

	void				SetPageSizePixel( const Size& rSize ) { maPageSize = rSize; }
	const Size& 		GetPageSizePixel() const { return maPageSize; }

	void				SetActivatePageHdl( const Link& rLink ) { maActivateHdl = rLink; }
	const Link& 		GetActivatePageHdl() const { return maActivateHdl; }
	void				SetDeactivatePageHdl( const Link& rLink ) { maDeactivateHdl = rLink; }
	const Link& 		GetDeactivatePageHdl() const { return maDeactivateHdl; }
};

#endif	
