
#ifndef _XTEXTEDT_HXX
#define _XTEXTEDT_HXX

#include <svtools/texteng.hxx>
#include <svtools/textview.hxx>

#define XTEXTUNDO_REPLACEALL	(XTEXTUNDO_START+1)
#define XTEXTUNDO_INDENTBLOCK		122
#define XTEXTUNDO_UNINDENTBLOCK		123

namespace com {
namespace sun {
namespace star {
namespace util {
	struct SearchOptions;
}}}}

class ExtTextEngine : public TextEngine
{
private:
	String				maGroupChars;

public:
			ExtTextEngine();
			~ExtTextEngine();

	const String&		GetGroupChars() const { return maGroupChars; }
	void				SetGroupChars( const String& r ) { maGroupChars = r; }
	TextSelection		MatchGroup( const TextPaM& rCursor ) const;

	BOOL				Search( TextSelection& rSel, const ::com::sun::star::util::SearchOptions& rSearchOptions, BOOL bForward = TRUE );
};

class ExtTextView : public TextView
{
protected:
	BOOL				ImpIndentBlock( BOOL bRight );

public:
			ExtTextView( ExtTextEngine* pEng, Window* pWindow );
			~ExtTextView();

	BOOL				MatchGroup();

	BOOL				Search( const ::com::sun::star::util::SearchOptions& rSearchOptions, BOOL bForward );
	USHORT				Replace( const ::com::sun::star::util::SearchOptions& rSearchOptions, BOOL bAll, BOOL bForward );

	BOOL				IndentBlock();
	BOOL				UnindentBlock();
};

#endif 
