
#ifndef _SVX_ALIGN_HXX
#define _SVX_ALIGN_HXX

#ifndef _FIELD_HXX 
#include <vcl/field.hxx>
#endif
#ifndef _IMAGEBTN_HXX 
#include <vcl/imagebtn.hxx>
#endif
#ifndef _FIXED_HXX 
#include <vcl/fixed.hxx>
#endif
#ifndef _LSTBOX_HXX 
#include <vcl/lstbox.hxx>
#endif
#ifndef _SFXTABDLG_HXX 
#include <sfx2/tabdlg.hxx>
#endif

#include <svx/worient.hxx> 

#define WBA_NO_ORIENTATION	((USHORT)0x0001)
#define WBA_NO_LINEBREAK	((USHORT)0x0002)
#define WBA_NO_HORIZONTAL	((USHORT)0x0004)
#define WBA_NO_LEFTINDENT	((USHORT)0x0008)
#define WBA_NO_VERTICAL		((USHORT)0x0010)
#define WBA_NO_GRIDLINES	((USHORT)0x0020)
#define WBA_NO_HYPHENATION	((USHORT)0x0040)

class SvxAlignmentTabPage : public SfxTabPage
{
private:
	 FixedLine           aFlAlignment;
	FixedText           aFtHorAlign;
	ListBox             aLbHorAlign;
	FixedText           aFtIndent;
	MetricField         aEdIndent;
	FixedText           aFtVerAlign;
	ListBox             aLbVerAlign;

	SvxWinOrientation	aWinOrient; 
	 FixedLine           aFlSpace;
	FixedText			aFtLeftSpace;
	MetricField 		aEdLeftSpace;
	FixedText			aFtRightSpace;
	MetricField 		aEdRightSpace;
	FixedText			aFtTopSpace;
	MetricField 		aEdTopSpace;
	FixedText			aFtBottomSpace;
	MetricField 		aEdBottomSpace;
	 FixedLine           aFlWrap;
	TriStateBox			aBtnWrap;
	TriStateBox			aBtnHyphen;

	BOOL				bHyphenDisabled;

	SvxAlignmentTabPage( Window* pParent, const SfxItemSet& rCoreSet );

	void FillForLockMode();

#ifdef _SVX_ALIGN_CXX
	 DECL_LINK( HorAlignSelectHdl_Impl, ListBox * );
	DECL_LINK( WrapClickHdl_Impl, TriStateBox * );
	void EnableHyphen_Impl();
#endif

public:
	~SvxAlignmentTabPage();

	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );
	static USHORT*		GetRanges();

	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
	virtual	void 		Reset( const SfxItemSet& rSet );
	virtual int			DeactivatePage( SfxItemSet* pSet );

	void				SetFlags( USHORT nFlags );
};

#endif

