
#ifndef _SVX_BACKGRND_HXX
#define _SVX_BACKGRND_HXX

#ifndef _GROUP_HXX 
#include <vcl/group.hxx>
#endif
#ifndef _STDCTRL_HXX 
#include <svtools/stdctrl.hxx>
#endif
#ifndef _GRAPH_HXX 
#include <vcl/graph.hxx>
#endif
#ifndef _VALUESET_HXX 
#include <svtools/valueset.hxx>
#endif
#ifndef _SVX_DLG_CTRL_HXX
#include <svx/dlgctrl.hxx>
#endif

#define PARA_DEST_PARA	0
#define PARA_DEST_CHAR  1

class BackgroundPreviewImpl;
class SvxOpenGraphicDialog;
struct SvxBackgroundTable_Impl;
struct SvxBackgroundPara_Impl;
struct SvxBackgroundPage_Impl;
class SvxBrushItem;

class SvxBackgroundTabPage : public SvxTabPage
{
public:
	static SfxTabPage*  Create( Window* pParent, const SfxItemSet& rAttrSet );
	static USHORT*      GetRanges();

	virtual BOOL        FillItemSet( SfxItemSet& rSet );
	virtual void        Reset( const SfxItemSet& rSet );
	virtual void        FillUserData();
	virtual void        PointChanged( Window* pWindow, RECT_POINT eRP );

	void                ShowSelector(); 
	void                ShowTblControl(); 
	void                ShowParaControl(BOOL bCharOnly = FALSE); 

protected:
	virtual int         DeactivatePage( SfxItemSet* pSet = 0 );

private:
	SvxBackgroundTabPage( Window* pParent, const SfxItemSet& rCoreSet );
	~SvxBackgroundTabPage();

	Window					aBorderWin;
	ValueSet                aBackgroundColorSet;
	FixedLine               aBackgroundColorBox;
	BackgroundPreviewImpl*  pPreviewWin1;

	PushButton              aBtnBrowse;
	CheckBox                aBtnLink;
	CheckBox                aBtnPreview;
	FixedInfo               aFtFile;
	FixedLine               aGbFile;
	RadioButton             aBtnPosition;
	RadioButton             aBtnArea;
	RadioButton             aBtnTile;
	SvxRectCtl              aWndPosition;
	FixedLine               aGbPosition;
	BackgroundPreviewImpl*  pPreviewWin2;

	FixedText               aSelectTxt;
	ListBox                 aLbSelect;
	const String            aStrBrowse;
	const String            aStrUnlinked;

	FixedText               aTblDesc;
	ListBox                 aTblLBox;
	ListBox					aParaLBox;

	Color		aBgdColor;
	USHORT		nHtmlMode;
	BOOL        bAllowShowSelector	: 1;
	BOOL        bIsGraphicValid		: 1;
	BOOL		bLinkOnly			: 1;
	BOOL        bResized            : 1;
	Graphic     aBgdGraphic;
	String      aBgdGraphicPath;
	String      aBgdGraphicFilter;

	SvxBackgroundPage_Impl* pPageImpl;
	SvxOpenGraphicDialog* pImportDlg;

	SvxBackgroundTable_Impl*	pTableBck_Impl;

	SvxBackgroundPara_Impl*	pParaBck_Impl;

#ifdef _SVX_BACKGRND_CXX
	void                FillColorValueSets_Impl();
	void                ShowColorUI_Impl();
	void                ShowBitmapUI_Impl();
	BOOL                LoadLinkedGraphic_Impl();
	void                RaiseLoadError_Impl();
	void                SetGraphicPosition_Impl( SvxGraphicPosition ePos );
	SvxGraphicPosition  GetGraphicPosition_Impl();
	void				FillControls_Impl(const SvxBrushItem& rBgdAttr,
								const String& rUserData);
	BOOL 				FillItemSetWithWallpaperItem( SfxItemSet& rCoreSet, USHORT nSlot);
	void				ResetFromWallpaperItem( const SfxItemSet& rSet );

	DECL_LINK( LoadTimerHdl_Impl, Timer* );
	DECL_LINK( SelectHdl_Impl, ListBox* );
	DECL_LINK( BrowseHdl_Impl, PushButton* );
	DECL_LINK( RadioClickHdl_Impl, RadioButton* );
	DECL_LINK( FileClickHdl_Impl, CheckBox* );
	DECL_LINK( BackgroundColorHdl_Impl, ValueSet* );
	DECL_LINK( PatternHdl_Impl, ValueSet* );
	DECL_LINK( TblDestinationHdl_Impl, ListBox* );
	DECL_LINK( ParaDestinationHdl_Impl, ListBox* );
#endif
};

#endif 

