
#ifndef _SVX_BOLNITEM_HXX
#define _SVX_BOLNITEM_HXX

#ifndef _SFXPOOLITEM_HXX 
#include <svtools/poolitem.hxx>
#endif

class SvxBorderLine;

class SvxLineItem : public SfxPoolItem
{
public:
	TYPEINFO();

	SvxLineItem( const USHORT nId = ITEMID_LINE );
	SvxLineItem( const SvxLineItem& rCpy );
	~SvxLineItem();
	SvxLineItem &operator=( const SvxLineItem& rLine );

	virtual int 			 operator==( const SfxPoolItem& ) const;
	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
	                                String &rText, const IntlWrapper * = 0 ) const;

	virtual SfxPoolItem*	 Clone( SfxItemPool *pPool = 0 ) const;
	virtual SfxPoolItem*	 Create(SvStream &, USHORT) const;
	virtual SvStream&		 Store(SvStream &, USHORT nItemVersion ) const;
	virtual int				 ScaleMetrics( long nMult, long nDiv );
	virtual	int				 HasMetrics() const;

	const	SvxBorderLine*	GetLine		() const { return pLine; }
	void					SetLine		( const SvxBorderLine *pNew );

private:
	SvxBorderLine*	pLine;
};

#endif

