
#ifndef _SVX_BOXITEM_HXX
#define _SVX_BOXITEM_HXX

#ifndef _SFXPOOLITEM_HXX 
#include <svtools/poolitem.hxx>
#endif
#ifndef _COLOR_HXX 
#include <vcl/color.hxx>
#endif
#ifndef _SVX_SVXIDS_HRC
#include <svx/svxids.hrc>
#endif

#ifdef _USE_NAMESPACE
namespace rtl
{
#endif
	class OUString;
#ifdef _USE_NAMESPACE
}
#endif

#define DEF_LINE_WIDTH_0        1
#define DEF_LINE_WIDTH_1        20
#define DEF_LINE_WIDTH_2        50
#define DEF_LINE_WIDTH_3        80
#define DEF_LINE_WIDTH_4        100

#define DEF_MAX_LINE_WIDHT      DEF_LINE_WIDTH_4
#define DEF_MAX_LINE_DIST       DEF_LINE_WIDTH_2

#define DEF_DOUBLE_LINE0_OUT    DEF_LINE_WIDTH_0
#define DEF_DOUBLE_LINE0_IN     DEF_LINE_WIDTH_0
#define DEF_DOUBLE_LINE0_DIST   DEF_LINE_WIDTH_1

#define DEF_DOUBLE_LINE1_OUT    DEF_LINE_WIDTH_1
#define DEF_DOUBLE_LINE1_IN     DEF_LINE_WIDTH_1
#define DEF_DOUBLE_LINE1_DIST   DEF_LINE_WIDTH_1

#define DEF_DOUBLE_LINE2_OUT    DEF_LINE_WIDTH_2
#define DEF_DOUBLE_LINE2_IN     DEF_LINE_WIDTH_2
#define DEF_DOUBLE_LINE2_DIST   DEF_LINE_WIDTH_2

#define DEF_DOUBLE_LINE3_OUT    DEF_LINE_WIDTH_2
#define DEF_DOUBLE_LINE3_IN     DEF_LINE_WIDTH_1
#define DEF_DOUBLE_LINE3_DIST   DEF_LINE_WIDTH_2

#define DEF_DOUBLE_LINE4_OUT    DEF_LINE_WIDTH_1
#define DEF_DOUBLE_LINE4_IN     DEF_LINE_WIDTH_2
#define DEF_DOUBLE_LINE4_DIST   DEF_LINE_WIDTH_1

#define DEF_DOUBLE_LINE5_OUT    DEF_LINE_WIDTH_3
#define DEF_DOUBLE_LINE5_IN     DEF_LINE_WIDTH_2
#define DEF_DOUBLE_LINE5_DIST   DEF_LINE_WIDTH_2

#define DEF_DOUBLE_LINE6_OUT    DEF_LINE_WIDTH_2
#define DEF_DOUBLE_LINE6_IN     DEF_LINE_WIDTH_3
#define DEF_DOUBLE_LINE6_DIST   DEF_LINE_WIDTH_2

#define DEF_DOUBLE_LINE7_OUT    DEF_LINE_WIDTH_0
#define DEF_DOUBLE_LINE7_IN     DEF_LINE_WIDTH_0
#define DEF_DOUBLE_LINE7_DIST   DEF_LINE_WIDTH_2

#define DEF_DOUBLE_LINE8_OUT    DEF_LINE_WIDTH_1
#define DEF_DOUBLE_LINE8_IN     DEF_LINE_WIDTH_0
#define DEF_DOUBLE_LINE8_DIST   DEF_LINE_WIDTH_2

#define DEF_DOUBLE_LINE9_OUT    DEF_LINE_WIDTH_2
#define DEF_DOUBLE_LINE9_IN     DEF_LINE_WIDTH_0
#define DEF_DOUBLE_LINE9_DIST   DEF_LINE_WIDTH_2

#define DEF_DOUBLE_LINE10_OUT	DEF_LINE_WIDTH_3
#define DEF_DOUBLE_LINE10_IN	DEF_LINE_WIDTH_0
#define DEF_DOUBLE_LINE10_DIST	DEF_LINE_WIDTH_2

class SvxBorderLine
{
protected:
	Color  aColor;
	USHORT nOutWidth;
	USHORT nInWidth;
	USHORT nDistance;

public:
	SvxBorderLine( const Color *pCol = 0, USHORT nOut = 0,
	   USHORT nIn = 0, USHORT nDist = 0 );

	const Color&	GetColor() const { return aColor; }
	USHORT 			GetOutWidth() const { return nOutWidth; }
	USHORT 			GetInWidth() const { return nInWidth; }
	USHORT 			GetDistance() const { return nDistance; }

	void 			SetColor( const Color &rColor ) { aColor = rColor; }
	void			SetOutWidth( USHORT nNew ) { nOutWidth = nNew; }
	void			SetInWidth( USHORT nNew ) { nInWidth = nNew;  }
	void			SetDistance( USHORT nNew ) { nDistance = nNew; }
	void			ScaleMetrics( long nMult, long nDiv );

	BOOL			operator==( const SvxBorderLine &rCmp ) const;

	String			GetValueString( SfxMapUnit eSrcUnit, SfxMapUnit eDestUnit,
						BOOL bMetricStr = FALSE ) const;
};

#define BOX_LINE_TOP	((USHORT)0)
#define BOX_LINE_BOTTOM	((USHORT)1)
#define BOX_LINE_LEFT	((USHORT)2)
#define BOX_LINE_RIGHT	((USHORT)3)

#define BOX_4DISTS_VERSION ((USHORT)1)

class SvxBoxItem : public SfxPoolItem
{
	SvxBorderLine  *pTop,
	   *pBottom,
	   *pLeft,
	   *pRight;
	USHORT			nTopDist,
		nBottomDist,
		nLeftDist,
		nRightDist;

public:
	TYPEINFO();

	SvxBoxItem( const USHORT nId = ITEMID_BOX );
	SvxBoxItem( const SvxBoxItem &rCpy );
	~SvxBoxItem();
	SvxBoxItem &operator=( const SvxBoxItem& rBox );

	virtual int 			 operator==( const SfxPoolItem& ) const;
	virtual	sal_Bool        	 QueryValue( com::sun::star::uno::Any& rVal, BYTE nMemberId = 0 ) const;
	virtual	sal_Bool			 PutValue( const com::sun::star::uno::Any& rVal, BYTE nMemberId = 0 );

	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
	                                String &rText, const IntlWrapper * = 0 ) const;

	virtual SfxPoolItem*	 Clone( SfxItemPool *pPool = 0 ) const;
	virtual SfxPoolItem*	 Create(SvStream &, USHORT) const;
	virtual SvStream&		 Store(SvStream &, USHORT nItemVersion ) const;
	virtual USHORT			 GetVersion( USHORT nFileVersion ) const;

	virtual int				 ScaleMetrics( long nMult, long nDiv );
	virtual	int				 HasMetrics() const;

	const	SvxBorderLine* GetTop()    const { return pTop; }
	const	SvxBorderLine* GetBottom() const { return pBottom; }
	const	SvxBorderLine* GetLeft()   const { return pLeft; }
	const	SvxBorderLine* GetRight()  const { return pRight; }

	const	SvxBorderLine* GetLine( USHORT nLine ) const;

	void	SetLine( const SvxBorderLine* pNew, USHORT nLine );

	USHORT	GetDistance( USHORT nLine ) const;
	USHORT	GetDistance() const;

	void 	SetDistance( USHORT nNew, USHORT nLine );
	inline void SetDistance( USHORT nNew );

	USHORT 	CalcLineSpace( USHORT nLine, BOOL bIgnoreLine = FALSE ) const;
};

inline void SvxBoxItem::SetDistance( USHORT nNew )
{
	nTopDist = nBottomDist = nLeftDist = nRightDist = nNew;
}

#define BOXINFO_LINE_HORI	((USHORT)0)
#define BOXINFO_LINE_VERT	((USHORT)1)

#define VALID_TOP			0x01
#define VALID_BOTTOM		0x02
#define VALID_LEFT			0x04
#define VALID_RIGHT			0x08
#define VALID_HORI			0x10
#define VALID_VERT			0x20
#define VALID_DISTANCE		0x40
#define VALID_DISABLE		0x80

#ifdef ITEMID_BOXINFO
class SvxBoxInfoItem : public SfxPoolItem
{
	SvxBorderLine* pHori;   
	SvxBorderLine* pVert;   

	BOOL bTable     :1;     

	BOOL	bDist      :1;  
	BOOL	bMinDist   :1;  

	BYTE	nValidFlags;	

	USHORT	nDefDist;       

public:
	TYPEINFO();

	SvxBoxInfoItem( const USHORT nId = ITEMID_BOXINFO );
	SvxBoxInfoItem( const SvxBoxInfoItem &rCpy );
	~SvxBoxInfoItem();
	SvxBoxInfoItem &operator=( const SvxBoxInfoItem &rCpy );

	virtual int 			 operator==( const SfxPoolItem& ) const;
	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
	                                String &rText, const IntlWrapper * = 0 ) const;

	virtual SfxPoolItem*	Clone( SfxItemPool *pPool = 0 ) const;
	virtual SfxPoolItem*	Create(SvStream &, USHORT) const;
	virtual SvStream&		Store(SvStream &, USHORT nItemVersion ) const;
	virtual int				 ScaleMetrics( long nMult, long nDiv );
	virtual	int				 HasMetrics() const;

	const SvxBorderLine*	GetHori() const { return pHori; }
	const SvxBorderLine*	GetVert() const { return pVert; }

	void					SetLine( const SvxBorderLine* pNew, USHORT nLine );

	BOOL 	IsTable() const				{ return bTable; }
	void 	SetTable( BOOL bNew )		{ bTable = bNew; }
	BOOL 	IsDist() const				{ return bDist; }
	void 	SetDist( BOOL bNew )		{ bDist = bNew; }
	BOOL 	IsMinDist() const			{ return bMinDist; }
	void 	SetMinDist( BOOL bNew )		{ bMinDist = bNew; }
	USHORT	GetDefDist() const			{ return nDefDist; }
	void 	SetDefDist( USHORT nNew )	{ nDefDist = nNew; }

	BOOL					IsValid( BYTE nValid ) const
					{ return ( nValidFlags & nValid ) == nValid; }
	void 					SetValid( BYTE nValid, BOOL bValid = TRUE )
					{ bValid ? ( nValidFlags |= nValid )
							 : ( nValidFlags &= ~nValid ); }
	void					ResetFlags();
};
#endif

#endif

