
#ifndef _SVX_CHARRELIEFITEM_HXX
#define _SVX_CHARRELIEFITEM_HXX

#ifndef _SFXENUMITEM_HXX
#include <svtools/eitem.hxx>
#endif
#ifndef _VCL_FNTSTYLE_HXX
#include <vcl/fntstyle.hxx>
#endif
#ifndef _SVX_SVXIDS_HRC
#include <svx/svxids.hrc>
#endif

class SvxCharReliefItem : public SfxEnumItem
{
public:
	TYPEINFO();

	SvxCharReliefItem( FontRelief eValue = RELIEF_NONE,
		   const sal_uInt16 nId = ITEMID_CHARRELIEF );

	virtual SfxPoolItem*	Clone( SfxItemPool *pPool = 0 ) const;
	virtual SfxPoolItem*	Create(SvStream &, USHORT) const;
	virtual SvStream& 		Store(SvStream & rStrm, USHORT nIVer) const;
	virtual USHORT			GetVersion( USHORT nFileVersion ) const;

	virtual String			GetValueTextByPos( USHORT nPos ) const;
 	virtual USHORT			GetValueCount() const;

	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
						String &rText,
	                                const IntlWrapper * = 0 ) const;

	virtual sal_Bool PutValue( const com::sun::star::uno::Any& rVal,
						BYTE nMemberId );
	virtual sal_Bool QueryValue( com::sun::star::uno::Any& rVal,
					BYTE nMemberId ) const;

	inline SvxCharReliefItem& operator=( const SvxCharReliefItem& rItem )
	{
		SetValue( rItem.GetValue() );
		return *this;
	}
};

#endif

