
#ifndef _SVX_CHARROTATEITEM_HXX
#define _SVX_CHARROTATEITEM_HXX

#ifndef _SFXENUMITEM_HXX
#include <svtools/intitem.hxx>
#endif
#ifndef _SVX_SVXIDS_HRC
#include <svx/svxids.hrc>
#endif

class SvxCharRotateItem : public SfxUInt16Item
{
	sal_Bool bFitToLine;
public:
	TYPEINFO();

	SvxCharRotateItem( sal_uInt16 nValue = 0,
		   sal_Bool bFitIntoLine = sal_False,
		   const sal_uInt16 nId = ITEMID_CHARROTATE );

	virtual SfxPoolItem*	Clone( SfxItemPool *pPool = 0 ) const;
	virtual SfxPoolItem*	Create(SvStream &, USHORT) const;
	virtual SvStream& 		Store(SvStream & rStrm, USHORT nIVer) const;
	virtual USHORT			GetVersion( USHORT nFileVersion ) const;

	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
						String &rText,
	                                const IntlWrapper * = 0 ) const;

	virtual sal_Bool PutValue( const com::sun::star::uno::Any& rVal,
						BYTE nMemberId );
	virtual sal_Bool QueryValue( com::sun::star::uno::Any& rVal,
					BYTE nMemberId ) const;

	inline SvxCharRotateItem& operator=( const SvxCharRotateItem& rItem )
	{
		SetValue( rItem.GetValue() );
		SetFitToLine( rItem.IsFitToLine() );
		return *this;
	}

	virtual int 			 operator==( const SfxPoolItem& ) const;

	void SetTopToBotton() 					{ SetValue( 2700 ); }
	void SetBottomToTop() 					{ SetValue(  900 ); }
	sal_Bool IsTopToBotton() const			{ return 2700 == GetValue(); }
	sal_Bool IsBottomToTop() const			{ return  900 == GetValue(); }

	sal_Bool IsFitToLine() const 			{ return bFitToLine; }
	void SetFitToLine( sal_Bool b )			{ bFitToLine = b; }
};

#endif

