
#ifndef _SVX_COLRCTRL_HXX
#define _SVX_COLRCTRL_HXX

#ifndef _SFXDOCKWIN_HXX 
#include <sfx2/dockwin.hxx>
#endif
#ifndef _SFX_CHILDWIN_HXX 
#include <sfx2/childwin.hxx>
#endif
#ifndef _VALUESET_HXX 
#include <svtools/valueset.hxx>
#endif
#ifndef _TRANSFER_HXX 
#include <svtools/transfer.hxx>
#endif
#ifndef _SFXLSTNER_HXX 
#include <svtools/lstner.hxx>
#endif

class XColorTable;
class SvData;

class SvxColorValueSet : public ValueSet, public DragSourceHelper
{
private:

	BOOL			bLeft;
	Point           aDragPosPixel;

protected:

	void            DoDrag();

	virtual void	MouseButtonDown( const MouseEvent& rMEvt );
	virtual void	MouseButtonUp( const MouseEvent& rMEvt );
	virtual void    Command(const CommandEvent& rCEvt );

	virtual void	StartDrag( sal_Int8 nAction, const Point& rPtPixel );
			DECL_STATIC_LINK(SvxColorValueSet, ExecDragHdl, void*);

public:
		SvxColorValueSet( Window* pParent, WinBits nWinStyle = WB_ITEMBORDER );
		SvxColorValueSet( Window* pParent, const ResId& rResId );

	BOOL			IsLeftButton() const { return bLeft; }
};

class SvxColorChildWindow : public SfxChildWindow
{
 public:
	SvxColorChildWindow( Window*, USHORT, SfxBindings*,
			 SfxChildWinInfo* );

	SFX_DECL_CHILDWINDOW(SvxColorChildWindow);
};

class SvxColorDockingWindow : public SfxDockingWindow, public SfxListener
{
 friend class SvxColorChildWindow;

private:
	XColorTable*		pColorTable;
	SvxColorValueSet	aColorSet;
	USHORT				nLeftSlot;
	USHORT				nRightSlot;
	USHORT				nCols;
	USHORT				nLines;
	long				nCount;
	Size				aColorSize;
	Size				aItemSize;

#if 0 // _SOLAR__PRIVATE
	void				FillValueSet();
	void 				SetSize();
			DECL_LINK( SelectHdl, void * );
#endif

protected:
	virtual BOOL	Close();
	virtual void	Resize();
	virtual void	Resizing( Size& rSize );

public:
		SvxColorDockingWindow( SfxBindings* pBindings,
							   SfxChildWindow *pCW,
							   Window* pParent,
							   const ResId& rResId );
		~SvxColorDockingWindow();

	virtual void 	SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCType,
				const SfxHint& rHint, const TypeId& rHintType );

	void			SetSlotIDs( USHORT nLeft, USHORT nRight )
			{ nLeftSlot = nLeft; nRightSlot = nRight; }
};

#endif

