
#ifndef _SVX_CONNECT_HXX
#define _SVX_CONNECT_HXX

#ifndef _SVX_CONNCTRL_HXX
#include <svx/connctrl.hxx>
#endif

#ifndef _SFXTABDLG_HXX 
#include <sfx2/tabdlg.hxx>
#endif

#ifndef _FIXED_HXX 
#include <vcl/fixed.hxx>
#endif

#ifndef _FIELD_HXX 
#include <vcl/field.hxx>
#endif

#ifndef _LSTBOX_HXX 
#include <vcl/lstbox.hxx>
#endif

#ifndef _GROUP_HXX 
#include <vcl/group.hxx>
#endif

#ifndef _BASEDLGS_HXX 
#include <sfx2/basedlgs.hxx>
#endif

class SdrView;

class SvxConnectionPage : public SfxTabPage
{
private:
	FixedText   		aFtType;
	ListBox 			aLbType;

	FixedLine			aFlDelta;
	FixedText			aFtLine1;
	MetricField			aMtrFldLine1;
	FixedText			aFtLine2;
	MetricField			aMtrFldLine2;
	FixedText			aFtLine3;
	MetricField			aMtrFldLine3;

	FixedLine			aFlDistance;
	FixedText			aFtHorz1;
	MetricField			aMtrFldHorz1;
	FixedText			aFtVert1;
	MetricField			aMtrFldVert1;
	FixedText			aFtHorz2;
	MetricField			aMtrFldHorz2;
	FixedText			aFtVert2;
	MetricField			aMtrFldVert2;

	SvxXConnectionPreview	aCtlPreview;

	const SfxItemSet&	rOutAttrs;
	SfxItemSet			aAttrSet;
	const SdrView*		pView;
	SfxMapUnit			eUnit;

#ifdef _SVX_CONNECT_CXX
	void 				FillTypeLB();
				DECL_LINK( ChangeAttrHdl_Impl, void * );
#endif

public:

	SvxConnectionPage( Window* pWindow, const SfxItemSet& rInAttrs );
	~SvxConnectionPage();

	static SfxTabPage* 	Create( Window*, const SfxItemSet& );
	static  USHORT*	    GetRanges();

	virtual BOOL 		FillItemSet( SfxItemSet& );
	virtual void 		Reset( const SfxItemSet & );

	void 		 Construct();
	void		 SetView( const SdrView* pSdrView ) { pView = pSdrView; }
};

class SvxConnectionDialog : public SfxSingleTabDialog
{
public:
	SvxConnectionDialog( Window* pParent, const SfxItemSet& rAttr,
		   const SdrView* pView );
	~SvxConnectionDialog();
};

#endif 

