

#ifndef _CONTDLG_HXX_
#define _CONTDLG_HXX_

#ifndef _BASEDLGS_HXX 
#include <sfx2/basedlgs.hxx>
#endif
#ifndef _SFXCTRLITEM_HXX 
#include <sfx2/ctrlitem.hxx>
#endif
#ifndef _SFX_CHILDWIN_HXX 
#include <sfx2/childwin.hxx>
#endif

class Graphic;

class SvxContourDlgChildWindow : public SfxChildWindow
{
 public:

	SvxContourDlgChildWindow( Window*, USHORT, SfxBindings*, SfxChildWinInfo* );

	SFX_DECL_CHILDWINDOW( SvxContourDlgChildWindow );

	static void UpdateContourDlg( const Graphic& rGraphic, BOOL bGraphicLinked,
					  const PolyPolygon* pPolyPoly = NULL,
					  void* pEditingObj = NULL );
};

#ifndef _REDUCED_ContourDlg_HXX_
#define _REDUCED_CONTDLG_HXX_

class SvxSuperContourDlg;

class SvxContourDlgItem : public SfxControllerItem
{
	SvxSuperContourDlg&	rDlg;

protected:

	virtual void		StateChanged( USHORT nSID, SfxItemState eState, const SfxPoolItem* pState );

public:
				SvxContourDlgItem( USHORT nId, SvxSuperContourDlg& rDlg, SfxBindings& rBindings );
};

class SvxContourDlg : public SfxFloatingWindow
{
	SvxSuperContourDlg*	pSuperClass;

#if 0 // _SOLAR__PRIVATE

protected:

	void				SetSuperClass( SvxSuperContourDlg& rSuperClass ) { pSuperClass = &rSuperClass; }

#endif 

public:
				SvxContourDlg( SfxBindings *pBindings, SfxChildWindow *pCW,
						   Window* pParent, const ResId& rResId );
			~SvxContourDlg();

	void				SetExecState( BOOL bEnable );

	void				SetGraphic( const Graphic& rGraphic );
	void				SetGraphicLinked( BOOL bLinked );
	const Graphic&		GetGraphic() const;
	BOOL				IsGraphicChanged() const;

	void				SetPolyPolygon( const PolyPolygon& rPolyPoly );
	PolyPolygon			GetPolyPolygon();

	void				SetEditingObject( void* pObj );
	const void*			GetEditingObject() const;

	void				Update( const Graphic& rGraphic, BOOL bGraphicLinked,
					const PolyPolygon* pPolyPoly = NULL, void* pEditingObj = NULL );

	static PolyPolygon	CreateAutoContour( 	const Graphic& rGraphic,
								const Rectangle* pRect = NULL,
								const ULONG nFlags = 0L );
	static void			ScaleContour( PolyPolygon& rContour, const Graphic& rGraphic,
						  const MapUnit eUnit, const Size& rDisplaySize );
};

#define SVXCONTOURDLG() ( (SvxContourDlg*) ( SfxViewFrame::Current()->GetChildWindow( 	\
			  SvxContourDlgChildWindow::GetChildWindowId() )-> 	\
			  GetWindow() ) )

#endif 
#endif 

