

#ifndef _SVX_CTRDIAL_HXX
#define	_SVX_CTRDIAL_HXX

#ifndef _SV_CTRL_HXX 
#include <vcl/ctrl.hxx>
#endif

#ifndef _SV_VIRDEV_HXX 
#include <vcl/virdev.hxx>
#endif

class SvxCtrDialBmp : public VirtualDevice
{
	private:
	    Rectangle       aDrawRect;
	    Color           aBgColor;
	    short           nCenterX;
	    short           nCenterY;
	     void            InitBitmap( const Size& rSize, const Color& rBackgr );
	    void            DrawBackground( BOOL bEnabled );
	    void            DrawShadow( BOOL bEnabled );
	    void            DrawCalibration( BOOL bEnabled );
	 public:
	    void            InitBitmap( const Size& rSize, const Color& rBackgr, const Font& rFont );
	    void            DrawBackgrBitmap( const Size& rSize, const Color& rBackgr, BOOL bEnabled );
	    void            DrawBackgrBitmap( const SvxCtrDialBmp& rSrc );
	    void            DrawElements( const String& rText, short nDelta, BOOL bEnabled );
};

class SvxCtrDial : public Control
{
	private:
		Link            aCtrModifiedLink;
		Link			aMouseUpLink;
	     SvxCtrDialBmp   aEnabledBmp;
	    SvxCtrDialBmp   aDisabledBmp;
	    SvxCtrDialBmp   aBufferBmp;
		short			nDelta;
		Font			aRotFont;
	    short           nCenterX;
	    short           nCenterY;
	    Size            aWinSize;
	    Color           aBgColor;
	     void            Init();
	    void            Paint( const Rectangle& rRect );
	 public:
	                    SvxCtrDial( Window* pParent,Size aSize, Font aFont, WinBits nWinStyle = 0);
	                    SvxCtrDial( Window* pParent,Size aSize, WinBits nWinStyle = 0);
	                    SvxCtrDial( Window* pWindow, const ResId& rResId);
	     virtual void    Invalidate();
	     virtual USHORT  GetOrientation();
		virtual void	SetOrientation(short alpha);

		virtual void	KeyInput( const KeyEvent& rKeyEvt );
		virtual void	MouseMove( const MouseEvent& rMEvt );
		virtual void	MouseButtonDown( const MouseEvent& rMEvt );
		virtual void	MouseButtonUp( const MouseEvent& rMEvt );

		virtual void    CtrModified();
		virtual void	CtrMouseUp();

		void            SetCtrModifiedHdl( const Link& rLink ) { aCtrModifiedLink = rLink; }
		const Link&     GetCtrModifiedHdl() const { return aCtrModifiedLink; }
		void            SetMouseUpHdl( const Link& rLink ) { aMouseUpLink = rLink; }
		const Link&     GetMouseUpLink() const { return aMouseUpLink; }
};

#endif
