

#ifndef _SVX_DATACCESSDESCRIPTOR_HXX_
#define _SVX_DATACCESSDESCRIPTOR_HXX_

#ifndef _COM_SUN_STAR_BEANS_PROPERTYVALUE_HPP_
#include <com/sun/star/beans/PropertyValue.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif

namespace svx
{

	class ODADescriptorImpl;

	enum DataAccessDescriptorProperty
	{
		daDataSource,			
		daConnection,			

		daCommand,				
		daCommandType,			
		daEscapeProcessing,		
		daCursor,				

		daColumnName,			
		daColumnObject,			

		daSelection			
	};

	class ODataAccessDescriptor
	{
	protected:
		ODADescriptorImpl*		m_pImpl;

	public:
		ODataAccessDescriptor();
		ODataAccessDescriptor( const ODataAccessDescriptor& _rSource );
		ODataAccessDescriptor( const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >& _rValues );
		ODataAccessDescriptor( const ::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue >& _rValues );

		const ODataAccessDescriptor& operator=(const ODataAccessDescriptor& _rSource);

		~ODataAccessDescriptor();

		::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >
		createPropertySet();

		::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue >
		createPropertyValueSequence();

		void		initializeFrom(
			const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >& _rxValues,
			sal_Bool _bClear = sal_True);

		void		initializeFrom(
			const ::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue >& _rValues,
			sal_Bool _bClear = sal_True);

		sal_Bool	has(DataAccessDescriptorProperty _eWhich) const;

		void		erase(DataAccessDescriptorProperty _eWhich);

		void		clear();

		const	::com::sun::star::uno::Any& operator [] ( DataAccessDescriptorProperty _eWhich ) const;
		::com::sun::star::uno::Any& operator [] ( DataAccessDescriptorProperty _eWhich );
	};

}	

#endif 

