

#ifndef _SVX_DEF3D_HXX
#define _SVX_DEF3D_HXX

class Vector3D;

#ifndef _INC_MATH
#include <math.h>
#endif

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif

const double fPiDiv180 = 0.01745329251994;
const double EPSILON = 1e-06;

#define DEG2RAD(fAngle) (fPiDiv180 * (fAngle))

FASTBOOL Do3DEdgesIntersect(const Vector3D& rV1a, const Vector3D& rV1b,
				const Vector3D& rV2a, const Vector3D& rV2b);

enum E3dDragDetail { E3DDETAIL_DEFAULT = 0,
		 E3DDETAIL_ONEBOX,
		 E3DDETAIL_ALLBOXES,
		 E3DDETAIL_ALLLINES
};

enum E3dDragConstraint { E3DDRAG_CONSTR_X	= 0x0001,
			 E3DDRAG_CONSTR_Y	= 0x0002,
			 E3DDRAG_CONSTR_Z	= 0x0004,
			 E3DDRAG_CONSTR_XY	= 0x0003,
			 E3DDRAG_CONSTR_XZ	= 0x0005,
			 E3DDRAG_CONSTR_YZ	= 0x0006,
			 E3DDRAG_CONSTR_XYZ	= 0x0007
};

#endif
