

#ifndef _E3D_UNDO_HXX
#define _E3D_UNDO_HXX

#ifndef _SVDUNDO_HXX
#include <svx/svdundo.hxx>
#endif
class E3DObject;
#ifndef _E3D_SCENE3D_HXX
#include <svx/scene3d.hxx>
#endif

class E3dView;

class E3dUndoAction : public SdrUndoAction
{

	protected :
		E3dObject *pMy3DObj;

	public:
		TYPEINFO();
		E3dUndoAction (SdrModel  *pModel,
		   E3dObject *p3DObj) :
			SdrUndoAction (*pModel),
			pMy3DObj (p3DObj)
			{
			}

		virtual ~E3dUndoAction ();

		virtual BOOL CanRepeat(SfxRepeatTarget&) const;
};

class E3dRotateUndoAction : public E3dUndoAction
{
		Matrix4D aMyOldRotation;
		Matrix4D aMyNewRotation;

	public:
		TYPEINFO();
		E3dRotateUndoAction (SdrModel       *pModel,
				 E3dObject      *p3DObj,
				 const Matrix4D &aOldRotation,
				 const Matrix4D &aNewRotation) :
			E3dUndoAction (pModel, p3DObj),
			aMyOldRotation (aOldRotation),
			aMyNewRotation (aNewRotation)
			{
			}

		virtual ~E3dRotateUndoAction ();

		virtual void Undo();
		virtual void Redo();

};

class E3dAttributesUndoAction : public SdrUndoAction
{
	SdrObject*	pObject;
	E3dView*	pView;
	BOOL		bUseSubObjects;

	const SfxItemSet aNewSet;
	const SfxItemSet aOldSet;

 public:
		TYPEINFO();
		E3dAttributesUndoAction( SdrModel &rModel, E3dView*	pView,
			E3dObject* pInObject,
			const SfxItemSet& rNewSet,
			const SfxItemSet& rOldSet,
			BOOL bUseSubObj);

		virtual ~E3dAttributesUndoAction();

		virtual BOOL CanRepeat(SfxRepeatTarget& rView) const;
		virtual void Undo();
		virtual void Redo();
		virtual void Repeat();
};

#endif			
