

#ifndef _EDITUND2_HXX
#define _EDITUND2_HXX

#ifndef _UNDO_HXX
#include <svtools/undo.hxx>
#endif

class ImpEditEngine;

class EditUndoManager : public SfxUndoManager
{
private:
	ImpEditEngine*	pImpEE;
public:
		EditUndoManager( ImpEditEngine* pImpEE );

	virtual BOOL	Undo( USHORT nCount=1 );
	virtual BOOL	Redo( USHORT nCount=1 );
};

class EditUndo : public SfxUndoAction
{
private:
	USHORT 			nId;
	ImpEditEngine*	pImpEE;

public:
		TYPEINFO();
		EditUndo( USHORT nI, ImpEditEngine* pImpEE );
	virtual 		~EditUndo();

	ImpEditEngine*	GetImpEditEngine() const	{ return pImpEE; }

	virtual void	Undo() 		= 0;
	virtual void	Redo()		= 0;
	virtual void 	Repeat()	= 0;

	virtual BOOL	CanRepeat(SfxRepeatTarget&) const;
	virtual String	GetComment() const;
	virtual USHORT	GetId() const;
};

#endif	

