

#ifndef _SVX_ESCHEREX_HXX
#define _SVX_ESCHEREX_HXX

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif
#ifndef _SV_GEN_HXX
#include <tools/gen.hxx>
#endif
#ifndef _LIST_HXX
#include <tools/list.hxx>
#endif
#ifndef _STREAM_HXX 
#include <tools/stream.hxx>
#endif
#ifndef _COM_SUN_STAR_UNO_REFERENCE_H_
#include <com/sun/star/uno/Reference.h>
#endif
#ifndef _GRFMGR_HXX
#include <goodies/grfmgr.hxx>
#endif
#ifndef _COM_SUN_STAR_AWT_SIZE_HPP_
#include <com/sun/star/awt/Size.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_POINT_HPP_
#include <com/sun/star/awt/Point.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_RECTANGLE_HPP_
#include <com/sun/star/awt/Rectangle.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSTATE_HPP_
#include <com/sun/star/beans/XPropertyState.hpp>
#endif

#define ESCHER_DggContainer      0xF000 
#define   ESCHER_Dgg             0xF006 
#define   ESCHER_CLSID           0xF016 
#define   ESCHER_OPT             0xF00B 
#define   ESCHER_ColorMRU        0xF11A 
#define   ESCHER_SplitMenuColors 0xF11E 
#define   ESCHER_BstoreContainer 0xF001 
#define     ESCHER_BSE           0xF007 
#define     ESCHER_BlipFirst     0xF018 
#define     ESCHER_BlipLast      0xF117 

#define ESCHER_DgContainer       0xF002 
#define   ESCHER_Dg              0xF008 
#define   ESCHER_RegroupItems    0xF118 
#define   ESCHER_ColorScheme     0xF120 
#define   ESCHER_SpgrContainer   0xF003 
#define   ESCHER_SpContainer     0xF004 
#define     ESCHER_Spgr          0xF009 
#define     ESCHER_Sp            0xF00A 

#define     ESCHER_Textbox       0xF00C 
#define     ESCHER_ClientTextbox 0xF00D 
#define     ESCHER_Anchor        0xF00E 
#define     ESCHER_ChildAnchor   0xF00F 
#define     ESCHER_ClientAnchor  0xF010 
#define     ESCHER_ClientData    0xF011 
#define     ESCHER_OleObject     0xF11F 
#define     ESCHER_DeletedPspl   0xF11D 
#define   ESCHER_SolverContainer 0xF005 
#define     ESCHER_ConnectorRule 0xF012 
#define     ESCHER_AlignRule     0xF013 
#define     ESCHER_ArcRule       0xF014 
#define     ESCHER_ClientRule    0xF015 
#define     ESCHER_CalloutRule   0xF017 
#define ESCHER_Selection         0xF119 

#define SHAPEFLAG_GROUP			0x001	
#define SHAPEFLAG_CHILD			0x002	
#define SHAPEFLAG_PATRIARCH		0x004	
#define SHAPEFLAG_DELETED		0x008	
#define SHAPEFLAG_OLESHAPE		0x010	
#define SHAPEFLAG_HAVEMASTER	0x020	
#define SHAPEFLAG_FLIPH			0x040	
#define SHAPEFLAG_FLIPV			0x080	
#define SHAPEFLAG_CONNECTOR		0x100	
#define SHAPEFLAG_HAVEANCHOR	0x200	
#define SHAPEFLAG_BACKGROUND	0x400	
#define SHAPEFLAG_HAVESPT		0x800	

#define ESCHER_ShpInst_Min				0
#define ESCHER_ShpInst_NotPrimitive		ESCHER_ShpInst_Min
#define ESCHER_ShpInst_Rectangle		1
#define ESCHER_ShpInst_RoundRectangle	2
#define ESCHER_ShpInst_Ellipse			3
#define ESCHER_ShpInst_Diamond			4
#define ESCHER_ShpInst_IsocelesTriangle	5
#define ESCHER_ShpInst_RightTriangle	6
#define ESCHER_ShpInst_Parallelogram	7
#define ESCHER_ShpInst_Trapezoid		8
#define ESCHER_ShpInst_Hexagon			9
#define ESCHER_ShpInst_Octagon			10
#define ESCHER_ShpInst_Plus				11
#define ESCHER_ShpInst_Star				12
#define ESCHER_ShpInst_Arrow			13
#define ESCHER_ShpInst_ThickArrow		14
#define ESCHER_ShpInst_HomePlate		15
#define ESCHER_ShpInst_Cube				16
#define ESCHER_ShpInst_Balloon			17
#define ESCHER_ShpInst_Seal				18
#define ESCHER_ShpInst_Arc				19
#define ESCHER_ShpInst_Line				20
#define ESCHER_ShpInst_Plaque			21
#define ESCHER_ShpInst_Can				22
#define ESCHER_ShpInst_Donut			23
#define ESCHER_ShpInst_TextSimple		24
#define ESCHER_ShpInst_TextOctagon		25
#define ESCHER_ShpInst_TextHexagon		26
#define ESCHER_ShpInst_TextCurve		27
#define ESCHER_ShpInst_TextWave			28
#define ESCHER_ShpInst_TextRing			29
#define ESCHER_ShpInst_TextOnCurve		30
#define ESCHER_ShpInst_TextOnRing		31
#define ESCHER_ShpInst_StraightConnector1 32
#define ESCHER_ShpInst_BentConnector2	33
#define ESCHER_ShpInst_BentConnector3	34
#define ESCHER_ShpInst_BentConnector4	35
#define ESCHER_ShpInst_BentConnector5	36
#define ESCHER_ShpInst_CurvedConnector2	37
#define ESCHER_ShpInst_CurvedConnector3	38
#define ESCHER_ShpInst_CurvedConnector4	39
#define ESCHER_ShpInst_CurvedConnector5	40
#define ESCHER_ShpInst_Callout1			41
#define ESCHER_ShpInst_Callout2			42
#define ESCHER_ShpInst_Callout3			43
#define ESCHER_ShpInst_AccentCallout1	44
#define ESCHER_ShpInst_AccentCallout2	45
#define ESCHER_ShpInst_AccentCallout3	46
#define ESCHER_ShpInst_BorderCallout1	47
#define ESCHER_ShpInst_BorderCallout2	48
#define ESCHER_ShpInst_BorderCallout3	49
#define ESCHER_ShpInst_AccentBorderCallout1	50
#define ESCHER_ShpInst_AccentBorderCallout2	51
#define ESCHER_ShpInst_AccentBorderCallout3	52
#define ESCHER_ShpInst_Ribbon			53
#define ESCHER_ShpInst_Ribbon2			54
#define ESCHER_ShpInst_Chevron			55
#define ESCHER_ShpInst_Pentagon			56
#define ESCHER_ShpInst_NoSmoking		57
#define ESCHER_ShpInst_Seal8			58
#define ESCHER_ShpInst_Seal16			59
#define ESCHER_ShpInst_Seal32			60
#define ESCHER_ShpInst_WedgeRectCallout	61
#define ESCHER_ShpInst_WedgeRRectCallout	62
#define ESCHER_ShpInst_WedgeEllipseCallout	63
#define ESCHER_ShpInst_Wave				64
#define ESCHER_ShpInst_FoldedCorner		65
#define ESCHER_ShpInst_LeftArrow		66
#define ESCHER_ShpInst_DownArrow		67
#define ESCHER_ShpInst_UpArrow			68
#define ESCHER_ShpInst_LeftRightArrow	69
#define ESCHER_ShpInst_UpDownArrow		70
#define ESCHER_ShpInst_IrregularSeal1	71
#define ESCHER_ShpInst_IrregularSeal2	72
#define ESCHER_ShpInst_LightningBolt	73
#define ESCHER_ShpInst_Heart			74
#define ESCHER_ShpInst_PictureFrame		75
#define ESCHER_ShpInst_QuadArrow		76
#define ESCHER_ShpInst_LeftArrowCallout	77
#define ESCHER_ShpInst_RightArrowCallout	78
#define ESCHER_ShpInst_UpArrowCallout	79
#define ESCHER_ShpInst_DownArrowCallout	80
#define ESCHER_ShpInst_LeftRightArrowCallout	81
#define ESCHER_ShpInst_UpDownArrowCallout	82
#define ESCHER_ShpInst_QuadArrowCallout	83
#define ESCHER_ShpInst_Bevel			84
#define ESCHER_ShpInst_LeftBracket		85
#define ESCHER_ShpInst_RightBracket		86
#define ESCHER_ShpInst_LeftBrace		87
#define ESCHER_ShpInst_RightBrace		88
#define ESCHER_ShpInst_LeftUpArrow		89
#define ESCHER_ShpInst_BentUpArrow		90
#define ESCHER_ShpInst_BentArrow		91
#define ESCHER_ShpInst_Seal24			92
#define ESCHER_ShpInst_StripedRightArrow	93
#define ESCHER_ShpInst_NotchedRightArrow	94
#define ESCHER_ShpInst_BlockArc			95
#define ESCHER_ShpInst_SmileyFace		96
#define ESCHER_ShpInst_VerticalScroll	97
#define ESCHER_ShpInst_HorizontalScroll	98
#define ESCHER_ShpInst_CircularArrow	99
#define ESCHER_ShpInst_NotchedCircularArrow	100
#define ESCHER_ShpInst_UturnArrow		101
#define ESCHER_ShpInst_CurvedRightArrow	102
#define ESCHER_ShpInst_CurvedLeftArrow	103
#define ESCHER_ShpInst_CurvedUpArrow	104
#define ESCHER_ShpInst_CurvedDownArrow	105
#define ESCHER_ShpInst_CloudCallout		106
#define ESCHER_ShpInst_EllipseRibbon	107
#define ESCHER_ShpInst_EllipseRibbon2	108
#define ESCHER_ShpInst_FlowChartProcess	109
#define ESCHER_ShpInst_FlowChartDecision	110
#define ESCHER_ShpInst_FlowChartInputOutput	111
#define ESCHER_ShpInst_FlowChartPredefinedProcess	112
#define ESCHER_ShpInst_FlowChartInternalStorage	113
#define ESCHER_ShpInst_FlowChartDocument	114
#define ESCHER_ShpInst_FlowChartMultidocument	115
#define ESCHER_ShpInst_FlowChartTerminator	116
#define ESCHER_ShpInst_FlowChartPreparation	117
#define ESCHER_ShpInst_FlowChartManualInput	118
#define ESCHER_ShpInst_FlowChartManualOperation	119
#define ESCHER_ShpInst_FlowChartConnector	120
#define ESCHER_ShpInst_FlowChartPunchedCard	121
#define ESCHER_ShpInst_FlowChartPunchedTape	122
#define ESCHER_ShpInst_FlowChartSummingJunction	123
#define ESCHER_ShpInst_FlowChartOr		124
#define ESCHER_ShpInst_FlowChartCollate	125
#define ESCHER_ShpInst_FlowChartSort	126
#define ESCHER_ShpInst_FlowChartExtract	127
#define ESCHER_ShpInst_FlowChartMerge	128
#define ESCHER_ShpInst_FlowChartOfflineStorage	129
#define ESCHER_ShpInst_FlowChartOnlineStorage	130
#define ESCHER_ShpInst_FlowChartMagneticTape	131
#define ESCHER_ShpInst_FlowChartMagneticDisk	132
#define ESCHER_ShpInst_FlowChartMagneticDrum	133
#define ESCHER_ShpInst_FlowChartDisplay	134
#define ESCHER_ShpInst_FlowChartDelay	135
#define ESCHER_ShpInst_TextPlainText	136
#define ESCHER_ShpInst_TextStop			137
#define ESCHER_ShpInst_TextTriangle		138
#define ESCHER_ShpInst_TextTriangleInverted	139
#define ESCHER_ShpInst_TextChevron		140
#define ESCHER_ShpInst_TextChevronInverted	141
#define ESCHER_ShpInst_TextRingInside	142
#define ESCHER_ShpInst_TextRingOutside	143
#define ESCHER_ShpInst_TextArchUpCurve	144
#define ESCHER_ShpInst_TextArchDownCurve	145
#define ESCHER_ShpInst_TextCircleCurve	146
#define ESCHER_ShpInst_TextButtonCurve	147
#define ESCHER_ShpInst_TextArchUpPour	148
#define ESCHER_ShpInst_TextArchDownPour	149
#define ESCHER_ShpInst_TextCirclePour	150
#define ESCHER_ShpInst_TextButtonPour	151
#define ESCHER_ShpInst_TextCurveUp		152
#define ESCHER_ShpInst_TextCurveDown	153
#define ESCHER_ShpInst_TextCascadeUp	154
#define ESCHER_ShpInst_TextCascadeDown	155
#define ESCHER_ShpInst_TextWave1		156
#define ESCHER_ShpInst_TextWave2		157
#define ESCHER_ShpInst_TextWave3		158
#define ESCHER_ShpInst_TextWave4		159
#define ESCHER_ShpInst_TextInflate		160
#define ESCHER_ShpInst_TextDeflate		161
#define ESCHER_ShpInst_TextInflateBottom	162
#define ESCHER_ShpInst_TextDeflateBottom	163
#define ESCHER_ShpInst_TextInflateTop		164
#define ESCHER_ShpInst_TextDeflateTop		165
#define ESCHER_ShpInst_TextDeflateInflate	166
#define ESCHER_ShpInst_TextDeflateInflateDeflate	167
#define ESCHER_ShpInst_TextFadeRight	168
#define ESCHER_ShpInst_TextFadeLeft		169
#define ESCHER_ShpInst_TextFadeUp		170
#define ESCHER_ShpInst_TextFadeDown		171
#define ESCHER_ShpInst_TextSlantUp		172
#define ESCHER_ShpInst_TextSlantDown	173
#define ESCHER_ShpInst_TextCanUp		174
#define ESCHER_ShpInst_TextCanDown		175
#define ESCHER_ShpInst_FlowChartAlternateProcess	176
#define ESCHER_ShpInst_FlowChartOffpageConnector	177
#define ESCHER_ShpInst_Callout90		178
#define ESCHER_ShpInst_AccentCallout90	179
#define ESCHER_ShpInst_BorderCallout90	180
#define ESCHER_ShpInst_AccentBorderCallout90	181
#define ESCHER_ShpInst_LeftRightUpArrow	182
#define ESCHER_ShpInst_Sun				183
#define ESCHER_ShpInst_Moon				184
#define ESCHER_ShpInst_BracketPair		185
#define ESCHER_ShpInst_BracePair		186
#define ESCHER_ShpInst_Seal4			187
#define ESCHER_ShpInst_DoubleWave		188
#define ESCHER_ShpInst_ActionButtonBlank	189
#define ESCHER_ShpInst_ActionButtonHome		190
#define ESCHER_ShpInst_ActionButtonHelp		191
#define ESCHER_ShpInst_ActionButtonInformation	192
#define ESCHER_ShpInst_ActionButtonForwardNext	193
#define ESCHER_ShpInst_ActionButtonBackPrevious	194
#define ESCHER_ShpInst_ActionButtonEnd		195
#define ESCHER_ShpInst_ActionButtonBeginning	196
#define ESCHER_ShpInst_ActionButtonReturn	197
#define ESCHER_ShpInst_ActionButtonDocument	198
#define ESCHER_ShpInst_ActionButtonSound	199
#define ESCHER_ShpInst_ActionButtonMovie	200
#define ESCHER_ShpInst_HostControl			201
#define ESCHER_ShpInst_TextBox				202
#define ESCHER_ShpInst_Max					0x0FFF
#define ESCHER_ShpInst_Nil					ESCHER_ShpInst_Max

enum ESCHER_BlibType
{							
   ERROR = 0,				
   UNKNOWN,					
   EMF,						
   WMF,						
   PICT,					
   PEG,						
   PNG,						
   DIB,						
   FirstClient = 32,		
   LastClient  = 255		
};

enum ESCHER_FillStyle
{
	ESCHER_FillSolid,		
	ESCHER_FillPattern,     
	ESCHER_FillTexture,     
	ESCHER_FillPicture,     
	ESCHER_FillShade,       
	ESCHER_FillShadeCenter, 
	ESCHER_FillShadeShape,  
	ESCHER_FillShadeScale,
	ESCHER_FillShadeTitle,
	ESCHER_FillBackground
};

enum ESCHER_wMode
{
	ESCHER_wColor,          
	ESCHER_wAutomatic,      
	ESCHER_wGrayScale,      
	ESCHER_wLightGrayScale, 
	ESCHER_wInverseGray,    
	ESCHER_wGrayOutline,    
	ESCHER_wBlackTextLine,  
	ESCHER_wHighContrast,   
	ESCHER_wBlack,          
	ESCHER_wDontShow,       
	ESCHER_wNumModes        
};

enum ESCHER_ShapePath
{
	ESCHER_ShapeLines,        
	ESCHER_ShapeLinesClosed,  
	ESCHER_ShapeCurves,       
	ESCHER_ShapeCurvesClosed, 
	ESCHER_ShapeComplex      
};

enum ESCHER_WrapMode
{
	ESCHER_WrapSquare,
	ESCHER_WrapByPoints,
	ESCHER_WrapNone,
	ESCHER_WrapTopBottom,
	ESCHER_WrapThrough
};

enum ESCHER_bwMode
{
	ESCHER_bwColor,          
	ESCHER_bwAutomatic,      
	ESCHER_bwGrayScale,      
	ESCHER_bwLightGrayScale, 
	ESCHER_bwInverseGray,    
	ESCHER_bwGrayOutline,    
	ESCHER_bwBlackTextLine,  
	ESCHER_bwHighContrast,   
	ESCHER_bwBlack,          
	ESCHER_bwWhite,          
	ESCHER_bwDontShow,       
	ESCHER_bwNumModes        
};

enum ESCHER_AnchorText
{
	ESCHER_AnchorTop,
	ESCHER_AnchorMiddle,
	ESCHER_AnchorBottom,
	ESCHER_AnchorTopCentered,
	ESCHER_AnchorMiddleCentered,
	ESCHER_AnchorBottomCentered,
	ESCHER_AnchorTopBaseline,
	ESCHER_AnchorBottomBaseline,
	ESCHER_AnchorTopCenteredBaseline,
	ESCHER_AnchorBottomCenteredBaseline
};

enum ESCHER_cDir
{
	ESCHER_cDir0,       
	ESCHER_cDir90,      
	ESCHER_cDir180,     
	ESCHER_cDir270      
};

enum ESCHER_cxSTYLE
{
	ESCHER_cxstyleStraight = 0,
	ESCHER_cxstyleBent,
	ESCHER_cxstyleCurved,
	ESCHER_cxstyleNone
};

enum ESCHER_txfl
{
	ESCHER_txflHorzN,           
	ESCHER_txflTtoBA,           
	ESCHER_txflBtoT,            
	ESCHER_txflTtoBN,           
	ESCHER_txflHorzA,           
	ESCHER_txflVertN			
};

enum ESCHER_txDir
{
	ESCHER_txdirLTR,			
	ESCHER_txdirRTL,			
	ESCHER_txdirContext			
};

enum ESCHER_spcot
{
	ESCHER_spcotRightAngle = 1,
	ESCHER_spcotOneSegment = 2,
	ESCHER_spcotTwoSegment = 3,
	ESCHER_spcotThreeSegment = 4
};

enum ESCHER_spcoa
{
	ESCHER_spcoaAny,
	ESCHER_spcoa30,
	ESCHER_spcoa45,
	ESCHER_spcoa60,
	ESCHER_spcoa90,
	ESCHER_spcoa0
};

enum ESCHER_spcod
{
	ESCHER_spcodTop,
	ESCHER_spcodCenter,
	ESCHER_spcodBottom,
	ESCHER_spcodSpecified
};

enum ESCHER_GeoTextAlign
{
	ESCHER_AlignTextStretch,      
	ESCHER_AlignTextCenter,       
	ESCHER_AlignTextLeft,         
	ESCHER_AlignTextRight,        
	ESCHER_AlignTextLetterJust,   
	ESCHER_AlignTextWordJust,     
	ESCHER_AlignTextInvalid       
};

enum ESCHER_BlipFlags
{
	ESCHER_BlipFlagDefault = 0,
	ESCHER_BlipFlagComment = 0,   
	ESCHER_BlipFlagFile,          
	ESCHER_BlipFlagURL,           
	ESCHER_BlipFlagType = 3,      

	ESCHER_BlipFlagDontSave = 4,  

	ESCHER_BlipFlagDoNotSave = 4, 
	ESCHER_BlipFlagLinkToFile = 8
};

enum ESCHER_3DRenderMode
{
	ESCHER_FullRender,      
	ESCHER_Wireframe,       
	ESCHER_BoundingCube		
};

enum ESCHER_xFormType
{
	ESCHER_xFormAbsolute,   
	ESCHER_xFormShape,      
	ESCHER_xFormDrawing     
};

enum ESCHER_ShadowType
{
	ESCHER_ShadowOffset,    
	ESCHER_ShadowDouble,    
	ESCHER_ShadowRich,      
	ESCHER_ShadowShape,     
	ESCHER_ShadowDrawing,   
	ESCHER_ShadowEmbossOrEngrave
};

enum ESCHER_dzType
   {
   ESCHER_dzTypeMin          = 0,
   ESCHER_dzTypeDefault      = 0,  
   ESCHER_dzTypeA            = 1,  
   ESCHER_dzTypeV            = 2,  
   ESCHER_dzTypeShape        = 3,  
   ESCHER_dzTypeFixedAspect  = 4,  
   ESCHER_dzTypeAFixed       = 5,  
   ESCHER_dzTypeVFixed       = 6,  
   ESCHER_dzTypeShapeFixed   = 7,  
   ESCHER_dzTypeFixedAspectEnlarge= 8,  
   ESCHER_dzTypeAFixedBig    = 9,  
   ESCHER_dzTypeVFixedBig    = 10, 
   ESCHER_dzTypeShapeFixedBig= 11, 
   ESCHER_dzTypeMax         = 11
};

enum ESCHER_ShadeType
{
	ESCHER_ShadeNone  = 0,        
	ESCHER_ShadeGamma = 1,        
	ESCHER_ShadeSigma = 2,        
	ESCHER_ShadeBand  = 4,        
	ESCHER_ShadeOneColor = 8,     

	ESCHER_ShadeParameterShift = 16,
	ESCHER_ShadeParameterMask  = 0xffff0000,

	ESCHER_ShadeDefault = (ESCHER_ShadeGamma|ESCHER_ShadeSigma|
		 (16384<<ESCHER_ShadeParameterShift))
};

enum ESCHER_LineStyle
{
	ESCHER_LineSimple,            
	ESCHER_LineDouble,            
	ESCHER_LineThickThin,         
	ESCHER_LineThinThick,         
	ESCHER_LineTriple             
};

enum ESCHER_LineType
{
   ESCHER_lineSolidType,         
   ESCHER_linePattern,           
   ESCHER_lineTexture,           
   ESCHER_linePicture            
};

enum ESCHER_LineDashing
{
	ESCHER_LineSolid,              
	ESCHER_LineDashSys,            
	ESCHER_LineDotSys,             
	ESCHER_LineDashDotSys,         
	ESCHER_LineDashDotDotSys,      
	ESCHER_LineDotGEL,             
	ESCHER_LineDashGEL,            
	ESCHER_LineLongDashGEL,        
	ESCHER_LineDashDotGEL,         
	ESCHER_LineLongDashDotGEL,     
	ESCHER_LineLongDashDotDotGEL   
};

enum ESCHER_LineEnd
{
	ESCHER_LineNoEnd,
	ESCHER_LineArrowEnd,
	ESCHER_LineArrowStealthEnd,
	ESCHER_LineArrowDiamondEnd,
	ESCHER_LineArrowOvalEnd,
	ESCHER_LineArrowOpenEnd
};

enum ESCHER_LineWidth
{
	ESCHER_LineNarrowArrow,
	ESCHER_LineMediumWidthArrow,
	ESCHER_LineWideArrow
};

enum ESCHER_LineEndLenght
{
	ESCHER_LineShortArrow,
	ESCHER_LineMediumLenArrow,
	ESCHER_LineLongArrow
};

enum ESCHER_LineJoin
{
	ESCHER_LineJoinBevel,     
	ESCHER_LineJoinMiter,     
	ESCHER_LineJoinRound      
};

enum ESCHER_LineCap
{
	ESCHER_LineEndCapRound,   
	ESCHER_LineEndCapSquare,  
	ESCHER_LineEndCapFlat     
};

#define ESCHER_Prop_Rotation                      4  

#define ESCHER_Prop_LockRotation                119  
#define ESCHER_Prop_LockAspectRatio             120  
#define ESCHER_Prop_LockPosition                121  
#define ESCHER_Prop_LockAgainstSelect           122  
#define ESCHER_Prop_LockCropping                123  
#define ESCHER_Prop_LockVertices                124  
#define ESCHER_Prop_LockText                    125  
#define ESCHER_Prop_LockAdjustHandles           126  
#define ESCHER_Prop_LockAgainstGrouping         127  

#define ESCHER_Prop_lTxid                       128  
#define ESCHER_Prop_dxTextLeft                  129  
#define ESCHER_Prop_dyTextTop                   130  
#define ESCHER_Prop_dxTextRight                 131  
#define ESCHER_Prop_dyTextBottom                132  
#define ESCHER_Prop_WrapText                    133  
#define ESCHER_Prop_scaleText                   134  
#define ESCHER_Prop_AnchorText                  135  
#define ESCHER_Prop_txflTextFlow                136  
#define ESCHER_Prop_cdirFont                    137  
#define ESCHER_Prop_hspNext                     138  
#define ESCHER_Prop_txdir                       139  
#define ESCHER_Prop_SelectText                  187  
#define ESCHER_Prop_AutoTextMargin              188  
#define ESCHER_Prop_RotateText                  189  
#define ESCHER_Prop_FitShapeToText              190  
#define ESCHER_Prop_FitTextToShape              191  

#define ESCHER_Prop_gtextUNICODE                192  
#define ESCHER_Prop_gtextRTF                    193  
#define ESCHER_Prop_gtextAlign                  194  
#define ESCHER_Prop_gtextSize                   195  
#define ESCHER_Prop_gtextSpacing                196  
#define ESCHER_Prop_gtextFont                   197  
#define ESCHER_Prop_gtextFReverseRows           240  
#define ESCHER_Prop_fGtext                      241  
#define ESCHER_Prop_gtextFVertical              242  
#define ESCHER_Prop_gtextFKern                  243  
#define ESCHER_Prop_gtextFTight                 244  
#define ESCHER_Prop_gtextFStretch               245  
#define ESCHER_Prop_gtextFShrinkFit             246  
#define ESCHER_Prop_gtextFBestFit               247  
#define ESCHER_Prop_gtextFNormalize             248  
#define ESCHER_Prop_gtextFDxMeasure             249  
#define ESCHER_Prop_gtextFBold                  250  
#define ESCHER_Prop_gtextFItalic                251  
#define ESCHER_Prop_gtextFUnderline             252  
#define ESCHER_Prop_gtextFShadow                253  
#define ESCHER_Prop_gtextFSmallcaps             254  
#define ESCHER_Prop_gtextFStrikethrough         255  

#define ESCHER_Prop_cropFromTop                 256  
#define ESCHER_Prop_cropFromBottom				257  
#define ESCHER_Prop_cropFromLeft                258  
#define ESCHER_Prop_cropFromRight               259  
#define ESCHER_Prop_pib                         260  
#define ESCHER_Prop_pibName                     261  
#define ESCHER_Prop_pibFlags                    262  
#define ESCHER_Prop_pictureTransparent          263  
#define ESCHER_Prop_pictureContrast             264  
#define ESCHER_Prop_pictureBrightness           265  
#define ESCHER_Prop_pictureGamma                266  
#define ESCHER_Prop_pictureId                   267  
#define ESCHER_Prop_pictureDblCrMod             268  
#define ESCHER_Prop_pictureFillCrMod            269  
#define ESCHER_Prop_pictureLineCrMod            270  
#define ESCHER_Prop_pibPrint                    271  
#define ESCHER_Prop_pibPrintName                272  
#define ESCHER_Prop_pibPrintFlags               273  
#define ESCHER_Prop_fNoHitTestPicture           316  
#define ESCHER_Prop_pictureGray                 317  
#define ESCHER_Prop_pictureBiLevel              318  
#define ESCHER_Prop_pictureActive               319  

#define ESCHER_Prop_geoLeft                     320  
#define ESCHER_Prop_geoTop                      321  
#define ESCHER_Prop_geoRight                    322  
#define ESCHER_Prop_geoBottom                   323  
#define ESCHER_Prop_shapePath                   324  
#define ESCHER_Prop_pVertices                   325  
#define ESCHER_Prop_pSegmentInfo                326  
#define ESCHER_Prop_adjustValue                 327  
#define ESCHER_Prop_adjust2Value                328  
#define ESCHER_Prop_adjust3Value                329  
#define ESCHER_Prop_adjust4Value                330  
#define ESCHER_Prop_adjust5Value                331  
#define ESCHER_Prop_adjust6Value                332  
#define ESCHER_Prop_adjust7Value                333  
#define ESCHER_Prop_adjust8Value                334  
#define ESCHER_Prop_adjust9Value                335  
#define ESCHER_Prop_adjust10Value               336  
#define ESCHER_Prop_fShadowOK                   378  
#define ESCHER_Prop_f3DOK                       379  
#define ESCHER_Prop_fLineOK                     380  
#define ESCHER_Prop_fGtextOK                    381  
#define ESCHER_Prop_fFillShadeShapeOK           382  
#define ESCHER_Prop_fFillOK                     383  

#define ESCHER_Prop_fillType                    384  
#define ESCHER_Prop_fillColor                   385  
#define ESCHER_Prop_fillOpacity                 386  
#define ESCHER_Prop_fillBackColor               387  
#define ESCHER_Prop_fillBackOpacity             388  
#define ESCHER_Prop_fillCrMod                   389  
#define ESCHER_Prop_fillBlip                    390  
#define ESCHER_Prop_fillBlipName                391  
#define ESCHER_Prop_fillBlipFlags               392  
#define ESCHER_Prop_fillWidth                   393  
#define ESCHER_Prop_fillHeight                  394  
#define ESCHER_Prop_fillAngle                   395  
#define ESCHER_Prop_fillFocus                   396  
#define ESCHER_Prop_fillToLeft                  397  
#define ESCHER_Prop_fillToTop                   398  
#define ESCHER_Prop_fillToRight                 399  
#define ESCHER_Prop_fillToBottom                400  
#define ESCHER_Prop_fillRectLeft                401  
#define ESCHER_Prop_fillRectTop                 402  
#define ESCHER_Prop_fillRectRight               403  
#define ESCHER_Prop_fillRectBottom              404  
#define ESCHER_Prop_fillDztype                  405  
#define ESCHER_Prop_fillShadePreset             406  
#define ESCHER_Prop_fillShadeColors             407  
#define ESCHER_Prop_fillOriginX                 408  
#define ESCHER_Prop_fillOriginY                 409  
#define ESCHER_Prop_fillShapeOriginX            410  
#define ESCHER_Prop_fillShapeOriginY            411  
#define ESCHER_Prop_fillShadeType               412  
#define ESCHER_Prop_fFilled                     443  
#define ESCHER_Prop_fHitTestFill                444  
#define ESCHER_Prop_fillShape                   445  
#define ESCHER_Prop_fillUseRect                 446  
#define ESCHER_Prop_fNoFillHitTest              447  

#define ESCHER_Prop_lineColor                   448  
#define ESCHER_Prop_lineOpacity                 449  
#define ESCHER_Prop_lineBackColor               450  
#define ESCHER_Prop_lineCrMod                   451  
#define ESCHER_Prop_lineType                    452  
#define ESCHER_Prop_lineFillBlip                453  
#define ESCHER_Prop_lineFillBlipName            454  
#define ESCHER_Prop_lineFillBlipFlags           455  
#define ESCHER_Prop_lineFillWidth               456  
#define ESCHER_Prop_lineFillHeight              457  
#define ESCHER_Prop_lineFillDztype              458  
#define ESCHER_Prop_lineWidth                   459  
#define ESCHER_Prop_lineMiterLimit              460  
#define ESCHER_Prop_lineStyle                   461  
#define ESCHER_Prop_lineDashing                 462  
#define ESCHER_Prop_lineDashStyle               463  
#define ESCHER_Prop_lineStartArrowhead          464  
#define ESCHER_Prop_lineEndArrowhead            465  
#define ESCHER_Prop_lineStartArrowWidth         466  
#define ESCHER_Prop_lineStartArrowLength        467  
#define ESCHER_Prop_lineEndArrowWidth           468  
#define ESCHER_Prop_lineEndArrowLength          469  
#define ESCHER_Prop_lineJoinStyle               470  
#define ESCHER_Prop_lineEndCapStyle             471  
#define ESCHER_Prop_fArrowheadsOK               507  
#define ESCHER_Prop_fLine                       508  
#define ESCHER_Prop_fHitTestLine                509  
#define ESCHER_Prop_lineFillShape               510  
#define ESCHER_Prop_fNoLineDrawDash             511  

#define ESCHER_Prop_shadowType                  512  
#define ESCHER_Prop_shadowColor                 513  
#define ESCHER_Prop_shadowHighlight             514  
#define ESCHER_Prop_shadowCrMod                 515  
#define ESCHER_Prop_shadowOpacity               516  
#define ESCHER_Prop_shadowOffsetX               517  
#define ESCHER_Prop_shadowOffsetY               518  
#define ESCHER_Prop_shadowSecondOffsetX         519  
#define ESCHER_Prop_shadowSecondOffsetY         520  
#define ESCHER_Prop_shadowScaleXToX             521  
#define ESCHER_Prop_shadowScaleYToX             522  
#define ESCHER_Prop_shadowScaleXToY             523  
#define ESCHER_Prop_shadowScaleYToY             524  
#define ESCHER_Prop_shadowPerspectiveX          525  
#define ESCHER_Prop_shadowPerspectiveY          526  
#define ESCHER_Prop_shadowWeight                527  
#define ESCHER_Prop_shadowOriginX               528  
#define ESCHER_Prop_shadowOriginY               529  
#define ESCHER_Prop_fShadow                     574  
#define ESCHER_Prop_fshadowObscured             575  

#define ESCHER_Prop_perspectiveType             576  
#define ESCHER_Prop_perspectiveOffsetX          577  
#define ESCHER_Prop_perspectiveOffsetY          578  
#define ESCHER_Prop_perspectiveScaleXToX        579  
#define ESCHER_Prop_perspectiveScaleYToX        580  
#define ESCHER_Prop_perspectiveScaleXToY        581  
#define ESCHER_Prop_perspectiveScaleYToY        582  
#define ESCHER_Prop_perspectivePerspectiveX     583  
#define ESCHER_Prop_perspectivePerspectiveY     584  
#define ESCHER_Prop_perspectiveWeight           585  
#define ESCHER_Prop_perspectiveOriginX          586  
#define ESCHER_Prop_perspectiveOriginY          587  
#define ESCHER_Prop_fPerspective                639  

#define ESCHER_Prop_c3DSpecularAmt              640  
#define ESCHER_Prop_c3DDiffuseAmt               641  
#define ESCHER_Prop_c3DShininess                642  
#define ESCHER_Prop_c3DEdgeThickness            643  
#define ESCHER_Prop_c3DExtrudeForward           644  
#define ESCHER_Prop_c3DExtrudeBackward          645  
#define ESCHER_Prop_c3DExtrudePlane             646  
#define ESCHER_Prop_c3DExtrusionColor           647  
#define ESCHER_Prop_c3DCrMod                    648  
#define ESCHER_Prop_f3D                         700  
#define ESCHER_Prop_fc3DMetallic                701  
#define ESCHER_Prop_fc3DUseExtrusionColor       702  
#define ESCHER_Prop_fc3DLightFace               703  

#define ESCHER_Prop_c3DYRotationAngle           704  
#define ESCHER_Prop_c3DXRotationAngle           705  
#define ESCHER_Prop_c3DRotationAxisX            706  
#define ESCHER_Prop_c3DRotationAxisY            707  
#define ESCHER_Prop_c3DRotationAxisZ            708  
#define ESCHER_Prop_c3DRotationAngle            709  
#define ESCHER_Prop_c3DRotationCenterX          710  
#define ESCHER_Prop_c3DRotationCenterY          711  
#define ESCHER_Prop_c3DRotationCenterZ          712  
#define ESCHER_Prop_c3DRenderMode               713  
#define ESCHER_Prop_c3DTolerance                714  
#define ESCHER_Prop_c3DXViewpoint               715  
#define ESCHER_Prop_c3DYViewpoint               716  
#define ESCHER_Prop_c3DZViewpoint               717  
#define ESCHER_Prop_c3DOriginX                  718  
#define ESCHER_Prop_c3DOriginY                  719  
#define ESCHER_Prop_c3DSkewAngle                720  
#define ESCHER_Prop_c3DSkewAmount               721  
#define ESCHER_Prop_c3DAmbientIntensity         722  
#define ESCHER_Prop_c3DKeyX                     723  
#define ESCHER_Prop_c3DKeyY                     724  
#define ESCHER_Prop_c3DKeyZ                     725  
#define ESCHER_Prop_c3DKeyIntensity             726  
#define ESCHER_Prop_c3DFillX                    727  
#define ESCHER_Prop_c3DFillY                    728  
#define ESCHER_Prop_c3DFillZ                    729  
#define ESCHER_Prop_c3DFillIntensity            730  
#define ESCHER_Prop_fc3DConstrainRotation       763  
#define ESCHER_Prop_fc3DRotationCenterAuto      764  
#define ESCHER_Prop_fc3DParallel                765  
#define ESCHER_Prop_fc3DKeyHarsh                766  
#define ESCHER_Prop_fc3DFillHarsh               767  

#define ESCHER_Prop_hspMaster                   769  
#define ESCHER_Prop_cxstyle                     771  
#define ESCHER_Prop_bWMode                      772  
#define ESCHER_Prop_bWModePureBW                773  
#define ESCHER_Prop_bWModeBW                    774  
#define ESCHER_Prop_fOleIcon                    826  
#define ESCHER_Prop_fPreferRelativeResize       827  
#define ESCHER_Prop_fLockShapeType              828  
#define ESCHER_Prop_fDeleteAttachedObject       830  
#define ESCHER_Prop_fBackground                 831  

#define ESCHER_Prop_spcot                       832  
#define ESCHER_Prop_dxyCalloutGap               833  
#define ESCHER_Prop_spcoa                       834  
#define ESCHER_Prop_spcod                       835  
#define ESCHER_Prop_dxyCalloutDropSpecified     836  
#define ESCHER_Prop_dxyCalloutLengthSpecified   837  
#define ESCHER_Prop_fCallout                    889  
#define ESCHER_Prop_fCalloutAccentBar           890  
#define ESCHER_Prop_fCalloutTextBorder          891  
#define ESCHER_Prop_fCalloutMinusX              892  
#define ESCHER_Prop_fCalloutMinusY              893  
#define ESCHER_Prop_fCalloutDropAuto            894  
#define ESCHER_Prop_fCalloutLengthSpecified     895  

#define ESCHER_Prop_wzName                      896  
#define ESCHER_Prop_wzDescription               897  
#define ESCHER_Prop_pihlShape                   898  
#define ESCHER_Prop_pWrapPolygonVertices        899  
#define ESCHER_Prop_dxWrapDistLeft              900  
#define ESCHER_Prop_dyWrapDistTop               901  
#define ESCHER_Prop_dxWrapDistRight             902  
#define ESCHER_Prop_dyWrapDistBottom            903  
#define ESCHER_Prop_lidRegroup                  904  
#define ESCHER_Prop_fEditedWrap                 953  
#define ESCHER_Prop_fBehindDocument             954  
#define ESCHER_Prop_fOnDblClickNotify           955  
#define ESCHER_Prop_fIsButton                   956  
#define ESCHER_Prop_fOneD                       957  
#define ESCHER_Prop_fHidden                     958  
#define ESCHER_Prop_fPrint                      959  

#define ESCHER_PERSISTENTRY_PREALLOCATE		64

#define ESCHER_Persist_PrivateEntry			0x80000000
#define ESCHER_Persist_Dgg					0x00010000
#define ESCHER_Persist_Dgg_FIDCL			0x00010001
#define ESCHER_Persist_Dg					0x00020000
#define ESCHER_Persist_BlibStoreContainer	0x00030000
#define ESCHER_Persist_CurrentPosition		0x00040000
#define ESCHER_Persist_Grouping_Snap		0x00050000
#define ESCHER_Persist_Grouping_Logic		0x00060000

namespace com { namespace sun { namespace star {
	namespace awt {
		struct Gradient;
	}
	namespace drawing {
		class XShape;
	}
}}}

struct EscherPropertyValueHelper
{
		static sal_Bool GetPropertyValue(
	::com::sun::star::uno::Any& rAny,
		const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > &,
			const String& rPropertyName,
				sal_Bool bTestPropertyAvailability = sal_False );

		static ::com::sun::star::beans::PropertyState GetPropertyState(
		const ::com::sun::star::uno::Reference < ::com::sun::star::beans::XPropertySet > &,
			const String& rPropertyName );
};

struct EscherPersistEntry
{
	UINT32	mnID;
	UINT32	mnOffset;
			EscherPersistEntry( UINT32 nId, UINT32 nOffset ) { mnID = nId; mnOffset = nOffset; };

};

class SvMemoryStream;
class EscherBlibEntry
{

		friend class EscherGraphicProvider;
		friend class EscherEx;
		friend class _EscherEx;

	protected:

		UINT32			mnIdentifier[ 4 ];
		UINT32			mnPictureOffset;		
		UINT32			mnSize;					

		UINT32			mnRefCount;				
		UINT32			mnSizeExtra;			

		ESCHER_BlibType	meBlibType;

		sal_Bool		mbIsEmpty;
		sal_Bool		mbIsNativeGraphicPossible;

		Size			maPrefSize;
		MapMode			maPrefMapMode;

	public:
				EscherBlibEntry( sal_uInt32 nPictureOffset, const GraphicObject& rObj,
									const ByteString& rId, const GraphicAttr* pAttr = NULL );
				~EscherBlibEntry();

		void			WriteBlibEntry( SvStream& rSt, sal_Bool bWritePictureOffset, sal_uInt32 nResize = 0 );
		sal_Bool		IsEmpty() const { return mbIsEmpty; };

		BOOL			operator==( const EscherBlibEntry& ) const;
};

#define _E_GRAPH_PROV_USE_INSTANCES				1
#define _E_GRAPH_PROV_DO_NOT_ROTATE_METAFILES	2

class EscherGraphicProvider
{
		sal_uInt32				mnFlags;

		EscherBlibEntry**		mpBlibEntrys;
		sal_uInt32				mnBlibBufSize;
		sal_uInt32				mnBlibEntrys;

	protected :

		UINT32					ImplInsertBlib( EscherBlibEntry* p_EscherBlibEntry );

	public :

		sal_uInt32	GetBlibStoreContainerSize( SvStream* pMergePicStreamBSE = NULL ) const;
		void		WriteBlibStoreContainer( SvStream& rStrm, SvStream* pMergePicStreamBSE = NULL  );
		sal_uInt32	GetBlibID( SvStream& rPicOutStream, const ByteString& rGraphicId, const Rectangle& rBoundRect,
					const GraphicAttr* pGrafikAttr = NULL );
		sal_Bool	HasGraphics() const { return mnBlibEntrys != 0; };

		void		SetNewBlipStreamOffset( sal_Int32 nOffset );

		sal_Bool	GetPrefSize( const sal_uInt32 nBlibId, Size& rSize, MapMode& rMapMode );

		EscherGraphicProvider( sal_uInt32 nFlags = _E_GRAPH_PROV_DO_NOT_ROTATE_METAFILES );
		~EscherGraphicProvider();

};

class EscherSolverContainer
{
	List				maShapeList;
	List				maConnectorList;

	sal_uInt32			ImplGetId( const ::com::sun::star::uno::Reference< ::com::sun::star::drawing::XShape > & rShape );

public:

	void				AddShape( const ::com::sun::star::uno::Reference< ::com::sun::star::drawing::XShape > &, sal_uInt32 nId );
	void				AddConnector( const ::com::sun::star::uno::Reference< ::com::sun::star::drawing::XShape > &,
							const ::com::sun::star::awt::Point& rA,
						::com::sun::star::uno::Reference< ::com::sun::star::drawing::XShape > &,
							const ::com::sun::star::awt::Point& rB,
						::com::sun::star::uno::Reference< ::com::sun::star::drawing::XShape > & rConB );

	void				WriteSolver( SvStream& );
				EscherSolverContainer(){};
			~EscherSolverContainer();
};

#define ESCHER_CREATEPOLYGON_LINE			1
#define ESCHER_CREATEPOLYGON_POLYLINE		2
#define ESCHER_CREATEPOLYGON_POLYPOLYGON	4

struct EscherPropSortStruct;
class GraphicAttr;
class EscherPropertyContainer
{
		sal_uInt32				nSortCount;
		sal_uInt32				nSortBufSize;
		EscherPropSortStruct*	pSortStruct;
		sal_uInt32				nCountCount;
		sal_uInt32				nCountSize;
		sal_Bool				bHasComplexData;
		sal_Bool				bSuppressRotation;

		EscherGraphicProvider*	pGraphicProvider;
		Rectangle*				pShapeBoundRect;
		SvStream*				pPicOutStrm;

		sal_uInt32	ImplGetColor( const sal_uInt32 rColor, sal_Bool bSwap = sal_True );
		void		ImplCreateGraphicAttributes( const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > & rXPropSet,
										sal_uInt32 nBlibId, sal_Bool bCreateCroppingAttributes );
		void		ImplInit();

	public :

		EscherPropertyContainer();
		EscherPropertyContainer(
			EscherGraphicProvider& rGraphicProvider,	
		SvStream* pPicOutStrm,				
			Rectangle& rShapeBoundRect );	

		~EscherPropertyContainer();								

		void		AddOpt( sal_uInt16 nPropertyID, sal_uInt32 nPropValue,
				sal_Bool bBlib = sal_False );

		void		AddOpt( sal_uInt16 nPropertyID, sal_Bool bBlib, sal_uInt32 nPropValue,
				sal_uInt8* pProp, sal_uInt32 nPropSize );

		sal_Bool	GetOpt( sal_uInt16 nPropertyID, sal_uInt32& rPropValue ) const;

		void		Commit( SvStream& rSt, sal_uInt16 nVersion = 3 );

		sal_Bool	CreateGraphicProperties( const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > & rXPropSet,
			const String& rSource, sal_Bool bFillBitmap, sal_Bool bCreateCroppingAttributes = sal_False );

		sal_Bool	CreatePolygonProperties( const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > & rXPropSet,
			sal_uInt32 nFlags, sal_Bool bBezier, ::com::sun::star::awt::Rectangle& rGeoRect, Polygon* pPolygon = NULL );

		static sal_uInt32 GetGradientColor( const ::com::sun::star::awt::Gradient* pGradient, sal_uInt32 nStartColor );
		void		CreateGradientProperties( const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > & );
		void		CreateFillProperties( const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > &, sal_Bool bEdge );
		void		CreateLineProperties( const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > &, sal_Bool bEdge );

		sal_Bool	CreateConnectorProperties( const ::com::sun::star::uno::Reference< ::com::sun::star::drawing::XShape > & rXShape,
									EscherSolverContainer& rSolver, ::com::sun::star::awt::Rectangle& rGeoRect,
										sal_uInt16& rShapeType, sal_uInt16& rShapeFlags );

		sal_Bool	CreateShadowProperties( const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > & );
	     static PolyPolygon GetPolyPolygon( const ::com::sun::star::uno::Reference< ::com::sun::star::drawing::XShape > & rXShape );
		static PolyPolygon GetPolyPolygon( const ::com::sun::star::uno::Any& rSource );
};

class EscherPersistTable
{

	public:
		List	maPersistTable;

		BOOL	PtIsID( UINT32 nID );
		void	PtInsert( UINT32 nID, UINT32 nOfs );
		UINT32	PtDelete( UINT32 nID );
		UINT32	PtGetOffsetByID( UINT32 nID );
		UINT32	PtReplace( UINT32 nID, UINT32 nOfs );
		UINT32	PtReplaceOrInsert( UINT32 nID, UINT32 nOfs );
		UINT32	PtGetCount() const { return maPersistTable.Count(); };
		EscherPersistTable();
		virtual	~EscherPersistTable();
};

class EscherEx;

class EscherExClientRecord_Base
{
public:
					EscherExClientRecord_Base() {}
	virtual						~EscherExClientRecord_Base();

	virtual	void				WriteData( EscherEx& rEx ) const = 0;
};

class EscherExClientAnchor_Base
{
public:
					EscherExClientAnchor_Base() {}
	virtual						~EscherExClientAnchor_Base();

	virtual	void				WriteData( EscherEx& rEx,
						const Rectangle& rRect ) = 0;
};

class EscherExHostAppData
{
private:
		EscherExClientAnchor_Base*	pClientAnchor;
		EscherExClientRecord_Base*	pClientData;
		EscherExClientRecord_Base*	pClientTextbox;

		BOOL						bDontWriteShape;

public:
		EscherExHostAppData() : pClientAnchor(0), pClientData(0),
					pClientTextbox(0), bDontWriteShape(FALSE)
		{}

		void SetClientAnchor( EscherExClientAnchor_Base* p )
			{ pClientAnchor = p; }
		void SetClientData( EscherExClientRecord_Base* p )
			{ pClientData = p; }
		void SetClientTextbox( EscherExClientRecord_Base* p )
			{ pClientTextbox = p; }
		void SetDontWriteShape( BOOL b )
			{ bDontWriteShape = b; }
		EscherExClientAnchor_Base* GetClientAnchor() const
			{ return pClientAnchor; }
		EscherExClientRecord_Base* GetClientData() const
			{ return pClientData; }
		EscherExClientRecord_Base* GetClientTextbox() const
			{ return pClientTextbox; }

		void WriteClientAnchor( EscherEx& rEx, const Rectangle& rRect )
			{ if( pClientAnchor ) 	pClientAnchor->WriteData( rEx, rRect ); }
		void WriteClientData( EscherEx& rEx )
			{ if( pClientData ) 	pClientData->WriteData( rEx ); }
		void WriteClientTextbox( EscherEx& rEx )
			{ if( pClientTextbox ) 	pClientTextbox->WriteData( rEx ); }

		BOOL DontWriteShape() const { return bDontWriteShape; }
};

class SdrObject;
class SdrPage;
class ImplEscherExSdr;
class Color;

class Graphic;
class SvMemoryStream;
class SvStream;

class EscherEx : public EscherPersistTable, public EscherGraphicProvider
{
	protected :

		SvStream*				mpOutStrm;
		ImplEscherExSdr*		mpImplEscherExSdr;
		UINT32					mnStrmStartOfs;
		int						mnLevel;
		UINT32*					mpOffsets;
		UINT16*					mpRecTypes;					

		UINT32					mnDrawings;
		UINT32					mnFIDCLs;					

		UINT32					mnCurrentDg;
		UINT32					mnCurrentShapeID;			
		UINT32					mnCurrentShapeMaximumID;	
		UINT32					mnTotalShapesDg;			
		UINT32					mnTotalShapeIdUsedDg;		
		UINT32					mnTotalShapesDgg;			
		UINT32					mnCountOfs;

		UINT32					mnGroupLevel;
		UINT16					mnHellLayerId;

		BOOL					mbEscherSpgr;
		BOOL					mbEscherDgg;
		BOOL					mbEscherDg;
		BOOL					mbOleEmf;					

		BOOL	DoSeek( UINT32 nKey );

	public:
		EscherEx( SvStream& rOut, UINT32 nDrawings );

		void	Flush( SvStream* pPicStreamMergeBSE = NULL );

	virtual		~EscherEx();

	virtual void	InsertAtCurrentPos( UINT32 nBytes, BOOL bCont = FALSE );

		void	InsertPersistOffset( UINT32 nKey, UINT32 nOffset );	
		BOOL	SeekToPersistOffset( UINT32 nKey );
		BOOL	InsertAtPersistOffset( UINT32 nKey, UINT32 nValue );

		SvStream&	GetStream() const	{ return *mpOutStrm; }
		ULONG	GetStreamPos() const	{ return mpOutStrm->Tell(); }

		BOOL	SeekBehindRecHeader( UINT16 nRecType );				

		virtual void OpenContainer( UINT16 nEscherContainer, int nRecInstance = 0 );
		virtual void CloseContainer();

		void	BeginAtom();
		void	EndAtom( UINT16 nRecType, int nRecVersion = 0, int nRecInstance = 0 );
		void	AddAtom( UINT32 nAtomSitze, UINT16 nRecType, int nRecVersion = 0, int nRecInstance = 0 );
		void	AddClientAnchor( const Rectangle& rRectangle );

		UINT32	EnterGroup( const Rectangle* pBoundRect = NULL );
		UINT32	GetGroupLevel() const { return mnGroupLevel; };
		BOOL	SetGroupSnapRect( UINT32 nGroupLevel, const Rectangle& rRect );
		BOOL	SetGroupLogicRect( UINT32 nGroupLevel, const Rectangle& rRect );
		void	LeaveGroup();

		void	AddShape( UINT32 nShpInstance, UINT32 nFlagIds, UINT32 nShapeID = 0 );

		UINT32	GetShapeID();

		UINT32	GetColor( const UINT32 nColor, BOOL bSwap = TRUE );
		UINT32	GetColor( const Color& rColor, BOOL bSwap = TRUE );

		void	SetOleEmf( BOOL bVal )		{ mbOleEmf = bVal; }
		BOOL	IsOleEmf() const			{ return mbOleEmf; }

		void	AddSdrPage( const SdrPage& rPage );

		UINT32	AddSdrObject( const SdrObject& rObj );

		void	EndSdrObjectPage();

		virtual	EscherExHostAppData* StartShape( const ::com::sun::star::uno::Reference< ::com::sun::star::drawing::XShape >& rShape );

	virtual	void	EndShape( UINT16 nShapeType, UINT32 nShapeID );

	virtual	EscherExHostAppData*	EnterAdditionalTextGroup();

	virtual SvStream*	QueryPicStream();

	virtual	UINT32	QueryTextID( const ::com::sun::star::uno::Reference< ::com::sun::star::drawing::XShape >&, UINT32 nShapeId );

		UINT32 	AddDummyShape( const SdrObject& rObj );

	static const SdrObject* GetSdrObject( const ::com::sun::star::uno::Reference< ::com::sun::star::drawing::XShape >& rXShape );

	void SetHellLayerId( UINT16 nId )		{ mnHellLayerId = nId; }
	UINT16 GetHellLayerId() const			{ return mnHellLayerId; }
};

#endif 
