
#ifndef _SVX_FMGRIDCL_HXX
#define _SVX_FMGRIDCL_HXX

#ifndef _COM_SUN_STAR_CONTAINER_XINDEXCONTAINER_HPP_
#include <com/sun/star/container/XIndexContainer.hpp>
#endif

#ifndef _COM_SUN_STAR_FORM_XINDEXCONTAINER_HPP_
#include <com/sun/star/container/XIndexContainer.hpp>
#endif

#ifndef _SVX_GRIDCTRL_HXX
#include <svx/gridctrl.hxx>
#endif
#ifndef _TRANSFER_HXX
#include <svtools/transfer.hxx>
#endif

struct FmGridHeaderData;
class FmGridHeader
			:public ::svt::EditBrowserHeader
			,public DropTargetHelper
{
protected:
	FmGridHeaderData*		m_pImpl;

public:
	FmGridHeader( BrowseBox* pParent, WinBits nWinBits = WB_STDHEADERBAR | WB_DRAG );
	~FmGridHeader();

protected:
	virtual void Command( const CommandEvent& rCEvt );
	virtual void RequestHelp( const HelpEvent& rHEvt );

	virtual void Select();

	sal_uInt16 GetModelColumnPos(sal_uInt16 nId) const;

	virtual void	PreExecuteColumnContextMenu(sal_uInt16 nColId, PopupMenu& rMenu);

	virtual	void	PostExecuteColumnContextMenu(sal_uInt16 nColId, const PopupMenu& rMenu, sal_uInt16 nExecutionResult);

	virtual sal_Int8	AcceptDrop( const AcceptDropEvent& rEvt );
	virtual sal_Int8	ExecuteDrop( const ExecuteDropEvent& rEvt );

private:
	DECL_LINK( OnAsyncExecuteDrop, void* );
};

class FmGridControl : public DbGridControl

{
	friend class FmGridHeader;
	friend class FmXGridPeer;

	FmXGridPeer*		m_pPeer;
	sal_uInt16			m_nMarkedColumnId;
	sal_Bool			m_bInColumnMove	: 1;

public:
	FmGridControl(
		::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory >,
		Window* pParent,
		FmXGridPeer* _pPeer,
		WinBits nBits);

	void SAL_CALL propertyChange(const ::com::sun::star::beans::PropertyChangeEvent& evt);

	void positioned(const ::com::sun::star::lang::EventObject& rEvent);

	sal_Bool commit();

	void inserted(const ::com::sun::star::lang::EventObject& rEvent);

	void restored(const ::com::sun::star::lang::EventObject& rEvent);

	void markColumn(sal_uInt16 nId);
	sal_Bool isColumnMarked(sal_uInt16 nId) const;

protected:
	virtual BrowserHeader* imp_CreateHeaderBar(BrowseBox* pParent);
	virtual void ColumnResized(sal_uInt16 nId);
	virtual void ColumnMoved(sal_uInt16 nId);
	virtual void DeleteSelectedRows();
	virtual void SetDesignMode(sal_Bool bMode);
	virtual void CellModified();
	virtual void HideColumn(sal_uInt16 nId);
	virtual void ShowColumn(sal_uInt16 nId);

	sal_Bool	IsInColumnMove() const {return m_bInColumnMove;}

	virtual void BeginCursorAction();
	virtual void EndCursorAction();

	virtual void InitColumnsByModels(const ::com::sun::star::uno::Reference< ::com::sun::star::container::XIndexContainer >& xColumns);

	virtual void InitColumnsByFields(const ::com::sun::star::uno::Reference< ::com::sun::star::container::XIndexAccess >& xFields);

	FmXGridPeer* GetPeer() const {return m_pPeer;}

	::com::sun::star::uno::Sequence< ::com::sun::star::uno::Any>
			getSelectionBookmarks();
	sal_Bool selectBookmarks(const ::com::sun::star::uno::Sequence< ::com::sun::star::uno::Any>& _rBookmarks);
};

#endif 

