

#ifndef _SVX_GRAFCTRL_HXX
#define _SVX_GRAFCTRL_HXX

#ifndef _SFXLSTNER_HXX 
#include <svtools/lstner.hxx>
#endif
#ifndef _SFXINTITEM_HXX
#include <svtools/intitem.hxx>
#endif
#ifndef _SFXTBXCTRL_HXX 
#include <sfx2/tbxctrl.hxx>
#endif

class TbxImageItem : public SfxUInt16Item
{
public:
				TYPEINFO();
				TbxImageItem( USHORT nWhich = 0, UINT16 nImage = 0 );

	virtual SfxPoolItem*	Clone( SfxItemPool* pPool = 0 ) const;
	virtual int 			operator==( const SfxPoolItem& ) const;
};

class SvxGrafFilterToolBoxControl : public SfxToolBoxControl
{
public:
						SFX_DECL_TOOLBOX_CONTROL();
						SvxGrafFilterToolBoxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind );
					~SvxGrafFilterToolBoxControl();

	virtual void				StateChanged( USHORT nSID, SfxItemState eState, const SfxPoolItem* pState );
	virtual SfxPopupWindowType	GetPopupWindowType() const;
	virtual SfxPopupWindow*		CreatePopupWindow();
};

class SvxGrafToolBoxControl : public SfxToolBoxControl, public SfxListener
{
public:
				SFX_DECL_TOOLBOX_CONTROL();
			SvxGrafToolBoxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind );
			~SvxGrafToolBoxControl();

	virtual void		StateChanged( USHORT nSID, SfxItemState eState, const SfxPoolItem* pState );
	virtual Window*		CreateItemWindow( Window *pParent );
	virtual void 		SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCType,
						const SfxHint& rHint, const TypeId& rHintType );
};

class SvxGrafRedToolBoxControl : public SvxGrafToolBoxControl
{
public:
			SFX_DECL_TOOLBOX_CONTROL();
			SvxGrafRedToolBoxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind );
};

class SvxGrafGreenToolBoxControl : public SvxGrafToolBoxControl
{
public:
			SFX_DECL_TOOLBOX_CONTROL();
			SvxGrafGreenToolBoxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind );
};

class SvxGrafBlueToolBoxControl : public SvxGrafToolBoxControl
{
public:
			SFX_DECL_TOOLBOX_CONTROL();
			SvxGrafBlueToolBoxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind );
};

class SvxGrafLuminanceToolBoxControl : public SvxGrafToolBoxControl
{
public:
			SFX_DECL_TOOLBOX_CONTROL();
			SvxGrafLuminanceToolBoxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind );
};

class SvxGrafContrastToolBoxControl : public SvxGrafToolBoxControl
{
public:
			SFX_DECL_TOOLBOX_CONTROL();
			SvxGrafContrastToolBoxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind );
};

class SvxGrafGammaToolBoxControl : public SvxGrafToolBoxControl
{
public:
			SFX_DECL_TOOLBOX_CONTROL();
			SvxGrafGammaToolBoxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind );
};

class SvxGrafTransparenceToolBoxControl : public SvxGrafToolBoxControl
{
public:
			SFX_DECL_TOOLBOX_CONTROL();
			SvxGrafTransparenceToolBoxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind );
};

class SvxGrafModeToolBoxControl : public SfxToolBoxControl, public SfxListener
{
public:
			SFX_DECL_TOOLBOX_CONTROL();
			SvxGrafModeToolBoxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind );
			~SvxGrafModeToolBoxControl();

	virtual void		StateChanged( USHORT nSID, SfxItemState eState, const SfxPoolItem* pState );
	virtual Window*		CreateItemWindow( Window *pParent );
	virtual void 		SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCType,
						const SfxHint& rHint, const TypeId& rHintType );
};

class SdrView;
class SfxRequest;

class SvxGrafAttrHelper
{
public:

	static void		ExecuteGrafAttr( SfxRequest& rReq, SdrView& rView );
	static void		GetGrafAttrState( SfxItemSet& rSet, SdrView& rView );
};

#endif 
