
#ifndef _SVX_HDFT_HXX
#define _SVX_HDFT_HXX

#ifndef _SFXTABDLG_HXX 
#include <sfx2/tabdlg.hxx>
#endif

#ifndef _FIXED_HXX 
#include <vcl/fixed.hxx>
#endif

#ifndef _FIELD_HXX 
#include <vcl/field.hxx>
#endif

#ifndef _GROUP_HXX 
#include <vcl/group.hxx>
#endif

#ifndef _SVX_PAGECTRL_HXX 
#include <svx/pagectrl.hxx>
#endif

class SvxHFPage: public SfxTabPage
{
public:

	virtual BOOL 	FillItemSet( SfxItemSet& rOutSet );
	virtual void	Reset( const SfxItemSet& rSet );

	virtual 		~SvxHFPage();

	void			DisableDeleteQueryBox() { bDisableQueryBox = TRUE; }
	void			EnableBackgroundSelector( BOOL bNew ) { bEnableBackgroundSelector = bNew; }

protected:
	virtual void	ActivatePage( const SfxItemSet& rSet );
	virtual int		DeactivatePage( SfxItemSet* pSet = 0 );

	SvxHFPage( Window* pParent, USHORT nResId, const SfxItemSet& rSet,
	  USHORT nSetId );

	CheckBox        aTurnOnBox;
	CheckBox        aCntSharedBox;
	FixedText       aLMLbl;
	MetricField     aLMEdit;
	FixedText       aRMLbl;
	MetricField     aRMEdit;
	FixedText		aDistFT;
	MetricField     aDistEdit;
	FixedText		aHeightFT;
	MetricField     aHeightEdit;
	CheckBox     	aHeightDynBtn;
	FixedLine       aFrm;
	SvxPageWindow	aBspWin;
	PushButton		aBackgroundBtn;

	USHORT			nId;
	SfxItemSet*		pBBSet;
	BOOL			bDisableQueryBox;
	BOOL			bEnableBackgroundSelector;
	FASTBOOL		bInReset;

	void 			InitHandler();
	DECL_LINK( TurnOnHdl, CheckBox*);
	DECL_LINK( DistModify, MetricField*);
	DECL_LINK( HeightModify, MetricField*);
	DECL_LINK( BorderModify, MetricField*);
	DECL_LINK( BackgroundHdl, Button*);

	void			UpdateExample();
	DECL_LINK( RangeHdl, Edit*);

private:
#ifdef _SVX_HDFT_CXX
	void			ResetBackground_Impl( const SfxItemSet& rSet );
#endif
};

class SvxHeaderPage : public SvxHFPage
{
public:
	static SfxTabPage* 	Create(	Window* pParent, const SfxItemSet& rSet );
	static USHORT*		GetRanges();

private:
	SvxHeaderPage( Window* pParent, const SfxItemSet& rSet );
};

class SvxFooterPage : public SvxHFPage
{
public:
	static SfxTabPage* 	Create(	Window* pParent, const SfxItemSet& rSet );
	static USHORT*		GetRanges();

private:
	SvxFooterPage( 	Window* pParent, const SfxItemSet& rSet );
};

#endif

