

#ifndef _SVX_TAB_HYPERLINK_HXX
#define _SVX_TAB_HYPERLINK_HXX

#ifndef _SVX_HLNKITEM_HXX
#include <svx/hlnkitem.hxx>
#endif
#ifndef _SFX_CHILDWIN_HXX
#include <sfx2/childwin.hxx>
#endif
#ifndef _SFXCTRLITEM_HXX
#include <sfx2/ctrlitem.hxx>
#endif
#ifndef _SFX_BINDINGS_HXX 
#include <sfx2/bindings.hxx>
#endif

#ifndef _SV_IMAGE_HXX
#include <vcl/image.hxx>
#endif

#include <svx/iconcdlg.hxx>

class SvxHpLinkDlg;
class SvxHlinkCtrl : public SfxControllerItem
{
private :
	SvxHpLinkDlg *pParent;

	SfxStatusForwarder aOnlineForwarder;
	SfxStatusForwarder aRdOnlyForwarder;

public :
	SvxHlinkCtrl( USHORT nId, SfxBindings & rBindings, SvxHpLinkDlg* pDlg);

	virtual void	StateChanged( USHORT nSID, SfxItemState eState,
					const SfxPoolItem* pState );
};

class SvxHlinkDlgWrapper : public SfxChildWindow
{
public:
	SvxHlinkDlgWrapper( Window*pParent, USHORT nId,
			SfxBindings* pBindings, SfxChildWinInfo* pInfo );

	SFX_DECL_CHILDWINDOW(SvxHlinkDlgWrapper);
};

class SvxHpLinkDlg : public IconChoiceDialog
{
private:
	SvxHlinkCtrl		maCtrl;			
	SfxBindings*		mpBindings;
	SfxItemSet*			mpItemSet;
	 sal_Bool            mbDummy1    : 1;
	sal_Bool            mbDummy2    : 1;
	sal_Bool            mbDummy3    : 1;
	sal_Bool            mbDummy4    : 1;
	sal_Bool            mbDummy5    : 1;
	sal_Bool            mbDummy6    : 1;
	sal_Bool            mbReadOnly  : 1;
	sal_Bool            mbIsHTMLDoc : 1;
	 void*               mpDummy1;
	void*               mpDummy2;

	DECL_LINK (ClickApplyHdl_Impl, void * );
	DECL_LINK (ClickCloseHdl_Impl, void * );

protected:
	virtual BOOL	Close();
	virtual void	Move();

public:
	SvxHpLinkDlg (Window* pParent, SfxBindings* pBindings );
	~SvxHpLinkDlg ();

	USHORT SetPage( SvxHyperlinkItem* pItem );
	void   EnableInetBrowse( sal_Bool bEnable = sal_True );
	void   SetReadOnlyMode( sal_Bool bReadOnly = sal_False );
	const BOOL IsHTMLDoc() const { return mbIsHTMLDoc; }

	SfxDispatcher* GetDispatcher() const { return mpBindings->GetDispatcher(); }
};

#endif 
