

#ifndef _IMAPDLG_HXX_
#define _IMAPDLG_HXX_

#ifndef _SFX_CHILDWIN_HXX 
#include <sfx2/childwin.hxx>
#endif

#ifndef _SFXCTRLITEM_HXX 
#include <sfx2/ctrlitem.hxx>
#endif

#ifndef _BASEDLGS_HXX 
#include <sfx2/basedlgs.hxx>
#endif

#ifndef _FIXED_HXX 
#include <vcl/fixed.hxx>
#endif

#ifndef _COMBOBOX_HXX 
#include <vcl/combobox.hxx>
#endif

#ifndef _EDIT_HXX 
#include <vcl/edit.hxx>
#endif

#ifndef _TOOLBOX_HXX 
#include <vcl/toolbox.hxx>
#endif

#ifndef _STATUS_HXX 
#include <vcl/status.hxx>
#endif

#ifndef _GOMISC_HXX
class ImageMap;
#endif

class Graphic;
class TargetList;

class SvxIMapDlgChildWindow : public SfxChildWindow
{
 public:

	SvxIMapDlgChildWindow( Window*, USHORT, SfxBindings*, SfxChildWinInfo* );

	SFX_DECL_CHILDWINDOW( SvxIMapDlgChildWindow );

	static void UpdateIMapDlg( const Graphic& rGraphic, const ImageMap* pImageMap = NULL,
				   const TargetList* pTargetList = NULL, void* pEditingObj = NULL );
};

#ifndef _REDUCED_IMAPDLG_HXX_
#define _REDUCED_IMAPDLG_HXX_

class SvxIMapDlg;

class SvxIMapDlgItem : public SfxControllerItem
{
	SvxIMapDlg&	rIMap;

protected:

	virtual void StateChanged( USHORT nSID, SfxItemState eState,
				   const SfxPoolItem* pState );

public:

	SvxIMapDlgItem( USHORT nId, SvxIMapDlg& rIMapDlg, SfxBindings& rBindings );
};

class IMapOwnData;

class SvxIMapDlg : public SfxFloatingWindow
{
	friend class IMapOwnData;
	friend class IMapWindow;

	Size				aLastSize;
	IMapWindow*			pIMapWnd;
	IMapOwnData*		pOwnData;
	void*				pCheckObj;
	SvxIMapDlgItem		aIMapItem;

	ToolBox				aTbxIMapDlg1;
	StatusBar			aStbStatus;
	FixedText			aFtURL;
	FixedText			aFtText;
	ComboBox			aCbbURL;
	Edit				aEdtText;

	virtual	void		Resize();
	virtual BOOL 		Close();

#ifdef _IMAPDLG_PRIVATE
				DECL_LINK( TbxClickHdl, ToolBox* );
			DECL_LINK( InfoHdl, IMapWindow* );
			DECL_LINK( MousePosHdl, IMapWindow* );
			DECL_LINK( GraphSizeHdl, IMapWindow* );
			DECL_LINK( URLModifyHdl, void* );
			DECL_LINK( URLLoseFocusHdl, void* );
			DECL_LINK( UpdateHdl, Timer* );
			DECL_LINK( TbxUpdateHdl, Timer* );
			DECL_LINK( StateHdl, IMapWindow* );

	void				DoOpen();
	BOOL				DoSave();

#endif

public:
				SvxIMapDlg( SfxBindings *pBindings, SfxChildWindow *pCW,
						Window* pParent, const ResId& rResId );
			~SvxIMapDlg();

	void				SetExecState( BOOL bEnable );

	void				SetGraphic( const Graphic& rGraphic );

	void				SetEditingObject( void* pObj ) { pCheckObj = pObj; }
	const void*			GetEditingObject() const { return pCheckObj; }

	void				SetImageMap( const ImageMap& rImageMap );
	const ImageMap&		GetImageMap() const;

	void				SetTargetList( const TargetList& rTargetList );
	const TargetList&	GetTargetList() const;

	void				Update( const Graphic& rGraphic, const ImageMap* pImageMap = NULL,
					const TargetList* pTargetList = NULL, void* pEditingObj = NULL );
};

#define SVXIMAPDLG() ( (SvxIMapDlg*) ( SfxViewFrame::Current()->GetChildWindow( 		\
			SvxIMapDlgChildWindow::GetChildWindowId() )-> 	\
			GetWindow() ) )

#endif 
#endif 

