
#ifndef _SVX_ITEMTYPE_HXX
#define _SVX_ITEMTYPE_HXX

#ifndef _SVXITEMS_HRC
#include <svx/svxitems.hrc>
#endif

#ifndef _STRING_HXX 
#include <tools/string.hxx>
#endif
#ifndef _TOOLS_RESID_HXX 
#include <tools/resid.hxx>
#endif
#ifndef _BIGINT_HXX 
#include <tools/bigint.hxx>
#endif
#ifndef _SVX_DIALMGR_HXX 
#include <svx/dialmgr.hxx>
#endif
#ifndef _SFXPOOLITEM_HXX 
#include <svtools/poolitem.hxx>
#endif
#ifndef _SHL_HXX 
#include <tools/shl.hxx>
#endif

#ifndef VCL
#ifndef _SV_COLOR_HXX 
#include <vcl/color.hxx>
#endif
#else
class Color;
#endif

class XColorTable;

static const sal_Unicode cDelim = ',';
static const sal_Unicode cpDelim[] = { ',' , ' ', '\0' };

String GetSvxString( USHORT nId );
String GetMetricText( long nVal, SfxMapUnit eSrcUnit, SfxMapUnit eDestUnit );
#ifndef SVX_LIGHT
String GetColorString( const Color& rCol );
#endif
USHORT GetMetricId( SfxMapUnit eUnit );

inline String GetBoolString( BOOL bVal )
{
	return String( ResId( bVal ? RID_SVXITEMS_TRUE
				   : RID_SVXITEMS_FALSE, DIALOG_MGR() ) );
}

#ifndef VCL

inline Color LongToColor( long nCol )
{
	return Color( (USHORT)((nCol >> 8) & 0xFF00 ),
	  (USHORT)(nCol & 0xFF00 ),
	  (USHORT)((nCol & 0xFF)<<8 ) );
}

inline long ColorToLong( const Color &rCol )
{
	long nRet = (( rCol.GetRed() ) & 0xff00) + (rCol.GetGreen() >> 8);
	nRet <<= 8;
	return nRet += rCol.GetBlue() >> 8;
}
#endif

inline long Scale( long nVal, long nMult, long nDiv )
{
	BigInt aVal( nVal );
	aVal *= nMult;
	aVal += nDiv/2;
	aVal /= nDiv;
	return aVal;
}

#endif

