
#ifndef _SVX_LABDLG_HXX
#define _SVX_LABDLG_HXX

#ifndef _FIELD_HXX 
#include <vcl/field.hxx>
#endif
#ifndef _LSTBOX_HXX 
#include <vcl/lstbox.hxx>
#endif
#ifndef _FIXED_HXX 
#include <vcl/fixed.hxx>
#endif
#ifndef _VALUESET_HXX 
#include <svtools/valueset.hxx>
#endif
#ifndef _SFXTABDLG_HXX 
#include <sfx2/tabdlg.hxx>
#endif
class SdrView;

class SvxCaptionTabPage : public SfxTabPage
{
private:
	ValueSet		aCT_CAPTTYPE;
	FixedText		aFT_ABSTAND;
	MetricField		aMF_ABSTAND;
	FixedText		aFT_WINKEL;
	ListBox			aLB_WINKEL;
	FixedText		aFT_ANSATZ;
	ListBox			aLB_ANSATZ;
	FixedText		aFT_UM;
	MetricField		aMF_ANSATZ;
	FixedText		aFT_ANSATZ_REL;
	ListBox			aLB_ANSATZ_REL;
	FixedText		aFT_LAENGE;
	MetricField		aMF_LAENGE;
	CheckBox		aCB_LAENGE;

	String			aStrHorzList;
	String			aStrVertList;

	short			nCaptionType;
	BOOL			bFixedAngle;
	INT32			nFixedAngle;
	INT32			nGap;
	short			nEscDir;
	BOOL			bEscRel;
	INT32			nEscAbs;
	INT32			nEscRel;
	INT32			nLineLen;
	BOOL			bFitLineLen;

	USHORT			nAnsatzRelPos;
	USHORT			nAnsatzTypePos;
	USHORT			nWinkelTypePos;

#ifdef _SVX_LABDLG_CXX
	void			SetupAnsatz_Impl( USHORT nType );
	void			SetupType_Impl( USHORT nType );
	DECL_LINK( AnsatzSelectHdl_Impl, ListBox * );
	DECL_LINK( AnsatzRelSelectHdl_Impl, ListBox * );
	DECL_LINK( LineOptHdl_Impl, Button * );
	DECL_LINK( SelectCaptTypeHdl_Impl, void * );
#endif

	const SfxItemSet&	rOutAttrs;
	const SdrView*		pView;

public:
	SvxCaptionTabPage( Window* pParent, const SfxItemSet& rInAttrs  );

	static SfxTabPage*	Create( Window*, const SfxItemSet& );
	static USHORT*		GetRanges();

	virtual BOOL 		FillItemSet( SfxItemSet& );
	virtual void 		Reset( const SfxItemSet & );
	void				Construct();
	void				SetView( const SdrView* pSdrView )
				{ pView = pSdrView; }
};

class SvxCaptionTabDialog : public SfxTabDialog
{
private:

	const SdrView*		pView;
	USHORT				nAnchorCtrls;

	virtual void		PageCreated( USHORT nId, SfxTabPage &rPage );

public:
	SvxCaptionTabDialog(Window* pParent, const SdrView* pView,
						USHORT nAnchorTypes = 0 );
	~SvxCaptionTabDialog();
};

#endif 

