

#ifndef _E3D_LIGHT3D_HXX
#define _E3D_LIGHT3D_HXX

#ifndef _E3D_PNTOBJ3D_HXX
#include <svx/pntobj3d.hxx>
#endif

class E3dLight;

#ifndef _E3D_LIGHT3D_LIST
DECLARE_LIST(E3dLightList, E3dLight*);
#endif

class E3dLight : public E3dPointObj
{
 private:
	Color		aColor;
	double		fIntensity;
	double		fRed, fGreen, fBlue;

	FASTBOOL	bOn				: 1;
	FASTBOOL	bVisible		: 1;

 protected:
	FASTBOOL ImpCalcLighting(Color& rNewColor, const Color& rPntColor,
				 double fR, double fG, double fB) const;

	virtual void Insert3DObj(E3dObject* p3DObj);

	virtual void CreateLightObj();

 public:
	TYPEINFO();
	E3dLight(const Vector3D& rPos, const Color& rColor,
	double fLightIntensity = 1.0);
	E3dLight();

	virtual UINT16 GetObjIdentifier() const;

	virtual FASTBOOL CalcLighting(Color& rNewColor,
					  const Vector3D& rPnt,
					  const Vector3D& rPntNormal,
					  const Color& rPntColor);

	virtual void SetPosition(const Vector3D& rNewPos);

	double GetIntensity() const { return fIntensity; }
	virtual void SetIntensity(double fNew);

	const Color& GetColor() const { return aColor; }
	virtual void SetColor(const Color& rNewColor);

	FASTBOOL IsOn() const { return bOn; }
	void SetOn(FASTBOOL bNewOn = TRUE);

	FASTBOOL IsLightObjVisible() const { return bVisible; }
	void SetLightObjVisible(FASTBOOL bNewVisible = TRUE);

	double GetRed() const	{ return fRed; }
	double GetGreen() const	{ return fGreen; }
	double GetBlue() const	{ return fBlue; }

	virtual void WriteData(SvStream& rOut) const;
	virtual void ReadData(const SdrObjIOHeader& rHead, SvStream& rIn);

	virtual void operator=(const SdrObject& rObj);

	virtual void           NbcSetStyleSheet(SfxStyleSheet* pNewStyleSheet, FASTBOOL bDontRemoveHardAttr);
	virtual void           SetStyleSheet(SfxStyleSheet* pNewStyleSheet, FASTBOOL bDontRemoveHardAttr);
	virtual SfxStyleSheet* GetStyleSheet() const;
};

#endif			
