
#ifndef _SVX_LINECTRL_HXX
#define _SVX_LINECTRL_HXX

#ifndef _VALUESET_HXX 
#include <svtools/valueset.hxx>
#endif
#ifndef _SFXLSTNER_HXX 
#include <svtools/lstner.hxx>
#endif
#ifndef _SFXTBXCTRL_HXX 
#include <sfx2/tbxctrl.hxx>
#endif
class XLineStyleItem;
class XLineDashItem;
class SvxLineBox;
class SvxMetricField;
class SvxColorBox;
class XLineEndList;

class SvxLineStyleToolBoxControl : public SfxToolBoxControl, public SfxListener
{
private:
	XLineStyleItem*		pStyleItem;
	XLineDashItem* 		pDashItem;

	SfxStatusForwarder	aDashForwarder;
	BOOL				bUpdate;

public:
	SFX_DECL_TOOLBOX_CONTROL();

	SvxLineStyleToolBoxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind );
	~SvxLineStyleToolBoxControl();

	virtual void		StateChanged( USHORT nSID, SfxItemState eState,
						  const SfxPoolItem* pState );
	virtual void 		SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCType,
					const SfxHint& rHint, const TypeId& rHintType );
	virtual Window*		CreateItemWindow( Window *pParent );
};

class SvxLineWidthToolBoxControl : public SfxToolBoxControl, public SfxListener
{
public:
	SFX_DECL_TOOLBOX_CONTROL();

	SvxLineWidthToolBoxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind );
	~SvxLineWidthToolBoxControl();

	virtual void		StateChanged( USHORT nSID, SfxItemState eState,
						  const SfxPoolItem* pState );
	virtual void 		SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCType,
					const SfxHint& rHint, const TypeId& rHintType );
	virtual Window*		CreateItemWindow( Window *pParent );
};

class SvxLineColorToolBoxControl : public SfxToolBoxControl, public SfxListener
{
public:
	SFX_DECL_TOOLBOX_CONTROL();

	SvxLineColorToolBoxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind );
	~SvxLineColorToolBoxControl();

	virtual void		StateChanged( USHORT nSID, SfxItemState eState,
						  const SfxPoolItem* pState );
	virtual void 		SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCType,
					const SfxHint& rHint, const TypeId& rHintType );
	virtual Window*		CreateItemWindow( Window *pParent );
};

class SvxLineEndWindow : public SfxPopupWindow, public SfxListener
{
private:
	XLineEndList*	pLineEndList;
	ValueSet		aLineEndSet;
	USHORT			nCols;
	USHORT			nLines;
	ULONG 			nLineEndWidth;
	Size			aBmpSize;
	BOOL			bPopupMode;

	DECL_LINK( SelectHdl, void * );
	void			FillValueSet();
	void 			SetSize();

protected:
	virtual void	Resizing( Size& rSize );
	virtual void    Resize();
	virtual BOOL	Close();
	virtual void	PopupModeEnd();

public:
	SvxLineEndWindow( USHORT nId, const String& rWndTitle,
		  SfxBindings& rBindings );
	~SvxLineEndWindow();

	void            StartSelection();

	virtual void 	SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCType,
				const SfxHint& rHint, const TypeId& rHintType );
	virtual SfxPopupWindow* Clone() const;
};

class SvxLineEndToolBoxControl : public SfxToolBoxControl
{
public:
	SFX_DECL_TOOLBOX_CONTROL();
	SvxLineEndToolBoxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBindings );
	~SvxLineEndToolBoxControl();

	virtual void				StateChanged( USHORT nSID, SfxItemState eState,
								  const SfxPoolItem* pState );
	virtual SfxPopupWindowType	GetPopupWindowType() const;
	virtual SfxPopupWindow*		CreatePopupWindow();
};

#endif

