
#ifndef _SVX_MEASURE_HXX
#define _SVX_MEASURE_HXX

#ifndef _SV_FIXED_HXX
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_GROUP_HXX
#include <vcl/group.hxx>
#endif
#ifndef _BASEDLGS_HXX
#include <sfx2/basedlgs.hxx>
#endif
#ifndef _SVX_DLGCTRL_HXX
#include <svx/dlgctrl.hxx>
#endif
#ifndef _SVX_MEASCTRL_HXX
#include <svx/measctrl.hxx>
#endif

class SdrView;

class SvxMeasurePage : public SvxTabPage
{
private:

	FixedLine			aFlLine;
	FixedText			aFtLineDist;
	MetricField			aMtrFldLineDist;
	FixedText			aFtHelplineOverhang;
	MetricField			aMtrFldHelplineOverhang;
	FixedText			aFtHelplineDist;
	MetricField			aMtrFldHelplineDist;
	FixedText			aFtHelpline1Len;
	MetricField			aMtrFldHelpline1Len;
	FixedText			aFtHelpline2Len;
	MetricField			aMtrFldHelpline2Len;
	TriStateBox 		aTsbBelowRefEdge;

	FixedLine			aFlLabel;
	FixedText           aFtPosition;
	SvxRectCtl			aCtlPosition;
	TriStateBox 		aTsbAutoPosV;
	TriStateBox 		aTsbAutoPosH;
	TriStateBox 		aTsbShowUnit;
	ListBox				aLbUnit;
	TriStateBox 		aTsbParallel;

	SvxXMeasurePreview	aCtlPreview;
	 FixedLine           aFlVert;

	const SfxItemSet&	rOutAttrs;
	SfxItemSet			aAttrSet;
	const SdrView*		pView;
	SfxMapUnit			eUnit;

	BOOL				bPositionModified;

#ifdef _SVX_MEASURE_CXX
	void 				FillUnitLB();

	DECL_LINK( ClickAutoPosHdl_Impl, void * );
	DECL_LINK( ChangeAttrHdl_Impl, void * );
#endif

public:

	SvxMeasurePage( Window* pWindow, const SfxItemSet& rInAttrs );
	~SvxMeasurePage();

	static SfxTabPage* 	Create( Window*, const SfxItemSet& );
	static  USHORT*	    GetRanges();

	virtual BOOL 		FillItemSet( SfxItemSet& );
	virtual void 		Reset( const SfxItemSet & );

	virtual void 		PointChanged( Window* pWindow, RECT_POINT eRP );

	void 		 Construct();
	void		 SetView( const SdrView* pSdrView ) { pView = pSdrView; }
};

class SvxMeasureDialog : public SfxSingleTabDialog
{
public:
	SvxMeasureDialog( Window* pParent, const SfxItemSet& rAttr,
		   const SdrView* pView );
	~SvxMeasureDialog();
};

#endif 

