

#ifndef _MSDFFDEF_HXX
#define _MSDFFDEF_HXX

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif
#ifndef _STREAM_HXX
#include <tools/stream.hxx>
#endif
#ifndef _TABLE_HXX
#include <tools/table.hxx>
#endif
#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif
#ifndef _GEN_HXX
#include <tools/gen.hxx>
#endif

#define DFF_COMMON_RECORD_HEADER_SIZE			8

#define DFF_PSFLAG_CONTAINER 0x0F         

#define DFF_PST_Unknown                        0
#define DFF_PST_SubContainerCompleted          1
#define DFF_PST_IRRAtom                        2
#define DFF_PST_PSS                            3
#define DFF_PST_SubContainerException          4
#define DFF_PST_ClientSignal1                  6
#define DFF_PST_ClientSignal2                  7
#define DFF_PST_PowerPointStateInfoAtom       10
#define DFF_PST_Document                    1000
#define DFF_PST_DocumentAtom                1001
#define DFF_PST_EndDocument                 1002
#define DFF_PST_SlidePersist                1003
#define DFF_PST_SlideBase                   1004
#define DFF_PST_SlideBaseAtom               1005
#define DFF_PST_Slide                       1006
#define DFF_PST_SlideAtom                   1007
#define DFF_PST_Notes                       1008
#define DFF_PST_NotesAtom                   1009
#define DFF_PST_Environment                 1010
#define DFF_PST_SlidePersistAtom            1011
#define DFF_PST_Scheme                      1012
#define DFF_PST_SchemeAtom                  1013
#define DFF_PST_DocViewInfo                 1014
#define DFF_PST_SslideLayoutAtom            1015
#define DFF_PST_MainMaster                  1016
#define DFF_PST_SSSlideInfoAtom             1017
#define DFF_PST_SlideViewInfo               1018
#define DFF_PST_GuideAtom                   1019
#define DFF_PST_ViewInfo                    1020
#define DFF_PST_ViewInfoAtom                1021
#define DFF_PST_SlideViewInfoAtom           1022
#define DFF_PST_VBAInfo                     1023
#define DFF_PST_VBAInfoAtom                 1024
#define DFF_PST_SSDocInfoAtom               1025
#define DFF_PST_Summary                     1026
#define DFF_PST_Texture                     1027
#define DFF_PST_VBASlideInfo                1028
#define DFF_PST_VBASlideInfoAtom            1029
#define DFF_PST_DocRoutingSlip              1030
#define DFF_PST_OutlineViewInfo             1031
#define DFF_PST_SorterViewInfo              1032
#define DFF_PST_ExObjList                   1033
#define DFF_PST_ExObjListAtom               1034
#define DFF_PST_PPDrawingGroup              1035
#define DFF_PST_PPDrawing                   1036
#define DFF_PST_NamedShows                  1040
#define DFF_PST_NamedShow                   1041
#define DFF_PST_NamedShowSlides             1042
#define DFF_PST_List                        2000
#define DFF_PST_FontCollection              2005
#define DFF_PST_ListPlaceholder             2017
#define DFF_PST_BookmarkCollection          2019
#define DFF_PST_SoundCollection             2020
#define DFF_PST_SoundCollAtom               2021
#define DFF_PST_Sound                       2022
#define DFF_PST_SoundData                   2023
#define DFF_PST_BookmarkSeedAtom            2025
#define DFF_PST_GuideList                   2026
#define DFF_PST_RunArray                    2028
#define DFF_PST_RunArrayAtom                2029
#define DFF_PST_ArrayElementAtom            2030
#define DFF_PST_Int4ArrayAtom               2031
#define DFF_PST_ColorSchemeAtom             2032
#define DFF_PST_OEShape                     3008
#define DFF_PST_ExObjRefAtom                3009
#define DFF_PST_OEPlaceholderAtom           3011
#define DFF_PST_GrColor                     3020
#define DFF_PST_GrectAtom                   3025
#define DFF_PST_GratioAtom                  3031
#define DFF_PST_Gscaling                    3032
#define DFF_PST_GpointAtom                  3034
#define DFF_PST_OEShapeAtom                 3035
#define DFF_PST_OutlineTextRefAtom          3998
#define DFF_PST_TextHeaderAtom              3999
#define DFF_PST_TextCharsAtom               4000
#define DFF_PST_StyleTextPropAtom           4001
#define DFF_PST_BaseTextPropAtom            4002
#define DFF_PST_TxMasterStyleAtom           4003
#define DFF_PST_TxCFStyleAtom               4004
#define DFF_PST_TxPFStyleAtom               4005
#define DFF_PST_TextRulerAtom               4006
#define DFF_PST_TextBookmarkAtom            4007
#define DFF_PST_TextBytesAtom               4008
#define DFF_PST_TxSIStyleAtom               4009
#define DFF_PST_TextSpecInfoAtom            4010
#define DFF_PST_DefaultRulerAtom            4011
#define DFF_PST_FontEntityAtom              4023
#define DFF_PST_FontEmbedData               4024
#define DFF_PST_TypeFace                    4025
#define DFF_PST_CString                     4026
#define DFF_PST_ExternalObject              4027
#define DFF_PST_MetaFile                    4033
#define DFF_PST_ExOleObj                    4034
#define DFF_PST_ExOleObjAtom                4035
#define DFF_PST_ExPlainLinkAtom             4036
#define DFF_PST_CorePict                    4037
#define DFF_PST_CorePictAtom                4038
#define DFF_PST_ExPlainAtom                 4039
#define DFF_PST_SrKinsoku                   4040
#define DFF_PST_Handout                     4041
#define DFF_PST_ExEmbed                     4044
#define DFF_PST_ExEmbedAtom                 4045
#define DFF_PST_ExLink                      4046
#define DFF_PST_ExLinkAtom_old              4047
#define DFF_PST_BookmarkEntityAtom          4048
#define DFF_PST_ExLinkAtom                  4049
#define DFF_PST_SrKinsokuAtom               4050
#define DFF_PST_ExHyperlinkAtom             4051
#define DFF_PST_ExPlain                     4053
#define DFF_PST_ExPlainLink                 4054
#define DFF_PST_ExHyperlink                 4055
#define DFF_PST_SlideNumberMCAtom           4056
#define DFF_PST_HeadersFooters              4057
#define DFF_PST_HeadersFootersAtom          4058
#define DFF_PST_RecolorEntryAtom            4062
#define DFF_PST_TxInteractiveInfoAtom       4063
#define DFF_PST_EmFormatAtom                4065
#define DFF_PST_CharFormatAtom              4066
#define DFF_PST_ParaFormatAtom              4067
#define DFF_PST_MasterText                  4068
#define DFF_PST_RecolorInfoAtom             4071
#define DFF_PST_ExQuickTime                 4073
#define DFF_PST_ExQuickTimeMovie            4074
#define DFF_PST_ExQuickTimeMovieData        4075
#define DFF_PST_ExSubscription              4076
#define DFF_PST_ExSubscriptionSection       4077
#define DFF_PST_ExControl                   4078
#define DFF_PST_ExControlAtom               4091
#define DFF_PST_SlideListWithText           4080
#define DFF_PST_AnimationInfoAtom           4081
#define DFF_PST_InteractiveInfo             4082
#define DFF_PST_InteractiveInfoAtom         4083
#define DFF_PST_SlideList                   4084
#define DFF_PST_UserEditAtom                4085
#define DFF_PST_CurrentUserAtom             4086
#define DFF_PST_DateTimeMCAtom              4087
#define DFF_PST_GenericDateMCAtom           4088
#define DFF_PST_HeaderMCAtom                4089
#define DFF_PST_FooterMCAtom                4090
#define DFF_PST_ExMediaAtom                 4100
#define DFF_PST_ExVideo                     4101
#define DFF_PST_ExAviMovie                  4102
#define DFF_PST_ExMCIMovie                  4103
#define DFF_PST_ExMIDIAudio                 4109
#define DFF_PST_ExCDAudio                   4110
#define DFF_PST_ExWAVAudioEmbedded          4111
#define DFF_PST_ExWAVAudioLink              4112
#define DFF_PST_ExOleObjStg                 4113
#define DFF_PST_ExCDAudioAtom               4114
#define DFF_PST_ExWAVAudioEmbeddedAtom      4115
#define DFF_PST_AnimationInfo               4116
#define DFF_PST_RTFDateTimeMCAtom           4117
#define DFF_PST_ProgTags                    5000
#define DFF_PST_ProgStringTag               5001
#define DFF_PST_ProgBinaryTag               5002
#define DFF_PST_BinaryTagData               5003
#define DFF_PST_PrintOptions                6000
#define DFF_PST_PersistPtrFullBlock         6001
#define DFF_PST_PersistPtrIncrementalBlock  6002
#define DFF_PST_RulerIndentAtom            10000
#define DFF_PST_GscalingAtom               10001
#define DFF_PST_GrColorAtom                10002
#define DFF_PST_GLPointAtom                10003
#define DFF_PST_GlineAtom                  10004

#define DFF_msofbtDggContainer      0xF000 
#define   DFF_msofbtDgg             0xF006 
#define   DFF_msofbtCLSID           0xF016 
#define   DFF_msofbtOPT             0xF00B 
#define   DFF_msofbtColorMRU        0xF11A 
#define   DFF_msofbtSplitMenuColors 0xF11E 
#define   DFF_msofbtBstoreContainer 0xF001 
#define     DFF_msofbtBSE           0xF007 
#define     DFF_msofbtBlipFirst     0xF018 
#define     DFF_msofbtBlipLast      0xF117 

#define DFF_msofbtDgContainer       0xF002 
#define   DFF_msofbtDg              0xF008 
#define   DFF_msofbtRegroupItems    0xF118 
#define   DFF_msofbtColorScheme     0xF120 
#define   DFF_msofbtSpgrContainer   0xF003 
#define   DFF_msofbtSpContainer     0xF004 
#define     DFF_msofbtSpgr          0xF009 
#define     DFF_msofbtSp            0xF00A 

#define     DFF_msofbtTextbox       0xF00C 
#define     DFF_msofbtClientTextbox 0xF00D 
#define     DFF_msofbtAnchor        0xF00E 
#define     DFF_msofbtChildAnchor   0xF00F 
#define     DFF_msofbtClientAnchor  0xF010 
#define     DFF_msofbtClientData    0xF011 
#define     DFF_msofbtOleObject     0xF11F 
#define     DFF_msofbtDeletedPspl   0xF11D 
#define     DFF_msofbtUDefProp      0xF122 
#define   DFF_msofbtSolverContainer 0xF005 
#define     DFF_msofbtConnectorRule 0xF012 
#define     DFF_msofbtAlignRule     0xF013 
#define     DFF_msofbtArcRule       0xF014 
#define     DFF_msofbtClientRule    0xF015 
#define     DFF_msofbtCalloutRule   0xF017 

#define DFF_msofbtSelection         0xF119 

enum DFF_TextHeader {
	DFFTH_TITLE,
	DFFTH_BODY,
	DFFTH_NOTES,
	DFFTH_NOTUSED,
	DFFTH_OTHER,       
	DFFTH_CENTERBODY,  
	DFFTH_CENTERTITLE, 
	DFFTH_HALFBODY,    
	DFFTH_QUARTERBODY  
};

#define DFF_Prop_Rotation                      4  

#define DFF_Prop_LockRotation                119  
#define DFF_Prop_LockAspectRatio             120  
#define DFF_Prop_LockPosition                121  
#define DFF_Prop_LockAgainstSelect           122  
#define DFF_Prop_LockCropping                123  
#define DFF_Prop_LockVertices                124  
#define DFF_Prop_LockText                    125  
#define DFF_Prop_LockAdjustHandles           126  
#define DFF_Prop_LockAgainstGrouping         127  

#define DFF_Prop_lTxid                       128  
#define DFF_Prop_dxTextLeft                  129  
#define DFF_Prop_dyTextTop                   130  
#define DFF_Prop_dxTextRight                 131  
#define DFF_Prop_dyTextBottom                132  
#define DFF_Prop_WrapText                    133  
#define DFF_Prop_scaleText                   134  
#define DFF_Prop_anchorText                  135  
#define DFF_Prop_txflTextFlow                136  
#define DFF_Prop_cdirFont                    137  
#define DFF_Prop_hspNext                     138  
#define DFF_Prop_txdir                       139  
#define DFF_Prop_SelectText                  187  
#define DFF_Prop_AutoTextMargin              188  
#define DFF_Prop_RotateText                  189  
#define DFF_Prop_FitShapeToText              190  
#define DFF_Prop_FitTextToShape              191  

#define DFF_Prop_gtextUNICODE                192  
#define DFF_Prop_gtextRTF                    193  
#define DFF_Prop_gtextAlign                  194  
#define DFF_Prop_gtextSize                   195  
#define DFF_Prop_gtextSpacing                196  
#define DFF_Prop_gtextFont                   197  
#define DFF_Prop_gtextFReverseRows           240  
#define DFF_Prop_fGtext                      241  
#define DFF_Prop_gtextFVertical              242  
#define DFF_Prop_gtextFKern                  243  
#define DFF_Prop_gtextFTight                 244  
#define DFF_Prop_gtextFStretch               245  
#define DFF_Prop_gtextFShrinkFit             246  
#define DFF_Prop_gtextFBestFit               247  
#define DFF_Prop_gtextFNormalize             248  
#define DFF_Prop_gtextFDxMeasure             249  
#define DFF_Prop_gtextFBold                  250  
#define DFF_Prop_gtextFItalic                251  
#define DFF_Prop_gtextFUnderline             252  
#define DFF_Prop_gtextFShadow                253  
#define DFF_Prop_gtextFSmallcaps             254  
#define DFF_Prop_gtextFStrikethrough         255  

#define DFF_Prop_cropFromTop                 256  
#define DFF_Prop_cropFromBottom              257  
#define DFF_Prop_cropFromLeft                258  
#define DFF_Prop_cropFromRight               259  
#define DFF_Prop_pib                         260  
#define DFF_Prop_pibName                     261  
#define DFF_Prop_pibFlags                    262  
#define DFF_Prop_pictureTransparent          263  
#define DFF_Prop_pictureContrast             264  
#define DFF_Prop_pictureBrightness           265  
#define DFF_Prop_pictureGamma                266  
#define DFF_Prop_pictureId                   267  
#define DFF_Prop_pictureDblCrMod             268  
#define DFF_Prop_pictureFillCrMod            269  
#define DFF_Prop_pictureLineCrMod            270  
#define DFF_Prop_pibPrint                    271  
#define DFF_Prop_pibPrintName                272  
#define DFF_Prop_pibPrintFlags               273  
#define DFF_Prop_fNoHitTestPicture           316  
#define DFF_Prop_pictureGray                 317  
#define DFF_Prop_pictureBiLevel              318  
#define DFF_Prop_pictureActive               319  

#define DFF_Prop_geoLeft                     320  
#define DFF_Prop_geoTop                      321  
#define DFF_Prop_geoRight                    322  
#define DFF_Prop_geoBottom                   323  
#define DFF_Prop_shapePath                   324  
#define DFF_Prop_pVertices                   325  
#define DFF_Prop_pSegmentInfo                326  
#define DFF_Prop_adjustValue                 327  
#define DFF_Prop_adjust2Value                328  
#define DFF_Prop_adjust3Value                329  
#define DFF_Prop_adjust4Value                330  
#define DFF_Prop_adjust5Value                331  
#define DFF_Prop_adjust6Value                332  
#define DFF_Prop_adjust7Value                333  
#define DFF_Prop_adjust8Value                334  
#define DFF_Prop_adjust9Value                335  
#define DFF_Prop_adjust10Value               336  
#define DFF_Prop_fShadowOK                   378  
#define DFF_Prop_f3DOK                       379  
#define DFF_Prop_fLineOK                     380  
#define DFF_Prop_fGtextOK                    381  
#define DFF_Prop_fFillShadeShapeOK           382  
#define DFF_Prop_fFillOK                     383  

#define DFF_Prop_fillType                    384  
#define DFF_Prop_fillColor                   385  
#define DFF_Prop_fillOpacity                 386  
#define DFF_Prop_fillBackColor               387  
#define DFF_Prop_fillBackOpacity             388  
#define DFF_Prop_fillCrMod                   389  
#define DFF_Prop_fillBlip                    390  
#define DFF_Prop_fillBlipName                391  
#define DFF_Prop_fillBlipFlags               392  
#define DFF_Prop_fillWidth                   393  
#define DFF_Prop_fillHeight                  394  
#define DFF_Prop_fillAngle                   395  
#define DFF_Prop_fillFocus                   396  
#define DFF_Prop_fillToLeft                  397  
#define DFF_Prop_fillToTop                   398  
#define DFF_Prop_fillToRight                 399  
#define DFF_Prop_fillToBottom                400  
#define DFF_Prop_fillRectLeft                401  
#define DFF_Prop_fillRectTop                 402  
#define DFF_Prop_fillRectRight               403  
#define DFF_Prop_fillRectBottom              404  
#define DFF_Prop_fillDztype                  405  
#define DFF_Prop_fillShadePreset             406  
#define DFF_Prop_fillShadeColors             407  
#define DFF_Prop_fillOriginX                 408  
#define DFF_Prop_fillOriginY                 409  
#define DFF_Prop_fillShapeOriginX            410  
#define DFF_Prop_fillShapeOriginY            411  
#define DFF_Prop_fillShadeType               412  
#define DFF_Prop_fFilled                     443  
#define DFF_Prop_fHitTestFill                444  
#define DFF_Prop_fillShape                   445  
#define DFF_Prop_fillUseRect                 446  
#define DFF_Prop_fNoFillHitTest              447  

#define DFF_Prop_lineColor                   448  
#define DFF_Prop_lineOpacity                 449  
#define DFF_Prop_lineBackColor               450  
#define DFF_Prop_lineCrMod                   451  
#define DFF_Prop_lineType                    452  
#define DFF_Prop_lineFillBlip                453  
#define DFF_Prop_lineFillBlipName            454  
#define DFF_Prop_lineFillBlipFlags           455  
#define DFF_Prop_lineFillWidth               456  
#define DFF_Prop_lineFillHeight              457  
#define DFF_Prop_lineFillDztype              458  
#define DFF_Prop_lineWidth                   459  
#define DFF_Prop_lineMiterLimit              460  
#define DFF_Prop_lineStyle                   461  
#define DFF_Prop_lineDashing                 462  
#define DFF_Prop_lineDashStyle               463  
#define DFF_Prop_lineStartArrowhead          464  
#define DFF_Prop_lineEndArrowhead            465  
#define DFF_Prop_lineStartArrowWidth         466  
#define DFF_Prop_lineStartArrowLength        467  
#define DFF_Prop_lineEndArrowWidth           468  
#define DFF_Prop_lineEndArrowLength          469  
#define DFF_Prop_lineJoinStyle               470  
#define DFF_Prop_lineEndCapStyle             471  
#define DFF_Prop_fArrowheadsOK               507  
#define DFF_Prop_fLine                       508  
#define DFF_Prop_fHitTestLine                509  
#define DFF_Prop_lineFillShape               510  
#define DFF_Prop_fNoLineDrawDash             511  

#define DFF_Prop_shadowType                  512  
#define DFF_Prop_shadowColor                 513  
#define DFF_Prop_shadowHighlight             514  
#define DFF_Prop_shadowCrMod                 515  
#define DFF_Prop_shadowOpacity               516  
#define DFF_Prop_shadowOffsetX               517  
#define DFF_Prop_shadowOffsetY               518  
#define DFF_Prop_shadowSecondOffsetX         519  
#define DFF_Prop_shadowSecondOffsetY         520  
#define DFF_Prop_shadowScaleXToX             521  
#define DFF_Prop_shadowScaleYToX             522  
#define DFF_Prop_shadowScaleXToY             523  
#define DFF_Prop_shadowScaleYToY             524  
#define DFF_Prop_shadowPerspectiveX          525  
#define DFF_Prop_shadowPerspectiveY          526  
#define DFF_Prop_shadowWeight                527  
#define DFF_Prop_shadowOriginX               528  
#define DFF_Prop_shadowOriginY               529  
#define DFF_Prop_fShadow                     574  
#define DFF_Prop_fshadowObscured             575  

#define DFF_Prop_perspectiveType             576  
#define DFF_Prop_perspectiveOffsetX          577  
#define DFF_Prop_perspectiveOffsetY          578  
#define DFF_Prop_perspectiveScaleXToX        579  
#define DFF_Prop_perspectiveScaleYToX        580  
#define DFF_Prop_perspectiveScaleXToY        581  
#define DFF_Prop_perspectiveScaleYToY        582  
#define DFF_Prop_perspectivePerspectiveX     583  
#define DFF_Prop_perspectivePerspectiveY     584  
#define DFF_Prop_perspectiveWeight           585  
#define DFF_Prop_perspectiveOriginX          586  
#define DFF_Prop_perspectiveOriginY          587  
#define DFF_Prop_fPerspective                639  

#define DFF_Prop_c3DSpecularAmt              640  
#define DFF_Prop_c3DDiffuseAmt               641  
#define DFF_Prop_c3DShininess                642  
#define DFF_Prop_c3DEdgeThickness            643  
#define DFF_Prop_c3DExtrudeForward           644  
#define DFF_Prop_c3DExtrudeBackward          645  
#define DFF_Prop_c3DExtrudePlane             646  
#define DFF_Prop_c3DExtrusionColor           647  
#define DFF_Prop_c3DCrMod                    648  
#define DFF_Prop_f3D                         700  
#define DFF_Prop_fc3DMetallic                701  
#define DFF_Prop_fc3DUseExtrusionColor       702  
#define DFF_Prop_fc3DLightFace               703  

#define DFF_Prop_c3DYRotationAngle           704  
#define DFF_Prop_c3DXRotationAngle           705  
#define DFF_Prop_c3DRotationAxisX            706  
#define DFF_Prop_c3DRotationAxisY            707  
#define DFF_Prop_c3DRotationAxisZ            708  
#define DFF_Prop_c3DRotationAngle            709  
#define DFF_Prop_c3DRotationCenterX          710  
#define DFF_Prop_c3DRotationCenterY          711  
#define DFF_Prop_c3DRotationCenterZ          712  
#define DFF_Prop_c3DRenderMode               713  
#define DFF_Prop_c3DTolerance                714  
#define DFF_Prop_c3DXViewpoint               715  
#define DFF_Prop_c3DYViewpoint               716  
#define DFF_Prop_c3DZViewpoint               717  
#define DFF_Prop_c3DOriginX                  718  
#define DFF_Prop_c3DOriginY                  719  
#define DFF_Prop_c3DSkewAngle                720  
#define DFF_Prop_c3DSkewAmount               721  
#define DFF_Prop_c3DAmbientIntensity         722  
#define DFF_Prop_c3DKeyX                     723  
#define DFF_Prop_c3DKeyY                     724  
#define DFF_Prop_c3DKeyZ                     725  
#define DFF_Prop_c3DKeyIntensity             726  
#define DFF_Prop_c3DFillX                    727  
#define DFF_Prop_c3DFillY                    728  
#define DFF_Prop_c3DFillZ                    729  
#define DFF_Prop_c3DFillIntensity            730  
#define DFF_Prop_fc3DConstrainRotation       763  
#define DFF_Prop_fc3DRotationCenterAuto      764  
#define DFF_Prop_fc3DParallel                765  
#define DFF_Prop_fc3DKeyHarsh                766  
#define DFF_Prop_fc3DFillHarsh               767  

#define DFF_Prop_hspMaster                   769  
#define DFF_Prop_cxstyle                     771  
#define DFF_Prop_bWMode                      772  
#define DFF_Prop_bWModePureBW                773  
#define DFF_Prop_bWModeBW                    774  
#define DFF_Prop_fOleIcon                    826  
#define DFF_Prop_fPreferRelativeResize       827  
#define DFF_Prop_fLockShapeType              828  
#define DFF_Prop_fDeleteAttachedObject       830  
#define DFF_Prop_fBackground                 831  

#define DFF_Prop_spcot                       832  
#define DFF_Prop_dxyCalloutGap               833  
#define DFF_Prop_spcoa                       834  
#define DFF_Prop_spcod                       835  
#define DFF_Prop_dxyCalloutDropSpecified     836  
#define DFF_Prop_dxyCalloutLengthSpecified   837  
#define DFF_Prop_fCallout                    889  
#define DFF_Prop_fCalloutAccentBar           890  
#define DFF_Prop_fCalloutTextBorder          891  
#define DFF_Prop_fCalloutMinusX              892  
#define DFF_Prop_fCalloutMinusY              893  
#define DFF_Prop_fCalloutDropAuto            894  
#define DFF_Prop_fCalloutLengthSpecified     895  

#define DFF_Prop_wzName                      896  
#define DFF_Prop_wzDescription               897  
#define DFF_Prop_pihlShape                   898  
#define DFF_Prop_pWrapPolygonVertices        899  
#define DFF_Prop_dxWrapDistLeft              900  
#define DFF_Prop_dyWrapDistTop               901  
#define DFF_Prop_dxWrapDistRight             902  
#define DFF_Prop_dyWrapDistBottom            903  
#define DFF_Prop_lidRegroup                  904  
#define DFF_Prop_fEditedWrap                 953  
#define DFF_Prop_fBehindDocument             954  
#define DFF_Prop_fOnDblClickNotify           955  
#define DFF_Prop_fIsButton                   956  
#define DFF_Prop_fOneD                       957  
#define DFF_Prop_fHidden                     958  
#define DFF_Prop_fPrint                      959  

#define DFF_PBit_EditedWrap			0x00000040
#define DFF_PBit_BehindDocument		0x00000020
#define DFF_PBit_OnDblClickNotify	0x00000010
#define DFF_PBit_IsButton			0x00000008
#define DFF_PBit_OneD				0x00000004
#define DFF_PBit_Hidden				0x00000002
#define DFF_PBit_Print				0x00000001

enum MSO_ShapePath {
   mso_shapeLines,        
   mso_shapeLinesClosed,  
   mso_shapeCurves,       
   mso_shapeCurvesClosed, 
   mso_shapeComplex       
};

enum MSO_WrapMode {
   mso_wrapSquare,
   mso_wrapByPoints,
   mso_wrapNone,
   mso_wrapTopBottom,
   mso_wrapThrough
};

enum MSO_BWMode {
   mso_bwColor,          
   mso_bwAutomatic,      
   mso_bwGrayScale,      
   mso_bwLightGrayScale, 
   mso_bwInverseGray,    
   mso_bwGrayOutline,    
   mso_bwBlackTextLine,  
   mso_bwHighContrast,   
   mso_bwBlack,          
   mso_bwWhite,          
   mso_bwDontShow,       
   mso_bwNumModes        
};

enum MSO_Anchor {
   mso_anchorTop,
   mso_anchorMiddle,
   mso_anchorBottom,
   mso_anchorTopCentered,
   mso_anchorMiddleCentered,
   mso_anchorBottomCentered,
   mso_anchorTopBaseline,
   mso_anchorBottomBaseline,
   mso_anchorTopCenteredBaseline,
   mso_anchorBottomCenteredBaseline
};

enum MSO_CDir {
   mso_cdir0,       
   mso_cdir90,      
   mso_cdir180,     
   mso_cdir270      
};

enum MSO_ConnectorStyle {
   mso_cxstyleStraight = 0,
   mso_cxstyleBent,
   mso_cxstyleCurved,
   mso_cxstyleNone
};

enum MSO_TextFlow {
   mso_txflHorzN,           
   mso_txflTtoBA,           
   mso_txflBtoT,            
   mso_txflTtoBN,           
   mso_txflHorzA,           
   mso_txflVertN           
};

enum MSO_TextDir {
   mso_txdirLTR,            
   mso_txdirRTL,            
   mso_txdirContext        
};

enum MSO_SPCalloutType {
   mso_spcotRightAngle = 1,
   mso_spcotOneSegment = 2,
   mso_spcotTwoSegment = 3,
   mso_spcotThreeSegment = 4
};

enum MSO_SPCalloutAngle {
   mso_spcoaAny,
   mso_spcoa30,
   mso_spcoa45,
   mso_spcoa60,
   mso_spcoa90,
   mso_spcoa0
};

enum MSO_SPCalloutDrop {
   mso_spcodTop,
   mso_spcodCenter,
   mso_spcodBottom,
   mso_spcodSpecified
};

enum MSO_GeoTextAlign {
   mso_alignTextStretch,      
   mso_alignTextCenter,       
   mso_alignTextLeft,         
   mso_alignTextRight,        
   mso_alignTextLetterJust,   
   mso_alignTextWordJust,     
   mso_alignTextInvalid       
};

enum MSO_BlipFlags {
   mso_blipflagDefault = 0,
   mso_blipflagComment = 0,   
   mso_blipflagFile,          
   mso_blipflagURL,           
   mso_blipflagType = 3,      
	mso_blipflagDontSave = 4,  
	mso_blipflagDoNotSave = 4, 
   mso_blipflagLinkToFile = 8
};

enum MSO_3DRenderMode {
   mso_FullRender,      
   mso_Wireframe,       
   mso_BoundingCube    
};

enum MSO_XFormType {
   mso_xformAbsolute,   
   mso_xformShape,      
   mso_xformDrawing     
};

enum MSO_ShadowType {
   mso_shadowOffset,    
   mso_shadowDouble,    
   mso_shadowRich,      
   mso_shadowShape,     
   mso_shadowDrawing,   
   mso_shadowEmbossOrEngrave
};

enum MSO_DZType {
   mso_dztypeMin          = 0,
   mso_dztypeDefault      = 0,  
   mso_dztypeA            = 1,  
   mso_dztypeV            = 2,  
   mso_dztypeShape        = 3,  
   mso_dztypeFixedAspect  = 4,  
   mso_dztypeAFixed       = 5,  
   mso_dztypeVFixed       = 6,  
   mso_dztypeShapeFixed   = 7,  
   mso_dztypeFixedAspectEnlarge
			 = 8,  
   mso_dztypeAFixedBig    = 9,  
   mso_dztypeVFixedBig    = 10, 
   mso_dztypeShapeFixedBig= 11, 
   mso_dztypeMax          = 11
};

enum MSO_FillType {
   mso_fillSolid,             
   mso_fillPattern,           
   mso_fillTexture,           
   mso_fillPicture,           
   mso_fillShade,             
   mso_fillShadeCenter,       
   mso_fillShadeShape,        
   mso_fillShadeScale,        
	mso_fillShadeTitle,        
   mso_fillBackground         
};

enum MSO_ShadeType {
   mso_shadeNone  = 0,        
   mso_shadeGamma = 1,        
   mso_shadeSigma = 2,        
   mso_shadeBand  = 4,        
   mso_shadeOneColor = 8,     
	mso_shadeParameterShift = 16,
   mso_shadeParameterMask  = 0xffff0000,
	mso_shadeDefault = (mso_shadeGamma|mso_shadeSigma|
		 (16384<<mso_shadeParameterShift))
};

enum MSO_LineStyle {
   mso_lineSimple,			
   mso_lineDouble,			
   mso_lineThickThin,		
   mso_lineThinThick,		
   mso_lineTriple			
};

enum MSO_LineType {
   mso_lineSolidType,         
   mso_linePattern,           
   mso_lineTexture,           
   mso_linePicture            
};

enum MSO_LineDashing {
   mso_lineSolid,              
   mso_lineDashSys,            
   mso_lineDotSys,             
   mso_lineDashDotSys,         
   mso_lineDashDotDotSys,      
   mso_lineDotGEL,             
   mso_lineDashGEL,            
   mso_lineLongDashGEL,        
   mso_lineDashDotGEL,         
   mso_lineLongDashDotGEL,     
   mso_lineLongDashDotDotGEL   
};

enum MSO_LineEnd {
   mso_lineNoEnd,
   mso_lineArrowEnd,
   mso_lineArrowStealthEnd,
   mso_lineArrowDiamondEnd,
   mso_lineArrowOvalEnd,
   mso_lineArrowOpenEnd
};

enum MSO_LineEndWidth {
   mso_lineNarrowArrow,
   mso_lineMediumWidthArrow,
   mso_lineWideArrow
};

enum MSO_LineEndLength {
   mso_lineShortArrow,
   mso_lineMediumLenArrow,
   mso_lineLongArrow
};

enum MSO_LineJoin {
   mso_lineJoinBevel,     
   mso_lineJoinMiter,     
   mso_lineJoinRound      
};

enum MSO_LineCap {
   mso_lineEndCapRound,   
   mso_lineEndCapSquare,  
   mso_lineEndCapFlat     
};

typedef struct _MSOF_BSE {
   BYTE      btWin32;    
   BYTE      btMacOS;    
   BYTE      rgbUid[16]; 
   USHORT    tag;        
   ULONG     size;       
   ULONG     cRef;       
   ULONG  foDelay;    
   BYTE      usage;      
   BYTE      cbName;     
   BYTE      unused2;    
   BYTE      unused3;    
} MSO_FBSE;

typedef enum {
   mso_blipUsageDefault,  
   mso_blipUsageTexture,
   mso_blipUsageMax = 255 
} MSO_BLIPUSAGE;

typedef enum {                          
   mso_blipERROR = 0,          
   mso_blipUNKNOWN,            
   mso_blipEMF,                
   mso_blipWMF,                
   mso_blipPICT,               
   mso_blipJPEG,               
   mso_blipPNG,                
   mso_blipDIB,                
   mso_blipFirstClient = 32,   
   mso_blipLastClient  = 255   
} MSO_BLIPTYPE;

typedef enum {
   mso_biUNKNOWN = 0,
   mso_biWMF  = 0x216,      
   mso_biEMF  = 0x3D4,      
   mso_biPICT = 0x542,      
   mso_biPNG  = 0x6E0,      
   mso_biJFIF = 0x46A,      
   mso_biJPEG = mso_biJFIF,
   mso_biDIB  = 0x7A8,      
   mso_biClient=0x800       
} MSO_BI;                     

typedef enum {
   mso_compressionDeflate = 0,
   mso_compressionNone = 254,    
   mso_compressionTest = 255     
} MSO_BLIPCOMPRESSION;

typedef enum {
   mso_filterAdaptive = 0,       
   mso_filterNone = 254,
   mso_filterTest = 255          
} MSO_BLIPFILTER;

#ifdef Hier_noch_was_aus_der_Doku

BYTE  m_rgbUid[16];

BYTE  m_rgbUidPrimary[16]; 

int           m_cb;           
RECT          m_rcBounds;     
POINT         m_ptSize;       
int           m_cbSave;       
BYTE          m_fCompression; 
BYTE          m_fFilter;      
void         *m_pvBits;       

BYTE  m_rgbUid[16];

BYTE  m_rgbUidPrimary[16];    
BYTE  m_bTag;
void  *m_pvBits;              
#endif

class DffRecordHeader
{

public:
	BYTE    nRecVer; 
	UINT16  nRecInstance;
	UINT16  nImpVerInst;
	UINT16  nRecType;
	UINT32  nRecLen;
	ULONG	nFilePos;
public:
	FASTBOOL IsContainer() const { return nRecVer == DFF_PSFLAG_CONTAINER; }
	ULONG    GetRecBegFilePos() const { return nFilePos; }
	ULONG    GetRecEndFilePos() const { return nFilePos + DFF_COMMON_RECORD_HEADER_SIZE + nRecLen; }
	void SeekToEndOfRecord(SvStream& rIn) const { rIn.Seek(nFilePos + DFF_COMMON_RECORD_HEADER_SIZE + nRecLen ); }
	void SeekToContent(    SvStream& rIn) const { rIn.Seek(nFilePos + DFF_COMMON_RECORD_HEADER_SIZE ); }
	void SeekToBegOfRecord(SvStream& rIn) const { rIn.Seek( nFilePos ); }

	friend SvStream& operator>>(SvStream& rIn, DffRecordHeader& rRec);

};

struct DffPropFlags
{
	BYTE	bSet		: 1;
	BYTE	bComplex	: 1;
	BYTE	bBlip		: 1;
	BYTE	bSoftAttr	: 1;
};

class SvxMSDffManager;

class DffPropSet : public Table
{
	protected :

		UINT32			mpContents[ 1024 ];
		DffPropFlags	mpFlags[ 1024 ];

	public :

		DffPropSet( BOOL bInitialize = FALSE ){ if ( bInitialize )
									memset( mpFlags, 0, 0x400 * sizeof( DffPropFlags ) ); };

		inline BOOL	IsProperty( UINT32 nRecType ) const { return ( mpFlags[ nRecType & 0x3ff ].bSet ); };
		BOOL		IsHardAttribute( UINT32 nId ) const;
		UINT32		GetPropertyValue( UINT32 nId, UINT32 nDefault = 0 ) const;
		void		SetPropertyValue( UINT32 nId, UINT32 nValue ) const;
		BOOL		SeekToContent( UINT32 nRecType, SvStream& rSt ) const;
		void		Merge( DffPropSet& rMasterPropSet ) const;
		void		InitializePropSet() const;
		friend SvStream& operator>>( SvStream& rIn, DffPropSet& rPropSet );
};

class SfxItemSet;
class SdrObject;

class DffPropertyReader : public DffPropSet
{
	const SvxMSDffManager&	rManager;
	DffPropSet*				pDefaultPropSet;

public:

	INT32					mnFix16Angle;

	DffPropertyReader( const SvxMSDffManager& rManager );
	~DffPropertyReader();
	INT32		Fix16ToAngle( INT32 nAngle ) const;

#ifdef DBG_AUTOSHAPE
	void		ReadPropSet( SvStream& rIn, void* pClientData, UINT32 nShapeType = 0 ) const;
#else
	void		ReadPropSet( SvStream& rIn, void* pClientData ) const;
#endif

	void		SetDefaultPropSet( SvStream& rIn, UINT32 nOffDgg ) const;
	void		ApplyAttributes( SvStream& rIn, SfxItemSet& rSet, SdrObject* pObj = NULL ) const;
};

#endif
