
#ifndef _SVX_NUMFMTSH_HXX
#define _SVX_NUMFMTSH_HXX

#ifndef _STRING_HXX 
#include <tools/string.hxx>
#endif
#ifndef _LANG_HXX 
#include <tools/lang.hxx>
#endif

#ifndef	_SVSTDARR_ULONGS
#define _SVSTDARR_ULONGS
#endif
#ifndef	_SVSTDARR_USHORTS
#define _SVSTDARR_USHORTS
#endif
#ifndef	_SVSTDARR_STRINGS
#define _SVSTDARR_STRINGS
#endif

#include <svtools/svstdarr.hxx>

class Color;
class SvNumberFormatter;
class SvNumberFormatTable;
class SvStrings;
class SvStringsDtor;
class NfCurrencyEntry;

enum SvxNumberValueType
{
	SVX_VALUE_TYPE_UNDEFINED = 0,
	SVX_VALUE_TYPE_NUMBER,
	SVX_VALUE_TYPE_STRING
};

#define CAT_ALL				0	
#define CAT_USERDEFINED		1	
#define CAT_NUMBER			2
#define CAT_PERCENT			3
#define CAT_CURRENCY		4
#define CAT_DATE			5
#define CAT_TIME			6
#define CAT_SCIENTIFIC		7
#define CAT_FRACTION		8
#define CAT_BOOLEAN			9
#define CAT_TEXT			10

#define SELPOS_NONE			-1

#define NUMBERFORMAT_ENTRY_NEW_CURRENCY		NUMBERFORMAT_ENTRY_NOT_FOUND-1

typedef NfCurrencyEntry* NfShCurrencyEntryPtr;
SV_DECL_PTRARR( NfShCurrencyEntries, NfShCurrencyEntryPtr, 8, 1 );

class SvxDelStrgs: public SvStrings
{

public:
		~SvxDelStrgs() { DeleteAndDestroy(0,Count());}

};

class SvxNumberFormatShell
{
public:
			SvxNumberFormatShell( SvNumberFormatter* pNumFormatter,
								  ULONG              nFormatKey,
								  SvxNumberValueType eNumValType,
								  const String&		 rNumStr );
				SvxNumberFormatShell( SvNumberFormatter* pNumFormatter,
								  ULONG				 nFormatKey,
								  SvxNumberValueType eNumValType,
								  double			 nNumVal,
								  const String*		 pNumStr = NULL );
				~SvxNumberFormatShell();

	static SvxNumberFormatShell*	Create( SvNumberFormatter* pNumFormatter,
								  ULONG              nFormatKey,
								  SvxNumberValueType eNumValType,
								  const String&		 rNumStr );

	static SvxNumberFormatShell*	Create( SvNumberFormatter* pNumFormatter,
								  ULONG				 nFormatKey,
								  SvxNumberValueType eNumValType,
								  double			 nNumVal,
								  const String*		 pNumStr = NULL );

	void				GetInitSettings( USHORT&       nCatLbPos,
							LanguageType& rLangType,
							 USHORT&       nFmtLbSelPos,
							 SvStrings&    rFmtEntries,
							 String&	   rPrevString,
							 Color&		   rPrevColor );

	void				CategoryChanged( USHORT     nCatLbPos,
							short&     rFmtSelPos,
							 SvStrings& rFmtEntries );

	void				LanguageChanged( LanguageType eLangType,
							 short&       rFmtSelPos,
							 SvStrings&   rFmtEntries );

	void				FormatChanged( USHORT  nFmtLbPos,
						   String& rPreviewStr,
						   Color&  rFontColor );

	BOOL				AddFormat( String&    rFormat,
					   ULONG&     rErrPos,
					   USHORT&    rCatLbSelPos,
					   short&     rFmtSelPos,
					   SvStrings& rFmtEntries );

	BOOL				RemoveFormat( const String&	rFormat,
						  USHORT&       rCatLbSelPos,
						  short&        rFmtSelPos,
						  SvStrings&    rFmtEntries );

	void				MakeFormat( String& rFormat,
						BOOL    bThousand,
						BOOL    bNegRed,
						USHORT  nPrecision,
						USHORT  nLeadingZeroes,
						USHORT  nCurrencyEntryPos);

	void				GetOptions( const String& rFormat,
						BOOL&         rThousand,
						BOOL&         rNegRed,
						USHORT&       rPrecision,
						USHORT&       rLeadingZeroes,
						USHORT&       rCatLbPos );

	void				MakePreviewString( const String& rFormatStr,
							   String&       rPreviewStr,
							   Color&        rFontColor );

	void				MakePrevStringFromVal( const String& rFormatStr,		
									String&	rPreviewStr,
									Color&	rFontColor,
									double	nValue);

	BOOL				IsUserDefined( const String& rFmtString );
	BOOL				IsTmpCurrencyFormat( const String& rFmtString );
	BOOL				FindEntry( const String& rFmtString, ULONG* pAt = NULL );

	void				ValidateNewEntries( BOOL bValidate = TRUE ) { bUndoAddList = !bValidate; }
	ULONG				GetUpdateDataCount() const;
	void				GetUpdateData( ULONG* pDelArray, const ULONG nSize );

	void				SetCurNumFmtKey( ULONG nNew )		{ nCurFormatKey = nNew; }
	void				SetCurLanguage( LanguageType eNew ) { eCurLanguage = eNew; }
	ULONG				GetCurNumFmtKey() const				{ return nCurFormatKey; }
	LanguageType		GetCurLanguage() const				{ return eCurLanguage; }

	String				GetComment4Entry(short nEntry);
	short				GetCategory4Entry(short nEntry);
	BOOL				GetUserDefined4Entry(short nEntry);
	String				GetFormat4Entry(short nEntry);
	void				SetComment4Entry(short nEntry,String aCommentString);

	BOOL				IsBankingSymbol(USHORT nPos);
	void				SetCurrencySymbol(USHORT nPos);
	ULONG				GetCurrencySymbol();
	USHORT				FindCurrencyFormat( const String& rFmtString );
	USHORT				FindCurrencyFormat(const NfCurrencyEntry* pTmpCurrencyEntry,BOOL bTmpBanking);
	NfCurrencyEntry*	GetCurCurrencyEntry();
	void				SetCurCurrencyEntry(NfCurrencyEntry*);
	short				GetListPos4Entry(ULONG nIdx);
	short				GetListPos4Entry( const String& rFmtString );

	void				GetCurrencySymbols(SvStringsDtor& rList,const XubString& rStrEurope,USHORT* pPos);
	void				GetCurrencySymbols(SvStringsDtor& rList,const XubString& rStrEurope, BOOL bFlag);

	USHORT				FindCurrencyTableEntry( const String& rFmtString, BOOL &bTestBanking );
	BOOL				IsInTable(USHORT nPos,BOOL bTmpBanking,const String &rFmtString);

	void				GetCurrencyFormats(SvStrings& rList);

private:
	static const double 	DEFAULT_NUMVALUE;	

	SvNumberFormatter*		pFormatter;
	SvNumberFormatTable*	pCurFmtTable;
	SvxNumberValueType		eValType;
	String					aValStr;
	double					nValNum;
	BOOL					bUndoAddList;
	SvULongs				aAddList;
	SvULongs				aDelList;
	SvULongs				aCurEntryList;
	ULONG					nInitFormatKey;
	ULONG					nCurFormatKey;
	short					nCurCategory;
	LanguageType			eCurLanguage;
	SvUShorts				aCurCurrencyList;
	NfCurrencyEntry*		pCurCurrencyEntry;
	BOOL					bBankingSymbol;
	USHORT					nCurCurrencyEntryPos;
	SvStrings				aCurrencyFormatList;

#ifdef _SVX_NUMFMTSH_CXX
	short					FillEntryList_Impl( SvStrings& rList );
	void					FillEListWithStd_Impl( SvStrings& rList,USHORT aPrivCat, short &Pos);
	short					FillEListWithFormats_Impl( SvStrings& rList,short nSelPos,
										   NfIndexTableOffset eOffsetStart,
										   NfIndexTableOffset eOffsetEnd);

	short					FillEListWithDateTime_Impl( SvStrings& rList,short nSelPos);

	short					FillEListWithCurrency_Impl( SvStrings& rList,short nSelPos);
	short					FillEListWithSysCurrencys( SvStrings& rList,short nSelPos);
	short					FillEListWithUserCurrencys( SvStrings& rList,short nSelPos);

	short					FillEListWithUsD_Impl( SvStrings& rList, sal_uInt16 nPrivCat, short Pos );
	BOOL					IsRemoved_Impl( ULONG nKey );
	BOOL					IsAdded_Impl( ULONG nKey );
	void					GetPreviewString_Impl( String& rString,
									   Color& rColor );
	void					PosToCategory_Impl( USHORT nPos, short& rCategory );
	void					CategoryToPos_Impl( short nCategory, USHORT& rPos );
#endif
};

#endif

