
#ifndef _SVX_OPTEXTBR_HXX
#define _SVX_OPTEXTBR_HXX

#ifndef _SV_FIXED_HXX 
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_EDIT_HXX 
#include <vcl/edit.hxx>
#endif
#ifndef _SV_LSTBOX_HXX 
#include <vcl/lstbox.hxx>
#endif
#ifndef _SFXTABDLG_HXX 
#include <sfx2/tabdlg.hxx>
#endif

class SvStrings;

class SvxExternBrowserTabPage : public SfxTabPage
{
private:
	CheckBox            aOnCB;
	CheckBox            aFileCB;
	Edit				aFileED;
	PushButton			aFileBtn;
	PushButton			aIEOptionsBtn;
	FixedText           aExceptionFT;
	Edit                aExceptionED;
	PushButton          aAddBtn;
	ListBox             aExceptionLB;
	PushButton          aDeleteBtn;
	CheckBox			aNoHintCB;

	BOOL				bNoWarning			: 1,
			bOldNoHintValue		: 1;

	String				aExceptionText;
	String				aExternBrowserText;

	SvStrings*          pOnExceptionList;
	SvStrings*          pOffExceptionList;
	CheckBox*			pCheckBox;

#ifdef _SVX_OPTEXTBR_CXX
	DECL_LINK( CheckHdl_Impl, CheckBox * );
	DECL_LINK( ModifyHdl_Impl, Edit * );
	DECL_LINK( SelectHdl_Impl, ListBox * );
	DECL_LINK( ClickHdl_Impl, PushButton * );

	void                TakeServerName();
	void				EnableControls();
#endif

protected:
	virtual void		ActivatePage( const SfxItemSet& );
	virtual int			DeactivatePage( SfxItemSet* pSet );

public:
	SvxExternBrowserTabPage( Window* pParent, const SfxItemSet& rSet );
	~SvxExternBrowserTabPage();

	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rSet );

	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
	virtual	void 		Reset( const SfxItemSet& rSet );
};

#endif 

