
#ifndef _SVX_OPTLINGU_HXX
#define _SVX_OPTLINGU_HXX

#ifndef _GROUP_HXX 
#include <vcl/group.hxx>
#endif
#ifndef _FIXED_HXX 
#include <vcl/fixed.hxx>
#endif
#ifndef _TOOLBOX_HXX 
#include <vcl/toolbox.hxx>
#endif
#ifndef _FIELD_HXX 
#include <vcl/field.hxx>
#endif
#ifndef _SFXTABDLG_HXX 
#include <sfx2/tabdlg.hxx>
#endif
#ifndef _SVX_CHECKLBX_HXX 
#include <svx/checklbx.hxx>
#endif
#ifndef _SVX_LANGBOX_HXX
#include <svx/langbox.hxx>
#endif
#ifndef _COM_SUN_STAR_UNO_REFERENCE_HXX_
#include <com/sun/star/uno/Reference.hxx>
#endif
#ifndef _COM_SUN_STAR_UNO_SEQUENCE_HXX_
#include <com/sun/star/uno/Sequence.hxx>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif

namespace com{namespace sun{namespace star{
namespace beans{
	class XPropertySet;
}
namespace linguistic2{
	class XDictionary;
	class XDictionaryList;
	class XSpellChecker1;
}}}}

class SvLBoxEntry;
class SvxLinguData_Impl;

#define GROUP_MODULES	((sal_uInt16)0x0008)

class SvxEditModulesDlg : public ModalDialog
{
	OKButton			aClosePB;
	HelpButton			aHelpPB;
	 FixedLine           aModulesFL;

	FixedText			aLanguageFT;
	SvxLanguageBox		aLanguageLB;

	SvxCheckListBox		aModulesCLB;
	PushButton			aPrioUpPB;
	PushButton			aPrioDownPB;
	PushButton			aBackPB;

	Bitmap				aChkunBmp;
	Bitmap				aChkchBmp;

	String 				sSpell;
	String 				sHyph;
	String 				sThes;
	 SvxLinguData_Impl*  pDefaultLinguData;
	SvxLinguData_Impl& 	rLinguData;

	SvLBoxButtonData*	pCheckButtonData;
	 SvLBoxEntry*    CreateEntry(String& rTxt, USHORT nCol);

#ifdef _SVX_OPTLINGU_CXX
	DECL_LINK( SelectHdl_Impl, SvxCheckListBox * );
	DECL_LINK( UpDownHdl_Impl, PushButton * );
	DECL_LINK( ClickHdl_Impl, PushButton * );
	DECL_LINK( BackHdl_Impl, PushButton * );
	DECL_LINK( SelectHdlLB_Impl, ListBox * );
	DECL_LINK( LangSelectHdl_Impl, ListBox* );
	DECL_LINK( BoxCheckButtonHdl_Impl, SvTreeListBox * );
#endif

public:
	SvxEditModulesDlg(Window* pParent, SvxLinguData_Impl& rData);
	virtual	~SvxEditModulesDlg();
};

class SvxLinguTabPage : public SfxTabPage
{
private:
	FixedLine           aLinguisticFL;
	FixedText			aLinguModulesFT;
	SvxCheckListBox		aLinguModulesCLB;
	PushButton			aLinguModulesEditPB;
	FixedText           aLinguDicsFT;
	SvxCheckListBox     aLinguDicsCLB;
	PushButton          aLinguDicsNewPB;
	PushButton          aLinguDicsEditPB;
	PushButton          aLinguDicsDelPB;
	FixedText			aLinguOptionsFT;
	SvxCheckListBox		aLinguOptionsCLB;
	PushButton			aLinguOptionsEditPB;

	String				sCapitalWords;
	String				sWordsWithDigits;
	String				sCapitalization;
	String				sSpellSpecial;
	String				sAllLanguages;
	String				sSpellAuto;
	String				sHideMarkings;
	String				sOldGerman;
	String				sNumMinWordlen;
	String				sNumPreBreak;
	String				sNumPostBreak;
	String				sHyphAuto;
	String				sHyphSpecial;

	Bitmap				aChkunBmp;
	Bitmap				aChkchBmp;

	com::sun::star::uno::Reference<
		com::sun::star::beans::XPropertySet >	xProp;

	com::sun::star::uno::Reference<
		com::sun::star::linguistic2::XDictionaryList >		xDicList;
	com::sun::star::uno::Sequence<
		com::sun::star::uno::Reference<
			com::sun::star::linguistic2::XDictionary > >	aDics;

	SvLBoxButtonData*	pCheckButtonData;

	SvxLinguData_Impl* 	pLinguData;

	SvxLinguTabPage( Window* pParent, const SfxItemSet& rCoreSet );
	SvLBoxEntry*	CreateEntry(String& rTxt, USHORT nCol);

#ifdef _SVX_OPTLINGU_CXX
	DECL_LINK( SelectHdl_Impl, SvxCheckListBox * );
	DECL_LINK( ClickHdl_Impl, PushButton * );
	DECL_LINK( BoxDoubleClickHdl_Impl, SvTreeListBox * );
	DECL_LINK( BoxCheckButtonHdl_Impl, SvTreeListBox * );
	DECL_LINK( PostDblClickHdl_Impl, SvTreeListBox * );
	 void                UpdateModulesBox_Impl();
	void                UpdateDicBox_Impl();
#endif

public:
	virtual				~SvxLinguTabPage();
	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rSet );
	static sal_uInt16*	GetRanges();

	virtual	sal_Bool 	FillItemSet( SfxItemSet& rSet );
	virtual	void 		Reset( const SfxItemSet& rSet );

	void				HideGroups( sal_uInt16 nGrp );
};

#endif

