
#ifndef _SVX_OPTPATH_HXX
#define _SVX_OPTPATH_HXX

#ifndef _SFXTABDLG_HXX 
#include <sfx2/tabdlg.hxx>
#endif
#ifndef _FIXED_HXX 
#include <vcl/fixed.hxx>
#endif
#ifndef _GROUP_HXX 
#include <vcl/group.hxx>
#endif

#ifdef _SVX_OPTPATH_CXX
#ifndef _HEADBAR_HXX 
#include <svtools/headbar.hxx>
#endif
#else
class HeaderBar;
#endif

class SvTabListBox;
class OptHeaderTabListBox;
struct OptPath_Impl;

#define SfxPathTabPage SvxPathTabPage

class SvxPathControl_Impl : public Control
{
private:
	Control*		m_pFocusCtrl;

public:
	SvxPathControl_Impl( Window* pParent, const ResId& rId ) :
		Control( pParent, rId ), m_pFocusCtrl( NULL ) {}

	void			SetFocusControl( Control* pCtrl ) { m_pFocusCtrl = pCtrl; }

	virtual long	Notify( NotifyEvent& rNEvt );
};

class SvxPathTabPage : public SfxTabPage
{
private:
	FixedText			aTypeText;
	FixedText			aPathText;
	SvxPathControl_Impl	aPathCtrl;
	PushButton			aStandardBtn;
	PushButton      	aPathBtn;
	FixedLine           aStdBox;

	HeaderBar*				pHeaderBar;
	OptHeaderTabListBox*	pPathBox;
	OptPath_Impl*			pImpl;

#ifdef _SVX_OPTPATH_CXX
	DECL_LINK( PathHdl_Impl, PushButton * );
	DECL_LINK( StandardHdl_Impl, PushButton * );

	DECL_LINK( PathSelect_Impl, OptHeaderTabListBox * );
	DECL_LINK( HeaderSelect_Impl, HeaderBar * );
	DECL_LINK( HeaderEndDrag_Impl, HeaderBar * );
#endif

public:
	SvxPathTabPage( Window* pParent, const SfxItemSet& rSet );
	~SvxPathTabPage();

	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rSet );
	static USHORT*		GetRanges();

	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
	virtual	void 		Reset( const SfxItemSet& rSet );
	virtual void        FillUserData();
};

#endif

