
#ifndef _SVX_ORPHITEM_HXX
#define _SVX_ORPHITEM_HXX

#ifndef _SFXINTITEM_HXX 
#include <svtools/intitem.hxx>
#endif
#ifndef _SVX_SVXIDS_HRC
#include <svx/svxids.hrc>
#endif

class SvXMLUnitConverter;
#ifdef _USE_NAMESPACE
namespace rtl
{
#endif
	class OUString;
#ifdef _USE_NAMESPACE
}
#endif

class SvxOrphansItem: public SfxByteItem
{
	friend SvStream & operator<<( SvStream & aS, SvxOrphansItem & );
public:
	TYPEINFO();

	SvxOrphansItem( const BYTE nL=0, const USHORT nId = ITEMID_ORPHANS );

	virtual SfxPoolItem*    Clone( SfxItemPool *pPool = 0 ) const;
	virtual SfxPoolItem*    Create(SvStream &, USHORT) const;
	virtual SvStream&		Store(SvStream &, USHORT nItemVersion ) const;

	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
	                                String &rText, const IntlWrapper * = 0 ) const;

	inline SvxOrphansItem& operator=( const SvxOrphansItem& rOrphans )
	{
		SetValue( rOrphans.GetValue() );
		return *this;
	}
};

#endif

