
#ifndef _SVX_PAPERINF_HXX
#define _SVX_PAPERINF_HXX

#ifndef _PRINT_HXX 
#include <vcl/print.hxx>
#endif
#ifndef _MAPMOD_HXX 
#include <vcl/mapmod.hxx>
#endif
#ifndef _SVX_SVXENUM_HXX
#include <svx/svxenum.hxx>
#endif

class Printer;
class Size;
class String;

class SvxPaperInfo
{
public:
	static Size			GetPaperSize( const Printer* );
	static Size			GetPaperSize( SvxPaper ePaper,
						  MapUnit eUnit = MAP_TWIP );

	static SvxPaper		GetPaper( const Size&, MapUnit eUnit = MAP_TWIP,
					  BOOL bSloppy = FALSE );

	static SvxPaper		GetSvxPaper( const Size&, MapUnit eUnit = MAP_TWIP,
						 BOOL bSloppy = FALSE );
	static Paper		GetSvPaper( const Size&, MapUnit eUnit = MAP_TWIP,
						BOOL bSloppy = FALSE );
	static String		GetName( SvxPaper ePaper );
};

inline Size &Swap(Size &rSize)
{
	const long lVal = rSize.Width();
	rSize.Width() = rSize.Height();
	rSize.Height() = lVal;
	return rSize;
}

inline Size &LandscapeSwap(Size &rSize)
{
	if ( rSize.Height() > rSize.Width() )
		Swap( rSize );
	return rSize;
}

const long lA0Width			= 47678;			
const long lA0Height		= 67407;			
const long lA1Width			= 33675;			
const long lA1Height		= lA0Width;			
const long lA2Width			= 23811;			
const long lA2Height		= lA1Width;			
const long lA3Width			= 16837;			
const long lA3Height		= lA2Width;			
const long lA4Width			= 11905;			
const long lA4Height		= lA3Width;			
const long lA5Width			= 8390;				
const long lA5Height		= lA4Width;			

const long lB4Width			= 14173;			
const long lB4Height		= 20012;			
const long lB5Width			=  9977;			
const long lB5Height		= lB4Width;			
const long lB6Width			= 7086;
const long lB6Height		= lB5Width;

const long lC4Width			= 12983;
const long lC4Height		= 18368;
const long lC5Width			= 9184;
const long lC5Height		= lC4Width;
const long lC6Width			= 6463;
const long lC6Height		= lC5Width;
const long lC65Width		= 6463;
const long lC65Height		= 12870;
const long lDLWidth			= 6236;
const long lDLHeight		= 12472;

const long lLetterWidth		= 12240;			
const long lLetterHeight	= 15840;			
const long lLegalWidth		= lLetterWidth;		
const long lLegalHeight		= 20163;			
const long lTabloidWidth	= 15850;			
const long lTabloidHeight	= 24450;			

const long lDiaWidth		= 10206;			
const long lDiaHeight		= 15309;			
const long lScreenWidth		= 11905;			
const long lScreenHeight	= 15874;			

const long lAWidth			= 12240;			
const long lAHeight			= 15840;			
const long lBWidth			= lAHeight;			
const long lBHeight			= 24480;			
const long lCWidth			= lBHeight;			
const long lCHeight			= 31680;			
const long lDWidth			= lCHeight;			
const long lDHeight			= 48960;			
const long lEWidth			= lDHeight;			
const long lEHeight			= 63360;			

const long lExeWidth		= 10440;			
const long lExeHeight		= 15120;			
const long lLegal2Width		= 12240;			
const long lLegal2Height 	= 18720;			
const long lCom675Width		= 5220;				
const long lCom675Height	= 9360;				
const long lCom9Width		= 5580;				
const long lCom9Height		= 12780;			
const long lCom10Width		= 5940;				
const long lCom10Height		= 13680;			
const long lCom11Width		= 6480;				
const long lCom11Height		= 14940;			
const long lCom12Width		= 6840;				
const long lCom12Height		= lAHeight;			
const long lMonarchWidth 	= lCom9Width;		
const long lMonarchHeight	= 10800;			

const long lKai16Width		= 10433;			
const long lKai16Height		= 14742;			
const long lKai32Width		= 7371;				
const long lKai32Height		= lKai16Width;		
const long lKai32BigWidth	= 7938;				
const long lKai32BigHeight	= 11510;			

#endif

