
#ifndef _SVX_PARAPREV_HXX
#define _SVX_PARAPREV_HXX

#ifndef _WINDOW_HXX 
#include <vcl/window.hxx>
#endif

#ifndef _SVX_SVXENUM_HXX 
#include <svx/svxenum.hxx>
#endif

enum SvxPrevLineSpace
{
	SVX_PREV_LINESPACE_1 = 0,
	SVX_PREV_LINESPACE_15,
	SVX_PREV_LINESPACE_2,
	SVX_PREV_LINESPACE_PROP,
	SVX_PREV_LINESPACE_MIN,
	SVX_PREV_LINESPACE_DURCH
};

class SvxParaPrevWindow : public Window
{
private:
	Size				aWinSize;
	Size				aSize;

	long				nLeftMargin;
	long				nRightMargin;
	short	   			nFirstLineOfst;

	USHORT				nUpper;
	USHORT				nLower;

	SvxAdjust			eAdjust;
#if  SUPD>352

	SvxAdjust			eLastLine;
#endif

	SvxPrevLineSpace	eLine;
	USHORT				nLineVal;

	String				aText;
	Rectangle			Lines[9];

protected:
	virtual void Paint( const Rectangle& rRect );

	void DrawParagraph( BOOL bAll );

public:
	SvxParaPrevWindow( Window* pParent, const ResId& rId );

	void		SetFirstLineOfst( short nNew ) { nFirstLineOfst = nNew; }
	void		SetLeftMargin( long nNew ) 	{ nLeftMargin = nNew; }
	void		SetRightMargin( long nNew )	{ nRightMargin = nNew; }
	void		SetUpper( USHORT nNew )			{ nUpper = nNew; }
	void		SetLower( USHORT nNew )			{ nLower = nNew; }
	void		SetAdjust( SvxAdjust eNew )		{ eAdjust = eNew; }
#if  SUPD>352
	void		SetLastLine( SvxAdjust eNew )	{ eLastLine = eNew; }
#endif
	void		SetLineSpace( SvxPrevLineSpace eNew, USHORT nNew = 0 )
		{   eLine = eNew; nLineVal = nNew; }
	void        SetText( const String& rStr )	{ aText = rStr; }
	void		SetSize( Size aNew )			{ aSize = aNew; }

	short		GetFirstLineOfst() const 		{ return nFirstLineOfst; }
	long		GetLeftMargin() const			{ return nLeftMargin; }
	long		GetRightMargin() const			{ return nRightMargin; }
	USHORT		GetUpper() const				{ return nUpper; }
	USHORT		GetLower() const				{ return nLower; }
	SvxAdjust	GetAdjust() const				{ return eAdjust; }

	SvxPrevLineSpace	GetLineEnum() const 	{ return eLine; }
	USHORT				GetLineValue() const	{ return nLineVal; }
	String				GetText() const			{ return aText; }
	Size				GetSize() const			{ return aSize; }

	void		OutputSizeChanged();

	void 		Draw( BOOL bAll ) 				{ DrawParagraph( bAll ); }
};

#endif

