
#ifndef _SVX_PBINITEM_HXX
#define _SVX_PBINITEM_HXX

#ifndef _SFXINTITEM_HXX 
#include <svtools/intitem.hxx>
#endif
#ifndef _SVX_SVXIDS_HRC
#include <svx/svxids.hrc>
#endif

#define PAPERBIN_PRINTER_SETTINGS	((BYTE)0xFF)

class SvxPaperBinItem : public SfxByteItem
{
public:
	TYPEINFO();

	inline SvxPaperBinItem( const USHORT nId = ITEMID_PAPERBIN,
				const BYTE nTray = PAPERBIN_PRINTER_SETTINGS );
	inline SvxPaperBinItem &operator=( const SvxPaperBinItem &rCpy );

	virtual SfxPoolItem*    Clone( SfxItemPool *pPool = 0 ) const;
	virtual SfxPoolItem*    Create( SvStream &, USHORT ) const;
	virtual SvStream&		Store( SvStream &, USHORT nItemVersion ) const;
	virtual SfxItemPresentation	GetPresentation( SfxItemPresentation ePres,
								 SfxMapUnit eCoreMetric,
								 SfxMapUnit ePresMetric,
	                                         String &rText, const IntlWrapper * = 0 ) const;
};

inline SvxPaperBinItem::SvxPaperBinItem( const USHORT nId, const BYTE nT )
	: SfxByteItem( nId, nT )
{}

inline SvxPaperBinItem &SvxPaperBinItem::operator=(
	const SvxPaperBinItem &rCpy )
{
	SetValue( rCpy.GetValue() );
	return *this;
}

#endif

