
#ifndef _SVX_PMDLITEM_HXX
#define _SVX_PMDLITEM_HXX

#ifndef _SFXSTRITEM_HXX 
#include <svtools/stritem.hxx>
#endif
#ifndef _SVX_SVXIDS_HRC
#include <svx/svxids.hrc>
#endif

class SvxPageModelItem : public SfxStringItem
{
private:
	BOOL bAuto;

public:
	TYPEINFO();

	inline SvxPageModelItem( USHORT nWhich = ITEMID_PAGEMODEL );
	inline SvxPageModelItem( const String& rModel, BOOL bA = FALSE,
				 USHORT nWhich = ITEMID_PAGEMODEL );
	inline SvxPageModelItem& operator=( const SvxPageModelItem& rModel );

	virtual SfxPoolItem*    Clone( SfxItemPool *pPool = 0 ) const;

	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
	                                String &rText, const IntlWrapper * = 0 ) const;

	BOOL IsAuto() const { return bAuto; }
};

inline SvxPageModelItem::SvxPageModelItem( USHORT nWhich )
	: bAuto( FALSE )
{
	SetWhich( nWhich );
}

inline SvxPageModelItem::SvxPageModelItem( const String& rModel, BOOL bA,
							   USHORT nWhich ) :
	SfxStringItem( nWhich, rModel ),
	bAuto( bA )
{}

inline SvxPageModelItem& SvxPageModelItem::operator=( const SvxPageModelItem& rModel )
{
	SetValue( rModel.GetValue() );
	return *this;
}

#endif

