
#ifndef _SVX_POSTDLG_HXX
#define _SVX_POSTDLG_HXX

#ifndef _GROUP_HXX 
#include <vcl/group.hxx>
#endif
#ifndef _IMAGEBTN_HXX 
#include <vcl/imagebtn.hxx>
#endif
#ifndef _EDIT_HXX 
#include <vcl/edit.hxx>
#endif
#ifndef _STDCTRL_HXX 
#include <svtools/stdctrl.hxx>
#endif
#ifndef _BASEDLGS_HXX 
#include <sfx2/basedlgs.hxx>
#endif

#ifndef _SVEDIT_HXX 
#include <svtools/svmedit.hxx>
#endif

class SvxPostItDialog : public SfxModalDialog
{
public:
	SvxPostItDialog( Window* pParent, const SfxItemSet& rCoreSet,
		 BOOL bPrevNext = FALSE, BOOL bRedline = FALSE );
	~SvxPostItDialog();

	static USHORT*      GetRanges();
	const SfxItemSet*   GetOutputItemSet() const { return pOutSet; }

	Link                GetPrevHdl() const { return aPrevHdlLink; }
	void                SetPrevHdl( const Link& rLink )
				{ aPrevHdlLink = rLink; }
	Link                GetNextHdl() const { return aNextHdlLink; }
	void                SetNextHdl( const Link& rLink )
				{ aNextHdlLink = rLink; }

	void				EnableTravel(BOOL bNext, BOOL bPrev);
	inline String		GetNote() { return aEditED.GetText(); }
	inline void			SetNote(const String& rTxt) { aEditED.SetText(rTxt); }

	void				ShowLastAuthor(const String& rAuthor, const String& rDate);
	inline void			DontChangeAuthor()	{ aAuthorBtn.Enable(FALSE); }
	inline void			HideAuthor()		{ aAuthorBtn.Hide(); }
	inline void			SetReadonlyPostIt(BOOL bDisable)
				{
					aOKBtn.Enable( !bDisable );
					aEditED.SetReadOnly( bDisable );
					aAuthorBtn.Enable( !bDisable );
				}
	inline BOOL 		IsOkEnabled() const { return aOKBtn.IsEnabled(); }

private:
	FixedText           aLastEditLabelFT;
	FixedInfo           aLastEditFT;

	FixedText           aEditFT;
	MultiLineEdit       aEditED;
	FixedLine           aPostItFL;

	OKButton            aOKBtn;
	CancelButton        aCancelBtn;
	HelpButton          aHelpBtn;
	ImageButton         aPrevBtn;
	ImageButton         aNextBtn;
	PushButton          aAuthorBtn;

	const SfxItemSet&   rSet;
	SfxItemSet*         pOutSet;

	Link                aPrevHdlLink;
	Link                aNextHdlLink;

#ifdef _SVX_POSTDLG_CXX
	DECL_LINK( Stamp, Button* );
	DECL_LINK( OKHdl, Button* );
	DECL_LINK( PrevHdl, Button* );
	DECL_LINK( NextHdl, Button* );
#endif
};

#endif

