
#ifndef _SVX_SCRIPTTYPEITEM_HXX
#define _SVX_SCRIPTTYPEITEM_HXX

#ifndef _SFXINTITEM_HXX
#include <svtools/intitem.hxx>
#endif
#ifndef _SVX_SVXIDS_HRC
#include <svx/svxids.hrc>
#endif

#define SCRIPTTYPE_LATIN		0x01
#define SCRIPTTYPE_ASIAN		0x02
#define SCRIPTTYPE_COMPLEX		0x04

USHORT GetScriptTypeOfLanguage( USHORT nLang );

class SvxScriptTypeItem : public SfxUInt16Item
{
public:
	TYPEINFO();

	SvxScriptTypeItem( sal_uInt16 nType = SCRIPTTYPE_LATIN );
	virtual SfxPoolItem* Clone( SfxItemPool *pPool = 0 ) const;

};

class SvxScriptSetItem : public SfxSetItem
{
public:
	TYPEINFO();

	SvxScriptSetItem( USHORT nSlotId, SfxItemPool& rPool );

	virtual SfxPoolItem* Clone( SfxItemPool *pPool = 0 ) const;
	virtual SfxPoolItem* Create( SvStream &, USHORT nVersion ) const;

	static const SfxPoolItem* GetItemOfScriptSet( const SfxItemSet& rSet,
										USHORT nWhich );
	inline const SfxPoolItem* GetItemOfScriptSet( USHORT nWhich ) const
	{ return SvxScriptSetItem::GetItemOfScriptSet( GetItemSet(), nWhich ); }

	const SfxPoolItem* GetItemOfScript( USHORT nScript ) const;

	void PutItemForScriptType( USHORT nScriptType, const SfxPoolItem& rItem );

	void GetWhichIds( USHORT& rLatin, USHORT& rAsian, USHORT& rComplex) const;

	static void GetSlotIds( USHORT nSlotId, USHORT& rLatin, USHORT& rAsian,
								USHORT& rComplex );
	inline void GetSlotIds( USHORT& rLatin, USHORT& rAsian,
					USHORT& rComplex ) const
	{ GetSlotIds( Which(), rLatin, rAsian, rComplex ); }
};

#endif

