

#ifndef _SDASAITM_HXX
#define _SDASAITM_HXX

#ifndef _SFXPOOLITEM_HXX 
#include <svtools/poolitem.hxx>
#endif
#ifndef _LIST_HXX
#include <tools/list.hxx>
#endif

class SdrAutoShapeAdjustmentValue
{
	sal_uInt32	nValue;

	friend class SdrAutoShapeAdjustmentItem;

	public :

		void		SetValue( sal_uInt32 nVal ) { nValue = nVal; };
		sal_uInt32	GetValue() const { return nValue; };

};

class SdrAutoShapeAdjustmentItem : public SfxPoolItem
{
			List	aAdjustmentValueList;

	public :
	TYPEINFO();
			SdrAutoShapeAdjustmentItem();
			SdrAutoShapeAdjustmentItem( SvStream& rIn, sal_uInt16 nVersion );
			~SdrAutoShapeAdjustmentItem();
	virtual int					operator==( const SfxPoolItem& ) const;
			virtual SfxItemPresentation GetPresentation(SfxItemPresentation ePresentation,
								SfxMapUnit eCoreMetric, SfxMapUnit ePresentationMetric,
	                                            String &rText, const IntlWrapper * = 0) const;
			virtual SfxPoolItem*		Create( SvStream&, sal_uInt16 nItem ) const;
			virtual SvStream&			Store( SvStream&, sal_uInt16 nVersion ) const;
			virtual SfxPoolItem*		Clone( SfxItemPool* pPool = NULL ) const;
			virtual	sal_uInt16			GetVersion( sal_uInt16 nFileFormatVersion ) const;
	virtual	sal_Bool			QueryValue( com::sun::star::uno::Any& rVal, BYTE nMemberId = 0 ) const;
			virtual	sal_Bool			PutValue( const com::sun::star::uno::Any& rVal, BYTE nMemberId = 0 );

#ifdef SDR_ISPOOLABLE
			virtual int IsPoolable() const;
#endif
	sal_uInt32							GetCount() const { return aAdjustmentValueList.Count(); };
			const SdrAutoShapeAdjustmentValue&	GetValue( sal_uInt32 nIndex ) const;
			void								SetValue( sal_uInt32 nIndex,
											const SdrAutoShapeAdjustmentValue& rVal );
};

#endif

