

#ifndef _E3D_SPHERE3D_HXX
#define _E3D_SPHERE3D_HXX

#ifndef _E3D_OBJ3D_HXX
#include <svx/obj3d.hxx>
#endif

class E3dSphereObj : public E3dCompoundObject
{
	Vector3D		aCenter;
	Vector3D		aSize;

protected:
	void SetDefaultAttributes(E3dDefaultAttributes& rDefault);

public:
	TYPEINFO();
	E3dSphereObj(E3dDefaultAttributes& rDefault, const Vector3D& rCenter, const Vector3D& r3DSize);
	E3dSphereObj();

	sal_Int32 GetHorizontalSegments() const 
		{ return ((const Svx3DHorizontalSegmentsItem&)GetUnmergedItemSet().Get(SDRATTR_3DOBJ_HORZ_SEGS)).GetValue(); }

	sal_Int32 GetVerticalSegments() const 
		{ return ((const Svx3DVerticalSegmentsItem&)GetUnmergedItemSet().Get(SDRATTR_3DOBJ_VERT_SEGS)).GetValue(); }

	virtual UINT16 GetObjIdentifier() const;
	virtual void CreateWireframe(Polygon3D& rWirePoly, const Matrix4D* pTf = NULL,
		E3dDragDetail eDetail = E3DDETAIL_DEFAULT);

	virtual SdrObject* DoConvertToPolyObj(BOOL bBezier) const;

	virtual void operator=(const SdrObject&);
	virtual void WriteData(SvStream& rOut) const;
	virtual void ReadData(const SdrObjIOHeader& rHead, SvStream& rIn);

	void ReSegment(long nHorzSegments, long nVertSegments);
	const Vector3D Center() const { return aCenter; }
	const Vector3D Size() const { return aSize; }

	E3dSphereObj(int dummy);

	void ReadData31(const SdrObjIOHeader& rHead, SvStream& rIn);

	virtual void CreateGeometry();

	virtual void GetLineGeometry(PolyPolygon3D& rLinePolyPolygon) const;

	void SetCenter(const Vector3D& rNew);
	void SetSize(const Vector3D& rNew);

	virtual void PostItemChange(const sal_uInt16 nWhich);

	virtual void TakeObjNameSingul(String& rName) const;
	virtual void TakeObjNamePlural(String& rName) const;
};

#endif			
