
#ifndef _SVX_SPLTITEM_HXX
#define _SVX_SPLTITEM_HXX

#ifndef _SFXENUMITEM_HXX 
#include <svtools/eitem.hxx>
#endif
#ifndef _SVX_SVXIDS_HRC
#include <svx/svxids.hrc>
#endif

class SvXMLUnitConverter;
#ifdef _USE_NAMESPACE
namespace rtl
{
#endif
	class OUString;
#ifdef _USE_NAMESPACE
}
#endif

class SvxFmtSplitItem : public SfxBoolItem
{
public:
	TYPEINFO();
	~SvxFmtSplitItem();

	inline SvxFmtSplitItem( const BOOL bSplit = TRUE,
				const USHORT nWhich = ITEMID_FMTSPLIT );
	inline SvxFmtSplitItem& operator=( const SvxFmtSplitItem& rSplit );

	virtual SfxPoolItem*	Clone( SfxItemPool *pPool = 0 ) const;
	virtual SfxPoolItem*	Create( SvStream&, USHORT ) const;
	virtual SvStream&		Store( SvStream& , USHORT nItemVersion ) const;

	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
	                                String &rText, const IntlWrapper * = 0 ) const;
};

inline SvxFmtSplitItem::SvxFmtSplitItem( const BOOL bSplit, const USHORT nWhich ) :
	SfxBoolItem( nWhich, bSplit )
{}

inline SvxFmtSplitItem& SvxFmtSplitItem::operator=(
	const SvxFmtSplitItem& rSplit )
{
	SetValue( rSplit.GetValue() );
	return *this;
}

#endif

