
#ifndef _SVX_SPLWRAP_HXX
#define _SVX_SPLWRAP_HXX

#ifndef _SVX_SVXENUM_HXX 
#include <svx/svxenum.hxx>
#endif

#ifndef _STRING_HXX 
#include <tools/string.hxx>
#endif

#ifndef _COM_SUN_STAR_UNO_REFERENCE_HXX_
#include <com/sun/star/uno/Reference.hxx>
#endif

namespace com { namespace sun { namespace star { namespace linguistic2 {
	class XDictionary1;
	class XSpellChecker1;
	class XHyphenator;
}}}}

class Window;

class SvxSpellWrapper {
private:
	friend class SvxSpellCheckDialog;
	friend class SvxHyphenWordDialog;

	Window*		pWin;
	::com::sun::star::uno::Reference< 
		::com::sun::star::uno::XInterface > 			xLast;	
	::com::sun::star::uno::Reference< 
		::com::sun::star::linguistic2::XSpellChecker1 > xSpell;
	::com::sun::star::uno::Reference< 
		::com::sun::star::linguistic2::XHyphenator > 	xHyph;
	sal_uInt16 	nOldLang; 		
	sal_Bool 	bOtherCntnt : 1; 
	sal_Bool 	bDialog		: 1; 
	sal_Bool 	bHyphen		: 1; 
	sal_Bool	bAuto		: 1; 
	sal_Bool	bReverse	: 1; 
	sal_Bool	bStartDone	: 1; 
	sal_Bool	bEndDone	: 1; 
	sal_Bool	bStartChk	: 1; 
	sal_Bool	bRevAllowed : 1; 
	sal_Bool	bAllRight	: 1; 

	sal_Bool 	SpellNext();   		
	sal_Bool	FindSpellError(); 	

public:
	SvxSpellWrapper( Window* pWn, 
		 ::com::sun::star::uno::Reference< 
		 	::com::sun::star::linguistic2::XSpellChecker1 >  &xSpellChecker,
		 const sal_Bool bStart = sal_False, const sal_Bool bIsAllRight = sal_False,
		 const sal_Bool bOther = sal_False, const sal_Bool bRevAllow = sal_True );
	SvxSpellWrapper( Window* pWn, 
		 ::com::sun::star::uno::Reference< 
		 	::com::sun::star::linguistic2::XHyphenator >  &xHyphenator,
		 const sal_Bool bStart = sal_False, const sal_Bool bOther = sal_False );

	static sal_Int16	CheckSpellLang( 
				::com::sun::star::uno::Reference< 
					::com::sun::star::linguistic2::XSpellChecker1 >  xSpell, 
				sal_Int16 nLang );
	static sal_Int16	CheckHyphLang(
				::com::sun::star::uno::Reference< 
					::com::sun::star::linguistic2::XHyphenator >  xHyph, 
				sal_Int16 nLang );

	void 			SpellDocument();		
	inline sal_Bool IsStartDone(){ return bStartDone; }
	inline sal_Bool IsEndDone(){ return bEndDone; }
	inline sal_Bool IsReverse(){ return bReverse; }
	inline sal_Bool IsDialog(){ return bDialog; } 
	inline sal_Bool IsHyphen(){ return bHyphen; } 
	inline void 	SetHyphen( const sal_Bool bNew = sal_True ){ bHyphen = bNew; }
	inline ::com::sun::star::uno::Reference< 
		::com::sun::star::linguistic2::XSpellChecker1 >  
		GetXSpellChecker() { return xSpell; }
	inline ::com::sun::star::uno::Reference< 
		::com::sun::star::linguistic2::XHyphenator >  	
		GetXHyphenator() 	{ return xHyph; }
	inline sal_Bool				IsAllRight()		{ return bAllRight; }
	inline Window* 	GetWin() { return pWin; }

	inline void 	SetOldLang( const sal_uInt16 nNew ){ nOldLang = nNew; }

	inline void 	ChangeLanguage( const sal_uInt16 nNew ) 
		{ if ( nNew != nOldLang ) { SetLanguage( nNew ); nOldLang = nNew; } }
	inline void 	EnableAutoCorrect() { bAuto = sal_True; }

protected:
	::com::sun::star::uno::Reference< 
		::com::sun::star::uno::XInterface > 	
		 GetLast()		{ return xLast; }
	void			 SetLast(const ::com::sun::star::uno::Reference< 
					::com::sun::star::uno::XInterface >  &xNewLast)	
				{ xLast = xNewLast; }
	virtual	sal_Bool SpellMore(); 				
	virtual	sal_Bool HasOtherCnt(); 			
	virtual	void 	 SpellStart( SvxSpellArea eSpell ); 
	virtual	sal_Bool SpellContinue();			

	virtual void ReplaceAll( const String &rNewText, sal_Int16 nLanguage );	
	virtual void StartThesaurus( const String &rWord, sal_uInt16 nLang );	
	virtual ::com::sun::star::uno::Reference< 
		::com::sun::star::linguistic2::XDictionary1 > 	
	 GetAllRightDic() const;
	virtual	void SpellEnd();                        
	virtual void ScrollArea();                      

	virtual void ChangeWord( const String& rNewWord, const sal_uInt16 nLang );
	virtual String GetThesWord();

	virtual void ChangeThesWord( const String& rNewWord );
	virtual void SetLanguage( const sal_uInt16 nLang ); 
	virtual void AutoCorrect( const String& rAktStr, const String& rNewStr );
	virtual void InsertHyphen( const sal_uInt16 nPos ); 
};

#endif

