
#ifndef _SVX_SRCHCFG_HXX
#define _SVX_SRCHCFG_HXX

#ifndef _UTL_CONFIGITEM_HXX_
#include <unotools/configitem.hxx>
#endif
#ifndef _COM_SUN_STAR_UNO_SEQUENCE_H_
#include <com/sun/star/uno/Sequence.h>
#endif

struct SvxSearchConfig_Impl;
struct SvxSearchEngineData
{
	rtl::OUString   sEngineName;
	 rtl::OUString   sAndPrefix;
	rtl::OUString   sAndSuffix;
	rtl::OUString   sAndSeparator;
	sal_Int32       nAndCaseMatch;
	 rtl::OUString   sOrPrefix;
	rtl::OUString   sOrSuffix;
	rtl::OUString   sOrSeparator;
	sal_Int32       nOrCaseMatch;
	 rtl::OUString   sExactPrefix;
	rtl::OUString   sExactSuffix;
	rtl::OUString   sExactSeparator;
	sal_Int32       nExactCaseMatch;
	 SvxSearchEngineData() :
	    nAndCaseMatch(0),
	    nOrCaseMatch(0),
	    nExactCaseMatch(0){}
	 sal_Bool operator==(const SvxSearchEngineData& rData);
};
class SvxSearchConfig : public utl::ConfigItem
{
	SvxSearchConfig_Impl* pImpl;

public:
	SvxSearchConfig(sal_Bool bEnableNotify = sal_True);
	virtual ~SvxSearchConfig();

	void 			Load();
	virtual void	Commit();
	virtual void 	Notify( const com::sun::star::uno::Sequence<rtl::OUString>& aPropertyNames);
	 sal_uInt16                  Count();
	const SvxSearchEngineData&  GetData(sal_uInt16 nPos);
	const SvxSearchEngineData*  GetData(const rtl::OUString& rEngineName);
	void                        SetData(const SvxSearchEngineData& rData);
	void                        RemoveData(const rtl::OUString& rEngineName);
};

#endif

