

#ifndef _SVDGLEV_HXX
#define _SVDGLEV_HXX

#ifndef _SVDHDL_HXX
#include <svx/svdhdl.hxx>
#endif

#include <svx/svdpoev.hxx>

class SdrGluePoint;

class SdrGlueEditView: public SdrPolyEditView
{
	void ImpClearVars();

	void ImpCopyMarkedGluePoints();
	typedef void (*PGlueDoFunc)(SdrGluePoint&, const SdrObject* pObj, const void*, const void*, const void*, const void*, const void*);
	typedef void (*PGlueTrFunc)(Point&, const void*, const void*, const void*, const void*, const void*);
	void ImpDoMarkedGluePoints(PGlueDoFunc pDoFunc, BOOL bConst, const void* p1=NULL, const void* p2=NULL, const void* p3=NULL, const void* p4=NULL, const void* p5=NULL);
	void ImpTransformMarkedGluePoints(PGlueTrFunc pTrFunc, const void* p1=NULL, const void* p2=NULL, const void* p3=NULL, const void* p4=NULL, const void* p5=NULL);

public:
	SdrGlueEditView(SdrModel* pModel1, OutputDevice* pOut=NULL);
	SdrGlueEditView(SdrModel* pModel1, ExtOutputDevice* pXOut);
	virtual ~SdrGlueEditView();

	TRISTATE IsMarkedGluePointsEscDir(USHORT nThisEsc) const;
	void SetMarkedGluePointsEscDir(USHORT nThisEsc, BOOL bOn);
	BOOL IsSetMarkedGluePointsEscDirPossible() const { return !IsReadOnly() && HasMarkedGluePoints(); }

	TRISTATE IsMarkedGluePointsPercent() const;
	void SetMarkedGluePointsPercent(BOOL bOn);
	BOOL IsSetMarkedGluePointsPercentPossible() const { return !IsReadOnly() && HasMarkedGluePoints(); }

	USHORT GetMarkedGluePointsAlign(BOOL bVert) const;
	void SetMarkedGluePointsAlign(BOOL bVert, USHORT nAlign);
	BOOL IsSetMarkedGluePointsAlignPossible() const { return !IsReadOnly() && HasMarkedGluePoints(); }

	void DeleteMarkedGluePoints();
	BOOL IsDeleteMarkedGluePointsPossible() const;

	void MoveMarkedGluePoints  (const Size& rSiz, BOOL bCopy=FALSE);
	void ResizeMarkedGluePoints(const Point& rRef, const Fraction& xFact, const Fraction& yFact, BOOL bCopy=FALSE);
	void RotateMarkedGluePoints(const Point& rRef, long nWink, BOOL bCopy=FALSE);
	void MirrorMarkedGluePoints(const Point& rRef1, const Point& rRef2, BOOL bCopy=FALSE);
	void MirrorMarkedGluePointsHorizontal(BOOL bCopy=FALSE);
	void MirrorMarkedGluePointsVertical(BOOL bCopy=FALSE);
	void ShearMarkedGluePoints(const Point& rRef, long nWink, BOOL bVShear=FALSE, BOOL bCopy=FALSE);
	void CrookMarkedGluePoints(const Point& rRef, const Point& rRad, SdrCrookMode eMode, BOOL bVertical=FALSE, BOOL bNoContortion=FALSE, BOOL bCopy=FALSE);
	void DistortMarkedGluePoints(const Rectangle& rRef, const XPolygon& rDistortedRect, BOOL bNoContortion=FALSE, BOOL bCopy=FALSE);

	void AlignMarkedGluePoints(SdrHorAlign eHor, SdrVertAlign eVert);
};

#endif 

