

#ifndef _SVDOPAGE_HXX
#define _SVDOPAGE_HXX

#ifndef _SVDOBJ_HXX
#include <svx/svdobj.hxx>
#endif

class SdrPageObj : public SdrObject
{
	SfxItemSet*				mpPageItemSet;
	sal_uInt16				nPageNum;
	BOOL					bPainting;  
	BOOL					bNotifying; 

protected:
	virtual void SFX_NOTIFY(SfxBroadcaster& rBC, const TypeId& rBCType, const SfxHint& rHint, const TypeId& rHintType);

public:
	TYPEINFO();
	SdrPageObj(USHORT nNewPageNum=0);
	SdrPageObj(const Rectangle& rRect, USHORT nNewPageNum=0);
	~SdrPageObj();

	virtual void SetModel(SdrModel* pNewModel);
	USHORT GetPageNum() const { return nPageNum; }
	void SetPageNum(USHORT nNewPageNum) 
		{ NbcSetPageNum(nNewPageNum); SetChanged(); SendRepaintBroadcast(GetBoundRect()); }
	void NbcSetPageNum(USHORT nNewPageNum) { nPageNum=nNewPageNum; }

	virtual UINT16 GetObjIdentifier() const;
	virtual void TakeObjInfo(SdrObjTransformInfoRec& rInfo) const;
	virtual FASTBOOL Paint(ExtOutputDevice& rOut, const SdrPaintInfoRec& rInfoRec) const;
	virtual void operator=(const SdrObject& rObj);

	virtual void TakeObjNameSingul(String& rName) const;
	virtual void TakeObjNamePlural(String& rName) const;

	virtual const Rectangle& GetBoundRect() const;
	virtual const Rectangle& GetSnapRect() const;
	virtual const Rectangle& GetLogicRect() const;
	virtual void NbcSetSnapRect(const Rectangle& rRect);
	virtual void NbcSetLogicRect(const Rectangle& rRect);
	virtual void TakeXorPoly(XPolyPolygon& rPoly, FASTBOOL bDetail) const;
	virtual void TakeContour(XPolyPolygon& rXPoly, SdrContourType eType) const;
	virtual void WriteData(SvStream& rOut) const;
	virtual void ReadData(const SdrObjIOHeader& rHead, SvStream& rIn);

	virtual SfxItemSet* CreateNewItemSet(SfxItemPool& rPool);
	virtual const SfxItemSet& GetItemSet() const;

	virtual void ItemChange(const sal_uInt16 nWhich, const SfxPoolItem* pNewItem = 0);
};

#endif 

