

#ifndef _SVDSURO_HXX
#define _SVDSURO_HXX

#ifndef _SVDTYPES_HXX
#include <svx/svdtypes.hxx>
#endif

class SdrPage;
class SdrModel;
class SdrObject;
class SdrObjList;
class SvStream;

class SdrObjSurrogate {
protected:
	const SdrObject*  pRefObj;
	SdrObject*  pObj;
	const SdrObjList* pList;
	const SdrObjList* pRootList;
	const SdrPage*    pPage;
	const SdrModel*   pModel;
	SdrObjListKind eList;
	UINT32      nOrdNum;         
	UINT32*     pGrpOrdNums;     
	UINT16      nGrpLevel;
	UINT16      nPageNum;
#if 0 // _SOLAR__PRIVATE
private:
	void ImpClearVars();
	void ImpMakeSurrogate();
	void ImpFindObj();
	void ImpRead(SvStream& rIn);
	void ImpWriteValue(SvStream& rOut, UINT32 nVal, unsigned nByteAnz) const;
	void ImpReadValue(SvStream& rIn, UINT32& rVal, unsigned nByteAnz) const;
#endif 
public:

	SdrObjSurrogate(SdrObject* pObj1, const SdrObject* pRefObj1=NULL);

	SdrObjSurrogate(const SdrModel& rMod, SvStream& rIn);

	SdrObjSurrogate(const SdrObject& rRefObj1, SvStream& rIn);

	~SdrObjSurrogate();

	SdrObject* GetObject();

	friend SvStream& operator<<(SvStream& rOut, const SdrObjSurrogate& rSurro);
};

#endif 

