

#ifndef _SVDTYPES_HXX
#define _SVDTYPES_HXX

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif

const UINT32 SdrInventor=UINT32('S')*0x00000001+
			 UINT32('V')*0x00000100+
			 UINT32('D')*0x00010000+
			 UINT32('r')*0x01000000;

enum SdrCreateCmd {SDRCREATE_NEXTPOINT,     
	   SDRCREATE_NEXTOBJECT,    
	   SDRCREATE_FORCEEND};     

enum SdrDragMode 
{
	SDRDRAG_MOVE,		
	SDRDRAG_RESIZE,		
	SDRDRAG_ROTATE,		
	SDRDRAG_MIRROR,		
	SDRDRAG_SHEAR,		
	SDRDRAG_CROOK,		
	SDRDRAG_DISTORT,	

	SDRDRAG_TRANSPARENCE,
	SDRDRAG_GRADIENT
};

enum SdrConvertType {SDRCONVERT_POLY,   
		 SDRCONVERT_BEZIER, 
		 SDRCONVERT_MIXED}; 

enum SdrContourType {SDRCONTOUR_NORMAL,   
		 SDRCONTOUR_ALIGNED,  
		 SDRCONTOUR_DETAILED, 
		 SDRCONTOUR_OUTER,    
		 SDRCONTOUR_INNER,    
		 SDRCONTOUR_INNERUNROTATED}; 

#define SDRLAYER_NOTFOUND 0xFF

typedef BYTE SdrLayerID;

enum SdrObjListKind {SDROBJLIST_UNKNOWN    =0x00,    
			 SDROBJLIST_GROUPOBJ   =0x01,    
		 SDROBJLIST_VIRTOBJECTS=0x02,    
		 SDROBJLIST_SYMBOLTABLE=0x03,    
			 SDROBJLIST_DRAWPAGE   =0x10,    
		 SDROBJLIST_MASTERPAGE =0x11,    
			 SDROBJLIST_SAMELIST   =0x1E,    
		 SDROBJLIST_SAMEPAGE   =0x1F,    
		 SDROBJLIST_RESERVEDBEG=0xE0,    
		 SDROBJLIST_RESERVEDEND=0xFF};   

inline FASTBOOL SdrIsPageKind(SdrObjListKind eK) { return eK>=SDROBJLIST_DRAWPAGE && eK<=0x1A; }

enum SdrRepeatFunc {SDRREPFUNC_OBJ_NONE,
			SDRREPFUNC_OBJ_MOVE,         
		SDRREPFUNC_OBJ_RESIZE,       
		SDRREPFUNC_OBJ_SETSNAPRECT,  
		SDRREPFUNC_OBJ_SETLOGICRECT, 
		SDRREPFUNC_OBJ_ROTATE,       
		SDRREPFUNC_OBJ_SHEAR,        
		SDRREPFUNC_OBJ_CROOKROTATE,
		SDRREPFUNC_OBJ_CROOKSLANT,
		SDRREPFUNC_OBJ_CROOKSTRETCH,
		SDRREPFUNC_OBJ_ALIGN,        
		SDRREPFUNC_OBJ_SETATTRIBUTES,
		SDRREPFUNC_OBJ_SETSTYLESHEET,
			SDRREPFUNC_OBJ_DELETE,
		SDRREPFUNC_OBJ_COMBINE_POLYPOLY,
		SDRREPFUNC_OBJ_COMBINE_ONEPOLY,
		SDRREPFUNC_OBJ_DISMANTLE_POLYS,
		SDRREPFUNC_OBJ_DISMANTLE_LINES,
		SDRREPFUNC_OBJ_CONVERTTOPOLY,
		SDRREPFUNC_OBJ_CONVERTTOPATH,
		SDRREPFUNC_OBJ_GROUP,
		SDRREPFUNC_OBJ_UNGROUP,
		SDRREPFUNC_OBJ_PUTTOTOP,
		SDRREPFUNC_OBJ_PUTTOBTM,
		SDRREPFUNC_OBJ_MOVTOTOP,
		SDRREPFUNC_OBJ_MOVTOBTM,
		SDRREPFUNC_OBJ_REVORDER,
		SDRREPFUNC_OBJ_IMPORTMTF,
		SDRREPFUNC_PAGE_DELETE,
		SDRREPFUNC_LAST};

#endif 

