

#ifndef _SVDVITER_HXX
#define _SVDVITER_HXX

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif

class OutputDevice;
class Window;
class SdrView;
class SdrPageView;
class SdrModel;
class SdrPage;
class SdrObject;
class SetOfByte;

class SdrViewIter {
	const SdrModel*  pModel;
	const SdrPage*   pPage;
	const SdrObject* pObject;
	SdrView*   pAktView;
	FASTBOOL   bNoMasterPage;
	USHORT     nListenerNum;
	USHORT     nPageViewNum;
	USHORT     nOutDevNum;
private:
	void          ImpInitVars();
	SdrView*      ImpFindView();
	SdrPageView*  ImpFindPageView();
	OutputDevice* ImpFindOutDev();
	Window*       ImpFindWindow();
	FASTBOOL      ImpCheckPageView(SdrPageView* pPV) const;
public:
	SdrViewIter(const SdrModel*  pModel);
	SdrViewIter(const SdrPage*   pPage, FASTBOOL bNoMasterPage=FALSE);
	SdrViewIter(const SdrObject* pObject, FASTBOOL bNoMasterPage=FALSE);
	SdrView*      FirstView();
	SdrView*      NextView();
	SdrPageView*  FirstPageView();
	SdrPageView*  NextPageView();
	OutputDevice* FirstOutDev();
	OutputDevice* NextOutDev();
	Window*       FirstWindow();
	Window*       NextWindow();
};

#ifdef _JUST_DESCRIPTION

Mit dieser Klasse kann man rausbekommen:
- SdrView* First/NextView()
  - Alle Views in denen ein Models dargestellt wird
  - Alle Views in denen eine bestimme Page sichtbar ist (ww. auch als MasterPage)
  - Alle Views in denen ein bestimmes Objekt sichtbar ist (ww. auch auf MasterPage)
- SdrPageView* First/NextPageView()
  - Alle PageViews in denen ein Models dargestellt wird
  - Alle PageViews in denen eine bestimme Page sichtbar ist (ww. auch als MasterPage)
  - Alle PageViews in denen ein bestimmes Objekt sichtbar ist (ww. auch auf MasterPage)
- OutputDevice* First/NextOutDev()
  - Alle OutputDevices in denen ein Models dargestellt wird
  - Alle OutputDevices in denen eine bestimme Page sichtbar ist (ww. auch als MasterPage)
  - Alle OutputDevices in denen ein bestimmes Objekt sichtbar ist (ww. auch auf MasterPage)
- Window* First/NextWindow()
  - Alle Windows in denen ein Models dargestellt wird
  - Alle Windows in denen eine bestimme Page sichtbar ist (auch als MasterPage)
  - Alle Windows in denen ein bestimmes Objekt sichtbar ist (auch auf MasterPage)
Ob die Auswahl auf ein(e) bestimmte(s) Page/Objekt beschraenkt wird, bestimmt man
durch die Wahl des Konstruktors.

Es werden u.a. auch berueksichtigt:
- Layer Sichtbarkeitsstatus
- Visible Layer von MasterPages
- Mehrfachlayer bei Gruppenobjekten

Es wird nicht berueksichtigt:
- Ob die Pages/Objekte wirklich schon gepaintet wurden oder noch ein Invalidate ansteht, ...
- Ob die Pages/Objekte in einem Window im sichtbaren Bereich liegen

#endif 

#endif 

