
#ifndef	_SVX_SVXFONT_HXX
#define	_SVX_SVXFONT_HXX

#include <limits.h>		
#ifndef _SVX_SVXENUM_HXX
#include <svx/svxenum.hxx>
#endif

#ifndef _LANG_HXX 
#include <tools/lang.hxx>
#endif
#ifdef VCL
#ifndef _SV_FONT_HXX 
#include <vcl/font.hxx>
#endif
#endif

class SvxDoCapitals;
class OutputDevice;
class Printer;

class SvxFont : public Font
{
	LanguageType eLang;         
	SvxCaseMap	 eCaseMap;      
	short nEsc;                 
	BYTE  nPropr;               
	short nKern;                

public:
	SvxFont();
	SvxFont( const Font &rFont );
	SvxFont( const SvxFont &rFont );

	inline short GetEscapement() const { return nEsc; }
	inline void SetEscapement( const short nNewEsc ) { nEsc = nNewEsc; }

	inline BYTE GetPropr() const { return nPropr; }
	inline void SetPropr( const BYTE nNewPropr ) { nPropr = nNewPropr; }
	inline void SetProprRel( const BYTE nNewPropr )
		{ SetPropr( (BYTE)( (long)nNewPropr * (long)nPropr / 100L ) ); }

	inline short GetFixKerning() const { return nKern; }
	inline void  SetFixKerning( const short nNewKern ) { nKern = nNewKern; }

	inline SvxCaseMap GetCaseMap() const { return eCaseMap; }
	inline void    SetCaseMap( const SvxCaseMap eNew ) { eCaseMap = eNew; }

	inline LanguageType GetLanguage() const { return eLang; }
	inline void SetLanguage( const LanguageType eNewLan ) { eLang = eNewLan; }

	inline BOOL IsCaseMap() const { return SVX_CASEMAP_NOT_MAPPED != eCaseMap; }
	inline BOOL IsCapital() const { return SVX_CASEMAP_KAPITAELCHEN == eCaseMap; }
	inline BOOL IsKern() const { return 0 != nKern; }
	inline BOOL IsEsc() const { return 0 != nEsc; }

	String CalcCaseMap( const String &rTxt ) const;

#ifndef REDUCEDSVXFONT

	void DoOnCapitals( SvxDoCapitals &rDo,
		   const USHORT nPartLen = USHRT_MAX ) const;

	void SetPhysFont( OutputDevice *pOut ) const;
	Font ChgPhysFont( OutputDevice *pOut ) const;

	Size GetCapitalSize( const OutputDevice *pOut, const String &rTxt,
			  const USHORT nIdx, const USHORT nLen) const;
	void DrawCapital( OutputDevice *pOut, const Point &rPos, const String &rTxt,
		  const USHORT nIdx, const USHORT nLen ) const;

	Size GetPhysTxtSize( const OutputDevice *pOut, const String &rTxt,
			 const USHORT nIdx, const USHORT nLen ) const;

	Size GetPhysTxtSize( const OutputDevice *pOut, const String &rTxt );

	Size GetTxtSize( const OutputDevice *pOut, const String &rTxt,
		  const USHORT nIdx = 0, const USHORT nLen = STRING_LEN );

	void DrawText( OutputDevice *pOut, const Point &rPos, const String &rTxt,
	  const USHORT nIdx = 0, const USHORT nLen = STRING_LEN ) const;

	void QuickDrawText( OutputDevice *pOut, const Point &rPos, const String &rTxt,
	  const USHORT nIdx = 0, const USHORT nLen = STRING_LEN, const long* pDXArray = NULL ) const;

	Size QuickGetTextSize( const OutputDevice *pOut, const String &rTxt,
			 const USHORT nIdx, const USHORT nLen, long* pDXArray = NULL ) const;

	void DrawPrev( OutputDevice* pOut, Printer* pPrinter,
	   const Point &rPos, const String &rTxt,
	   const USHORT nIdx = 0, const USHORT nLen = STRING_LEN ) const;

#endif 
	static void DrawArrow( OutputDevice &rOut, const Rectangle& rRect,
		const Size& rSize, const Color& rCol, BOOL bLeft );
	SvxFont&	operator=( const SvxFont& rFont );
	SvxFont&	operator=( const Font& rFont );
};

#endif 

