
#ifndef _SVX_TABSTPGE_HXX
#define _SVX_TABSTPGE_HXX

#include <vcl/group.hxx>
#include <vcl/edit.hxx>
#include <vcl/field.hxx>
#include <vcl/fixed.hxx>
#include <sfx2/tabdlg.hxx>

#include <svx/tstpitem.hxx>

class TabWin_Impl;

#define TABTYPE_LEFT		0x0001
#define TABTYPE_RIGHT		0x0002
#define TABTYPE_CENTER		0x0004
#define TABTYPE_DEZIMAL		0x0008
#define TABTYPE_ALL			0x000F

#define TABFILL_NONE		0x0010
#define TABFILL_POINT		0x0020
#define TABFILL_DASHLINE 	0x0040
#define TABFILL_SOLIDLINE	0x0080
#define TABFILL_SPECIAL		0x0100
#define TABFILL_ALL			0x01F0

class SvxTabulatorTabPage : public SfxTabPage
{
public:
	~SvxTabulatorTabPage();

	static SfxTabPage* 	Create( Window* pParent, const SfxItemSet& rSet );
	static USHORT*		GetRanges();

	virtual BOOL 		FillItemSet( SfxItemSet& rSet );
	virtual void 		Reset( const SfxItemSet& rSet );

	void				DisableControls( const USHORT nFlag );

protected:
	virtual int			DeactivatePage( SfxItemSet* pSet = 0 );

private:
	SvxTabulatorTabPage( Window* pParent, const SfxItemSet& rSet );

	MetricBox		aTabBox;
	FixedLine       aTabLabel;
	FixedLine       aTabLabelVert;

	RadioButton		aLeftTab;
	RadioButton		aRightTab;
	RadioButton		aCenterTab;
	RadioButton		aDezTab;

	TabWin_Impl*	pLeftWin;
	TabWin_Impl*	pRightWin;
	TabWin_Impl*	pCenterWin;
	TabWin_Impl*	pDezWin;

	FixedText		aDezCharLabel;
	Edit			aDezChar;
	FixedLine       aTabTypeLabel;
	FixedLine       aTabTypeLabelVert;

	RadioButton		aNoFillChar;
	RadioButton		aFillPoints;
	RadioButton		aFillDashLine ;
	RadioButton		aFillSolidLine;
	RadioButton		aFillSpecial;
	Edit			aFillChar;
	FixedLine       aFillLabel;

	PushButton		aNewBtn;
	PushButton		aDelAllBtn;
	PushButton		aDelBtn;

	SvxTabStop     	aAktTab;
	SvxTabStopItem	aNewTabs;
	long			nDefDist;
	FieldUnit		eDefUnit;
	BOOL			bCheck;

#ifdef _SVX_TABSTPGE_CXX
	void 			InitTabPos_Impl( USHORT nPos = 0 );
	void 			SetFillAndTabType_Impl();

	DECL_LINK( NewHdl_Impl, Button* );
	DECL_LINK( DelHdl_Impl, Button* );
	DECL_LINK( DelAllHdl_Impl, Button* );

	DECL_LINK( FillTypeCheckHdl_Impl, RadioButton* );
	DECL_LINK( TabTypeCheckHdl_Impl, RadioButton* );

	DECL_LINK( SelectHdl_Impl, MetricBox* );
	DECL_LINK( ModifyHdl_Impl, MetricBox* );
	DECL_LINK( GetFillCharHdl_Impl, Edit* );
	DECL_LINK( GetDezCharHdl_Impl, Edit* );
#endif
};

#endif 

