
#ifndef _SVX_TEXTATTR_HXX
#define _SVX_TEXTATTR_HXX

#ifndef _SVX_DLG_CTRL_HXX
#include <svx/dlgctrl.hxx>
#endif

#ifndef _GROUP_HXX 
#include <vcl/group.hxx>
#endif

#ifndef _FIXED_HXX 
#include <vcl/fixed.hxx>
#endif

#ifndef _BASEDLGS_HXX 
#include <sfx2/basedlgs.hxx>
#endif

class SdrView;

class SvxTextAttrPage : public SvxTabPage
{
private:
	FixedLine			aFlText;
	TriStateBox         aTsbAutoGrowWidth;
	TriStateBox         aTsbAutoGrowHeight;
	TriStateBox			aTsbFitToSize;
	TriStateBox			aTsbContour;

	FixedLine			aFlDistance;
	FixedText			aFtLeft;
	MetricField			aMtrFldLeft;
	FixedText			aFtRight;
	MetricField			aMtrFldRight;
	FixedText			aFtTop;
	MetricField			aMtrFldTop;
	FixedText			aFtBottom;
	MetricField			aMtrFldBottom;

	FixedLine			aFlSeparator;

	FixedLine			aFlPosition;
	SvxRectCtl			aCtlPosition;
	TriStateBox			aTsbFullWidth;

	const SfxItemSet&	rOutAttrs;
	const SdrView*		pView;

	BOOL				bAutoGrowSizeEnabled;
	BOOL				bContourEnabled;

#ifdef _SVX_TEXTATTR_CXX
	DECL_LINK( ClickFullWidthHdl_Impl, void * );
	DECL_LINK( ClickHdl_Impl, void * );
#endif

public:

	SvxTextAttrPage( Window* pWindow, const SfxItemSet& rInAttrs );
	~SvxTextAttrPage();

	static SfxTabPage* 	Create( Window*, const SfxItemSet& );
	static  USHORT*	    GetRanges();

	virtual BOOL 		FillItemSet( SfxItemSet& );
	virtual void 		Reset( const SfxItemSet & );

	virtual void 		PointChanged( Window* pWindow, RECT_POINT eRP );

	void 		 Construct();
	void		 SetView( const SdrView* pSdrView ) { pView = pSdrView; }
};

class SvxTextAttrDialog : public SfxSingleTabDialog
{
public:
	SvxTextAttrDialog( Window* pParent, const SfxItemSet& rAttr,
		   const SdrView* pView );
	~SvxTextAttrDialog();
};

#endif 

