
#ifndef _SVX_TXENCBOX_HXX
#define _SVX_TXENCBOX_HXX

#ifndef _LSTBOX_HXX 
#include <vcl/lstbox.hxx>
#endif

class SvxTextEncodingTable;

class SvxTextEncodingBox : public ListBox
{
private:
	const SvxTextEncodingTable*		m_pEncTable;

	USHORT				EncodingToPos_Impl( rtl_TextEncoding nEnc ) const;

public:
			SvxTextEncodingBox( Window* pParent, const ResId& rResId );
			~SvxTextEncodingBox();

	void				FillFromTextEncodingTable(
				sal_uInt32 nExcludeInfoFlags = 0,
				sal_uInt32 nButIncludeInfoFlags = 0
				);

	void				FillWithMimeAndSelectBest();

	const SvxTextEncodingTable*		GetTextEncodingTable() const
				{ return m_pEncTable; }

	void				InsertTextEncoding( const rtl_TextEncoding nEnc,
				USHORT nPos = LISTBOX_APPEND );

	void				InsertTextEncoding( const rtl_TextEncoding nEnc,
				const String& rEntry,
				USHORT nPos = LISTBOX_APPEND );

	void				RemoveTextEncoding( const rtl_TextEncoding nEnc );

	void				SelectTextEncoding( const rtl_TextEncoding nEnc,
				BOOL bSelect = TRUE );

	rtl_TextEncoding	GetSelectTextEncoding() const;

	const String&		GetSelectTextString() const;

	BOOL				IsTextEncodingSelected( const rtl_TextEncoding nEnc ) const;
};

#endif

