

#ifndef _SVX_UNOIPSET_HXX_
#define _SVX_UNOIPSET_HXX_

#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSETINFO_HPP_
#include <com/sun/star/beans/XPropertySetInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif

class SvxIDPropertyCombineList;
class SdrItemPool;
struct SfxItemPropertyMap;
class SfxItemSet;
class SvxShape;

class SvxItemPropertySet
{
	const SfxItemPropertyMap* 	_pMap;
	SdrItemPool*				pItemPool;
	SvxIDPropertyCombineList*	pCombiList;
	sal_Bool					mbConvertTwips;

public:
	SvxItemPropertySet( const SfxItemPropertyMap *pMap, sal_Bool bConvertTwips = sal_False );
	~SvxItemPropertySet();

	::com::sun::star::uno::Any getPropertyValue( const SfxItemPropertyMap* pMap, const SfxItemSet& rSet ) const;
	void setPropertyValue( const SfxItemPropertyMap* pMap, const ::com::sun::star::uno::Any& rVal, SfxItemSet& rSet ) const;

	::com::sun::star::uno::Any getPropertyValue( const SfxItemPropertyMap* pMap ) const;
	void setPropertyValue( const SfxItemPropertyMap* pMap, const ::com::sun::star::uno::Any& rVal ) const;

	void ObtainSettingsFromPropertySet(SvxItemPropertySet& rPropSet,  SfxItemSet& rSet, ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > xSet );
	sal_Bool AreThereOwnUsrAnys() { return (pCombiList ? sal_True : sal_False); }
	::com::sun::star::uno::Any* GetUsrAnyForID(sal_uInt16 nWID) const;
	void AddUsrAnyForID(const ::com::sun::star::uno::Any& rAny, sal_uInt16 nWID);

	com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySetInfo > getPropertySetInfo() const;
	const SfxItemPropertyMap* getPropertyMap() const {return _pMap;}
	void setPropertyMap( const SfxItemPropertyMap *pMap ) { _pMap = pMap; }
	const SfxItemPropertyMap* getPropertyMapEntry(const ::rtl::OUString &rName) const;
};

#endif 

