

#ifndef _SVX_XBITMAP_HXX
#define _SVX_XBITMAP_HXX

#ifndef _COLOR_HXX 
#include <vcl/color.hxx>
#endif
#ifndef _BITMAP_HXX 
#include <vcl/bitmap.hxx>
#endif
#ifndef _GRFMGR_HXX 
#include <goodies/grfmgr.hxx>
#endif
#include <svx/xenum.hxx>

#if defined HP9000 || defined SINIX
static Size aXOBitmapDefaultSize( 8, 8 );
#endif

class XOBitmap
{
protected:
	XBitmapType     eType;
	XBitmapStyle    eStyle;
	GraphicObject	aGraphicObject;
	USHORT*         pPixelArray;
	Size            aArraySize;
	Color           aPixelColor;
	Color           aBckgrColor;
	BOOL            bGraphicDirty;

public:
	XOBitmap();
	XOBitmap( const GraphicObject& rGraphicObject, XBitmapStyle eStyle = XBITMAP_TILE );
	XOBitmap( const Bitmap& rBitmap, XBitmapStyle eStyle = XBITMAP_TILE );
#if defined HP9000 || defined SINIX
	XOBitmap( const USHORT* pArray, const Color& aPixelColor,
	const Color& aBckgrColor, const Size& rSize = aXOBitmapDefaultSize,
	XBitmapStyle eStyle = XBITMAP_TILE );
#else
	XOBitmap( const USHORT* pArray, const Color& aPixelColor,
	const Color& aBckgrColor, const Size& rSize = Size( 8, 8 ),
	XBitmapStyle eStyle = XBITMAP_TILE );
#endif
	XOBitmap( const XOBitmap& rXBmp );
	~XOBitmap();

	XOBitmap& operator=( const XOBitmap& rXOBitmap );
	int      operator==( const XOBitmap& rXOBitmap ) const;

	void Bitmap2Array();
	void Array2Bitmap();

	void SetGraphicObject( const GraphicObject& rObj )	{ aGraphicObject = rObj; bGraphicDirty = FALSE; }
	void SetBitmap( const Bitmap& rBmp )				{ aGraphicObject = GraphicObject( Graphic( rBmp ) ); bGraphicDirty = FALSE; }
	void SetBitmapType( XBitmapType eNewType )			{ eType = eNewType; }
	void SetBitmapStyle( XBitmapStyle eNewStyle )		{ eStyle = eNewStyle; }
	void SetPixelArray( const USHORT* pArray );
	void SetPixelSize( const Size& rSize )				{ aArraySize  = rSize;  bGraphicDirty = TRUE; }
	void SetPixelColor( const Color& rColor )			{ aPixelColor = rColor; bGraphicDirty = TRUE; }
	void SetBackgroundColor( const Color& rColor )		{ aBckgrColor = rColor; bGraphicDirty = TRUE; }

	XBitmapType				GetBitmapType() const				{ return eType; }
	XBitmapStyle			GetBitmapStyle() const				{ return eStyle; }
	const GraphicObject&	GetGraphicObject() const;
	Bitmap					GetBitmap() const;
	USHORT*					GetPixelArray() const				{ return pPixelArray; }
	Color					GetPixelColor() const				{ return aPixelColor; }
	Color					GetBackgroundColor() const			{ return aBckgrColor; }
};

#endif

