

#ifndef _SVX_XFLHTIT_HXX
#define _SVX_XFLHTIT_HXX

#ifndef _SVX_XIT_HXX 
#include <svx/xit.hxx>
#endif

#ifndef _SVX_XHATCH_HXX 
#include <svx/xhatch.hxx>
#endif

class SdrModel;

class XFillHatchItem : public NameOrIndex
{
	XHatch  aHatch;

public:
				TYPEINFO();
				XFillHatchItem() : NameOrIndex(XATTR_FILLHATCH, -1) {}
				XFillHatchItem(long nIndex, const XHatch& rTheHatch);
				XFillHatchItem(const String& rName, const XHatch& rTheHatch);
				XFillHatchItem(SfxItemPool* pPool, const XHatch& rTheHatch);
				XFillHatchItem(SfxItemPool* pPool );
				XFillHatchItem(const XFillHatchItem& rItem);
				XFillHatchItem(SvStream& rIn);

	virtual int             operator==(const SfxPoolItem& rItem) const;
	virtual SfxPoolItem*    Clone(SfxItemPool* pPool = 0) const;
	virtual SfxPoolItem*    Create(SvStream& rIn, USHORT nVer) const;
	virtual SvStream&       Store(SvStream& rOut, USHORT nItemVersion ) const;

	virtual	sal_Bool        	 QueryValue( com::sun::star::uno::Any& rVal, BYTE nMemberId = 0 ) const;
	virtual	sal_Bool			 PutValue( const com::sun::star::uno::Any& rVal, BYTE nMemberId = 0 );
	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
	                                String &rText, const IntlWrapper * = 0 ) const;
	virtual FASTBOOL		HasMetrics() const;
	virtual FASTBOOL		ScaleMetrics(long nMul, long nDiv);

	const XHatch&			GetValue(const XHatchTable* pTable = 0) const;
	void					SetValue(const XHatch& rNew)  { aHatch = rNew; Detach(); }

	static BOOL CompareValueFunc( const NameOrIndex* p1, const NameOrIndex* p2 );
	XFillHatchItem* checkForUniqueItem( SdrModel* pModel ) const;
};

#endif

