

#ifndef _SVX_XLNDSIT_HXX
#define _SVX_XLNDSIT_HXX

#ifndef _SVX_XIT_HXX 
#include <svx/xit.hxx>
#endif

#ifndef _SVX_XLINIIT_HXX 
#include <svx/xdash.hxx>
#endif

class SdrModel;

class XLineDashItem : public NameOrIndex
{
	XDash   aDash;

public:
				TYPEINFO();
				XLineDashItem() {}
				XLineDashItem(long nIndex, const XDash& rTheDash);
				XLineDashItem(const String& rName, const XDash& rTheDash);
				XLineDashItem(SfxItemPool* pPool, const XDash& rTheDash);
				XLineDashItem(SfxItemPool* pPool );
				XLineDashItem(const XLineDashItem& rItem);
				XLineDashItem(SvStream& rIn);

	virtual int             operator==(const SfxPoolItem& rItem) const;
	virtual SfxPoolItem*    Clone(SfxItemPool* pPool = 0) const;
	virtual SfxPoolItem*    Create(SvStream& rIn, USHORT nVer) const;
	virtual SvStream&       Store(SvStream& rOut, USHORT nItemVersion ) const;

	virtual	sal_Bool        	 QueryValue( com::sun::star::uno::Any& rVal, BYTE nMemberId = 0 ) const;
	virtual	sal_Bool			 PutValue( const com::sun::star::uno::Any& rVal, BYTE nMemberId = 0 );

	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
						SfxMapUnit eCoreMetric,
						SfxMapUnit ePresMetric,
	                                String &rText, const IntlWrapper * = 0 ) const;
	virtual FASTBOOL		HasMetrics() const;
	virtual FASTBOOL		ScaleMetrics(long nMul, long nDiv);

	const XDash&			GetValue(const XDashTable* pTable = 0) const;
	void					SetValue(const XDash& rNew)   { aDash = rNew; Detach(); }

	static BOOL CompareValueFunc( const NameOrIndex* p1, const NameOrIndex* p2 );
	XLineDashItem* checkForUniqueItem( SdrModel* pModel ) const;
};

#endif

