

#ifndef _XOUTX_HXX
#define _XOUTX_HXX

#ifndef _SV_BITMAP_HXX
#include <vcl/bitmap.hxx>
#endif

#include <svx/xhatch.hxx>
#include <svx/xgrad.hxx>
#ifndef _XPOLY_HXX 
#include <svx/xpoly.hxx>
#endif
#ifndef _SVX_RECTENUM_HXX 
#include <svx/rectenum.hxx>
#endif
#ifndef _XENUM_HXX
#include <svx/xenum.hxx>
#endif
#ifndef _OUTDEV_HXX 
#include <vcl/outdev.hxx>
#endif
#ifndef _BITMAP_HXX 
#include <vcl/bitmap.hxx>
#endif

class FormattedText;
class XPolygon;
class XPolyPolygon;
class XLineAttrSetItem;
class XFillAttrSetItem;
class XTextAttrSetItem;
class XLineAttrSetItem;
class XFillAttrSetItem;
class XOutdevItemPool;
class XLineParam;
struct ImpData;
class SfxItemSet;

#if 0 // _SOLAR__PRIVATE

struct ImpData
{
	XGradient*	pTransGradient;
	BOOL		bSolidHatch;
};

#define iRotTransGradient()	( ( (ImpData*)pImpData )->pTransGradient )
#define iSolidHatch()		( ( (ImpData*)pImpData )->bSolidHatch )

#endif 

class XOutputDevice
{

	ImpData*			pImpData;

	long*				pLinePattern;
	USHORT				nLinePatternCnt;

	XLineStyle			eLineStyle;
	Color				aLineColor;
	USHORT				nLineTransparence;
	long				nLineWidth;
	XPolygon			aLineStartPoly, aLineEndPoly;
	long				nLineStartSqLen, nLineEndSqLen;
	BOOL				bLineStart, bLineEnd;
	BOOL				bHair;

	XFillStyle			eFillStyle;
	Color				aFillColor;
	USHORT				nFillTransparence;

	Bitmap				aFillBitmap;
	Bitmap				aLastFillBitmap;
	Bitmap				aLastAttrBitmap;
	MapMode				aLastMapMode;
	MapMode				aScreenMap;
	Size				aFillBitmapSize;
	Size				aLastFillBitmapSize;
	Size				aBmpSize;
	Size				aTileSize;
	Point				aStartPoint;
	USHORT				nBmpPerCentX;
	USHORT				nBmpPerCentY;
	USHORT				nBmpOffX;
	USHORT				nBmpOffY;
	USHORT				nBmpOffPosX;
	USHORT				nBmpOffPosY;
	OutDevType			aLastOutDevType;
	RECT_POINT			eBmpRectPoint;
	BOOL				bBmpTile;
	BOOL				bBmpStretch;
	BOOL				bBmpLogSize;
	BOOL				bIntermediateBmp;
	BOOL				bRecalc;

	XGradient			aGradient;
	XHatch				aHatch;
	BOOL				bDither;

	BOOL				bIgnoreLineAttr;
	BOOL				bIgnoreLineStyle;
	BOOL				bIgnoreFillAttr;

	XFormTextStyle      eFormTextStyle;
	XFormTextAdjust     eFormTextAdjust;
	long                nFormTextDistance;
	long                nFormTextStart;
	BOOL                bFormTextMirror;
	BOOL                bFormTextOutline;
	XFormTextShadow     eFormTextShadow;
	Color               aFormTextShdwColor;
	USHORT              nFormTextShdwTransp;
	long                nFormTextShdwXVal;
	long                nFormTextShdwYVal;
	XFormTextStdForm    eFormTextStdForm;
	BOOL                bFormTextHideForm;

	long				nFtAutoHeightSave;

	Rectangle			aFormTextBoundRect;

	void				ImpDrawFillPolyPolygon( const PolyPolygon& rPoly, BOOL bRect, BOOL bPrinter );
	void				ImpDrawLinePolygon(const Polygon& rPoly, BOOL bClosePoly);

protected:

	OutputDevice*		pOut;
	Point				aOfs;

	void				CalcFatLineJoin(const Point& rEnd, const Point& rNext, XLineParam& rParam);
	void				DrawFillPolyPolygon( const PolyPolygon& rPoly, BOOL bRect = FALSE );
	void				DrawLinePolygon( const Polygon& rPoly, BOOL bClosePoly );
	void				DrawStartEndPoly(const Point& rPos, const XPolygon& rXPoly, const XLineParam& rParam);
	void				DrawLineStartEnd(const Polygon& rPoly);
	void				DrawFatLine(const Point& rStart, const Point& rEnd, const Point* pNext, XLineParam& rParam);
	void				DrawPatternLine(const Point& rStart, const Point& rEnd, XLineParam& rParam);

	long				ImpDrawFormText(const String& rText, const Polygon& rPoly,
							Font aFont, long nAbsStart, BOOL bIsShadow,
							BOOL bToLastPoint, BOOL bDraw,
							const long* pDXArray = NULL);
	void				DrawFormTextShadow(const String& rText, const Polygon& rPoly,
							   const Font& rFont, long nAbsStart,
							   BOOL bToLastPoint, BOOL bDraw,
							   const long* pDXArray = NULL);

	void				ImpDrawBitmapFill( const Rectangle& rRect, BOOL bPrinter );
	void				ImpCalcBmpFillStartValues( const Rectangle& rRect, BOOL bPrinter );
	void				ImpDrawTiledBitmap( OutputDevice* pOut, const Rectangle& rRect,
								const Point& rStartPoint, const Rectangle& rClipRect,
	                                        BOOL bPrinter );

 public:
			XOutputDevice(OutputDevice* pOut);
			~XOutputDevice();

	OutputDevice*		GetOutDev() const { return pOut; }
	void				SetOutDev(OutputDevice* pNewOut) { pOut=pNewOut; }

	RasterOp			GetRasterOp() const { return pOut->GetRasterOp(); }
	void				SetRasterOp(RasterOp eRop) { pOut->SetRasterOp(eRop); }

	void				DrawLine( const Point& rStart, const Point& rEnd );
	void				DrawRect( const Rectangle& rRect,
					  ULONG nXRound=0, ULONG nYRound=0 );
	void				DrawEllipse( const Rectangle& rRect );
	void				DrawArc( const Rectangle& rRect,
					 const Point& rStart, const Point& rEnd );
	void				DrawPie( const Rectangle& rRect,
					 const Point& rStart, const Point& rEnd );
	void				DrawPolyLine( const Polygon& rPoly );
	void				DrawPolygon( const Polygon& rPoly );
	void				DrawPolyPolygon( const PolyPolygon& rPolyPoly );
	void				DrawXPolyLine( const XPolygon& rXPoly );
	void				DrawXPolygon( const XPolygon& rXPoly );
	void				DrawXPolyPolygon( const XPolyPolygon& rXPoly );

	void				DrawBitmap( const Point& rPos, const Size& rSize, const Bitmap& rBmp );
	void				DrawBitmap( const Point& rDestPos, const Size& rDestSize,
						const Point& rSrcPos,  const Size& rSrcSize );

	void				DrawFormattedText( const Point& rPos, const FormattedText& rText );
	long				DrawFormText(const String& rText, const Polygon& rXPoly,
						 Font aFont, long nAbsStart = 0,
						 BOOL bToLastPoint = TRUE, BOOL bDraw = TRUE,
						 const long* pDXArray = NULL);
	long				DrawFormText(const String& rText, const XPolygon& rXPoly,
						 Font aFont, long nAbsStart = 0,
						 BOOL bToLastPoint = TRUE, BOOL bDraw = TRUE,
						 const long* pDXArray = NULL);
	const Rectangle&	GetFormTextBoundRect() const { return aFormTextBoundRect; }

#ifndef NOOLDSV

	const Pen&			GetPen() const { static Pen aPen; aPen = pOut->GetPen(); return aPen; }
	void				SetPen( const Pen& rPen ) { pOut->SetPen( rPen ); }

	const Brush&		GetBrush() const { static Brush aBrush; aBrush = pOut->GetFillInBrush(); return aBrush; }
	void				SetFillInBrush( const Brush& rBrush ) { pOut->SetFillInBrush( rBrush ); }

	void				OverridePen(const Pen& rPen);
	void				OverrideFillInBrush(const Brush& rBrush);
#endif

	const Color&		GetLineColor() const { return pOut->GetLineColor(); }
	void				SetLineColor( const Color& rColor ) { pOut->SetLineColor( rColor ); }

	const Color&		GetFillColor() const { return pOut->GetFillColor(); }
	void				SetFillColor( const Color& rColor ) { pOut->SetFillColor( rColor ); }

	void				SetLineAttr(const SfxItemSet& rAttr);
	void				SetFillAttr(const SfxItemSet& rAttr);
	void				SetTextAttr(const SfxItemSet& rAttr);

	void				SetIgnoreLineAttr(BOOL bIgnore) { bIgnoreLineAttr = bIgnore; }
	BOOL				GetIgnoreLineAttr() { return bIgnoreLineAttr; }
	void				SetIgnoreLineStyle(BOOL bIgnore) { bIgnoreLineStyle = bIgnore; }
	BOOL				GetIgnoreLineStyle() { return bIgnoreLineStyle; }
	void				SetIgnoreFillAttr(BOOL bIgnore) { bIgnoreFillAttr = bIgnore; }
	BOOL				GetIgnoreFillAttr() { return bIgnoreFillAttr; }

	void				OverrideLineColor(const Color& rColor );
	void				OverrideFillColor(const Color& rColor );

	BOOL				IsLineStart() const { return bLineStart; }
	void				OverrideLineStart(BOOL bOn) { bLineStart=bOn; }
	BOOL				IsLineEnd() const { return bLineEnd; }
	void				OverrideLineEnd(BOOL bOn) { bLineEnd=bOn; }

	const Point&		GetOffset() const { return aOfs; }
	void				SetOffset( const Point& rOfs );

	MapMode				GetMapMode() const;
	void				SetMapMode( const MapMode& rMap );

	static long			InitLineStartEnd(XPolygon& rXPoly, long nWidth, BOOL bCenter);
};

class ExtOutputDevice : public XOutputDevice 
{
public:

		ExtOutputDevice(OutputDevice* pNewOut): XOutputDevice(pNewOut) {}
};

Rectangle		XOutCalcXPolyExtent(const XPolygon& rXPoly, OutputDevice* pOut);
long			XOutCalcBezierStepCount( const XPolygon& rXPoly, USHORT nIndex, OutputDevice* pOut, USHORT nRough = 0 );
void			XOutCalcBezier( const XPolygon& rXPoly, USHORT nBezIndex, Polygon& rPoly, USHORT nPolyIndex, long nSteps );
Polygon			XOutCreatePolygon( const XPolygon& rXPoly, OutputDevice* pOut, USHORT nRough = 0 );
XPolyPolygon	XOutGetCharOutline( USHORT nChar, OutputDevice& rOut, BOOL bOptimizeSize = TRUE );

#endif      

