
#ifndef _SVX_ZOOM_HXX
#define _SVX_ZOOM_HXX

#ifndef _BASEDLGS_HXX 
#include <sfx2/basedlgs.hxx>
#endif
#ifndef _SV_BUTTON_HXX 
#include <vcl/button.hxx>
#endif
#ifndef _SV_FIELD_HXX 
#include <vcl/field.hxx>
#endif
#ifndef _SV_FIXED_HXX
#include <vcl/fixed.hxx>
#endif

#define	ZOOMBTN_OPTIMAL		((USHORT)0x0001)
#define ZOOMBTN_PAGEWIDTH	((USHORT)0x0002)
#define ZOOMBTN_WHOLEPAGE	((USHORT)0x0004)

class SvxZoomDialog : public SfxModalDialog
{
private:
	FixedLine           aZoomFl;
	RadioButton 		aWholePageBtn;
	RadioButton 		aPageWidthBtn;
	RadioButton 		aOptimalBtn;
	RadioButton         a200Btn;
	RadioButton 		a150Btn;
	RadioButton 		a100Btn;
	RadioButton 		a75Btn;
	RadioButton 		a50Btn;
	RadioButton         aUserBtn;
	MetricField 		aUserEdit;
	OKButton  			aOKBtn;
	CancelButton		aCancelBtn;
	HelpButton			aHelpBtn;

	const SfxItemSet&	rSet;
	SfxItemSet*			pOutSet;
	BOOL				bModified;

#ifdef _SVX_ZOOM_CXX
	DECL_LINK( UserHdl, RadioButton* );
	DECL_LINK( SpinHdl, MetricField* );
	DECL_LINK( OKHdl, Button* );
#endif

public:
	SvxZoomDialog( Window* pParent, const SfxItemSet& rCoreSet );
	~SvxZoomDialog();

	static USHORT*		GetRanges();
	const SfxItemSet*	GetOutputItemSet() const { return pOutSet; }

	USHORT				GetFactor() const;
	void				SetFactor( USHORT nNewFactor, USHORT nBtnId = 0 );

	void				SetButtonText( USHORT nBtnId, const String& aNewTxt );
	void				HideButton( USHORT nBtnId );
	void				SetLimits( USHORT nMin, USHORT nMax );
	void				SetSpinSize( USHORT nNewSpin );
};

#endif

