
#ifndef _SVX_ZOOMITEM_HXX
#define _SVX_ZOOMITEM_HXX

#ifndef _SFXINTITEM_HXX 
#include <svtools/intitem.hxx>
#endif
#ifndef _SVX_SVXIDS_HRC
#include <svx/svxids.hrc>
#endif

enum SvxZoomType
{
	SVX_ZOOM_PERCENT,   	
	SVX_ZOOM_OPTIMAL,		
	SVX_ZOOM_WHOLEPAGE,		
	SVX_ZOOM_PAGEWIDTH,      
	SVX_ZOOM_PAGEWIDTH_NOBORDER  
};

class SvxZoomItem: public SfxUInt16Item
{
	USHORT					nValueSet;	
	SvxZoomType				eType;

public:
	TYPEINFO();

	SvxZoomItem( SvxZoomType eZoomType = SVX_ZOOM_PERCENT,
	 USHORT nVal = 0, USHORT nWhich = SID_ATTR_ZOOM );
	SvxZoomItem( const SvxZoomItem& );
	~SvxZoomItem();

	void					SetValueSet( USHORT nValues ) { nValueSet = nValues; }
	USHORT					GetValueSet() const { return nValueSet; }
	FASTBOOL				IsValueAllowed( USHORT nValue ) const
				{ return nValue == ( nValue & nValueSet ); }

	SvxZoomType 			GetType() const { return eType; }
	void					SetType( SvxZoomType eNewType )
				{ eType = eNewType; }

	virtual SfxPoolItem*	Clone( SfxItemPool *pPool = 0 ) const;
	virtual SfxPoolItem*	Create( SvStream& rStrm, USHORT nVersion ) const;
	virtual SvStream&		Store( SvStream& rStrm , USHORT nItemVersion ) const;
	virtual int				operator==( const SfxPoolItem& ) const;
};

#define SVX_ZOOM_ENABLE_50 			0x0001
#define SVX_ZOOM_ENABLE_75 			0x0002
#define SVX_ZOOM_ENABLE_100			0x0004
#define SVX_ZOOM_ENABLE_150			0x0008
#define SVX_ZOOM_ENABLE_200			0x0010
#define SVX_ZOOM_ENABLE_OPTIMAL		0x1000
#define SVX_ZOOM_ENABLE_WHOLEPAGE	0x2000
#define SVX_ZOOM_ENABLE_PAGEWIDTH	0x4000
#define SVX_ZOOM_ENABLE_ALL         0x701F

#endif
