

#ifndef _TOOLKIT_HELPER_UNOWRAPPER_HXX_
#define _TOOLKIT_HELPER_UNOWRAPPER_HXX_

#ifndef _COM_SUN_STAR_AWT_XTOOLKIT_HPP_
#include <com/sun/star/awt/XToolkit.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_XGRAPHICS_HPP_
#include <com/sun/star/awt/XGraphics.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_XWINDOWPEER_HPP_
#include <com/sun/star/awt/XWindowPeer.hpp>
#endif

#include <vcl/unowrap.hxx>
#include <vcl/window.hxx>

class UnoWrapper : public UnoWrapperBase
{
private:
	::com::sun::star::uno::Reference< ::com::sun::star::awt::XToolkit> mxToolkit;

public:	
	UnoWrapper( const ::com::sun::star::uno::Reference< ::com::sun::star::awt::XToolkit>& rxToolkit );

	void 								Destroy();

	virtual ::com::sun::star::uno::Reference< ::com::sun::star::awt::XToolkit> GetVCLToolkit();

	virtual ::com::sun::star::uno::Reference< ::com::sun::star::awt::XGraphics>	CreateGraphics( OutputDevice* pOutDev );
	virtual void				ReleaseAllGraphics( OutputDevice* pOutDev );

	virtual ::com::sun::star::uno::Reference< ::com::sun::star::awt::XWindowPeer> GetWindowInterface( Window* pWindow, BOOL bCreate );
	virtual void				SetWindowInterface( Window* pWindow, ::com::sun::star::uno::Reference< ::com::sun::star::awt::XWindowPeer> xIFace );

	void				WindowDestroyed( Window* pWindow );
	void 				WindowEvent_Move( Window* pWindow );
	void 				WindowEvent_Resize( Window* pWindow );
	void 				WindowEvent_Show( Window* pWindow, BOOL bShow );
	void 				WindowEvent_Close( Window* pWindow );
	void 				WindowEvent_Minimize( Window* pWindow );
	void 				WindowEvent_Normalize( Window* pWindow );
	void 				WindowEvent_Activate( Window* pWindow, BOOL bActivated );
	void 				WindowEvent_MouseButtonUp( Window* pWindow, const MouseEvent& rEvt );
	void 				WindowEvent_MouseButtonDown( Window* pWindow, const MouseEvent& rEvt );
	void 				WindowEvent_MouseMove( Window* pWindow, const MouseEvent& rEvt );
	void 				WindowEvent_Command( Window* pWindow, const CommandEvent& rCEvt );
	void 				WindowEvent_KeyInput( Window* pWindow, const KeyEvent& rEvt );
	void 				WindowEvent_KeyUp( Window* pWindow, const KeyEvent& rEvt );
	void 				WindowEvent_GetFocus( Window* pWindow );
	void 				WindowEvent_LoseFocus( Window* pWindow );
	void 				WindowEvent_Paint( Window* pWindow, const Rectangle& rRect );
};

#endif 

