

#ifndef _TOOLKIT_HELPER_VCLUNOHELPER_HXX_
#define _TOOLKIT_HELPER_VCLUNOHELPER_HXX_

#ifndef _COM_SUN_STAR_UNO_REFERENCE_H_
#include <com/sun/star/uno/Reference.h>
#endif
#ifndef _COM_SUN_STAR_UNO_SEQUENCE_H_
#include <com/sun/star/uno/Sequence.h>
#endif

namespace com { namespace sun { namespace star { namespace uno {
	class XInterface;
}}}}

namespace com { namespace sun { namespace star { namespace awt {
	class XBitmap;
	class XWindow;
	class XWindowPeer;
	class XGraphics;
	class XRegion;
	class XDevice;
	class XPointer;
	class XToolkit;
	class XFont;
	class XControlContainer;
	struct SimpleFontMetric;
	struct FontDescriptor;
	struct Rectangle;
}}}}

#include <vcl/bitmapex.hxx>
#include <vcl/region.hxx>
#include <vcl/metric.hxx>
#include <vcl/poly.hxx>

class Window;
class OutputDevice;

class VCLUnoHelper
{
public:

	static ::com::sun::star::uno::Reference< ::com::sun::star::awt::XToolkit>	CreateToolkit();

	static BitmapEx															GetBitmap( const ::com::sun::star::uno::Reference< ::com::sun::star::awt::XBitmap>& rxBitmap );
	static ::com::sun::star::uno::Reference< ::com::sun::star::awt::XBitmap>	CreateBitmap( const BitmapEx& rBitmap );

	static Window* 															GetWindow( const ::com::sun::star::uno::Reference< ::com::sun::star::awt::XWindow>& rxWindow );
	static Window* 															GetWindow( const ::com::sun::star::uno::Reference< ::com::sun::star::awt::XWindowPeer>& rxWindowPeer );
	static ::com::sun::star::uno::Reference< ::com::sun::star::awt::XWindow>	GetInterface( Window* pWindow );

	static OutputDevice* 							GetOutputDevice( const ::com::sun::star::uno::Reference< ::com::sun::star::awt::XDevice>& rxDevice );
	static OutputDevice* 							GetOutputDevice( const ::com::sun::star::uno::Reference< ::com::sun::star::awt::XGraphics>& rxGraphics );

	static Region									GetRegion( const ::com::sun::star::uno::Reference< ::com::sun::star::awt::XRegion >& rxRegion );

	static ::com::sun::star::uno::Reference< ::com::sun::star::awt::XPointer> CreatePointer();

	static Polygon									CreatePolygon( const ::com::sun::star::uno::Sequence< sal_Int32 >& DataX, const ::com::sun::star::uno::Sequence< sal_Int32 >& DataY );

	static ::com::sun::star::awt::FontDescriptor	CreateFontDescriptor( const Font& rFont );
	static Font										CreateFont( const ::com::sun::star::awt::FontDescriptor& rDescr, const Font& rInitFont );
	static Font										CreateFont( const ::com::sun::star::uno::Reference< ::com::sun::star::awt::XFont >& rxFont );
	static ::com::sun::star::awt::SimpleFontMetric	CreateFontMetric( const FontMetric& rFontMetric );
	static float 									ConvertFontWidth( FontWidth eWidth );
	static FontWidth 								ConvertFontWidth( float f );
	static float 									ConvertFontWeight( FontWeight eWeight );
	static FontWeight 								ConvertFontWeight( float f );

	static sal_Bool									IsZero( ::com::sun::star::awt::Rectangle rRect );

	static ::com::sun::star::uno::Reference< ::com::sun::star::awt::XControlContainer>	CreateControlContainer( Window* pWindow );

};

#endif	
