

#ifndef _CACHESTR_HXX
#define _CACHESTR_HXX

#ifndef _STREAM_HXX
#include <tools/stream.hxx>
#endif
#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif
#ifndef _LINK_HXX
#include <tools/link.hxx>
#endif

class TempFile;
class SvCacheStream : public SvStream
{
private:
	String          aFileName;
	ULONG           nMaxSize;
	int             bPersistent;
	 SvStream*       pSwapStream;
	SvStream*       pCurrentStream;
	TempFile*       pTempFile;
	 Link    		aFilenameLinkHdl;
	 virtual ULONG   GetData( void* pData, ULONG nSize );
	virtual ULONG   PutData( const void* pData, ULONG nSize );
	virtual ULONG   SeekPos( ULONG nPos );
	virtual void    FlushData();
	virtual void    SetSize( ULONG nSize );

public:
	                SvCacheStream( ULONG nMaxMemSize = 0 );
	                SvCacheStream( const String &rFileName,
		               ULONG nExpectedSize = 0,
	                			   ULONG nMaxMemSize = 0 );
	                ~SvCacheStream();

	void			SetFilenameHdl( const Link& rLink);
	const Link&     GetFilenameHdl() const;
	void			SetFilename( const String& rFN )
	          { aFileName = rFN; } 
	const String&   GetFilename() const { return aFileName;	}
	 void            SwapOut();
	const void*     GetBuffer();
	ULONG           GetSize();

	BOOL			IsPersistent() { return bPersistent; }
	void			SetPersistence( BOOL b = TRUE ) { bPersistent = b; }
	void			SetSwapStream( SvStream *p )
	          { pSwapStream = p; } 
};

#endif
