

#ifndef _CHAPI_HXX
#define _CHAPI_HXX

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif

class ChannelAgentItem;
class INetURLObject;
class String;

enum RequestType {
	REQTYP_LOCAL_FILE	= 1,
	REQTYP_MEMORY		= 2
};

class ChApi
{
public:
	virtual ~ChApi() {}

	virtual void	ShutDownAgent() = 0;
	virtual void	SetLastSuccUpd() = 0;

	virtual void	GetChannelObject( const INetURLObject& rURL, RequestType eStreamType,
				const String& rFileName ) = 0;
	virtual void    AddChannelItem( const String& aChName, const INetURLObject& aTransmitter,
				const String& aChannel, USHORT nUpdPeriode,
				const String& rChAgentName ) = 0;
	virtual void    DelChannelItem( const String& aChName ) = 0;
	virtual void	SetChTransmitter( const String& aChName, const String& rNewVal ) = 0;
	virtual void	SetChannel( const String& aChName, const String& rNewVal ) = 0;
	virtual void	SetChannelName( const String& aChName, const String& rNewVal ) = 0;
	virtual void	SetChUpdPeriode( const String& aChName, USHORT nUpdPeriode ) = 0;
	virtual void	SetChannelAgentName( const String& aChName, const String& rNewVal ) = 0;

	virtual void	SetUpdateTransmitter(ChannelAgentItem* pAgent, const INetURLObject& rTransmitter) = 0;
};

#endif 
