

#ifndef _LIST_HXX
#define _LIST_HXX

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif

#ifndef _CONTNR_HXX
#include <tools/contnr.hxx>
#endif

#define LIST_APPEND           CONTAINER_APPEND
#define LIST_ENTRY_NOTFOUND   CONTAINER_ENTRY_NOTFOUND

class List : private Container
{
public:
			Container::Insert;
			Container::Remove;
			Container::Replace;
			Container::Clear;
			Container::Count;
			Container::GetCurObject;
			Container::GetCurPos;
			Container::GetObject;
			Container::GetPos;
			Container::Seek;
			Container::First;
			Container::Last;
			Container::Next;
			Container::Prev;
	         List( USHORT _nInitSize = 16, USHORT _nReSize = 16 ) :
	            Container( 1024, _nInitSize, _nReSize ) {}
	        List( USHORT _nBlockSize, USHORT _nInitSize, USHORT _nReSize ) :
	            Container( _nBlockSize, _nInitSize, _nReSize ) {}
	        List( const List& rList ) : Container( rList ) {}
	 List&   operator =( const List& rList )
	            { Container::operator =( rList ); return *this; }
	 BOOL    operator ==( const List& rList ) const
	            { return Container::operator ==( rList ); }
	BOOL    operator !=( const List& rList ) const
	            { return Container::operator !=( rList ); }
};

#define DECLARE_LIST( ClassName, Type )                                 \
class ClassName : private List                                          \
{                                                                       \
public:                                                                 \
	List::Clear;											\
	List::Count;											\
	List::GetCurPos;						\
															\
	            ClassName( USHORT _nInitSize = 16,                      \
	                       USHORT _nReSize = 16 ) :                     \
	                List( _nInitSize, _nReSize ) {}                     \
	            ClassName( USHORT _nBlockSize, USHORT _nInitSize,       \
	                       USHORT _nReSize ) :                          \
	                List( _nBlockSize, _nInitSize, _nReSize ) {}        \
	            ClassName( const ClassName& rClassName ) :              \
	                List( rClassName ) {}                               \
	                                                                    \
	void        Insert( Type p, ULONG nIndex )                          \
	                { List::Insert( (void*)p, nIndex ); }               \
	void        Insert( Type p )                                        \
	                { List::Insert( (void*)p ); }                       \
	void        Insert( Type pNew, Type pOld )                          \
	                { List::Insert( (void*)pNew, (void*)pOld ); }       \
	Type        Remove()                                                \
	                { return (Type)List::Remove(); }                    \
	Type        Remove( ULONG nIndex )                                  \
	                { return (Type)List::Remove( nIndex ); }            \
	Type        Remove( Type p )                                        \
	                { return (Type)List::Remove( (void*)p ); }          \
	Type        Replace( Type p )                                       \
	                { return (Type)List::Replace( (void*)p ); }         \
	Type        Replace( Type p, ULONG nIndex )                         \
	                { return (Type)List::Replace( (void*)p, nIndex ); } \
	Type        Replace( Type pNew, Type pOld )                         \
	                { return (Type)List::Replace( (void*)pNew,          \
	                                              (void*)pOld ); }      \
	                                                                    \
	Type        GetCurObject() const                                    \
	                { return (Type)List::GetCurObject(); }              \
	Type        GetObject( ULONG nIndex ) const                         \
	                { return (Type)List::GetObject( nIndex ); }         \
	ULONG       GetPos( const Type p ) const                            \
	                { return List::GetPos( (const void*)p ); }          \
	ULONG       GetPos( const Type p, ULONG nStartIndex,                \
	                    BOOL bForward = TRUE ) const                    \
	                { return List::GetPos( (const void*)p, nStartIndex, \
	                                       bForward ); }                \
	                                                                    \
	Type        Seek( ULONG nIndex )                                    \
	                { return (Type)List::Seek( nIndex ); }              \
	Type        Seek( void* p ) { return (Type)List::Seek( p ); }       \
	Type        First()         { return (Type)List::First(); }         \
	Type        Last()          { return (Type)List::Last(); }          \
	Type        Next()          { return (Type)List::Next(); }          \
	Type        Prev()          { return (Type)List::Prev(); }          \
	                                                                    \
	ClassName&  operator =( const ClassName& rClassName )               \
	                { List::operator =( rClassName ); return *this; }   \
	                                                                    \
	BOOL        operator ==( const ClassName& rList ) const             \
	                { return List::operator ==( rList ); }              \
	BOOL        operator !=( const ClassName& rList ) const             \
	                { return List::operator !=( rList ); }              \
};

#endif 
