

#ifndef _SVMEMPOOL_HXX
#define _SVMEMPOOL_HXX

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif

struct FixedMemBlock;

class FixedMemPool
{
private:
	FixedMemBlock*  pFirst;
	USHORT          nTypeSize;
	USHORT          nInitSize;
	USHORT          nGrowSize;

public:
	                FixedMemPool( USHORT nTypeSize,
	                              USHORT nInitSize = 512,
	                              USHORT nGrowSize = 256 );
	                ~FixedMemPool();
	 void*           Alloc();
	void            Free( void* p );
};

#define DECL_FIXEDMEMPOOL_NEWDEL_DLL( class, aPool )                 	\
	public:                                                             \
	void* operator new( size_t n )                                      \
	    { if ( n == sizeof( class ) ) return (aPool).Alloc();           \
	     else return new char[n]; }                                     \
	void operator delete( void* p, size_t n )                           \
	    { if ( n == sizeof( class ) ) (aPool).Free( p );                \
	     else delete p; }

#define INIT_FIXEDMEMPOOL_NEWDEL_DLL( class, aPool, InitSize, GrowSize )\
	aPool( sizeof( class ), InitSize, GrowSize )

#define DECL_FIXEDMEMPOOL_NEWDEL( class )                               \
	private:                                                            \
	static FixedMemPool aPool;                                          \
	DECL_FIXEDMEMPOOL_NEWDEL_DLL( class, aPool )

#define IMPL_FIXEDMEMPOOL_NEWDEL( class, InitSize, GrowSize )           \
	FixedMemPool class::aPool( sizeof( class ), InitSize, GrowSize );

#endif 
