

#ifndef _QUEUE_HXX
#define _QUEUE_HXX

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif

#ifndef _CONTNR_HXX
#include <tools/contnr.hxx>
#endif

#define QUEUE_ENTRY_NOTFOUND   CONTAINER_ENTRY_NOTFOUND

class Queue : private Container
{
public:
			Container::Clear;
			Container::Count;
			Container::GetObject;
			Container::GetPos;
	         Queue( USHORT _nInitSize = 16, USHORT _nReSize = 16 ) :
	            Container( _nReSize, _nInitSize, _nReSize ) {}
	        Queue( const Queue& rQueue ) : Container( rQueue ) {}
	 void    Put( void* p ) { Container::Insert( p, CONTAINER_APPEND ); }
	void*   Get()          { return Container::Remove( (ULONG)0 ); }
	 Queue&  operator =( const Queue& rQueue )
	            { Container::operator =( rQueue ); return *this; }
	 BOOL    operator ==( const Queue& rQueue ) const
	            { return Container::operator ==( rQueue ); }
	BOOL    operator !=( const Queue& rQueue ) const
	            { return Container::operator !=( rQueue ); }
};

#define DECLARE_QUEUE( ClassName, Type )                            \
class ClassName : private Queue                                     \
{                                                                   \
public:                                                             \
	Queue::Clear;										\
	Queue::Count;										\
	                                                                \
	            ClassName( USHORT _nInitSize = 16,                  \
	                       USHORT _nReSize = 16 ) :                 \
	                Queue( _nInitSize, _nReSize ) {}                \
	            ClassName( const ClassName& rClassName ) :          \
	                Queue( rClassName ) {}                          \
	                                                                \
	void        Put( Type p ) { Queue::Put( (void*)p ); }           \
	Type        Get()         { return (Type)Queue::Get(); }        \
	                                                                \
	Type        GetObject( ULONG nIndex ) const                     \
	                { return (Type)Queue::GetObject( nIndex ); }    \
	ULONG       GetPos( const Type p ) const                        \
	                { return Queue::GetPos( (const void*)p ); }     \
	ULONG       GetPos( const Type p, ULONG nStartIndex,            \
	                    BOOL bForward = TRUE ) const                \
	                { return Queue::GetPos( (const void*)p,         \
	                                        nStartIndex,            \
	                                        bForward ); }           \
	                                                                \
	ClassName&  operator =( const ClassName& rClassName )           \
	                { Queue::operator =( rClassName );              \
	                  return *this; }                               \
	                                                                \
	BOOL        operator ==( const Queue& rQueue ) const            \
	                { return Queue::operator ==( rQueue ); }        \
	BOOL        operator !=( const Queue& rQueue ) const            \
	                { return Queue::operator !=( rQueue ); }        \
};

#endif 
