

#ifndef _TOOLS_RC_HXX
#define _TOOLS_RC_HXX

#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif
#ifndef _LANG_HXX
#include <tools/lang.hxx>
#endif

#ifndef _TOOLS_RESMGR_HXX
#include <tools/resmgr.hxx>
#endif

class Resource
{
protected:

	BOOL				IsAvailableRes( const ResId& rId ) const;

	void				GetRes( const ResId& rResId );

	void				TestRes();

	static void*		GetClassRes()
				{ return GetResManager()->GetClass(); }

	static USHORT		GetStringRes( UniString& rStr, const BYTE* pStr )
				{ return ResMgr::GetString( rStr, pStr ); }

	static void*		IncrementRes( USHORT nBytes )
				{ return GetResManager()->Increment( nBytes ); }

	static USHORT		GetObjSizeRes( RSHEADER_TYPE * pHT )
				{ return ResMgr::GetObjSize( pHT ); }

	static USHORT		GetRemainSizeRes()
				{ return GetResManager()->GetRemainSize(); }

	static INT32		GetLongRes( void * pLong )
				{ return ResMgr::GetLong( pLong ); }

	static INT16		GetShortRes( void * pShort )
				{ return ResMgr::GetShort( pShort ); }

	static INT32		ReadLongRes()
				{ return GetResManager()->ReadLong(); }
	static INT16		ReadShortRes()
				{ return GetResManager()->ReadShort(); }
	static UniString	ReadStringRes()
				{ return GetResManager()->ReadString(); }

	RSHEADER_TYPE*		CreateBlockRes( const ResId& rId );

	void				FreeResource()
				{ GetResManager()->PopContext( this ); }
				Resource() {}
			Resource( const ResId& rResId );

public:
#ifdef DBG_UTIL
			~Resource() { TestRes(); }
#else
			~Resource() {}
#endif

	static void 		SetResManager( ResMgr* paResMgr );
	static ResMgr*		GetResManager();
};

inline BOOL Resource::IsAvailableRes( const ResId& rId ) const
{
	return GetResManager()->IsAvailable( rId, this );
}

inline RSHEADER_TYPE* Resource::CreateBlockRes( const ResId& rId )
{
	return GetResManager()->CreateBlock( rId );
}

#endif 
