

#ifndef _TOOLS_RESID_HXX
#define _TOOLS_RESID_HXX

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif

struct RSHEADER_TYPE;
typedef short RESOURCE_TYPE;
#define RSC_NOTYPE				0x100
#define RSC_DONTRELEASE 		((USHORT)(1 << 15))

class ResMgr;

class ResId
{
	RSHEADER_TYPE*	pResource;	   

	USHORT			nResId; 	   
	RESOURCE_TYPE	nRT;		   
	ResMgr *		pResMgr;	   
	RESOURCE_TYPE	nRT2;		   

public:
	ULONG			aWinBits;
			ResId( RSHEADER_TYPE * pRc )
		{
			nResId		= 0;
			pResource	= pRc;
			nRT = nRT2	= RSC_NOTYPE;
			pResMgr 	= NULL;
		}
		ResId( USHORT nId, ResMgr * pMgr = NULL )
		{
			nResId		= nId;
			pResource	= NULL;
			nRT = nRT2	= RSC_NOTYPE;
			pResMgr 	= pMgr;
		}

	RESOURCE_TYPE	GetRT() const { return( nRT ); }
	const ResId &	SetRT( RESOURCE_TYPE nTyp ) const
			{
			if( RSC_NOTYPE == nRT )
				((ResId *)this)->nRT = nTyp;
			return *this;
		}
	RESOURCE_TYPE	GetRT2() const
			{
			if( RSC_NOTYPE == nRT2 )
				return( nRT );
			else
				return( nRT2 );
		}
	const ResId &	SetRT2( RESOURCE_TYPE nTyp ) const
			{
			if( RSC_NOTYPE == nRT2 )
				((ResId *)this)->nRT2 = nTyp;
			return *this;
		}

	ResMgr *		GetResMgr() const { return pResMgr; }
	const ResId &	SetResMgr( ResMgr * pMgr ) const
		{
				((ResId *)this)->pResMgr = pMgr;
			return *this;
		}

	const ResId &  SetAutoRelease(BOOL bRelease) const
	   {
		   if( bRelease )
			   ((ResId *)this)->nResId &= ~RSC_DONTRELEASE;
		   else
			   ((ResId *)this)->nResId |= RSC_DONTRELEASE;
		   return *this;
	   }

	BOOL		   IsAutoRelease()	const
	   { return !(nResId & RSC_DONTRELEASE); }

	USHORT		   GetId()			const { return nResId & ~RSC_DONTRELEASE; }
	RSHEADER_TYPE* GetpResource()	const { return pResource; }
};

#endif 
