

#ifndef _STACK_HXX
#define _STACK_HXX

#ifndef _CONTNR_HXX
#include <tools/contnr.hxx>
#endif

#define STACK_ENTRY_NOTFOUND   CONTAINER_ENTRY_NOTFOUND

class Stack : private Container
{
public:
			Container::Clear;
			Container::Count;
			Container::GetObject;
			Container::GetPos;
	         Stack( USHORT _nInitSize = 16, USHORT _nReSize = 16 ) :
	            Container( CONTAINER_MAXBLOCKSIZE, _nInitSize, _nReSize ) {}
	        Stack( const Stack& rStack ) : Container( rStack ) {}
	 void    Push( void* p ) { Container::Insert( p, CONTAINER_APPEND ); }
	void*   Pop()           { return Container::Remove( Count()-1 ); }
	void*   Top() const     { return Container::GetObject( Count()-1 ); }
	 Stack&  operator =( const Stack& rStack )
	            { Container::operator =( rStack ); return *this; }
	 BOOL    operator ==( const Stack& rStack ) const
	            { return Container::operator ==( rStack ); }
	BOOL    operator !=( const Stack& rStack ) const
	            { return Container::operator !=( rStack ); }
};

#define DECLARE_STACK( ClassName, Type )                            \
class ClassName : private Stack                                     \
{                                                                   \
public:                                                             \
	Stack::Clear;										\
	Stack::Count;										\
	                                                                \
	            ClassName( USHORT _nInitSize = 16,                  \
	                   USHORT _nReSize = 16 ) :                     \
	                Stack( _nInitSize, _nReSize ) {}                \
	            ClassName( const ClassName& rClassName ) :          \
	                Stack( rClassName ) {}                          \
	                                                                \
	void        Push( Type p ) { Stack::Push( (void*)p ); }         \
	Type        Pop()          { return (Type)Stack::Pop(); }       \
	Type        Top() const    { return (Type)Stack::Top(); }       \
	                                                                \
	Type        GetObject( ULONG nIndex ) const                     \
	                { return (Type)Stack::GetObject( nIndex ); }    \
	ULONG       GetPos( const Type p ) const                        \
	                { return Stack::GetPos( (const void*)p ); }     \
	ULONG       GetPos( const Type p, ULONG nStartIndex,            \
	                    BOOL bForward = TRUE ) const                \
	                { return Stack::GetPos( (const void*)p,         \
	                                        nStartIndex,            \
	                                        bForward ); }           \
	                                                                \
	ClassName&  operator =( const ClassName& rClassName )           \
	                { Stack::operator =( rClassName );              \
	                  return *this; }                               \
	                                                                \
	BOOL        operator ==( const ClassName& rStack ) const        \
	                { return Stack::operator ==( rStack ); }        \
	BOOL        operator !=( const ClassName& rStack ) const        \
	                { return Stack::operator !=( rStack ); }        \
};

#endif  
