
#ifndef _TOOLS_TEMPFILE_HXX
#define _TOOLS_TEMPFILE_HXX

#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif

struct TempFile_Impl;
class TempFile
{
	TempFile_Impl*  pImp;
	sal_Bool        bKillingFileEnabled;

public:
	                 TempFile( const String* pParent=NULL, sal_Bool bDirectory=sal_False );
	                 TempFile( const String& rLeadingChars, const String* pExtension=NULL, const String* pParent=NULL, sal_Bool bDirectory=sal_False );
	                 ~TempFile();
	 sal_Bool        IsValid() const;
	 String          GetName() const;
	 void            EnableKillingFile( sal_Bool bEnable=sal_True )
	                { bKillingFileEnabled = bEnable; }
	 sal_Bool        IsKillingFileEnabled() const
	                { return bKillingFileEnabled; }
	 static String   CreateTempName( const String* pParent=NULL );
	 static String   SetTempNameBaseDirectory( const String &rBaseName );
	static String   GetTempNameBaseDirectory();
};

#endif
