

#ifndef _TIMESTAMP_HXX
#define _TIMESTAMP_HXX

#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif

#ifndef _STREAM_HXX
#include <tools/stream.hxx>
#endif

#ifndef _DATETIME_HXX
#include <tools/datetime.hxx>
#endif

#define TIMESTAMP_MAXLENGTH       		31														
#define TIMESTAMP_INVALID_DATETIME    	( DateTime ( Date ( 1, 1, 1601 ), Time ( 0, 0, 0 ) ) )	

class TimeStamp
{

	public:

		TimeStamp (													) ;
		TimeStamp ( const String& rName								) ;
		TimeStamp ( const DateTime& rDateTime						) ;
		TimeStamp ( const String& rName, const DateTime& rDateTime	) ;

		const TimeStamp&	operator=	( const TimeStamp& rCopy	)	    ;
		BOOL				operator==	( const TimeStamp& rCompare ) const ;
		int					operator!=	( const TimeStamp& rCompare ) const ;

		BOOL				IsValid	(							) const ;
		BOOL				Load	( SvStream& rStream 		)       ;
		BOOL				Save 	( SvStream& rStream 		) const ;
		void				SetName ( const String& rName 		)       ;
		void				SetTime ( const DateTime& rDateTime )       ;
		const String&		GetName (							) const ;
		const DateTime&		GetTime (							) const ;

	protected:

	private:

		void	impl_setInvalid		(				) ;
		void	impl_adjustName		( String& rName ) ;

		#ifdef DBG_UTIL

		BOOL	impl_debug_checkParameter	( const String& rString								) const ;
		BOOL	impl_debug_checkParameter	( const String& rString, const DateTime& rDateTime	) const ;
		BOOL	impl_debug_checkParameter	( const TimeStamp& rTimeStamp						) const ;
		BOOL	impl_debug_checkParameter	( SvStream& rSvStream								) const ;
		BOOL	impl_debug_checkParameter	( const DateTime& rDateTime							) const ;

		#endif 

	private:

		String		m_sModifiedByName	;	
		DateTime	m_aModifiedDateTime	;	

} ;

#endif 
