

#ifndef _UNQID_HXX
#define _UNQID_HXX

#ifndef _UNQIDX_HXX
#include <tools/unqidx.hxx>
#endif

struct ImpUniqueId
{
	ULONG    nId;
	USHORT   nRefCount;
	void     Release()
	         {
	            nRefCount--;
	            if( 0 == nRefCount )
	                delete this;
	         }
};

class UniqueIdContainer;
class UniqueItemId
{
	friend UniqueIdContainer;
	ImpUniqueId*    pId;
	                 UniqueItemId( ImpUniqueId * pIdP )
	                    { pId = pIdP; pId->nRefCount++; }
public:
	                UniqueItemId() { pId = NULL; }
	                UniqueItemId( const UniqueItemId & rId )
	                    { pId = rId.pId; if( pId ) pId->nRefCount++; }
	                ~UniqueItemId()
	                    { if( pId ) pId->Release(); }
	UniqueItemId&   operator = ( const UniqueItemId & rId )
	                    {
	                        if( rId.pId ) rId.pId->nRefCount++;
	                        if( pId ) pId->Release();
	                        pId = rId.pId;
	                        return *this;
	                    }
	ULONG           GetId() const { return pId ? pId->nId : 0; }
};

class UniqueIdContainer : private UniqueIndex
{
	USHORT              nCollectCount;

public: 
	void                Clear( BOOL bAll );
	UniqueItemId        CreateIdProt( ULONG nId );

public:
	                    UniqueIdContainer( ULONG _nStartIndex,
	                                       ULONG _nInitSize = 16,
	                                       ULONG _nReSize = 16 )
				: UniqueIndex( _nStartIndex, _nInitSize, _nReSize )
				, nCollectCount( 0 )
				{}
	                    UniqueIdContainer( const UniqueIdContainer& );
	                     ~UniqueIdContainer()
	                        { Clear( TRUE ); }
	UniqueIdContainer&  operator = ( const UniqueIdContainer & );
	 BOOL                IsIndexValid( ULONG nIndex ) const
	                        { return UniqueIndex::IsIndexValid( nIndex ); }
	 UniqueItemId        CreateId();
	static UniqueItemId CreateFreeId( ULONG nId ); 
};

#endif 
