

#ifndef _WLDCRD_HXX
#define _WLDCRD_HXX

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif

#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif

#ifndef _OSL_THREAD_H_
#include <osl/thread.h>
#endif

class WildCard
{
private:
	ByteString      aWildString;
	char            cSepSymbol;
	 USHORT          ImpMatch( const char *pWild, const char *pStr ) const;

public:
	                WildCard();
	                WildCard( const String& rWildCards,
	                          const char cSeparator = '\0' );

	const String    GetWildCard() const     { return UniString( aWildString, osl_getThreadTextEncoding()); }
	const String    operator ()() const     { return UniString( aWildString, osl_getThreadTextEncoding()); }
	 BOOL            Matches( const String& rStr ) const;
	 BOOL            operator ==( const String& rString ) const
	                    { return Matches( rString ); }
	BOOL            operator !=( const String& rString ) const
	                    { return !( Matches( rString ) ); }
	 WildCard&       operator =( const String& rString );
	WildCard&       operator =( const WildCard& rWildCard );
};

inline WildCard::WildCard() :
	                aWildString( '*' )
{
	cSepSymbol  = '\0';
}

inline WildCard::WildCard( const String& rWildCard, const char cSeparator ) :
	                aWildString( rWildCard, osl_getThreadTextEncoding())
{
	cSepSymbol  = cSeparator;
}

inline WildCard& WildCard::operator=( const String& rString )
{
	aWildString = ByteString(rString, osl_getThreadTextEncoding());
	return *this;
}

inline WildCard& WildCard::operator=( const WildCard& rWildCard )
{
	aWildString = rWildCard.aWildString;
	cSepSymbol = rWildCard.cSepSymbol;
	return *this;
}

#endif
