

#ifndef _SV_ALPHA_HXX
#define _SV_ALPHA_HXX

#ifndef _SV_BITMAP_HXX
#include <vcl/bitmap.hxx>
#endif

class AlphaMask : private Bitmap
{
	friend class BitmapEx;
	friend class OutputDevice;

private:

	long					nDummy1;
	long					nDummy2;

	const Bitmap&			ImplGetBitmap() const;
	void					ImplSetBitmap( const Bitmap& rBitmap );

public:
	                         AlphaMask();
				AlphaMask( const Bitmap& rBitmap );
	                        AlphaMask( const AlphaMask& rAlphaMask );
	                        AlphaMask( const Size& rSizePixel, BYTE* pEraseTransparency = NULL );
	                        ~AlphaMask();
	 AlphaMask&				operator=( const Bitmap& rBitmap );
	AlphaMask&				operator=( const AlphaMask& rAlphaMask ) { return (AlphaMask&) Bitmap::operator=( rAlphaMask ); }
	BOOL					operator!() const { return Bitmap::operator!(); }
	BOOL					operator==( const AlphaMask& rAlphaMask ) const { return Bitmap::operator==( rAlphaMask ); }
	BOOL					operator!=( const AlphaMask& rAlphaMask ) const { return Bitmap::operator!=( rAlphaMask ); }
	 const MapMode&			GetPrefMapMode() const { return Bitmap::GetPrefMapMode(); }
	void					SetPrefMapMode( const MapMode& rMapMode ) { Bitmap::SetPrefMapMode( rMapMode ); }
	 const Size&				GetPrefSize() const { return Bitmap::GetPrefSize(); }
	void					SetPrefSize( const Size& rSize ) { Bitmap::SetPrefSize( rSize ); }
	 Size					GetSizePixel() const { return Bitmap::GetSizePixel(); }
	void					SetSizePixel( const Size& rNewSize ) { Bitmap::SetSizePixel( rNewSize ); }
	 ULONG					GetSizeBytes() const { return Bitmap::GetSizeBytes(); }
	ULONG					GetChecksum() const { return Bitmap::GetChecksum(); }

	Bitmap					GetBitmap() const { return ImplGetBitmap(); }

public:
	 BOOL                    Crop( const Rectangle& rRectPixel );
	BOOL                    Expand( ULONG nDX, ULONG nDY, BYTE* pInitTransparency = NULL );
	BOOL                    CopyPixel( const Rectangle& rRectDst, const Rectangle& rRectSrc, const AlphaMask* pAlphaSrc = NULL );
	BOOL                    Erase( BYTE cTransparency );
	BOOL                    Invert();
	BOOL                    Mirror( ULONG nMirrorFlags );
	BOOL                    Scale( const Size& rNewSize, ULONG nScaleFlag = BMP_SCALE_FAST );
	BOOL                    Scale( const double& rScaleX, const double& rScaleY, ULONG nScaleFlag = BMP_SCALE_FAST );
	BOOL                    Rotate( long nAngle10, BYTE cFillTransparency );
	BOOL                    Replace( const Bitmap& rMask, BYTE rReplaceTransparency );
	BOOL                    Replace( BYTE cSearchTransparency, BYTE cReplaceTransparency, ULONG nTol = 0UL );
	BOOL                    Replace( BYTE* pSearchTransparencies, BYTE* pReplaceTransparencies,
						 ULONG nColorCount, ULONG* pTols = NULL );

public:
	 BitmapReadAccess*		AcquireReadAccess() { return Bitmap::AcquireReadAccess(); }
	BitmapWriteAccess*		AcquireWriteAccess() { return Bitmap::AcquireWriteAccess(); }
	void					ReleaseAccess( BitmapReadAccess* pAccess );

public:
	 BOOL					Read( SvStream& rIStm, BOOL bFileHeader = TRUE ) { return Bitmap::Read( rIStm, bFileHeader ); }
	BOOL					Write( SvStream& rOStm, BOOL bCompressed = TRUE, BOOL bFileHeader = TRUE ) const { return Bitmap::Write( rOStm, bCompressed, bFileHeader ); }

	friend SvStream&		operator<<( SvStream& rOStm, const BitmapEx& rBitmapEx );
	friend SvStream&		operator>>( SvStream& rIStm, BitmapEx& rBitmapEx );
};

#endif 
