

#ifndef _SV_BTNDLG_HXX
#define _SV_BTNDLG_HXX

#ifndef _SV_SV_H
#include <vcl/sv.h>
#endif
#ifndef _SV_DIALOG_HXX
#include <vcl/dialog.hxx>
#endif

struct ImplBtnDlgItem;
class ImplBtnDlgItemList;
class PushButton;

#define BUTTONDIALOG_BUTTON_NOTFOUND			((USHORT)0xFFFF)

#define BUTTONDIALOG_DEFBUTTON					((USHORT)0x0001)
#define BUTTONDIALOG_OKBUTTON					((USHORT)0x0002)
#define BUTTONDIALOG_CANCELBUTTON				((USHORT)0x0004)
#define BUTTONDIALOG_HELPBUTTON 				((USHORT)0x0008)
#define BUTTONDIALOG_FOCUSBUTTON				((USHORT)0x0010)

class ButtonDialog : public Dialog
{
private:
	ImplBtnDlgItemList* mpItemList;
	Size				maPageSize;
	Size				maCtrlSize;
	long				mnButtonSize;
	USHORT				mnCurButtonId;
	USHORT				mnFocusButtonId;
	BOOL				mbFormat;
	Link				maClickHdl;

#if 0 // _SOLAR__PRIVATE
#ifdef _SV_BTNDLG_CXX
	void				ImplInitData();
	PushButton* 		ImplCreatePushButton( USHORT nBtnFlags );
	ImplBtnDlgItem* 	ImplGetItem( USHORT nId ) const;
			DECL_LINK( ImplClickHdl, PushButton* pBtn );
	void				ImplPosControls();
#endif
protected:
	long				ImplGetButtonSize();
#endif

protected:
			ButtonDialog( WindowType nType );

public:
			ButtonDialog( Window* pParent, WinBits nStyle = WB_STDDIALOG );
			ButtonDialog( Window* pParent, const ResId& rResId );
			~ButtonDialog();

	virtual void		Resize();
	virtual void		StateChanged( StateChangedType nStateChange );

	virtual void		Click();

	void				SetPageSizePixel( const Size& rSize ) { maPageSize = rSize; }
	const Size& 		GetPageSizePixel() const { return maPageSize; }

	USHORT				GetCurButtonId() const { return mnCurButtonId; }

	void				AddButton( const XubString& rText, USHORT nId, USHORT nBtnFlags, long nSepPixel = 0 );
	void				AddButton( StandardButtonType eType, USHORT nId, USHORT nBtnFlags, long nSepPixel = 0 );
	void				AddButton( PushButton* pBtn, USHORT nId, USHORT nBtnFlags, long nSepPixel = 0 );
	void				RemoveButton( USHORT nId );
	void				Clear();
	USHORT				GetButtonCount() const;
	USHORT				GetButtonId( USHORT nButton ) const;
	PushButton* 		GetPushButton( USHORT nId ) const;
	void				SetButtonText( USHORT nId, const XubString& rText );
	XubString			GetButtonText( USHORT nId ) const;
	void				SetButtonHelpText( USHORT nId, const XubString& rText );
	XubString			GetButtonHelpText( USHORT nId ) const;
	void				SetButtonHelpId( USHORT nId, ULONG nHelpId );
	ULONG				GetButtonHelpId( USHORT nId ) const;

	void				SetFocusButton( USHORT nId = BUTTONDIALOG_BUTTON_NOTFOUND ) { mnFocusButtonId = nId; }
	USHORT				GetFocusButton() const { return mnFocusButtonId; }

	void				SetClickHdl( const Link& rLink ) { maClickHdl = rLink; }
	const Link& 		GetClickHdl() const { return maClickHdl; }
};

#endif	
