

#ifndef _SV_CLIP_HXX
#define _SV_CLIP_HXX

#ifdef TF_SVDATA
#error this header is going to be removed !
#endif

#ifndef _SOT_EXCHANGE_HXX
#include <sot/exchange.hxx>
#endif
#ifndef _SOT_DTRANS_HXX
#include <sot/dtrans.hxx>
#endif

#ifndef _SV_SV_H
#include <vcl/sv.h>
#endif
#ifndef _SV_EXCHANGE_HXX
#include <vcl/exchange.hxx>
#endif

class Bitmap;
class GDIMetaFile;

class VclClipboard : public Exchange
{
private:
	Link					aClearedHdl;

	static void ImplCopyToSystemClipboard( SotDataObject* pData );

	static SotDataMemberObject* ImplGetMemberObject( void );

public:
				VclClipboard();
				~VclClipboard();

	virtual void			Cleared();

	static void 			Clear();

	static void 			Copy( SotDataObject* pData_ );
	static SotDataObject*	Paste( void );

	static void 			ReleaseClipboard( BOOL bFlushToSystem );
	static BOOL 			ExistsSystemClipboard( void );

	static BOOL 			CopyString( const UniString& rStr );
	static BOOL 			CopyBitmap( const Bitmap& rBitmap );
	static BOOL 			CopyGDIMetaFile( const GDIMetaFile& rGDIMetaFile );

	static BOOL 			CopyPrivateData( void* pData );

	static BOOL 			CopyData( const void* pData, ULONG nLen,
						  ULONG nFormat, USHORT nTypeLen = 8 );
	static BOOL 			CopyRequest( ULONG nFormat );

	static UniString		PasteString();
	static Bitmap			PasteBitmap();
	static BOOL 			PasteGDIMetaFile( GDIMetaFile& rGDIMetaFile );

	static void*			PastePrivateData(); 	
	static BOOL 			PasteData( void* pBuf, ULONG nLen, ULONG nFormat );
	static ULONG			GetDataLen( ULONG nFormat );

	static USHORT			GetFormatCount();
	static ULONG			GetFormat( USHORT nPos );
	static BOOL 			HasFormat( ULONG nFormat );

	static ULONG			GetRequestFormat();

	void					SetClearedHdl( const Link& rLink ) { aClearedHdl = rLink; }
	const Link& 			GetClearedHdl() const { return aClearedHdl; }
};

#define Clipboard VclClipboard

#endif 
