

#ifndef _SV_COMBOBOX_HXX
#define _SV_COMBOBOX_HXX

#ifndef _SV_CTRL_HXX
#include <vcl/ctrl.hxx>
#endif
#ifndef _SV_COMBOBOX_H
#include <vcl/combobox.h>
#endif
#ifndef _SV_EDIT_HXX
#include <vcl/edit.hxx>
#endif

class UserDrawEvent;

class ImplListBoxFloatingWindow;
class ImplListBox;
class ImplBtn;

class ComboBox : public Edit
{
private:
	Edit*                       mpSubEdit;
	ImplListBox*                mpImplLB;
	ImplBtn*                    mpBtn;
	ImplListBoxFloatingWindow*  mpFloatWin;
	USHORT                      mnDDHeight;
	xub_Unicode                 mcMultiSep;
	BOOL                        mbDDAutoSize        : 1;
	BOOL                        mbSyntheticModify   : 1;
	BOOL                        mbMatchCase         : 1;
	Link                        maSelectHdl;
	Link                        maDoubleClickHdl;

#if 0 // _SOLAR__PRIVATE
private:
	void            ImplInitData();
	void            ImplUpdateFloatSelection();
	                 DECL_LINK( ImplSelectHdl, void* );
	                DECL_LINK( ImplCancelHdl, void* );
	                DECL_LINK( ImplDoubleClickHdl, void* );
	                DECL_LINK( ImplClickBtnHdl, void* );
	                DECL_LINK( ImplPopupModeEndHdl, void* );
	                DECL_LINK( ImplSelectionChangedHdl, void* );
	                DECL_LINK( ImplUserDrawHdl, UserDrawEvent* );
	                DECL_LINK( ImplAutocompleteHdl, Edit* );

protected:
	void            ImplInit( Window* pParent, WinBits nStyle );
	WinBits         ImplInitStyle( WinBits nStyle );
	void            ImplLoadRes( const ResId& rResId );
	void            ImplCalcEditHeight();
#endif

protected:
	                ComboBox( WindowType nType );
	BOOL            IsDropDownBox() const { return mpFloatWin ? TRUE : FALSE; }

public:
	                ComboBox( Window* pParent, WinBits nStyle = 0 );
	                ComboBox( Window* pParent, const ResId& rResId );
	                ~ComboBox();
	 virtual void    Draw( OutputDevice* pDev, const Point& rPos, const Size& rSize, ULONG nFlags );
	virtual void    Resize();
	virtual long    PreNotify( NotifyEvent& rNEvt );
	virtual long    Notify( NotifyEvent& rNEvt );
	virtual void    StateChanged( StateChangedType nType );
	virtual void    DataChanged( const DataChangedEvent& rDCEvt );
	 virtual void    UserDraw( const UserDrawEvent& rUDEvt );
	virtual void    Select();
	virtual void    DoubleClick();
	 virtual void    Modify();
	 virtual void    SetPosSizePixel( long nX, long nY, long nWidth, long nHeight, USHORT nFlags = WINDOW_POSSIZE_ALL );
	void            SetPosSizePixel( const Point& rNewPos, const Size& rNewSize )
	                    { Edit::SetPosSizePixel( rNewPos, rNewSize ); }
	 void            SetDropDownLineCount( USHORT nLines );
	USHORT          GetDropDownLineCount() const;
	 void            EnableAutoSize( BOOL bAuto );
	BOOL            IsAutoSizeEnabled() const               { return mbDDAutoSize; }
	 void            SetText( const XubString& rStr );
	void            SetText( const XubString& rStr, const Selection& rNewSelection );
	 USHORT          InsertEntry( const XubString& rStr, USHORT nPos = COMBOBOX_APPEND );
	USHORT          InsertEntry( const XubString& rStr, const Image& rImage, USHORT nPos = COMBOBOX_APPEND );
	 void            RemoveEntry( const XubString& rStr );
	void            RemoveEntry( USHORT nPos );
	 void            Clear();
	 USHORT          GetEntryPos( const XubString& rStr ) const;
	USHORT          GetEntryPos( const void* pData ) const;
	XubString       GetEntry( USHORT nPos ) const;
	USHORT          GetEntryCount() const;
	 BOOL            IsTravelSelect() const;
	BOOL            IsInDropDown() const;
	 long            CalcWindowSizePixel( USHORT nLines ) const;
	 void            SetUserItemSize( const Size& rSz );
	const Size&     GetUserItemSize() const;
	 void            EnableUserDraw( BOOL bUserDraw );
	BOOL            IsUserDrawEnabled() const;
	 void            DrawEntry( const UserDrawEvent& rEvt, BOOL bDrawImage, BOOL bDrawText, BOOL bDrawTextAtImagePos = FALSE );
	 void            SetSeparatorPos( USHORT n );
	void            SetSeparatorPos();
	USHORT          GetSeparatorPos() const;
	 void            EnableAutocomplete( BOOL bEnable, BOOL bMatchCase = FALSE );
	BOOL            IsAutocompleteEnabled() const;
	 void            EnableMultiSelection( BOOL bMulti );
	BOOL            IsMultiSelectionEnabled() const;
	void            SetMultiSelectionSeparator( xub_Unicode cSep ) { mcMultiSep = cSep; }
	xub_Unicode     GetMultiSelectionSeparator() const { return mcMultiSep; }
	 void            SetSelectHdl( const Link& rLink )       { maSelectHdl = rLink; }
	const Link&     GetSelectHdl() const                    { return maSelectHdl; }
	void            SetDoubleClickHdl( const Link& rLink )  { maDoubleClickHdl = rLink; }
	const Link&     GetDoubleClickHdl() const               { return maDoubleClickHdl; }
	 Size            CalcMinimumSize() const;
	Size            CalcAdjustedSize( const Size& rPrefSize ) const;
	Size            CalcSize( USHORT nColumns, USHORT nLines ) const;
	void            GetMaxVisColumnsAndLines( USHORT& rnCols, USHORT& rnLines ) const;
	 void            SetMRUEntries( const XubString& rEntries, xub_Unicode cSep = ';' );
	XubString       GetMRUEntries( xub_Unicode cSep = ';' ) const;
	void            SetMaxMRUCount( USHORT n );
	USHORT          GetMaxMRUCount() const;
	 void            SetEntryData( USHORT nPos, void* pNewData );
	void*           GetEntryData( USHORT nPos ) const;
};

#endif  
