

#ifndef _SV_DRAG_HXX
#define _SV_DRAG_HXX

#ifdef TF_SVDATA
#error this header is going to be removed !
#endif

#ifndef _SV_SV_H
#include <vcl/sv.h>
#endif
#ifndef _SV_EXCHANGE_HXX
#include <vcl/exchange.hxx>
#endif

#ifndef _SV_EVENT_HXX
#include <vcl/event.hxx>
#endif
#ifndef _SV_POINTR_HXX
#include <vcl/pointr.hxx>
#endif
#ifndef _SOT_DTRANS_HXX
#include <sot/dtrans.hxx>
#endif

#define OLDDRAGDROP

#ifndef SOT_DECL_MULTIITEMOBJECT_DEFINED
#define SOT_DECL_MULTIITEMOBJECT_DEFINED
SO2_DECL_REF(MultiItemObject)
#endif

class SalFrame;

class MultiItemObject : public SotDataMemberObject

{
	friend class DragManager;
	friend class ImplDragDropListener;

	SotDataObjectRef*	pDataList;
	USHORT				mnListSize;
	USHORT				mnItemCount;

#ifdef OLDDRAGDROP
	SotDataObjectRef	xExtObj;
				MultiItemObject( SotDataObject* pDataObject_ );
#endif 

public:
			MultiItemObject();
			~MultiItemObject();

	SotDataObject*		GetItem( USHORT nItem );
	USHORT				GetItemCount( void )	{ return mnItemCount; }
	void				InsertItem( SotDataObject* pDataObject );
	void				NewItem( void );

	virtual const		SvDataTypeList* GetTypeList( USHORT nItem );
	virtual BOOL		GetData( USHORT nItem, SvData * );

};

SO2_IMPL_REF(MultiItemObject)

class DropSource
{
public:

	virtual BOOL DrawDragPointer( DropAction eAction, const Point& rPos, Window* pTarget ) = 0;

	virtual void ClrDragPointer( const Point& rPos ) = 0;

};

class DragManager
{
	friend class DragServer;
	friend class ImplDragDropListener;

	friend long ImplHandleMouseEvent( Window*, USHORT, BOOL, long, long, ULONG,USHORT, USHORT );

	SotDataObjectRef	xData;
	USHORT				nOptions;
	DropSource* 		pDropSource;

	BOOL				bDrawPointerResult;
	Pointer 			aDragPointer;
	BOOL				bModifyPointer;
	MouseEvent			aLastMEvt;

	Window* 			pLastTargetWindow;	
	DropAction			eDropResult;
	BOOL				bOwnDragDrop;		

public:

	MultiItemObjectRef	mxDragServerData;

	static DragManager* ImplGetDragManager( void );

private:

	DragManager( void );

	void InitDrag( SotDataObject* pData_, USHORT nOptions_, DropSource* pDropSource_ );

public:

	static DropAction ExecuteDrag( SotDataObject* pData_, USHORT nOptions_, DropSource* pDropSource_=NULL );

	static DragManager* GetDragManager( void );

	const MouseEvent& GetLastMouseEvent() const { return aLastMEvt; }

	static void SystemEnableDrop( SalFrame* pFrame, BOOL bEnable );

	static Pointer GetDefaultPointer( DropAction eAction );

	void SetDragPointer( Pointer aDragPointer_ )
		{ aDragPointer = aDragPointer_; bModifyPointer = TRUE; }

	void MouseMove( const MouseEvent& rMEvt, Window* pTargetWindow );
	void ButtonUp( const MouseEvent& rMEvt, Window* pTargetWindow );
	void Escape( Window* pTargetWindow );
	void KeyModChanged( USHORT nKeyCode );

	void AppWindowLeaved( void );

	BOOL isModifyPointer( void )
		{ return bModifyPointer; }
	Pointer GetDragPointer( void )
		{ return aDragPointer; }
};

#ifdef OLDDRAGDROP

class Bitmap;
class GDIMetaFile;

class DragServer : public Exchange
{
public:
			DragServer();
			~DragServer();

	static void 		Clear();

	static void 		NewItem();
	static BOOL 		CopyString( const XubString& rStr );
	static BOOL 		CopyBitmap( const Bitmap& rBitmap );
	static BOOL 		CopyGDIMetaFile( const GDIMetaFile& rGDIMetaFile );
	static BOOL 		CopyPrivateData( void* pData );
	static BOOL 		CopyFile( const XubString& rStr );
	static BOOL 		CopyData( const void* pData, ULONG nLen,
					  ULONG nFormat, USHORT nTypeLen = 8 );
	static BOOL 		CopyRequest( ULONG nFormat );

	static USHORT		GetItemCount();
	static XubString	PasteString( USHORT nItem );
	static Bitmap		PasteBitmap( USHORT nItem );
	static BOOL 		PasteGDIMetaFile( USHORT nItem, GDIMetaFile& rGDIMetaFile );
	static void*		PastePrivateData( USHORT nItem );
	static XubString	PasteFile( USHORT nItem );
	static BOOL 		PasteData( USHORT nItem, void* pBuf,
					   ULONG nLen, ULONG nFormat );
	static ULONG		GetDataLen( USHORT nItem, ULONG nFormat );

	static USHORT		GetFormatCount( USHORT nItem );
	static ULONG		GetFormat( USHORT nItem, USHORT nPos );
	static BOOL 		HasFormat( USHORT nItem, ULONG nFormat );

	static USHORT		GetRequestItem();
	static ULONG		GetRequestFormat();
	static BOOL 		IsRequestName();

	static XubString	GetTargetPrinterName();
};

#endif 

SotDataObject* ImplGetActiveItem();
SotDataObject* ImplGetItem( USHORT nItem );

#endif 
