

#ifndef _SV_FIXBRD_HXX
#define _SV_FIXBRD_HXX

#ifndef _SV_SV_H
#include <vcl/sv.h>
#endif
#ifndef _SV_DECOVIEW_HXX
#include <vcl/decoview.hxx>
#endif
#ifndef _SV_CTRL_HXX
#include <vcl/ctrl.hxx>
#endif

#define FIXEDBORDER_TYPE_IN 					(FRAME_DRAW_IN)
#define FIXEDBORDER_TYPE_OUT					(FRAME_DRAW_OUT)
#define FIXEDBORDER_TYPE_GROUP					(FRAME_DRAW_GROUP)
#define FIXEDBORDER_TYPE_DOUBLEIN				(FRAME_DRAW_DOUBLEIN)
#define FIXEDBORDER_TYPE_DOUBLEOUT				(FRAME_DRAW_DOUBLEOUT)

class FixedBorder : public Control
{
private:
	USHORT			mnType;
	BOOL			mbTransparent;
	BOOL			mbDummy1;

#if 0 // _SOLAR__PRIVATE
#ifdef _SV_FIXBRD_CXX
private:
	void			ImplInit( Window* pParent, WinBits nStyle );
	WinBits 		ImplInitStyle( WinBits nStyle );
	void			ImplInitSettings();
	void			ImplDraw( OutputDevice* pDev, ULONG nDrawFlags,
				  const Point& rPos, const Size& rSize );
#endif
#endif

public:
		FixedBorder( Window* pParent, WinBits nStyle = 0 );
		FixedBorder( Window* pParent, const ResId& rResId );
		~FixedBorder();

	virtual void	Paint( const Rectangle& rRect );
	virtual void	Draw( OutputDevice* pDev, const Point& rPos, const Size& rSize, ULONG nFlags );
	virtual void	Resize();
	virtual void	StateChanged( StateChangedType nType );
	virtual void	DataChanged( const DataChangedEvent& rDCEvt );

	void			SetTransparent( BOOL bTransparent );
	BOOL			IsTransparent() const { return mbTransparent; }
	void			SetBorderType( USHORT nType );
	USHORT			GetBorderType() const { return mnType; }
};

#endif	
