

#ifndef _SV_FLOATWIN_HXX
#define _SV_FLOATWIN_HXX

#ifndef _SV_SV_H
#include <vcl/sv.h>
#endif
#ifndef _SV_SYSWIN_HXX
#include <vcl/syswin.hxx>
#endif

class ToolBox;
class PopupModeEvent;

#define FLOATWIN_POPUPMODE_ALLOWTEAROFF 		((ULONG)0x00000001)
#define FLOATWIN_POPUPMODE_ANIMATIONSLIDE		((ULONG)0x00000002)
#define FLOATWIN_POPUPMODE_NOAUTOARRANGE		((ULONG)0x00000004)
#define FLOATWIN_POPUPMODE_NOANIMATION			((ULONG)0x00000008)
#define FLOATWIN_POPUPMODE_DOWN 				((ULONG)0x00000010)
#define FLOATWIN_POPUPMODE_UP					((ULONG)0x00000020)
#define FLOATWIN_POPUPMODE_LEFT 				((ULONG)0x00000040)
#define FLOATWIN_POPUPMODE_RIGHT				((ULONG)0x00000080)
#define FLOATWIN_POPUPMODE_NOFOCUSCLOSE 		((ULONG)0x00000100)
#define FLOATWIN_POPUPMODE_NOKEYCLOSE			((ULONG)0x00000200)
#define FLOATWIN_POPUPMODE_NOMOUSECLOSE 		((ULONG)0x00000400)
#define FLOATWIN_POPUPMODE_NOMOUSERECTCLOSE 	((ULONG)0x00000800)
#define FLOATWIN_POPUPMODE_ALLMOUSEBUTTONCLOSE	((ULONG)0x00001000)
#define FLOATWIN_POPUPMODE_NOAPPFOCUSCLOSE		((ULONG)0x00002000)
#define FLOATWIN_POPUPMODE_PATHMOUSECANCELCLICK ((ULONG)0x00004000)
#define FLOATWIN_POPUPMODE_NEWLEVEL 			((ULONG)0x00008000)
#define FLOATWIN_POPUPMODE_NOMOUSEUPCLOSE		((ULONG)0x00010000)

#define FLOATWIN_POPUPMODEEND_CANCEL			((USHORT)0x0001)
#define FLOATWIN_POPUPMODEEND_TEAROFF			((USHORT)0x0002)
#define FLOATWIN_POPUPMODEEND_DONTCALLHDL		((USHORT)0x0004)
#define FLOATWIN_POPUPMODEEND_CLOSEALL			((USHORT)0x0008)

#define FLOATWIN_TITLE_NORMAL					((USHORT)0x0001)
#define FLOATWIN_TITLE_TEAROFF					((USHORT)0x0002)
#define FLOATWIN_TITLE_NONE 					((USHORT)0x0004)

class FloatingWindow : public SystemWindow
{
private:
	FloatingWindow* mpNextFloat;
	Window* 		mpFirstPopupModeWin;
	ToolBox*		mpBox;
	void*			mpDummy;
	Rectangle		maFloatRect;
	ULONG			mnPostId;
	ULONG			mnPopupModeFlags;
	USHORT			mnTitle;
	USHORT			mnOldTitle;
	BOOL			mbInPopupMode;
	BOOL			mbPopupMode;
	BOOL			mbPopupModeCanceled;
	BOOL			mbPopupModeTearOff;
	BOOL			mbMouseDown;
	BOOL			mbOldSaveBackMode;
	BOOL			mbDummy1;
	BOOL			mbDummy2;
	Link			maPopupModeEndHdl;

#if 0 // _SOLAR__PRIVATE
#ifdef _SV_FLOATWIN_CXX
	void			ImplCallPopupModeEnd();
		DECL_LINK( ImplEndPopupModeHdl, void* );
#endif

protected:
	void			ImplInit( Window* pParent, WinBits nStyle );
	void			ImplInitSettings();
	void			ImplLoadRes( const ResId& rResId );

public:
#define IMPL_FLOATWIN_HITTEST_OUTSIDE		((USHORT)0x0001)
#define IMPL_FLOATWIN_HITTEST_WINDOW		((USHORT)0x0002)
#define IMPL_FLOATWIN_HITTEST_RECT			((USHORT)0x0004)
	FloatingWindow* ImplFloatHitTest( const Point& rPos, USHORT& rHitTest );
	FloatingWindow* ImplFindLastLevelFloat();
	BOOL			ImplIsFloatPopupModeWindow( const Window* pWindow );
	void			ImplSetMouseDown() { mbMouseDown = TRUE; }
	BOOL			ImplIsMouseDown() const  { return mbMouseDown; }
	static Point	ImplCalcPos( Window* pWindow,
					 const Rectangle& rRect, ULONG nFlags,
					 USHORT& rArrangeIndex );
	void			ImplEndPopupMode( USHORT nFlags = 0, ULONG nFocusId = 0 );
#endif

public:
		FloatingWindow( Window* pParent, WinBits nStyle = WB_STDFLOATWIN );
		FloatingWindow( Window* pParent, const ResId& rResId );
		~FloatingWindow();

	virtual long	Notify( NotifyEvent& rNEvt );
	virtual void	StateChanged( StateChangedType nType );
	virtual void	DataChanged( const DataChangedEvent& rDCEvt );

	virtual void	PopupModeEnd();

	void			SetTitleType( USHORT nTitle );
	USHORT			GetTitleType() const { return mnTitle; }

	void			StartPopupMode( const Rectangle& rRect, ULONG nFlags = 0 );
	void			StartPopupMode( ToolBox* pBox, ULONG nFlags = 0  );
	void			EndPopupMode( USHORT nFlags = 0 );
	void			AddPopupModeWindow( Window* pWindow );
	void			RemovePopupModeWindow( Window* pWindow );
	ULONG			GetPopupModeFlags() const { return mnPopupModeFlags; }
	BOOL			IsInPopupMode() const { return mbPopupMode; }
	BOOL			IsPopupModeCanceled() const { return mbPopupModeCanceled; }
	BOOL			IsPopupModeTearOff() const { return mbPopupModeTearOff; }

	void			SetPopupModeEndHdl( const Link& rLink ) { maPopupModeEndHdl = rLink; }
	const Link& 	GetPopupModeEndHdl() const	{ return maPopupModeEndHdl; }
};

#endif 
