

#ifndef _VCL_INPUTCTX_HXX
#define _VCL_INPUTCTX_HXX

#ifndef _SV_SV_H
#include <vcl/sv.h>
#endif
#ifndef _SV_FONT_HXX
#include <vcl/font.hxx>
#endif

#define INPUTCONTEXT_TEXT				((ULONG)0x00000001)
#define INPUTCONTEXT_EXTTEXTINPUT		((ULONG)0x00000002)
#define INPUTCONTEXT_EXTTEXTINPUT_ON	((ULONG)0x00000004)
#define INPUTCONTEXT_EXTTEXTINPUT_OFF	((ULONG)0x00000008)

class InputContext
{
private:
	Font			maFont;
	ULONG			mnOptions;

public:
		InputContext() { mnOptions = 0; }
		InputContext( const InputContext& rInputContext ) :
			maFont( rInputContext.maFont )
		{ mnOptions = rInputContext.mnOptions; }
		InputContext( const Font& rFont, ULONG nOptions = 0 ) :
			maFont( rFont )
		{ mnOptions = nOptions; }

	void			SetFont( const Font& rFont ) { maFont = rFont; }
	const Font& 	GetFont() const { return maFont; }

	void			SetOptions( ULONG nOptions ) { mnOptions = nOptions; }
	ULONG			GetOptions() const { return mnOptions; }

	InputContext&	operator=( const InputContext& rInputContext );
	BOOL			operator==( const InputContext& rInputContext ) const;
	BOOL			operator!=( const InputContext& rInputContext ) const
			{ return !(InputContext::operator==( rInputContext )); }
};

inline InputContext& InputContext::operator=( const InputContext& rInputContext )
{
	maFont		= rInputContext.maFont;
	mnOptions	= rInputContext.mnOptions;
	return *this;
}

inline BOOL InputContext::operator==( const InputContext& rInputContext ) const
{
	return ((mnOptions	== rInputContext.mnOptions) &&
			(maFont 	== rInputContext.maFont));
}

#endif 
