

#ifndef _SV_JOBSET_HXX
#define _SV_JOBSET_HXX

#ifndef _TOOLS_STRING_HXX
#include <tools/string.hxx>
#endif
#ifndef _SV_SV_H
#include <vcl/sv.h>
#endif
#ifndef _SV_PRNTYPES_HXX
#include <vcl/prntypes.hxx>
#endif

class SvStream;
struct ImplJobSetup;

class JobSetup
{
	friend class Printer;

private:
	ImplJobSetup*		mpData;

#if 0 // _SOLAR__PRIVATE
public:
	ImplJobSetup*		ImplGetData();
	ImplJobSetup*		ImplGetConstData();
	const ImplJobSetup* ImplGetConstData() const;
#endif

public:
			JobSetup();
			JobSetup( const JobSetup& rJob );
			~JobSetup();

	String				GetPrinterName() const;
	String				GetDriverName() const;

	String				GetValue( const String& rKey ) const;
	void				SetValue( const String& rKey, const String& rValue );

	JobSetup&			operator=( const JobSetup& rJob );

	BOOL				operator==( const JobSetup& rJobSetup ) const;
	BOOL				operator!=( const JobSetup& rJobSetup ) const
				{ return !(JobSetup::operator==( rJobSetup )); }

	friend SvStream&	operator>>( SvStream& rIStream, JobSetup& rJobSetup );
	friend SvStream&	operator<<( SvStream& rOStream, const JobSetup& rJobSetup );
};

#endif	
