

#ifndef _SV_MAPMOD_HXX
#define _SV_MAPMOD_HXX

#ifndef _GEN_HXX
#include <tools/gen.hxx>
#endif
#ifndef _FRACT_HXX
#include <tools/fract.hxx>
#endif

#ifndef _SV_SV_H
#include <vcl/sv.h>
#endif
#ifndef _SV_RESID_HXX
#include <vcl/resid.hxx>
#endif
#ifndef _VCL_MAPUNIT_HXX
#include <vcl/mapunit.hxx>
#endif

class SvStream;

class ImplMapMode
{
	friend class	MapMode;
	friend class	OutputDevice;

private:
	USHORT			mnRefCount;
	MapUnit 		meUnit;
	Point			maOrigin;
	Fraction		maScaleX;
	Fraction		maScaleY;
	BOOL			mbSimple;

	friend SvStream& operator>>( SvStream& rIStm, ImplMapMode& rMapMode );
	friend SvStream& operator<<( SvStream& rOStm, const ImplMapMode& rMapMode );

#ifdef _SV_MAPMOD_CXX
public:
		ImplMapMode();
		ImplMapMode( const ImplMapMode& rImpMapMode );
#endif
};

class MapMode
{
	friend class	OutputDevice;

private:
	ImplMapMode*	mpImplMapMode;

#ifdef _SV_MAPMOD_CXX
	void			ImplMakeUnique();
#endif

public:
		MapMode();
		MapMode( const MapMode& rMapMode );
		MapMode( MapUnit eUnit );
		MapMode( MapUnit eUnit, const Point& rLogicOrg,
				 const Fraction& rScaleX, const Fraction& rScaleY );
		~MapMode();

	void			SetMapUnit( MapUnit eUnit );
	MapUnit 		GetMapUnit() const
			{ return mpImplMapMode->meUnit; }

	void			SetOrigin( const Point& rOrigin );
	const Point&	GetOrigin() const
			{ return mpImplMapMode->maOrigin; }

	void			SetScaleX( const Fraction& rScaleX );
	const Fraction& GetScaleX() const
			{ return mpImplMapMode->maScaleX; }
	void			SetScaleY( const Fraction& rScaleY );
	const Fraction& GetScaleY() const
			{ return mpImplMapMode->maScaleY; }

	MapMode&		operator=( const MapMode& rMapMode );
	BOOL			operator==( const MapMode& rMapMode ) const;
	BOOL			operator!=( const MapMode& rMapMode ) const
			{ return !(MapMode::operator==( rMapMode )); }
	BOOL			IsDefault() const;
	BOOL			IsSameInstance( const MapMode& rMapMode ) const
			{ return (mpImplMapMode == rMapMode.mpImplMapMode); }

	friend SvStream& operator>>( SvStream& rIStm, MapMode& rMapMode );
	friend SvStream& operator<<( SvStream& rOStm, const MapMode& rMapMode );
};

#endif	
