

#ifndef _SV_SOUND_HXX
#define _SV_SOUND_HXX

#ifndef _SV_SNDSTYLE_HXX
#include <vcl/sndstyle.hxx>
#endif

#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif
#ifndef _LINK_HXX
#include <tools/link.hxx>
#endif
#ifndef _TIME_HXX
#include <tools/time.hxx>
#endif
#ifndef _SV_SALSTYPE_HXX
#include <vcl/salstype.hxx>
#endif

class Window;
class Timer;
class SalSound;
class RMSound;

class Sound
{
private:

#ifndef REMOTE_APPSERVER
	SalSound*			mpSound;
#else
	RMSound*			mpSound;
#endif

	XubString			maSoundName;
	Window* 			mpWindow;
	BYTE*				mpSoundData;
	ULONG				mnDataLen;
	ULONG				mnSoundLen;
	ULONG				mnStartTime;
	ULONG				mnPlayTime;
	ULONG				mnErrorCode;
	SoundNotification	meNotification;
	BOOL				mbPlaying;
	BOOL				mbLoopMode;
	Link                maNotifyHdl;
	void*				mpExtraData;

private:
	                     Sound( const Sound& rSound );
	Sound&              operator=( const Sound& rSound );

#if 0 // _SOLAR__PRIVATE
public:
	void				ImplNotify( SoundNotification eNotification, ULONG nError );
#endif 

public:
	                    Sound( Window* pWindow = NULL );
	                    ~Sound();
	 virtual void        Notify();

	void				SetWindow( Window* pWindow ) { mpWindow = pWindow; }
	Window* 			GetWindow() const { return mpWindow; }
	BOOL				SetSoundName( const XubString& rSoundName );
	const XubString& 	GetSoundName() const { return maSoundName; }
	BOOL				SetSoundData( const BYTE* pSoundData, ULONG nDataLen );
	BYTE*				GetSoundData() const { return mpSoundData; }
	ULONG				GetSoundLen() const { return mnSoundLen; }
	 void				Play();
	void				Stop();
	void				Pause();
	BOOL                IsPlaying() const { return mbPlaying; }

	void				SetStartTime( ULONG nStartTime = 0 );
	ULONG				GetStartTime() const { return mnStartTime; }
	void				SetPlayTime( ULONG nPlayTime = SOUND_PLAYALL );
	ULONG				GetPlayTime() const { return mnPlayTime; }
	void				SetLoopMode( BOOL bLoop );
	BOOL				IsLoopMode() const { return mbLoopMode; }
	 void                ClearError();
	ULONG               GetLastError() const { return mnErrorCode; }
	SoundNotification   GetNotification() const { return meNotification; }
	 void                SetNotifyHdl( const Link& rLink ) { maNotifyHdl = rLink; }
	const Link&         GetNotifyHdl() const { return maNotifyHdl; }
	 static void         Beep( SoundType eType = SOUND_DEFAULT, Window* pWindow = NULL );

	static void			SetSoundPath( const XubString& rSoundPath );
	static const XubString&	GetSoundPath();
	 static BOOL         IsSoundFile( const XubString& rSoundPath );
};

#endif 

