

#ifndef _SV_SPINFLD_HXX
#define _SV_SPINFLD_HXX

#ifndef _SV_SV_H
#include <vcl/sv.h>
#endif
#ifndef _SV_EDIT_HXX
#include <vcl/edit.hxx>
#endif
#ifndef _SV_TIMER_HXX
#include <vcl/timer.hxx>
#endif

class SpinField : public Edit
{
protected:
	Edit*			mpEdit;
	AutoTimer		maRepeatTimer;
	Rectangle		maUpperRect;
	Rectangle		maLowerRect;
	Rectangle		maDropDownRect; 
	Link			maUpHdlLink;
	Link			maDownHdlLink;
	Link			maFirstHdlLink;
	Link			maLastHdlLink;
	BOOL			mbRepeat:1,
		mbSpin:1,
		mbInitialUp:1,
		mbInitialDown:1,
		mbNoSelect:1,
		mbUpperIn:1,
		mbLowerIn:1,
		mbInDropDown:1;

#if 0 // _SOLAR__PRIVATE
	void			ImplInit( Window* pParent, WinBits nStyle );

#ifdef _SV_SPINFLD_CXX
private:
		DECL_LINK( ImplTimeout, Timer* );
	void			ImplInitData();
	void			ImplCalcButtonAreas( OutputDevice* pDev, const Size& rOutSz, Rectangle& rDDArea, Rectangle& rSpinUpArea, Rectangle& rSpinDownArea );
#endif
#endif

protected:
		SpinField( WindowType nTyp );

	virtual long	Notify( NotifyEvent& rNEvt );
	virtual void	Command( const CommandEvent& rCEvt );

	void			EndDropDown();

public:
		SpinField( Window* pParent, WinBits nWinStyle = 0 );
		SpinField( Window* pParent, const ResId& rResId );
		~SpinField();

	virtual BOOL	ShowDropDown( BOOL bShow );

	virtual void	Up();
	virtual void	Down();
	virtual void	First();
	virtual void	Last();

	virtual void	MouseButtonDown( const MouseEvent& rMEvt );
	virtual void	MouseButtonUp( const MouseEvent& rMEvt );
	virtual void	MouseMove( const MouseEvent& rMEvt );
	virtual void	Paint( const Rectangle& rRect );
	virtual void	Draw( OutputDevice* pDev, const Point& rPos, const Size& rSize, ULONG nFlags );
	virtual void	Resize();
	virtual void	StateChanged( StateChangedType nType );
	virtual void	DataChanged( const DataChangedEvent& rDCEvt );

	void			SetUpHdl( const Link& rLink ) { maUpHdlLink = rLink; }
	const Link& 	GetUpHdl() const { return maUpHdlLink; }
	void			SetDownHdl( const Link& rLink ) { maDownHdlLink = rLink; }
	const Link& 	GetDownHdl() const { return maDownHdlLink; }
	void			SetFirstHdl( const Link& rLink ) { maFirstHdlLink = rLink; }
	const Link& 	GetFirstHdl() const { return maFirstHdlLink; }
	void			SetLastHdl( const Link& rLink ) { maLastHdlLink = rLink; }
	const Link& 	GetLastHdl() const { return maLastHdlLink; }

	Size			CalcMinimumSize() const;
	Size			CalcSize( USHORT nChars ) const;
	USHORT			GetMaxVisChars() const;
};

#endif 
