

#ifndef _XMLOFF_XMLEVENTEXPORT_HXX
#define _XMLOFF_XMLEVENTEXPORT_HXX

#ifndef _COM_SUN_STAR_UNO_SEQUENCE_HXX_
#include <com/sun/star/uno/Sequence.hxx>
#endif

#ifndef _COM_SUN_STAR_UNO_REFERENCE_HXX_
#include <com/sun/star/uno/Reference.hxx>
#endif

#ifndef _RTL_USTRING_HXX_
#include <rtl/ustring>
#endif

#ifndef _XMLOFF_XMLEVENT_HXX
#include <xmloff/xmlevent.hxx>
#endif

#include <map>

class SvXMLExport;
namespace com { namespace sun { namespace star {
	namespace document { class XEventsSupplier; }
	namespace container { class XNameReplace; }
	namespace container { class XNameAccess; }
	namespace beans { struct PropertyValue; }
} } }

typedef ::std::map< ::rtl::OUString, XMLEventExportHandler* > HandlerMap;
typedef ::std::map< ::rtl::OUString, ::rtl::OUString > NameMap;

class XMLEventExport
{
	const ::rtl::OUString sEventType;
	const ::rtl::OUString sScriptEvents;

	SvXMLExport& rExport;

	HandlerMap aHandlerMap;
	NameMap aNameTranslationMap;

public:
	XMLEventExport(SvXMLExport& rExport,
	   const XMLEventNameTranslation* pTranslationTable = NULL);
	~XMLEventExport();

	void AddHandler( const ::rtl::OUString& rName,
		 XMLEventExportHandler* rHandler );

	void AddTranslationTable( const XMLEventNameTranslation* pTransTable );

	void Export( ::com::sun::star::uno::Reference<
		 ::com::sun::star::document::XEventsSupplier> & xAccess,
	sal_Bool bUseWhitespace = sal_True);

	void Export( ::com::sun::star::uno::Reference<
		 ::com::sun::star::container::XNameReplace> & xAccess,
	sal_Bool bUseWhitespace = sal_True);

	void Export( ::com::sun::star::uno::Reference<
		 ::com::sun::star::container::XNameAccess> & xAccess,
	sal_Bool bUseWhitespace = sal_True);
	 void ExportSingleEvent(
	    ::com::sun::star::uno::Sequence<
	        ::com::sun::star::beans::PropertyValue>& rEventValues,
	    const ::rtl::OUString& rEventName,
	    sal_Bool bUseWhitespace = sal_True );

private:
	 void ExportEvent(
	    ::com::sun::star::uno::Sequence<
	        ::com::sun::star::beans::PropertyValue>& rEventValues,
	    const ::rtl::OUString& rEventName,
	    sal_Bool bUseWhitespace,
	    sal_Bool& rExported);

	void StartElement(sal_Bool bUseWhitespace);

	void EndElement(sal_Bool bUseWhitespace);
};

#endif
