

#ifndef _XMLOFF_NMSPMAP_HXX
#define _XMLOFF_NMSPMAP_HXX

#ifndef _RTL_USTRING_HXX_
#include <rtl/ustring.hxx>
#endif
#ifndef __SGI_STL_HASH_MAP
#include <hash_map>
#endif
#ifndef __SGI_STL_MAP
#include <map>
#endif
#ifndef _VOS_REF_HXX_
#include <vos/ref.hxx>
#endif
#ifndef _CPPUHELPER_WEAK_HXX_
#include <cppuhelper/weak.hxx>
#endif

const sal_uInt16 XML_NAMESPACE_XMLNS  = (USHRT_MAX-2);
const sal_uInt16 XML_NAMESPACE_NONE  = (USHRT_MAX-1);
const sal_uInt16 XML_NAMESPACE_UNKNOWN  = (USHRT_MAX);
const sal_uInt16 XML_NAMESPACE_UNKNOWN_FLAG  = 0x8000;

class NameSpaceEntry : public cppu::OWeakObject
{
public:

	::rtl::OUString 	sName;

	::rtl::OUString 	sPrefix;

	sal_uInt16			nKey;
};

struct OUStringEqFunc
{
	sal_Bool operator()( const rtl::OUString &r1,
	    	 const rtl::OUString &r2) const
	{
		return r1 == r2;
	}
};

struct uInt32lt
{
	sal_Bool operator()( const sal_uInt32 &r1,
	    	 const sal_uInt32 &r2) const
	{
		return r1 < r2;
	}
};

typedef ::std::hash_map < ::rtl::OUString, ::vos::ORef <NameSpaceEntry >, rtl::OUStringHash, OUStringEqFunc > NameSpaceHash;
typedef ::std::map < sal_uInt16, ::vos::ORef < NameSpaceEntry >, uInt32lt > NameSpaceMap;

class SvXMLNamespaceMap
{
	const ::rtl::OUString		sXMLNS;
	const ::rtl::OUString		sEmpty;

	NameSpaceHash 				aNameHash;
	NameSpaceMap				aNameMap;
	sal_uInt16 _Add( const rtl::OUString& rPrefix, const rtl::OUString &rName, sal_uInt16 nKey );

public:

	SvXMLNamespaceMap();
	~SvXMLNamespaceMap();

	SvXMLNamespaceMap( const SvXMLNamespaceMap& );

	int operator ==( const SvXMLNamespaceMap& rCmp ) const;

	sal_uInt16 Add( const ::rtl::OUString& rPrefix,
	const ::rtl::OUString& rName,
	sal_uInt16 nKey = XML_NAMESPACE_UNKNOWN );

	sal_uInt16 GetKeyByName( const ::rtl::OUString& rName ) const;
	const ::rtl::OUString& GetNameByKey( sal_uInt16 nKey ) const;

	sal_uInt16 GetKeyByPrefix( const ::rtl::OUString& rPrefix ) const;
	const ::rtl::OUString& GetPrefixByKey( sal_uInt16 nKey ) const;

	::rtl::OUString GetQNameByKey( sal_uInt16 nKey, 
			   const ::rtl::OUString& rLocalName ) const;

	::rtl::OUString GetAttrNameByKey( sal_uInt16 nKey ) const;

	sal_uInt16 _GetKeyByAttrName( const ::rtl::OUString& rAttrName,
				 ::rtl::OUString *pPrefix,
				 ::rtl::OUString *pLocalName,
				 ::rtl::OUString *pNamespace = 0 ) const;

	sal_uInt16 _GetKeyByAttrName( const ::rtl::OUString& rAttrName,
				 ::rtl::OUString *pLocalName = 0 ) const;

	sal_uInt16 GetFirstKey() const;
	sal_uInt16 GetNextKey( sal_uInt16 nOldKey ) const;

 sal_Bool AddAtIndex( sal_uInt16 nIdx, const ::rtl::OUString& rPrefix,
		 const ::rtl::OUString& rName, sal_uInt16 nKey = XML_NAMESPACE_UNKNOWN );
 sal_Bool AddAtIndex( sal_uInt16 nIdx, const sal_Char *pPrefix,
		 const sal_Char *pName, sal_uInt16 nKey = XML_NAMESPACE_UNKNOWN );
 sal_uInt16 GetIndexByKey( sal_uInt16 nKey ) const;
 sal_uInt16 GetKeyByIndex( sal_uInt16 nIdx ) const;
 sal_uInt16 GetIndexByPrefix( const ::rtl::OUString& rPrefix ) const;
 sal_uInt16 GetFirstIndex() const;
 sal_uInt16 GetNextIndex( sal_uInt16 nOldIdx ) const;
 const ::rtl::OUString& GetPrefixByIndex( sal_uInt16 nIdx ) const;
 const ::rtl::OUString& GetNameByIndex( sal_uInt16 nIdx ) const;
 ::rtl::OUString GetAttrNameByIndex( sal_uInt16 nIdx ) const;
 ::rtl::OUString GetQNameByIndex( sal_uInt16 nIdx,
				const ::rtl::OUString& rLocalName ) const;
 sal_uInt16 GetKeyByAttrName( const ::rtl::OUString& rAttrName,
				 ::rtl::OUString *pPrefix,
				 ::rtl::OUString *pLocalName,
				 ::rtl::OUString *pNamespace=0,
				 sal_uInt16 nIdxGuess = USHRT_MAX ) const;
 sal_uInt16 GetKeyByAttrName( const ::rtl::OUString& rAttrName,
				 ::rtl::OUString *pLocalName = 0,
				 sal_uInt16 nIdxGuess = USHRT_MAX ) const;
};

#endif	
