

#ifndef XMLOFF_NUMEHELP_HXX
#define XMLOFF_NUMEHELP_HXX

#ifndef _SAL_TYPES_H_
#include <sal/types.h>
#endif
#ifndef _COM_SUN_STAR_FRAME_XMODEL_HPP_
#include <com/sun/star/frame/XModel.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XNUMBERFORMATSSUPPLIER_HPP_
#include <com/sun/star/util/XNumberFormatsSupplier.hpp>
#endif

#ifndef __SGI_STL_SET
#include <set>
#endif

class SvXMLExport;
namespace rtl
{
	class OUString;
}

struct XMLNumberFormat
{
	rtl::OUString	sCurrency;
	sal_Int32		nNumberFormat;
	sal_Int16		nType;
	sal_Bool		bIsStandard : 1;
	XMLNumberFormat() : nNumberFormat(0), nType(0) {}
	XMLNumberFormat(const rtl::OUString& sTempCurrency, sal_Int32 nTempFormat,
		sal_Int16 nTempType) : sCurrency(sTempCurrency), nNumberFormat(nTempFormat),
			nType(nTempType) {}
};

struct LessNumberFormat
{
	sal_Bool operator() (const XMLNumberFormat& rValue1, const XMLNumberFormat& rValue2) const
	{
		return rValue1.nNumberFormat < rValue2.nNumberFormat;
	}
};

typedef std::set<XMLNumberFormat, LessNumberFormat>	XMLNumberFormatSet;

class XMLNumberFormatAttributesExportHelper
{
	::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatsSupplier > xNumberFormatsSupplier;
	SvXMLExport*		pExport;
	rtl::OUString		sEmpty;
	XMLNumberFormatSet	aNumberFormats;
public :
	XMLNumberFormatAttributesExportHelper(::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatsSupplier >& xNumberFormatsSupplier);
	~XMLNumberFormatAttributesExportHelper();
	void SetExport(SvXMLExport* pExport) { this->pExport = pExport; }

	sal_Int16 GetCellType(const sal_Int32 nNumberFormat, rtl::OUString& sCurrency, sal_Bool& bIsStandard);
	void SetNumberFormatAttributes(const sal_Int32 nNumberFormat,
						  const double& rValue,
						  sal_uInt16 nNamespace,
						  sal_Bool bExportValue = sal_True);
	void SetNumberFormatAttributes(const rtl::OUString& rValue,
							  const rtl::OUString& rCharacters,
							  sal_uInt16 nNamespace,
							  sal_Bool bExportValue = sal_True,
							  sal_Bool bExportTypeAttribute = sal_True);

	static void WriteAttributes(SvXMLExport& rXMLExport,
					const sal_Int16 nTypeKey,
					const double& rValue,
					const rtl::OUString& rCurrencySymbol,
					sal_uInt16 nNamespace,
					sal_Bool bExportValue = sal_True);
	static sal_Bool GetCurrencySymbol(const sal_Int32 nNumberFormat, rtl::OUString& rCurrencySymbol,
		::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatsSupplier > & xNumberFormatsSupplier);
	static sal_Int16 GetCellType(const sal_Int32 nNumberFormat, sal_Bool& bIsStandard,
		::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatsSupplier > & xNumberFormatsSupplier);
	static void SetNumberFormatAttributes(SvXMLExport& rXMLExport,
							  const sal_Int32 nNumberFormat,
							  const double& rValue,
							  sal_uInt16 nNamespace,
							  sal_Bool bExportValue = sal_True);
	static void SetNumberFormatAttributes(SvXMLExport& rXMLExport,
							  const rtl::OUString& rValue,
							  const rtl::OUString& rCharacters,
							  sal_uInt16 nNamespace,
							  sal_Bool bExportValue = sal_True,
							  sal_Bool bExportTypeAttribute = sal_True);
};

#endif

