
#ifndef _XMLOFF_PRSTYLEI_HXX_
#define _XMLOFF_PRSTYLEI_HXX_

#ifndef _COM_SUN_STAR_STYLE_XSTYLE_HPP_
#include <com/sun/star/style/XStyle.hpp>
#endif
#ifndef __SGI_STL_VECTOR
#include <vector>
#endif
#ifndef _XMLOFF_XMLSTYLE_HXX_
#include <xmloff/xmlstyle.hxx>
#endif

struct XMLPropertyState;
class SvXMLStylesContext;

namespace com { namespace sun { namespace star {
	namespace beans { class XPropertySet; }
} } }

class XMLPropStyleContext : public SvXMLStyleContext
{
	const ::rtl::OUString sIsPhysical;
	const ::rtl::OUString sFollowStyle;
	::std::vector< XMLPropertyState > aProperties;
	::com::sun::star::uno::Reference < ::com::sun::star::style::XStyle > xStyle;
	SvXMLImportContextRef				xStyles;

protected:

	virtual void SetAttribute( sal_uInt16 nPrefixKey,
				   const ::rtl::OUString& rLocalName,
				   const ::rtl::OUString& rValue );
	SvXMLStylesContext *GetStyles() { return (SvXMLStylesContext *)&xStyles; }
	::std::vector< XMLPropertyState > & GetProperties() { return aProperties; }

	virtual ::com::sun::star::uno::Reference <
		::com::sun::star::style::XStyle > Create();

public:

	TYPEINFO();

	XMLPropStyleContext( SvXMLImport& rImport, sal_uInt16 nPrfx,
			const ::rtl::OUString& rLName,
			const ::com::sun::star::uno::Reference< ::com::sun::star::xml::sax::XAttributeList > & xAttrList,
			SvXMLStylesContext& rStyles, sal_uInt16 nFamily = 0,
	  sal_Bool bDefaultStyle=sal_False );
	virtual ~XMLPropStyleContext();

	virtual SvXMLImportContext *CreateChildContext(
			sal_uInt16 nPrefix,
			const ::rtl::OUString& rLocalName,
			const ::com::sun::star::uno::Reference< ::com::sun::star::xml::sax::XAttributeList > & xAttrList );

	virtual void FillPropertySet(
			const ::com::sun::star::uno::Reference<
	::com::sun::star::beans::XPropertySet > & rPropSet );

	const SvXMLStylesContext *GetStyles() const { return (const SvXMLStylesContext *)&xStyles; }
	const ::std::vector< XMLPropertyState > & GetProperties() const { return aProperties; }

	const ::com::sun::star::uno::Reference <
	::com::sun::star::style::XStyle >&
			GetStyle() const { return xStyle; }
	void SetStyle(
			const ::com::sun::star::uno::Reference<
	::com::sun::star::style::XStyle >& xStl) { xStyle = xStl; }

	virtual void SetDefaults();

	virtual void CreateAndInsert( sal_Bool bOverwrite );
	virtual void Finish( sal_Bool bOverwrite );
};

#endif
