

#ifndef _XMLOFF_TXTFLDE_HXX
#define _XMLOFF_TXTFLDE_HXX

#ifndef _COM_SUN_STAR_UNO_REFERENCE_H_
#include <com/sun/star/uno/Reference.h>
#endif

#ifndef _XMLOFF_XMLNMSPE_HXX
#include <xmloff/xmlnmspe.hxx>
#endif

#ifndef _RTL_USTRING
#include <rtl/ustring>
#endif

#ifndef _XMLOFF_XMLTOKEN_HXX
#include <xmloff/xmltoken.hxx>
#endif

#include <map>
#include <set>

class SvXMLExport;
class SvXMLNumFmtExport;
struct XMLPropertyState;

namespace com { namespace sun { namespace star { 
	namespace util { struct DateTime; }
	namespace util { struct Date; }
	namespace text { class XTextField; } 
	namespace text { class XText; } 
	namespace beans { class XPropertySet; } 
	namespace frame { class XModel; } 
} } }
namespace rtl { class OUString; }

enum FieldIdEnum {
	FIELD_ID_SENDER,		
	FIELD_ID_AUTHOR,
	FIELD_ID_DATE,			
	FIELD_ID_TIME,			
	FIELD_ID_PAGENUMBER,	
	FIELD_ID_PAGESTRING,	
	FIELD_ID_REFPAGE_SET,	
	FIELD_ID_REFPAGE_GET,	

	FIELD_ID_PLACEHOLDER,	

	FIELD_ID_VARIABLE_DECL,	
	FIELD_ID_VARIABLE_GET,	
	FIELD_ID_VARIABLE_SET,	
	FIELD_ID_VARIABLE_INPUT,	
	FIELD_ID_USER_DECL,		
	FIELD_ID_USER_GET,		
	FIELD_ID_USER_INPUT,	
	FIELD_ID_TEXT_INPUT,	
	FIELD_ID_EXPRESSION,	
	FIELD_ID_SEQUENCE_DECL,	
	FIELD_ID_SEQUENCE,		

	FIELD_ID_DATABASE_NEXT,		
	FIELD_ID_DATABASE_SELECT,	
	FIELD_ID_DATABASE_DISPLAY,	
	FIELD_ID_DATABASE_NAME,		
	FIELD_ID_DATABASE_NUMBER,	

	FIELD_ID_DOCINFO_CREATION_AUTHOR,	
	FIELD_ID_DOCINFO_CREATION_TIME,
	FIELD_ID_DOCINFO_CREATION_DATE,
	FIELD_ID_DOCINFO_DESCRIPTION,
	FIELD_ID_DOCINFO_INFORMATION0,	
	FIELD_ID_DOCINFO_INFORMATION1,	
	FIELD_ID_DOCINFO_INFORMATION2,	
	FIELD_ID_DOCINFO_INFORMATION3,
	FIELD_ID_DOCINFO_PRINT_TIME,
	FIELD_ID_DOCINFO_PRINT_DATE,
	FIELD_ID_DOCINFO_PRINT_AUTHOR,
	FIELD_ID_DOCINFO_TITLE,
	FIELD_ID_DOCINFO_SUBJECT,
	FIELD_ID_DOCINFO_KEYWORDS,
	FIELD_ID_DOCINFO_REVISION,
	FIELD_ID_DOCINFO_EDIT_DURATION,
	FIELD_ID_DOCINFO_SAVE_TIME,
	FIELD_ID_DOCINFO_SAVE_DATE,
	FIELD_ID_DOCINFO_SAVE_AUTHOR,

	FIELD_ID_CONDITIONAL_TEXT,			
	FIELD_ID_HIDDEN_TEXT,				
	FIELD_ID_HIDDEN_PARAGRAPH,			

	FIELD_ID_TEMPLATE_NAME,		
	FIELD_ID_CHAPTER,			
	FIELD_ID_FILE_NAME,			

	FIELD_ID_COUNT_PARAGRAPHS,		
	FIELD_ID_COUNT_WORDS,			
	FIELD_ID_COUNT_CHARACTERS,		
	FIELD_ID_COUNT_PAGES,			
	FIELD_ID_COUNT_TABLES,			
	FIELD_ID_COUNT_GRAPHICS,		
	FIELD_ID_COUNT_OBJECTS,			

	FIELD_ID_MACRO,					
	FIELD_ID_REF_REFERENCE,			
	FIELD_ID_REF_SEQUENCE,			
	FIELD_ID_REF_BOOKMARK,			
	FIELD_ID_REF_FOOTNOTE,			
	FIELD_ID_REF_ENDNOTE,			
	FIELD_ID_DDE,					

	FIELD_ID_BIBLIOGRAPHY,			

	FIELD_ID_SHEET_NAME,			
	FIELD_ID_URL,					

	FIELD_ID_SCRIPT,				
	FIELD_ID_ANNOTATION,			

	FIELD_ID_COMBINED_CHARACTERS,	

	FIELD_ID_MEASURE,				

	FIELD_ID_UNKNOWN		
};

class XMLTextFieldExport
{
	SvXMLExport& rExport;

	::std::map<
			::com::sun::star::uno::Reference< ::com::sun::star::text::XText >,
			::std::set< ::rtl::OUString > > * 
		pUsedMasters;

public:

	XMLTextFieldExport( SvXMLExport& rExp, 
				XMLPropertyState* pCombinedCharState = NULL );
	virtual ~XMLTextFieldExport();

	void ExportField(const ::com::sun::star::uno::Reference <
		  ::com::sun::star::text::XTextField > & rTextField );

	void ExportFieldAutoStyle(const ::com::sun::star::uno::Reference <
		  ::com::sun::star::text::XTextField > & rTextField );

	void ExportFieldDeclarations();

	void ExportFieldDeclarations(
		const ::com::sun::star::uno::Reference < 
	::com::sun::star::text::XText > & rText);

	void SetExportOnlyUsedFieldDeclarations(
		sal_Bool bExportOnlyUsed = sal_True);

	static enum ::xmloff::token::XMLTokenEnum MapPlaceholderType(sal_uInt16 nType);
	static enum ::xmloff::token::XMLTokenEnum MapTemplateDisplayFormat(sal_Int16 nType);
	static enum ::xmloff::token::XMLTokenEnum MapChapterDisplayFormat(sal_Int16 nType);
	static enum ::xmloff::token::XMLTokenEnum MapFilenameDisplayFormat(sal_Int16 nType);
	static enum ::xmloff::token::XMLTokenEnum MapDocInfoFieldName(enum FieldIdEnum nToken);
	static enum ::xmloff::token::XMLTokenEnum MapReferenceSource(sal_Int16 nType);
	static enum ::xmloff::token::XMLTokenEnum MapReferenceType(sal_Int16 nType);
	static enum ::xmloff::token::XMLTokenEnum MapCountFieldName(sal_Int16 nToken);
	static enum ::xmloff::token::XMLTokenEnum MapBibliographyFieldName(::rtl::OUString sName);
	static enum ::xmloff::token::XMLTokenEnum MapMeasureKind(sal_Int16 nKind);
	enum ::xmloff::token::XMLTokenEnum MapPageNumberName(const ::com::sun::star::uno::Reference<
		  ::com::sun::star::beans::XPropertySet> & xPropSet,
		  sal_Int32& nOffset);	
	enum ::xmloff::token::XMLTokenEnum MapAuthorFieldName(const ::com::sun::star::uno::Reference <
		  ::com::sun::star::beans::XPropertySet > & xPropSet);
	enum ::xmloff::token::XMLTokenEnum MapSenderFieldName(const ::com::sun::star::uno::Reference <
		  ::com::sun::star::beans::XPropertySet > & xPropSet);

protected:

	SvXMLExport& GetExport() { return rExport; }

	void XMLTextFieldExport::ExportFieldHelper(
		const ::com::sun::star::uno::Reference<
	::com::sun::star::text::XTextField> & rTextField,
		const ::com::sun::star::uno::Reference<
	::com::sun::star::beans::XPropertySet> & rPropSet,
		const ::com::sun::star::uno::Reference<
	::com::sun::star::beans::XPropertySet> & rRangePropSet,
		enum FieldIdEnum nToken);

	void ExportElement(enum ::xmloff::token::XMLTokenEnum eElement,	
		   sal_Bool bAddSpace = sal_False); 

	void ExportElement(enum ::xmloff::token::XMLTokenEnum eElement,	
		   const ::rtl::OUString& sContent,	
		   sal_Bool bAddSpace = sal_False); 
	 void ExportMacro( const ::com::sun::star::uno::Reference<
	                      ::com::sun::star::beans::XPropertySet> & rPropSet,
	                  const ::rtl::OUString& rContent);

	void ProcessBoolean(
		enum ::xmloff::token::XMLTokenEnum eXmlName,	
		sal_Bool bBool,		
		sal_Bool bDefault);	

	void ProcessInteger(
		enum ::xmloff::token::XMLTokenEnum eXmlName,	
		sal_Int32 nNum);			

	void ProcessInteger(
		enum ::xmloff::token::XMLTokenEnum eXmlName,	
		sal_Int32 nNum,				
		sal_Int32 nDefault);		

	void ProcessString(
		enum ::xmloff::token::XMLTokenEnum eXmlName,		
		const ::rtl::OUString& sValue,	
		sal_Bool bOmitEmpty = sal_False, 
		sal_uInt16 nPrefix = XML_NAMESPACE_TEXT);	

	void ProcessString(
		enum ::xmloff::token::XMLTokenEnum eXmlName,		
		const ::rtl::OUString& sValue,	
		const ::rtl::OUString& sDefault, 
		sal_uInt16 nPrefix = XML_NAMESPACE_TEXT);	

	void ProcessString(
		enum ::xmloff::token::XMLTokenEnum eXmlName,		
		enum ::xmloff::token::XMLTokenEnum eValue,			
		sal_Bool bOmitEmpty = sal_False, 
		sal_uInt16 nPrefix = XML_NAMESPACE_TEXT);	

	void ProcessString(
		enum ::xmloff::token::XMLTokenEnum eXmlName,		
		enum ::xmloff::token::XMLTokenEnum eValue,			
		enum ::xmloff::token::XMLTokenEnum eDefault,		
		sal_uInt16 nPrefix = XML_NAMESPACE_TEXT);	

	void ProcessParagraphSequence(

		const ::rtl::OUString& sParagraphSequence);

	void ProcessNumberingType(
		sal_Int16 nNumberingType);		

	void ProcessDisplay(sal_Bool bIsVisible,	
			sal_Bool bIsCommand,	
			sal_Bool bDefault = sal_True);	

	void ProcessValueAndType(
		sal_Bool bIsString,		
		sal_Int32 nFormatKey,	
		const ::rtl::OUString& sContent, 
		const ::rtl::OUString& sDefault, 
		double fValue,			
		sal_Bool bExportValue,	
		sal_Bool bExportValueType,	
		sal_Bool bExportStyle,	
		sal_Bool bTimeStyle = sal_False);	

	void ProcessDateTime(
		enum ::xmloff::token::XMLTokenEnum eXMLName, 	
		double dValue, 				
		sal_Bool bIsDate, 			
		sal_Bool bIsDuration = sal_False,			
		sal_Bool bOmitDurationIfZero = sal_True,	
		sal_uInt16 nPrefix = XML_NAMESPACE_TEXT);	

	void ProcessDateTime(
		enum ::xmloff::token::XMLTokenEnum eXMLName, 	
		sal_Int32 nMinutes,				
		sal_Bool bIsDate, 			
		sal_Bool bIsDuration,		
		sal_Bool bOmitDurationIfZero,	
		sal_uInt16 nPrefix = XML_NAMESPACE_TEXT);	

	void ProcessDateTime(
		enum ::xmloff::token::XMLTokenEnum eXMLName, 	
		const ::com::sun::star::util::DateTime& rTime,		
		sal_Bool bIsDate,			
		sal_uInt16 nPrefix = XML_NAMESPACE_TEXT);	

	void ProcessDate(
		enum ::xmloff::token::XMLTokenEnum eXMLName, 	
		const ::com::sun::star::util::Date& rTime,	
		sal_uInt16 nPrefix = XML_NAMESPACE_TEXT);	

	void ProcessBibliographyData(
		const ::com::sun::star::uno::Reference < 
			::com::sun::star::beans::XPropertySet > & rPropertySet);

	::com::sun::star::uno::Reference < ::com::sun::star::beans::XPropertySet >
	GetMasterPropertySet(const ::com::sun::star::uno::Reference <
			 ::com::sun::star::text::XTextField > & rTextField);

	sal_Bool GetDependentFieldPropertySet(
		const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet> & xmaster,
		::com::sun::star::uno::Reference< 
		::com::sun::star::beans::XPropertySet> & xField);

	enum FieldIdEnum GetFieldID(const ::com::sun::star::uno::Reference <
			  ::com::sun::star::text::XTextField > & rTextField,
			  const ::com::sun::star::uno::Reference <
			  ::com::sun::star::beans::XPropertySet > & xPropSet);

	enum FieldIdEnum MapFieldName(const ::rtl::OUString& sFieldName,
				const ::com::sun::star::uno::Reference <
				::com::sun::star::beans::XPropertySet> & xPropSet);

	sal_Bool IsStringField(sal_uInt16 nFieldType,	
			   const ::com::sun::star::uno::Reference <
			   ::com::sun::star::beans::XPropertySet > & xPropSet);

	sal_Bool ExplodeFieldMasterName(
		const ::rtl::OUString& sMasterName,	
		::rtl::OUString& sFieldType,		
		::rtl::OUString& sVarName);			

	static ::rtl::OUString MakeFootnoteRefName(sal_Int16 nSeqNo);

	static ::rtl::OUString MakeSequenceRefName(sal_Int16 nSeqNo, 
								  const ::rtl::OUString& rSeqName);

private:	

	const ::rtl::OUString sServicePrefix;
	const ::rtl::OUString sFieldMasterPrefix;

	const ::rtl::OUString sPropertyContent;
	const ::rtl::OUString sPropertyIsFixed;
	const ::rtl::OUString sPropertyFullName;
	const ::rtl::OUString sPropertyFieldSubType;
	const ::rtl::OUString sPropertyHint;
	const ::rtl::OUString sPropertyPlaceholder;
	const ::rtl::OUString sPropertyPlaceholderType;
	const ::rtl::OUString sPropertyIsVisible;
	const ::rtl::OUString sPropertyIsShowFormula;
	const ::rtl::OUString sPropertyIsInput;
	const ::rtl::OUString sPropertyIsExpression;
	const ::rtl::OUString sPropertyNumberFormat;
	const ::rtl::OUString sPropertyVariableName;
	const ::rtl::OUString sPropertySubType;
	const ::rtl::OUString sPropertyName;
	const ::rtl::OUString sPropertyVariableSubType;
	const ::rtl::OUString sPropertyValue;
	const ::rtl::OUString sPropertyChapterNumberingLevel;
	const ::rtl::OUString sPropertyNumberingSeparator;
	const ::rtl::OUString sPropertyNumberingType;
	const ::rtl::OUString sPropertyDataBaseName;
	const ::rtl::OUString sPropertyDataTableName;
	const ::rtl::OUString sPropertyDateTimeValue;
	const ::rtl::OUString sPropertyDataColumnName;
	const ::rtl::OUString sPropertySetNumber;
	const ::rtl::OUString sPropertyIsDataBaseFormat;
	const ::rtl::OUString sPropertyUserText;
	const ::rtl::OUString sPropertyOffset;
	const ::rtl::OUString sPropertyCondition;
	const ::rtl::OUString sPropertyDateTime;
	const ::rtl::OUString sPropertyTrueContent;
	const ::rtl::OUString sPropertyFalseContent;
	const ::rtl::OUString sPropertyRevision;
	const ::rtl::OUString sPropertyChapterFormat;
	const ::rtl::OUString sPropertyFileFormat;
	const ::rtl::OUString sPropertyLevel;
	const ::rtl::OUString sPropertyIsDate;
	const ::rtl::OUString sPropertyAdjust;
	const ::rtl::OUString sPropertyOn;
	const ::rtl::OUString sPropertyMacro;
	const ::rtl::OUString sPropertyReferenceFieldPart;
	const ::rtl::OUString sPropertyReferenceFieldType;
	const ::rtl::OUString sPropertyReferenceFieldSource;
	const ::rtl::OUString sPropertySequenceNumber;
	const ::rtl::OUString sPropertySourceName;
	const ::rtl::OUString sPropertyIsAutomaticUpdate;
	const ::rtl::OUString sPropertyDependentTextFields;
	const ::rtl::OUString sPropertyDDECommandType;
	const ::rtl::OUString sPropertyDDECommandFile;
	const ::rtl::OUString sPropertyDDECommandElement;
	const ::rtl::OUString sPropertySequenceValue;
	const ::rtl::OUString sPropertyURL;
	const ::rtl::OUString sPropertyTargetFrame;
	const ::rtl::OUString sPropertyFields;
	const ::rtl::OUString sPropertyScriptType;
	const ::rtl::OUString sPropertyURLContent;
	const ::rtl::OUString sPropertyAuthor;
	const ::rtl::OUString sPropertyDate;
	const ::rtl::OUString sPropertyMeasureKind;
	const ::rtl::OUString sPropertyInstanceName;
	const ::rtl::OUString sPropertyIsHidden;
	const ::rtl::OUString sPropertyIsConditionTrue;

	const ::rtl::OUString sEmpty;

	XMLPropertyState* pCombinedCharactersPropertyState;

};

#endif
