
#ifndef _XMLOFF_TEXTPARAE_HXX_
#define _XMLOFF_TEXTPARAE_HXX_

#ifndef _RTL_USTRING_HXX_
#include <rtl/ustring.hxx>
#endif
#ifndef _COM_SUN_STAR_UNO_REFERENCE_H_
#include <com/sun/star/uno/Reference.h>
#endif
#ifndef _COM_SUN_STAR_UNO_SEQUENCE_H_
#include <com/sun/star/uno/Sequence.h>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYVALUE_HPP_
#include <com/sun/star/beans/PropertyValue.hpp>
#endif
#ifndef _UNIVERSALL_REFERENCE_HXX
#include <xmloff/uniref.hxx>
#endif
#ifndef _XMLOFF_XMLEXPPR_HXX
#include <xmloff/xmlexppr.hxx>
#endif
#ifndef _XMLOFF_STYLEEXP_HXX
#include <xmloff/styleexp.hxx>
#endif
#ifndef _XMLOFF_XMLTOKEN_HXX
#include <xmloff/xmltoken.hxx>
#endif

class SvXMLExport;
class SvXMLAutoStylePoolP;
class XMLTextFieldExport;
class OUStrings_Impl;
class OUStringsSort_Impl;
class XMLTextNumRuleInfo;
class XMLTextListAutoStylePool;
class SvLongs;
class XMLSectionExport;
class XMLIndexMarkExport;
class XMLRedlineExport;
struct XMLPropertyState;
class MultiPropertySetHelper;

namespace com { namespace sun { namespace star
{
	namespace beans { class XPropertySet; class XPropertyState;
		  class XPropertySetInfo; }
	namespace container { class XEnumeration; class XIndexAccess; }
	namespace text { class XTextContent; class XTextRange; class XText;
	                 class XFootnote; class XTextFrame; class XTextSection;
		 class XDocumentIndex; }
} } }

class XMLTextParagraphExport : public XMLStyleExport
{

	SvXMLAutoStylePoolP& rAutoStylePool;
	UniReference < SvXMLExportPropertyMapper > xParaPropMapper;
	UniReference < SvXMLExportPropertyMapper > xTextPropMapper;
	UniReference < SvXMLExportPropertyMapper > xFramePropMapper;
	UniReference < SvXMLExportPropertyMapper > xAutoFramePropMapper;
	UniReference < SvXMLExportPropertyMapper > xSectionPropMapper;
	UniReference < SvXMLExportPropertyMapper > xRubyPropMapper;
	::com::sun::star::uno::Reference <
		::com::sun::star::container::XIndexAccess > xTextFrames;
	::com::sun::star::uno::Reference <
		::com::sun::star::container::XIndexAccess > xGraphics;
	::com::sun::star::uno::Reference <
		::com::sun::star::container::XIndexAccess > xEmbeddeds;
	::com::sun::star::uno::Reference <
		::com::sun::star::container::XIndexAccess > xShapes;

	SvLongs 					*pPageTextFrameIdxs;
	SvLongs 					*pPageGraphicIdxs;
	SvLongs 					*pPageEmbeddedIdxs;
	SvLongs 					*pPageShapeIdxs;
	SvLongs 					*pFrameTextFrameIdxs;
	SvLongs 					*pFrameGraphicIdxs;
	SvLongs 					*pFrameEmbeddedIdxs;
	SvLongs 					*pFrameShapeIdxs;
	XMLTextFieldExport			*pFieldExport;
	OUStrings_Impl				*pListElements;
	OUStringsSort_Impl			*pExportedLists;
	XMLTextListAutoStylePool	*pListAutoPool;
	XMLSectionExport			*pSectionExport;
	XMLIndexMarkExport			*pIndexMarkExport;

	XMLRedlineExport			*pRedlineExport;

#if SUPD < 628 && !defined( TEST_MIB )
	sal_Int32					nProgress;
#else
	sal_Bool					bProgress;
#endif

	sal_Bool					bBlock;

	::rtl::OUString				sOpenRubyText;
	::rtl::OUString				sOpenRubyCharStyle;
	sal_Bool					bOpenRuby;

protected:

	const ::rtl::OUString sParagraphService;
	const ::rtl::OUString sTableService;
	const ::rtl::OUString sTextFieldService;
	const ::rtl::OUString sTextFrameService;
	const ::rtl::OUString sTextEmbeddedService;
	const ::rtl::OUString sTextGraphicService;
	const ::rtl::OUString sTextEndnoteService;
	const ::rtl::OUString sTextContentService;
	const ::rtl::OUString sShapeService;
	const ::rtl::OUString sParaStyleName;
	const ::rtl::OUString sParaConditionalStyleName;
	const ::rtl::OUString sParaChapterNumberingLevel;
	const ::rtl::OUString sCharStyleName;
	const ::rtl::OUString sFrameStyleName;
	const ::rtl::OUString sText;
	const ::rtl::OUString sTextField;
	const ::rtl::OUString sFrame;
	const ::rtl::OUString sCategory;
	const ::rtl::OUString sNumberingRules;
	const ::rtl::OUString sTextPortionType;
	const ::rtl::OUString sFootnote;
	const ::rtl::OUString sBookmark;
	const ::rtl::OUString sReferenceMark;
	const ::rtl::OUString sIsCollapsed;
	const ::rtl::OUString sIsStart;
	const ::rtl::OUString sReferenceId;
	const ::rtl::OUString sNumberingType;
	const ::rtl::OUString sPageStyleName;
	const ::rtl::OUString sPageDescName;
	const ::rtl::OUString sPrefix;
	const ::rtl::OUString sStartAt;
	const ::rtl::OUString sSuffix;
	const ::rtl::OUString sPositionEndOfDoc;
	const ::rtl::OUString sFootnoteCounting;
	const ::rtl::OUString sEndNotice;
	const ::rtl::OUString sBeginNotice;
	const ::rtl::OUString sFrameWidthAbsolute;
	const ::rtl::OUString sFrameWidthPercent;
	const ::rtl::OUString sFrameHeightAbsolute;
	const ::rtl::OUString sFrameHeightPercent;
	const ::rtl::OUString sWidth;
	const ::rtl::OUString sRelativeWidth;
	const ::rtl::OUString sHeight;
	const ::rtl::OUString sRelativeHeight;
	const ::rtl::OUString sSizeType;
	const ::rtl::OUString sIsSyncWidthToHeight;
	const ::rtl::OUString sIsSyncHeightToWidth;
	const ::rtl::OUString sHoriOrient;
	const ::rtl::OUString sHoriOrientPosition;
	const ::rtl::OUString sVertOrient;
	const ::rtl::OUString sVertOrientPosition;
	const ::rtl::OUString sChainNextName;
	const ::rtl::OUString sAnchorType;
	const ::rtl::OUString sAnchorPageNo;
	const ::rtl::OUString sGraphicURL;
	const ::rtl::OUString sGraphicFilter;
	const ::rtl::OUString sGraphicRotation;
	const ::rtl::OUString sAlternativeText;
	const ::rtl::OUString sHyperLinkURL;
	const ::rtl::OUString sHyperLinkName;
	const ::rtl::OUString sHyperLinkTarget;
	const ::rtl::OUString sUnvisitedCharStyleName;
	const ::rtl::OUString sVisitedCharStyleName;
	const ::rtl::OUString sDocumentIndex;
	const ::rtl::OUString sTextSection;
	const ::rtl::OUString sDocumentIndexMark;
	const ::rtl::OUString sActualSize;
	const ::rtl::OUString sContourPolyPolygon;
	const ::rtl::OUString sIsPixelContour;
	const ::rtl::OUString sIsAutomaticContour;
	const ::rtl::OUString sAnchorCharStyleName;
	const ::rtl::OUString sServerMap;
	const ::rtl::OUString sRedline;
	const ::rtl::OUString sRuby;
	const ::rtl::OUString sRubyText;
	const ::rtl::OUString sRubyAdjust;
	const ::rtl::OUString sRubyCharStyleName;

	UniReference < SvXMLExportPropertyMapper > GetParaPropMapper() const
	{
		return xParaPropMapper;
	}

	UniReference < SvXMLExportPropertyMapper > GetTextPropMapper() const
	{
		return xTextPropMapper;
	}

	UniReference < SvXMLExportPropertyMapper > GetFramePropMapper() const
	{
		return xFramePropMapper;
	}
	UniReference < SvXMLExportPropertyMapper > GetAutoFramePropMapper() const
	{
		return xAutoFramePropMapper;
	}
	UniReference < SvXMLExportPropertyMapper > GetSectionPropMapper() const
	{
		return xSectionPropMapper;
	}
	UniReference < SvXMLExportPropertyMapper > GetRubyPropMapper() const
	{
		return xRubyPropMapper;
	}

	SvXMLAutoStylePoolP& GetAutoStylePool() { return rAutoStylePool; }
	const SvXMLAutoStylePoolP& GetAutoStylePool() const { return rAutoStylePool; }

	::rtl::OUString FindTextStyle(
			const ::com::sun::star::uno::Reference <
	::com::sun::star::beans::XPropertySet > & rPropSet ) const;

	sal_Int32 addTextFrameAttributes(
		const ::com::sun::star::uno::Reference <
	::com::sun::star::beans::XPropertySet >& rPropSet,
		sal_Bool bShape );
	sal_Bool addTextStyleAttribute(
		const ::com::sun::star::uno::Reference <
	::com::sun::star::beans::XPropertySet >& rPropSet );
	sal_Bool addHyperlinkAttributes(
		const ::com::sun::star::uno::Reference <
	::com::sun::star::beans::XPropertySet > & rPropSet,
		const ::com::sun::star::uno::Reference <
	::com::sun::star::beans::XPropertyState > & rPropState,
		const ::com::sun::star::uno::Reference <
	::com::sun::star::beans::XPropertySetInfo > & rPropSetInfo );

	virtual void exportStyleAttributes(
		const ::com::sun::star::uno::Reference<
	::com::sun::star::style::XStyle > & rStyle );

	void collectFrames();
	void exportPageFrames( sal_Bool bAutoStyles, sal_Bool bProgress );
	void exportFrameFrames( sal_Bool bAutoStyles, sal_Bool bProgress,
			const ::com::sun::star::uno::Reference <
		::com::sun::star::text::XTextFrame > *pParentTxtFrame = 0 );

	void exportNumStyles( sal_Bool bUsed );

	void exportText(
		const ::com::sun::star::uno::Reference <
			::com::sun::star::text::XText > & rText,
		sal_Bool bAutoStyles, sal_Bool bProgress, sal_Bool bExportParagraph );
	sal_Bool exportTextContentEnumeration(
		const ::com::sun::star::uno::Reference <
			::com::sun::star::container::XEnumeration > & rContentEnum,
		sal_Bool bAutoStyles,
		const ::com::sun::star::uno::Reference <
			::com::sun::star::text::XTextSection > & rBaseSection,
		sal_Bool bProgress,
		sal_Bool bExportParagraph = sal_True,
		const ::com::sun::star::uno::Reference <
			::com::sun::star::beans::XPropertySet > *pRangePropSet = 0  );
	void exportParagraph(
		const ::com::sun::star::uno::Reference <
			::com::sun::star::text::XTextContent > & rTextContent,
		sal_Bool bAutoStyles, sal_Bool bProgress,
		sal_Bool bExportParagraph,
	    MultiPropertySetHelper& rPropSetHelper);
	virtual void exportTable(
		const ::com::sun::star::uno::Reference <
			::com::sun::star::text::XTextContent > & rTextContent,
		sal_Bool bAutoStyles, sal_Bool bProgress );
	void exportTextRangeEnumeration(
		const ::com::sun::star::uno::Reference <
			::com::sun::star::container::XEnumeration > & rRangeEnum,
		sal_Bool bAutoStyles, sal_Bool bProgress,
		sal_Bool bPrvChrIsSpc = sal_True  );

	void exportTextField(
		const ::com::sun::star::uno::Reference <
			::com::sun::star::text::XTextRange > & rTextRange,
		sal_Bool bAutoStyles );

	void _exportTextFrame(
		const ::com::sun::star::uno::Reference <
			::com::sun::star::beans::XPropertySet > & rPropSet,
		const ::com::sun::star::uno::Reference <
			::com::sun::star::beans::XPropertySetInfo > & rPropSetInfo,
		sal_Bool bProgress );
	void exportTextFrame(
		const ::com::sun::star::uno::Reference <
			::com::sun::star::text::XTextContent > & rTextContent,
		sal_Bool bAutoStyles, sal_Bool bProgress,
		const ::com::sun::star::uno::Reference <
			::com::sun::star::beans::XPropertySet > *pRangePropSet = 0 );
	void exportShape(
		const ::com::sun::star::uno::Reference <
			::com::sun::star::text::XTextContent > & rTextContent,
		sal_Bool bAutoStyles,
		const ::com::sun::star::uno::Reference <
			::com::sun::star::beans::XPropertySet > *pRangePropSet = 0  );

	void exportContour(
		const ::com::sun::star::uno::Reference <
			::com::sun::star::beans::XPropertySet > & rPropSet,
		const ::com::sun::star::uno::Reference <
			::com::sun::star::beans::XPropertySetInfo > & rPropSetInfo );
	void _exportTextGraphic(
		const ::com::sun::star::uno::Reference <
			::com::sun::star::beans::XPropertySet > & rPropSet,
		const ::com::sun::star::uno::Reference <
			::com::sun::star::beans::XPropertySetInfo > & rPropSetInfo );
	void exportTextGraphic(
		const ::com::sun::star::uno::Reference <
			::com::sun::star::text::XTextContent > & rTextContent,
		sal_Bool bAutoStyles,
		const ::com::sun::star::uno::Reference <
			::com::sun::star::beans::XPropertySet > *pRangePropSet = 0  );

	virtual void _collectTextEmbeddedAutoStyles(
		const ::com::sun::star::uno::Reference <
			::com::sun::star::beans::XPropertySet > & rPropSet );
	virtual void _exportTextEmbedded(
		const ::com::sun::star::uno::Reference <
			::com::sun::star::beans::XPropertySet > & rPropSet,
		const ::com::sun::star::uno::Reference <
			::com::sun::star::beans::XPropertySetInfo > & rPropSetInfo );
	void exportTextEmbedded(
		const ::com::sun::star::uno::Reference <
			::com::sun::star::text::XTextContent > & rTextContent,
		sal_Bool bAutoStyles,
		const ::com::sun::star::uno::Reference <
			::com::sun::star::beans::XPropertySet > *pRangePropSet = 0  );
	virtual void setTextEmbeddedGraphicURL(
		const ::com::sun::star::uno::Reference <
	::com::sun::star::beans::XPropertySet >& rPropSet,
		::rtl::OUString& rStreamName ) const;

	void exportTextFootnote(
		const ::com::sun::star::uno::Reference<
			::com::sun::star::beans::XPropertySet > & rPropSet,
		const ::rtl::OUString& sString,
		sal_Bool bAutoStyles, sal_Bool bProgress );

	void exportTextFootnoteHelper(
		const ::com::sun::star::uno::Reference<
			::com::sun::star::text::XFootnote > & rPropSet,
		const ::com::sun::star::uno::Reference<
			::com::sun::star::text::XText> & rText,
		const ::rtl::OUString& sString,
		sal_Bool bAutoStyles,
		sal_Bool bIsEndnote, sal_Bool bProgress );

	void exportTextFootnoteConfiguration();

	void exportTextFootnoteConfigurationHelper(
		const ::com::sun::star::uno::Reference<
			::com::sun::star::beans::XPropertySet> & rFootnoteSupplier,
		sal_Bool bIsEndnote);

	void exportTextMark(
		const ::com::sun::star::uno::Reference<
			::com::sun::star::beans::XPropertySet> & xPropSet,
		const ::rtl::OUString sProperty,
		const enum ::xmloff::token::XMLTokenEnum pElements[],
		sal_Bool bAutoStyles);

	void exportIndexMark(
		const ::com::sun::star::uno::Reference<
			::com::sun::star::beans::XPropertySet> & rPropSet,
		sal_Bool bAutoStyles);

	void _exportTextRange(
		const ::com::sun::star::uno::Reference <
			::com::sun::star::text::XTextRange > & rTextRange,
		const ::com::sun::star::uno::Reference <
			::com::sun::star::beans::XPropertySet > & rPropSet,
		sal_Bool& rPrevCharWasSpace	);
	void exportTextRange(
		const ::com::sun::star::uno::Reference <
			::com::sun::star::text::XTextRange > & rTextRange,
		sal_Bool bAutoStyles,
		sal_Bool& rPrevCharWasSpace	);

	void exportListChange( const XMLTextNumRuleInfo& rPrvInfo,
	  			   const XMLTextNumRuleInfo& rNextInfo );

	void exportListAndSectionChange(
		::com::sun::star::uno::Reference <
			::com::sun::star::text::XTextSection > & rOldSection,
		const ::com::sun::star::uno::Reference <
			::com::sun::star::text::XTextSection > & rNewSection,
		const XMLTextNumRuleInfo& rOldList,
		const XMLTextNumRuleInfo& rNewList,
		sal_Bool bAutoStyles );

	void exportListAndSectionChange(
		::com::sun::star::uno::Reference <
			::com::sun::star::text::XTextSection > & rOldSection,
		const ::com::sun::star::uno::Reference <
			::com::sun::star::text::XTextContent > & rNewContent,
		const XMLTextNumRuleInfo& rOldList,
		const XMLTextNumRuleInfo& rNewList,
		sal_Bool bAutoStyles );

	void exportChange(
		const ::com::sun::star::uno::Reference <
			::com::sun::star::beans::XPropertySet > & rPropSet,
		sal_Bool bAutoStyle);

	void exportRuby(
		const ::com::sun::star::uno::Reference<
			::com::sun::star::beans::XPropertySet> & rPortionPropSet,
		sal_Bool bAutoStyles );

public:

	XMLTextParagraphExport(
			SvXMLExport& rExp,
	 	SvXMLAutoStylePoolP & rASP
#if SUPD < 628 && !defined( TEST_MIB )
			, sal_Int32 nProg=0
#endif
			  );
	virtual ~XMLTextParagraphExport();

	void Add(
		sal_uInt16 nFamily,
		const ::com::sun::star::uno::Reference <
			::com::sun::star::beans::XPropertySet > & rPropSet,
		const XMLPropertyState** pAddState = NULL );

	::rtl::OUString Find(
		sal_uInt16 nFamily,
		const ::com::sun::star::uno::Reference <
			::com::sun::star::beans::XPropertySet > & rPropSet,
		const ::rtl::OUString& rParent,
		const XMLPropertyState** pAddState = NULL ) const;

	static SvXMLExportPropertyMapper *CreateShapeExtPropMapper(
									SvXMLExport& rExport );
	static SvXMLExportPropertyMapper *CreateCharExtPropMapper(
									SvXMLExport& rExport);
	static SvXMLExportPropertyMapper *CreateParaExtPropMapper(
									SvXMLExport& rExport);

	void exportTextStyles( sal_Bool bUsed
#if SUPD > 627 || defined( TEST_MIB )
			   , sal_Bool bProg = sal_False
#endif
			 );

	void exportTextDeclarations();

	void exportTextDeclarations(
		const ::com::sun::star::uno::Reference < 
			::com::sun::star::text::XText > & rText );

	void exportUsedDeclarations( sal_Bool bOnlyUsed );

	void exportTrackedChanges(sal_Bool bAutoStyle);

	void exportTrackedChanges(const ::com::sun::star::uno::Reference < 
					  ::com::sun::star::text::XText > & rText,
				  sal_Bool bAutoStyle );

	void recordTrackedChangesForXText(
		const ::com::sun::star::uno::Reference < 
			::com::sun::star::text::XText > & rText );

	void recordTrackedChangesNoXText();

	void exportText(
		const ::rtl::OUString& rText,
		sal_Bool& rPrevCharWasSpace );

	void collectTextAutoStyles(
		const ::com::sun::star::uno::Reference <
			::com::sun::star::text::XText > & rText,
		sal_Bool bProgress = sal_False,
		sal_Bool bExportParagraph = sal_True )
	{
		exportText( rText, sal_True, bProgress, bExportParagraph );
	}

	void collectFrameBoundToPageAutoStyles( sal_Bool bProgress = sal_False )
	{
		collectFrames();
		exportPageFrames( sal_True, bProgress );
		exportFrameFrames( sal_True, bProgress );
	}

	virtual void exportTextAutoStyles();

	void exportEvents( const ::com::sun::star::uno::Reference < com::sun::star::beans::XPropertySet > & rPropSet );
	void exportAlternativeText( const ::com::sun::star::uno::Reference < ::com::sun::star::beans::XPropertySet > & rPropSet,
				    const ::com::sun::star::uno::Reference < ::com::sun::star::beans::XPropertySetInfo > & rPropSetInfo );

	void exportText(
		const ::com::sun::star::uno::Reference <
			::com::sun::star::text::XText > & rText,
		sal_Bool bProgress = sal_False,
		sal_Bool bExportParagraph = sal_True)
	{
		exportText( rText, sal_False, bProgress, bExportParagraph );
	}

	void exportFramesBoundToPage( sal_Bool bProgress = sal_False )
	{
		exportPageFrames( sal_False, bProgress );
	}
	void exportFramesBoundToFrame(
			const ::com::sun::star::uno::Reference <
		::com::sun::star::text::XTextFrame >& rParentTxtFrame,
			sal_Bool bProgress = sal_False )
	{
		exportFrameFrames( sal_False, bProgress, &rParentTxtFrame );
	}
	inline const XMLTextListAutoStylePool& GetListAutoStylePool() const;

#if SUPD < 628 && !defined( TEST_MIB )
	inline void SetProgress( sal_Int32 nProg ) { nProgress = nProg; }
#endif
	void SetBlockMode( sal_Bool bSet ) { bBlock = bSet; }
	sal_Bool IsBlockMode() const { return bBlock; }

	UniReference < SvXMLExportPropertyMapper > GetParagraphPropertyMapper() const
	{
		return xParaPropMapper;
	}
};

inline const XMLTextListAutoStylePool&
	XMLTextParagraphExport::GetListAutoStylePool() const
{
	return *pListAutoPool;
}

#endif
