

#ifndef _XMLOFF_XMLEXPPR_HXX
#define _XMLOFF_XMLEXPPR_HXX

#ifndef _COM_SUN_STAR_XML_SAX_XDOCUMENTHANDLER_HPP_
#include <com/sun/star/xml/sax/XDocumentHandler.hpp>
#endif

#ifndef _XMLOFF_PROPERTYSETMAPPER_HXX
#include <xmloff/xmlprmap.hxx>
#endif
#ifndef _UNIVERSALL_REFERENCE_HXX
#include <xmloff/uniref.hxx>
#endif

namespace rtl { class OUString; }

class SvXMLUnitConverter;
class SvXMLAttributeList;
class SvXMLNamespaceMap;
class SvUShorts;
class FilterPropertiesInfos_Impl;

#define XML_EXPORT_FLAG_DEFAULTS	0x0001		
#define XML_EXPORT_FLAG_DEEP		0x0002		

#define XML_EXPORT_FLAG_EMPTY		0x0004		

#define XML_EXPORT_FLAG_IGN_WS		0x0008

class SvXMLExportPropertyMapper : public UniRefBase
{
	UniReference< SvXMLExportPropertyMapper> mxNextMapper;

	FilterPropertiesInfos_Impl *pCache;

protected:
	UniReference< XMLPropertySetMapper > maPropMapper;

	::std::vector< XMLPropertyState > _Filter(
			const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet > rPropSet,
			const sal_Bool bDefault ) const;

	virtual void ContextFilter(
			::std::vector< XMLPropertyState >& rProperties,
	  ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet > rPropSet ) const;

	void _exportXML( SvXMLAttributeList& rAttrList,
	           const ::std::vector< XMLPropertyState >& rProperties,
		 const SvXMLUnitConverter& rUnitConverter,
		 const SvXMLNamespaceMap& rNamespaceMap,
		 sal_uInt16 nFlags,
		 SvUShorts* pIndexArray,
	  	 sal_Int32 nPropMapStartIdx, sal_Int32 nPropMapEndIdx ) const;

	void _exportXML( SvXMLAttributeList& rAttrList,
	           const XMLPropertyState& rProperty,
		 const SvXMLUnitConverter& rUnitConverter,
		 const SvXMLNamespaceMap& rNamespaceMap,
		 sal_uInt16 nFlags,
		 const ::std::vector< XMLPropertyState > *pProperties = 0,
		 sal_uInt32 nIdx = 0 ) const;

	void exportElementItems(
			const ::com::sun::star::uno::Reference<
	::com::sun::star::xml::sax::XDocumentHandler > & rHandler,
			const SvXMLUnitConverter& rUnitConverter,
			const SvXMLNamespaceMap& rNamespaceMap,
			const ::std::vector< XMLPropertyState >& rProperties,
			sal_uInt16 nFlags,
			const SvUShorts& rIndexArray ) const;

public:

	SvXMLExportPropertyMapper(
			const UniReference< XMLPropertySetMapper >& rMapper );
	virtual ~SvXMLExportPropertyMapper();

	void ChainExportMapper(
		const UniReference< SvXMLExportPropertyMapper>& rMapper );

	::std::vector< XMLPropertyState > Filter(
			const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet > rPropSet ) const
		{ return _Filter(rPropSet, sal_False); }

	::std::vector< XMLPropertyState > FilterDefaults(
			const ::com::sun::star::uno::Reference<
		::com::sun::star::beans::XPropertySet > rPropSet ) const
		{ return _Filter(rPropSet, sal_True); }

	sal_Bool Equals( const ::std::vector< XMLPropertyState >& aProperties1,
	           const ::std::vector< XMLPropertyState >& aProperties2 ) const;

	void exportXML(
	 SvXMLAttributeList& rAttrList,
	 const ::std::vector< XMLPropertyState >& rProperties,
	 const SvXMLUnitConverter& rUnitConverter,
	 const SvXMLNamespaceMap& rNamespaceMap,
	 sal_uInt16 nFlags = 0 ) const;

	void exportXML(
	 SvXMLAttributeList& rAttrList,
	 const ::std::vector< XMLPropertyState >& rProperties,
	 const SvXMLUnitConverter& rUnitConverter,
	 const SvXMLNamespaceMap& rNamespaceMap,
	 sal_Int32 nPropMapStartIdx, sal_Int32 nPropMapEndIdx,
	 sal_uInt16 nFlags = 0 ) const;

	void exportXML(
	 SvXMLAttributeList& rAttrList,
	 const XMLPropertyState& rProperty,
	 const SvXMLUnitConverter& rUnitConverter,
	 const SvXMLNamespaceMap& rNamespaceMap,
	 sal_uInt16 nFlags = 0 ) const;

	void exportXML(
			const ::com::sun::star::uno::Reference<
		::com::sun::star::xml::sax::XDocumentHandler > & rHandler,
			const ::std::vector< XMLPropertyState >& rProperties,
			const SvXMLUnitConverter& rUnitConverter,
			const SvXMLNamespaceMap& rNamespaceMap,
			sal_uInt16 nFlags = 0 ) const;

	void exportXML(
			const ::com::sun::star::uno::Reference<
		::com::sun::star::xml::sax::XDocumentHandler > & rHandler,
			const ::std::vector< XMLPropertyState >& rProperties,
			const SvXMLUnitConverter& rUnitConverter,
			const SvXMLNamespaceMap& rNamespaceMap,
	  sal_Int32 nPropMapStartIdx, sal_Int32 nPropMapEndIdx,
			sal_uInt16 nFlags = 0 ) const;

	virtual void handleElementItem(
			const ::com::sun::star::uno::Reference<
		::com::sun::star::xml::sax::XDocumentHandler > & rHandler,
			const XMLPropertyState& rProperty,
			const SvXMLUnitConverter& rUnitConverter,
			const SvXMLNamespaceMap& rNamespaceMap,
			sal_uInt16 nFlags,
			const ::std::vector< XMLPropertyState > *pProperties = 0,
			sal_uInt32 nIdx = 0 ) const;

	virtual void handleSpecialItem(
			SvXMLAttributeList& rAttrList,
			const XMLPropertyState& rProperty,
			const SvXMLUnitConverter& rUnitConverter,
			const SvXMLNamespaceMap& rNamespaceMap,
			const ::std::vector< XMLPropertyState > *pProperties = 0,
			sal_uInt32 nIdx = 0 ) const;

	inline const UniReference< XMLPropertySetMapper >&
		getPropertySetMapper() const { return maPropMapper; }

};

#endif	
