

#ifndef _XMLOFF_XMLNUMI_HXX
#define _XMLOFF_XMLNUMI_HXX

#ifndef _COM_SUN_STAR_CONTAINER_XINDEXREPLACE_HPP_
#include <com/sun/star/container/XIndexReplace.hpp>
#endif

#include <xmloff/xmlstyle.hxx>

#ifndef _COM_SUN_STAR_STYLE_NUMBERINGTYPE_HPP_
#include <com/sun/star/style/NumberingType.hpp>
#endif

namespace com { namespace sun { namespace star { namespace frame { class XModel; } } } }
class SvI18NMap;
class SvxXMLListStyle_Impl;

class SvxXMLListStyleContext : public SvXMLStyleContext
{
	const ::rtl::OUString		sIsPhysical;
	const ::rtl::OUString		sNumberingRules;
	const ::rtl::OUString		sName;
	const ::rtl::OUString		sIsContinuousNumbering;
	const ::rtl::OUString		sIsNumbering;

	::com::sun::star::uno::Reference <
		::com::sun::star::container::XIndexReplace > xNumRules;

	SvxXMLListStyle_Impl		*pLevelStyles;

	sal_Int16					nLevels;
	sal_Bool					bConsecutive : 1;
	sal_Bool					bOutline : 1;

protected:

	virtual void SetAttribute( sal_uInt16 nPrefixKey,
				   const ::rtl::OUString& rLocalName,
				   const ::rtl::OUString& rValue );

public:

	TYPEINFO();

	SvxXMLListStyleContext(
			SvXMLImport& rImport, sal_uInt16 nPrfx,
			const ::rtl::OUString& rLName,
			const ::com::sun::star::uno::Reference<
		::com::sun::star::xml::sax::XAttributeList >& xAttrList,
			sal_Bool bOutl=sal_False );

	virtual ~SvxXMLListStyleContext();

	virtual SvXMLImportContext *CreateChildContext(
			sal_uInt16 nPrefix,
			const ::rtl::OUString& rLocalName,
			const ::com::sun::star::uno::Reference<
		::com::sun::star::xml::sax::XAttributeList >& xAttrList );

	void FillUnoNumRule(
			const ::com::sun::star::uno::Reference<
		::com::sun::star::container::XIndexReplace > & rNumRule,
			const SvI18NMap *pI18NMap ) const;

	const ::com::sun::star::uno::Reference <
		::com::sun::star::container::XIndexReplace >& GetNumRules() const
		{ return xNumRules; }
	sal_Bool IsOutline() const { return bOutline; }
	sal_Bool IsConsecutive() const { return bConsecutive; }
	sal_Int16 GetLevels() const { return nLevels; }

	static ::com::sun::star::uno::Reference <
		::com::sun::star::container::XIndexReplace >
	SvxXMLListStyleContext::CreateNumRule(
		const ::com::sun::star::uno::Reference <
			::com::sun::star::frame::XModel > & rModel );

	static void SvxXMLListStyleContext::SetDefaultStyle(
		const ::com::sun::star::uno::Reference <
			::com::sun::star::container::XIndexReplace > & rNumRule,
		sal_Int16 nLevel,
		sal_Bool bOrdered );

#if SUPD < 627
	static sal_Int16 GetNumType( const ::rtl::OUString& rNumFmt,
			const ::rtl::OUString& rLetterSync,
			sal_Int16 eDflt = ::com::sun::star::style::NumberingType::ARABIC,
			sal_Bool bNumberNone = sal_False );
#endif

	virtual void CreateAndInsertLate( sal_Bool bOverwrite );

	void CreateAndInsertAuto() const;
};

#endif	

