

#ifndef _XMLOFF_XMLSTYLE_HXX
#define _XMLOFF_XMLSTYLE_HXX

#ifndef _RSCSFX_HXX 
#include <rsc/rscsfx.hxx>
#endif

#ifndef _RTTI_HXX
#include <tools/rtti.hxx>
#endif
#ifndef _UNIVERSALL_REFERENCE_HXX
#include <xmloff/uniref.hxx>
#endif

#ifndef _XMLOFF_XMLTKMAP_HXX
#include <xmloff/xmltkmap.hxx>
#endif
#ifndef _XMLOFF_XMLICTXT_HXX
#include <xmloff/xmlictxt.hxx>
#endif

class SvXMLStylesContext_Impl;
class SvXMLUnitConverter;
class SvXMLImportPropertyMapper;

namespace com { namespace sun { namespace star { namespace container
{
	class XNameContainer;
} } } }

enum XMLStyleStylesElemTokens
{
	XML_TOK_STYLE_STYLE,
	XML_TOK_STYLE_PAGE_MASTER,
	XML_TOK_TEXT_LIST_STYLE,
	XML_TOK_TEXT_OUTLINE,
	XML_TOK_STYLES_GRADIENTSTYLES,
	XML_TOK_STYLES_HATCHSTYLES,
	XML_TOK_STYLES_BITMAPSTYLES,
	XML_TOK_STYLES_TRANSGRADIENTSTYLES,
	XML_TOK_STYLES_MARKERSTYLES,
	XML_TOK_STYLES_DASHSTYLES,
	XML_TOK_TEXT_FOOTNOTE_CONFIG,
	XML_TOK_TEXT_ENDNOTE_CONFIG,
	XML_TOK_TEXT_BIBLIOGRAPHY_CONFIG,
	XML_TOK_TEXT_LINENUMBERING_CONFIG,
	XML_TOK_STYLE_DEFAULT_STYLE,
	XML_TOK_STYLE_STYLES_ELEM_END=XML_TOK_UNKNOWN
};

class SvXMLStyleContext : public SvXMLImportContext
{
	::rtl::OUString		aName;
	::rtl::OUString		aParent;	
	::rtl::OUString		aFollow;	

	::rtl::OUString		aHelpFile;	

	sal_uInt32			nHelpId;	
	sal_uInt16			nFamily;

	sal_Bool			bValid : 1;	

	sal_Bool			bNew : 1;	

	sal_Bool			bDefaultStyle : 1;

protected:

	virtual void SetAttribute( sal_uInt16 nPrefixKey,
				   const ::rtl::OUString& rLocalName,
				   const ::rtl::OUString& rValue );

#if SUPD<618
	void SetFamily( sal_uInt16 nSet ) { nFamily = nSet; }
#endif

public:

	TYPEINFO();

	SvXMLStyleContext( SvXMLImport& rImport, sal_uInt16 nPrfx,
		const ::rtl::OUString& rLName,
		const ::com::sun::star::uno::Reference<
			::com::sun::star::xml::sax::XAttributeList >& xAttrList,
	sal_uInt16 nFamily=0, sal_Bool bDefaultStyle = sal_False );

	virtual ~SvXMLStyleContext();

	virtual SvXMLImportContext *CreateChildContext( sal_uInt16 nPrefix,
		const ::rtl::OUString& rLocalName,
		const ::com::sun::star::uno::Reference<
			::com::sun::star::xml::sax::XAttributeList > & xAttrList );

	virtual void StartElement(
		const ::com::sun::star::uno::Reference<
			::com::sun::star::xml::sax::XAttributeList > & xAttrList );

	const ::rtl::OUString&	GetName() const { return aName; }
	const ::rtl::OUString&	GetParent() const { return aParent; }
	const ::rtl::OUString&	GetFollow() const { return aFollow; }

	const ::rtl::OUString&	GetHelpFile() const { return aHelpFile; }
	sal_uInt32	GetHelpId() const { return nHelpId; }

	sal_uInt16 GetFamily() const { return nFamily; }

	BOOL IsValid() const { return bValid; }
	void SetValid( sal_Bool b ) { bValid = b; }

	BOOL IsNew() const { return bNew; }
	void SetNew( sal_Bool b ) { bNew = b; }

	virtual void SetDefaults();

	virtual void CreateAndInsert( sal_Bool bOverwrite );

	virtual void CreateAndInsertLate( sal_Bool bOverwrite );

	virtual void Finish( sal_Bool bOverwrite );

	sal_Bool IsDefaultStyle() const { return bDefaultStyle; }
};

class SvXMLStylesContext : public SvXMLImportContext
{
	const ::rtl::OUString sParaStyleServiceName;
	const ::rtl::OUString sTextStyleServiceName;

	SvXMLStylesContext_Impl	*pImpl;
	SvXMLTokenMap			*pStyleStylesElemTokenMap;

	::com::sun::star::uno::Reference <
		::com::sun::star::container::XNameContainer > xParaStyles;
	::com::sun::star::uno::Reference <
		::com::sun::star::container::XNameContainer > xTextStyles;

	UniReference < SvXMLImportPropertyMapper > xParaImpPropMapper;
	UniReference < SvXMLImportPropertyMapper > xTextImpPropMapper;
	UniReference < SvXMLImportPropertyMapper > xShapeImpPropMapper;
	mutable UniReference < SvXMLImportPropertyMapper > xChartImpPropMapper;
	mutable UniReference < SvXMLImportPropertyMapper > xPageImpPropMapper;

	const SvXMLTokenMap& GetStyleStylesElemTokenMap();

protected:

	sal_uInt32 GetStyleCount() const;
	SvXMLStyleContext *GetStyle( sal_uInt32 i );
	const SvXMLStyleContext *GetStyle( sal_uInt32 i ) const;

	virtual SvXMLStyleContext *CreateStyleChildContext( sal_uInt16 nPrefix,
		const ::rtl::OUString& rLocalName,
		const ::com::sun::star::uno::Reference<
			::com::sun::star::xml::sax::XAttributeList > & xAttrList );

	virtual SvXMLStyleContext *CreateStyleStyleChildContext( sal_uInt16 nFamily,
		sal_uInt16 nPrefix, const ::rtl::OUString& rLocalName,
		const ::com::sun::star::uno::Reference<
			::com::sun::star::xml::sax::XAttributeList > & xAttrList );

	virtual SvXMLStyleContext *CreateDefaultStyleStyleChildContext(
		sal_uInt16 nFamily, sal_uInt16 nPrefix,
		const ::rtl::OUString& rLocalName,
		const ::com::sun::star::uno::Reference<
			::com::sun::star::xml::sax::XAttributeList > & xAttrList );

	virtual sal_Bool InsertStyleFamily( sal_uInt16 nFamily ) const;

public:
	TYPEINFO();

	SvXMLStylesContext( SvXMLImport& rImport, sal_uInt16 nPrfx,
		const ::rtl::OUString& rLName,
		const ::com::sun::star::uno::Reference<
			::com::sun::star::xml::sax::XAttributeList > & xAttrList );

	virtual ~SvXMLStylesContext();

	virtual SvXMLImportContext *CreateChildContext( sal_uInt16 nPrefix,
		const ::rtl::OUString& rLocalName,
		const ::com::sun::star::uno::Reference<
			::com::sun::star::xml::sax::XAttributeList > & xAttrList );

	virtual void EndElement();

	void AddStyle(SvXMLStyleContext& rNew);

	const ::rtl::OUString& GetId() const;
	const ::rtl::OUString& GetParentHRef() const;

	const SvXMLStyleContext *FindStyleChildContext(
						  sal_uInt16 nFamily,
						  const ::rtl::OUString& rName,
						  BOOL bCreateIndex=sal_False ) const;
	virtual sal_uInt16 GetFamily( const ::rtl::OUString& rFamily ) const;
	virtual UniReference < SvXMLImportPropertyMapper > GetImportPropertyMapper(
			sal_uInt16 nFamily ) const;

	virtual ::com::sun::star::uno::Reference <
		::com::sun::star::container::XNameContainer >
		GetStylesContainer( sal_uInt16 nFamily ) const;
	virtual ::rtl::OUString GetServiceName( sal_uInt16 nFamily ) const;

	void CopyStylesToDoc( sal_Bool bOverwrite, sal_Bool bFinish=sal_True );
	void FinishStyles( sal_Bool bOverwrite );

	void Clear();
};

class SvXMLUseStylesContext : public SvXMLImportContext
{
public:

	SvXMLUseStylesContext( SvXMLImport& rImport, sal_uInt16 nPrfx,
		const ::rtl::OUString& rLName,
		const ::com::sun::star::uno::Reference<
			::com::sun::star::xml::sax::XAttributeList > & xAttrList,
		::rtl::OUString& rHRef );

	virtual ~SvXMLUseStylesContext();
};

#endif	

