

#ifndef _XMLOFF_XMLUCONV_HXX
#define _XMLOFF_XMLUCONV_HXX

#include <limits.h>

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif

#ifndef _TOOLS_COLOR_HXX
#include <tools/color.hxx>
#endif

#ifndef _VCL_MAPUNIT_HXX
#include <vcl/mapunit.hxx>
#endif

#ifndef _XMLOFF_XMLEMENT_HXX
#include <xmloff/xmlement.hxx>
#endif

#ifndef _XMLOFF_XMLTOKEN_HXX
#include <xmloff/xmltoken.hxx>
#endif

#ifndef _COM_SUN_STAR_UTIL_DATE_HPP_
#include <com/sun/star/util/Date.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XMODEL_HPP_
#include <com/sun/star/frame/XModel.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif

namespace rtl
{
class OUString;
class OUStringBuffer;
}

namespace com { namespace sun { namespace star {
	namespace util { struct DateTime; }
	namespace text { class XNumberingTypeInfo; }
}}}

class SvXMLTokenEnumerator
{
private:
	const ::rtl::OUString&	maTokenString;
	sal_Int32				mnNextTokenPos;
	sal_Unicode				mcSeperator;

public:
	SvXMLTokenEnumerator( const ::rtl::OUString& rString, sal_Unicode cSeperator = sal_Unicode(' ') );

	sal_Bool getNextToken( ::rtl::OUString& rToken );
};

class Vector3D;

class SvXMLUnitConverter
{
private:
	MapUnit	meCoreMeasureUnit;
	MapUnit	meXMLMeasureUnit;
	com::sun::star::util::Date aNullDate;
	::com::sun::star::uno::Reference<
		::com::sun::star::text::XNumberingTypeInfo > xNumTypeInfo;
	static ::rtl::OUString msXML_false;
	static ::rtl::OUString msXML_true;

	static void initXMLStrings();

	void createNumTypeInfo() const;

public:

	SvXMLUnitConverter( MapUnit eCoreMeasureUnit, MapUnit eXMLMeasureUnit );

	virtual ~SvXMLUnitConverter();

	static MapUnit GetMapUnit(sal_Int16 nFieldUnit);

	inline void setCoreMeasureUnit( MapUnit eCoreMeasureUnit );

	inline MapUnit getCoreMeasureUnit() const;

	void setXMLMeasureUnit( MapUnit eXMLMeasureUnit );

	MapUnit getXMLMeasureUnit() const;

	const ::com::sun::star::uno::Reference<
		::com::sun::star::text::XNumberingTypeInfo >& getNumTypeInfo() const
	{
		if( !xNumTypeInfo.is() )
			createNumTypeInfo();
		return xNumTypeInfo;
	}

	sal_Bool convertMeasure( sal_Int32& rValue,
			 const ::rtl::OUString& rString,
			 sal_Int32 nMin = LONG_MIN,
			 sal_Int32 nMax = LONG_MAX ) const;

	void convertMeasure( ::rtl::OUStringBuffer& rBuffer,
			 sal_Int32 nMeasure ) const;

	void convertMeasure( ::rtl::OUStringBuffer&,
			 sal_Int32 nMeasure,
			 MapUnit eSrcUnit ) const;

	static sal_Bool convertMeasure( sal_Int32& rVal,
					const ::rtl::OUString& rString,
					MapUnit eDstUnit,
					sal_Int32 nMin = LONG_MIN,
					sal_Int32 nMax = LONG_MAX );

	static void convertMeasure( ::rtl::OUStringBuffer& rBuffer,
					sal_Int32 nMeasure,
					MapUnit eSrcUnit,
					MapUnit eDstUnit );

	static sal_Bool convertBool( sal_Bool& rBool,
				 const ::rtl::OUString& rString );

	static void convertBool( ::rtl::OUStringBuffer& rBuffer,
				 sal_Bool bValue );

	static sal_Bool convertPercent( sal_Int32& rValue,
					const ::rtl::OUString& rString );

	static void convertPercent( ::rtl::OUStringBuffer& rBuffer,
					sal_Int32 nValue );

	static sal_Bool convertMeasurePx( sal_Int32& rValue,
					const ::rtl::OUString& rString );

	static void convertMeasurePx( ::rtl::OUStringBuffer& rBuffer,
					sal_Int32 nValue );

	static sal_Bool convertEnum( sal_uInt16& rEnum,
				 const ::rtl::OUString& rValue,
				 const SvXMLEnumMapEntry *pMap );

	static sal_Bool convertEnum( sal_uInt16& rEnum,
				 const ::rtl::OUString& rValue,
				 const SvXMLEnumStringMapEntry *pMap );

	static sal_Bool convertEnum( ::rtl::OUStringBuffer& rBuffer,
	                             USHORT nValue,
	                             const SvXMLEnumMapEntry *pMap,
	                             enum ::xmloff::token::XMLTokenEnum eDefault = 
	                                     ::xmloff::token::XML_TOKEN_INVALID );

	static sal_Bool convertEnum( ::rtl::OUStringBuffer& rBuffer,
	                             USHORT nValue,
	                             const SvXMLEnumStringMapEntry *pMap,
	                             sal_Char* pDefault = NULL );

	static sal_Bool convertColor( Color& rColor,
				  const ::rtl::OUString&rValue );

	static void convertColor( ::rtl::OUStringBuffer &rBuffer,
				  const Color& rCol );

	static void convertNumber( ::rtl::OUStringBuffer& rBuffer,
				   sal_Int32 nNumber );

	static sal_Bool convertNumber( sal_Int32& rValue,
				   const ::rtl::OUString& rString,
				   sal_Int32 nMin = LONG_MIN,
				   sal_Int32 nMax = LONG_MAX );

	void convertDouble(::rtl::OUStringBuffer& rBuffer,
		double fNumber, BOOL bWriteUnits) const;

	static void convertDouble( ::rtl::OUStringBuffer& rBuffer,
		double fNumber, BOOL bWriteUnits, MapUnit eCoreUnit, MapUnit eDstUnit);

	static void convertDouble( ::rtl::OUStringBuffer& rBuffer, double fNumber);

	sal_Bool convertDouble(double& rValue, const ::rtl::OUString& rString, BOOL bLookForUnits) const;

	static sal_Bool convertDouble(double& rValue,
		const ::rtl::OUString& rString, MapUnit eSrcUnit, MapUnit eCoreUnit);

	static sal_Bool convertDouble(double& rValue, const ::rtl::OUString& rString);

	sal_Bool setNullDate (
		const com::sun::star::uno::Reference <com::sun::star::frame::XModel>& xModel);

	void setNullDate ( const com::sun::star::util::Date& aTempNullDate ) { aNullDate = aTempNullDate; }

	static void convertTime( ::rtl::OUStringBuffer& rBuffer,
					const double& fTime);

	static void convertTime( ::rtl::OUStringBuffer& rBuffer,
					const ::com::sun::star::util::DateTime& rDateTime );

	static sal_Bool convertTime( double& fTime,
					const ::rtl::OUString& rString);

	static sal_Bool convertTime( ::com::sun::star::util::DateTime& rDateTime,
					 const ::rtl::OUString& rString );

	void convertDateTime( ::rtl::OUStringBuffer& rBuffer,
					const double& fDateTime) { convertDateTime(rBuffer, fDateTime, aNullDate); }

	sal_Bool convertDateTime( double& fDateTime,
					const ::rtl::OUString& rString) { return convertDateTime(fDateTime, rString, aNullDate); }

	static void convertDateTime( ::rtl::OUStringBuffer& rBuffer,
					const double& fDateTime,
					const com::sun::star::util::Date& aNullDate);

	static sal_Bool convertDateTime( double& fDateTime,
					const ::rtl::OUString& rString,
					const com::sun::star::util::Date& aNullDate);

	static sal_Bool convertVector3D( Vector3D& rVector,
				  const ::rtl::OUString& rValue );

	static void convertVector3D( ::rtl::OUStringBuffer &rBuffer,
				  const Vector3D& rVector );

	static void convertDateTime( ::rtl::OUStringBuffer& rBuffer,
					const com::sun::star::util::DateTime& rDateTime );

	static sal_Bool convertDateTime( com::sun::star::util::DateTime& rDateTime,
						 const ::rtl::OUString& rString );

	static sal_Int32 indexOfComma( const ::rtl::OUString& rStr,
					   sal_Int32 nPos );

	static void encodeBase64(rtl::OUStringBuffer& aStrBuffer, const com::sun::star::uno::Sequence<sal_Int8>& aPass);

	static void decodeBase64(com::sun::star::uno::Sequence<sal_Int8>& aPass, const rtl::OUString& sBuffer);

	static sal_Int32 decodeBase64SomeChars(com::sun::star::uno::Sequence<sal_Int8>& aPass, const rtl::OUString& sBuffer);

	sal_Bool convertNumFormat( sal_Int16& rType,
			 	   const ::rtl::OUString& rNumFormat,
				   const ::rtl::OUString& rNumLetterSync,
				   sal_Bool bNumberNone = sal_False ) const;

	void convertNumFormat( ::rtl::OUStringBuffer& rBuffer,
			   sal_Int16 nType ) const;
	void convertNumLetterSync( ::rtl::OUStringBuffer& rBuffer,
			   	   sal_Int16 nType ) const;

	static void convertPropertySet(com::sun::star::uno::Sequence<com::sun::star::beans::PropertyValue>& rProps,
			const com::sun::star::uno::Reference<com::sun::star::beans::XPropertySet>& aProperties);
	static void convertPropertySet(com::sun::star::uno::Reference<com::sun::star::beans::XPropertySet>& rProperties,
			const com::sun::star::uno::Sequence<com::sun::star::beans::PropertyValue>& aProps);

};

inline void SvXMLUnitConverter::setCoreMeasureUnit( MapUnit eCoreMeasureUnit )
{
	meCoreMeasureUnit = eCoreMeasureUnit;
}

inline MapUnit SvXMLUnitConverter::getCoreMeasureUnit() const
{
	return meCoreMeasureUnit;
}

inline void SvXMLUnitConverter::setXMLMeasureUnit( MapUnit eXMLMeasureUnit )
{
	meXMLMeasureUnit = eXMLMeasureUnit;
}

inline MapUnit SvXMLUnitConverter::getXMLMeasureUnit() const
{
	return meXMLMeasureUnit;
}

#endif	
